var applistingController = function()
{
	this.view = "default";
	this.style = "default";
	this.dom = null;
	this.data = null;
	
	this.categories = null;
};
applistingController.prototype.Init = function(viewDom)
{
	this.dom = viewDom;
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.showLoader();
	this.data = urlMgmt.customHeader[this.id];
	this.SetLayout();
	this.PopulateUI();
	this.BindEvents();
	urlMgmt.removeLoader();
};
applistingController.prototype.SetLayout = function()
{
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.lockRotation();
	urlMgmt.menuAction.view.hide();
	urlMgmt.headerAction.controler.DisplayHeader(this.dom, this.data.title, false, true, false);
};
applistingController.prototype.BindEvents = function()
{
	var urlMgmt = UrlMgmt.getObj();
	$(this.dom).find(".subItem").unbind().bind('click', this, function(e) {
		urlMgmt.ClearActionStack(false);
		var id = $(e.currentTarget).attr('data-index');
		var url = $(e.currentTarget).attr('data-url');
		if(typeof url == 'undefined' || url.length == 0){
			var action = $(e.currentTarget).attr('data-action');
			if(typeof action != 'undefined' && action.length > 0){
				UrlMgmt.getObj().Route({route: action, needData: true, emptyStack: true});
			}
		}
		else{
			URLRedirection(url);
		}
	});
	this.dom.find('.imgclose').unbind().bind('click',function(){
		urlMgmt.PopView();
	});
};
applistingController.prototype.PopulateUI = function()
{
	var navTabs = '';
	var	tabContent = '';
	var	once = true;
	var levels = 1;
	for(var item in this.data.children)
	{
		if(this.data.children[item].children.length > 0){
			levels = 2;
			break;
		}
	}
	
	if(levels == 1){
		var html = "";
		if(this.data.children.length > 0){
			for(var item in this.data.children)
			{	
				var itemData = this.data.children[item];
				html += '<div class="subItem" '+ itemData["attributes"] +' data-index="'+item+'" data-url="'+itemData["url"]+'" style="order:'+itemData["index"]+';">'+
							  	'<p>'+itemData["title"]+'</p>'+
							  	'<img src="img/right-nav-blue.png">'+
							  '</div>';
			}
			this.dom.find('.listingContainer').html(html);
		}
	}
	else if(levels == 2){
		for(var item in this.data.children)
		{	
			var itemData = this.data.children[item];		
			if(itemData.children.length > 0)
			{	
				navTabs += 
					'<li class="categoryTab '+(once?'active':'')+'" style="order:'+itemData["index"]+';"><a href="#listCategory'+item+'" data-toggle="tab">'+itemData.title+'</a></li>';
				tabContent +=
					'<div class="tab-pane '+(once?'active':'')+'" id="listCategory'+item+'">'+
						'<div class="items">';
				for(var index in itemData.children)
				{
					 var listItem = itemData.children[index];
					 tabContent += '<div class="subItem" '+ listItem["attributes"] +' data-index="'+index+'" data-url="'+listItem["url"]+'" style="order:'+listItem["index"]+';">'+
					 	 				'<p>'+listItem.title+'</p>'+
					 					'<img src="img/right-nav-blue.png">'+
								   '</div>';			
				}
				tabContent += '</div></div>';
				once = false;
			}
			else {
				navTabs += 
					'<li class="categoryTab '+(once?'active':'')+'"><a href="#listCategory'+item+'" data-toggle="tab">'+itemData.title+'</a></li>';
				tabContent +=
					'<div class="tab-pane '+(once?'active':'')+'" id="listCategory'+item+'">'+
						'<div class="items">';
				 var listItem = itemData.children[index];
				 tabContent += '<div class="subItem" '+ itemData["attributes"] +' data-index="0" data-url="'+itemData["url"]+'" style="order:'+itemData["index"]+';">'+
				 	 				'<p>'+itemData.title+'</p>'+
				 					'<img src="img/right-nav-blue.png">'+
							   '</div>';			
				tabContent += '</div></div>';
				once = false;
			}
		}
		this.dom.find(".nav-tabs").append(navTabs);
		$(".categoryTab").unbind().bind('click', function(e){
			var calculate1 = $(".cattabList").scrollLeft() + $(e.currentTarget).offset().left-$(".cattabList").offset().left-$(".cattabList")[0].clientWidth/2 + $(e.currentTarget).outerWidth(true)/2;
			$('.cattabList').animate({
				scrollLeft: calculate1
			}, 1000);
		});    
		//slider for category tabs
		if($(".catListingDiv").length > 0){
			slider("catListingDiv", 'cattabList', "categoryTab");
		}
		this.dom.find(".tab-content").append(tabContent);
	}
};