/** timer **/
var QTimer = function() {
	this.seconds = 0;
	this.TimeCountCheck = true;
	this.cancel = null;
	this.questionTimer = null;
};
var QuestionPosition = 1;

var appquizController = function() {
	this.view = "default";
	this.style = "default";
	this.dom = null;
	this.id = 0;
	this.data = null;
	this.submitted = false;
};
appquizController.prototype.Init = function(viewDom) {
	this.dom = viewDom;
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.showLoader();
	this.SetLayout();
	if (!UrlMgmt.getObj().App.isOnline) {
		this.OfflineInit();
	} else {
		this.OnlineInit();
	}
	urlMgmt.removeLoader();
};
appquizController.prototype.SetLayout = function() {
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.lockRotation();
	urlMgmt.menuAction.view.hide();
	urlMgmt.headerAction.view.hide();
};
appquizController.prototype.OfflineInit = function() {
	Factory.getObj().LoadViewForOffline(this);
};
appquizController.prototype.OnlineInit = function() {
	if ($(this.dom).find(".tryagain").length != 0)
		$(this.dom).find(".tryagain").remove();
	this.timer = new QTimer();
	this.GetQuizData();
};

appquizController.prototype.GetQuizData = function() {
	$.ajax({
		type : "POST",
		url : remoteServer + "/?route=common/ajax",
		data : {
			mod : "tr2dquiz",
			ack : "getquizdataapp",
			quizid : this.id,
		},
		xhrFields : {
			withCredentials : true
		},
		crossDomain : true,
		complete : function(reply) {
			var response = reply.responseJSON;
			this.data = response.data;
			this.PopulateView();
		}.bind(this)
	});
};
appquizController.prototype.PopulateView = function() {
	if (this.data != null) {
		Total_questions = parseInt(this.data.quizInfo.info.totalQuestions);
		//TODO no need to pass parameters
		QuestionPosition = 1;
		this.Quizpatti(this.data.quizInfo.id, this.data.quizInfo.info.totalQuestions, this.data.quizInfo.info.totalmarks, this.data.quizSession.lastQuestion);
		$(".quiz-patti").show();
		$(this.dom).find('.quiz-header').find('.quiz-title').text(this.data.quizInfo.title);
		this.PopulateQuizData(this.data, this.data.quizInfo.id);
		//adding action to submit quiz button
		$('#quiz-status-modal').find('.statusbody').find(".quiz-submit").attr('data-action', "app/quizreport&id=" + this.data.quizInfo.id);
	}
	this.BindEvents();
};

appquizController.prototype.Quizpatti = function(quizId, quizques, quizmarks, resumefetch) {
	if (resumefetch == undefined) {
		resumefetch = 0;
	}
	else{
		QuestionPosition = parseInt(resumefetch) + 1;
		if(resumefetch == this.data.quizInfo.info.totalQuestions - 1 || this.data.quizInfo.info.totalQuestions == 1){
			$(this.dom).find(".nextQuestion").hide();
			$(this.dom).find('.questionNavigation').find(".quiz-submit").show();
		}
		else{
			$(this.dom).find(".nextQuestion").show();
			$(this.dom).find('.questionNavigation').find(".quiz-submit").hide();
		}
	}
	if(this.data.quizInfo.info.totalQuestions == 1){
		$(this.dom).find(".nextQuestion").hide();
		$(this.dom).find('.questionNavigation').find(".quiz-submit").show();
	}
	//var quizHTML = '<div class="quiz-patti " quiz-id="' + quizId + '">' + '<div class="description">' + '<table><tr><td><div class="ongoingQues">' + '<span class="quizquestnno">' + (parseInt(resumefetch) + 1) + '</span>/<span class="marks">' + (quizques) + '</span>' + '</div></td>' + '<td><div class="marks "><span>' + quizques + '</span> QUES</div></td>' + '<td><div class="marks "><span>' + quizmarks + '</span> MARKS</div></td><td><div class="timer marks">' + '<img src="img/time_spent.png">' + '<span class="questionTimer">0</span>' + '</div></td></tr></table>'+ '</div>' + '</div>';
	var quizHTML = '<div class="quiz-patti " quiz-id="' + quizId + '">' + '<div class="description">' + '<table><tr><td><div class="ongoingQues">' + '<span class="quizquestnno">' + (parseInt(resumefetch) + 1) + '</span>/<span class="marks">' + (quizques) + '</span>' + '</div></td>' + '<td><div class="marks "><span>' + quizques + '</span> QUES</div></td>' + '<td><div class="marks "><span>' + quizmarks + '</span> MARKS</div></td><td><div class="timer marks">' + '<img src="img/time_spent.png">' + '<span class="questionTimer">0</span>' + '</div></td></tr></table>';	
	var languages = (typeof this.data.quizInfo.info.languages != "undefined")?this.data.quizInfo.info.languages:[];	
	if(languages.length > 1)	
		quizHTML  += '<span class="quizlanguage js-SelectQuizLanguage" data-languageselected="' + TestLanguageType.English + '">' +	
					 '<img src="img/eng-hindi.png"></span>';	
	quizHTML += '</div></div>';
	
	$(quizHTML).appendTo(".allQuiz");
};
appquizController.prototype.PopulateQuizData = function(res, quizId) {
	var qno = 0;
	var qdata,
	    myQuiz = 'active';
	var html = 	"<div class='question-status-info'>"+
					"<p class='correct-status'>CORRECT</p>"+
					"<p class='incorrect-status'>INCORRECT</p>"+
					"<p class='unattempted-status'>UNATTEMPTED</p>"+
				"</div>"+
				"<div class='question-status'>"+
				"<div class='questionsholder'>"+
				'<span class="glyphicon glyphicon-menu-left question-numberbtnleft"></span>'+
				"<div class='questionsslider'>";
	for (var i in res.questionData) {
		if (res.questionData[i].subtypeId == "0") {
			qno++;
			var state = "notvisited";
			if(typeof res.questionData[i].correct != 'undefined'){
				if(res.questionData[i].correct == '1'){
					state = "correct";
				}
				else if(res.questionData[i].correct == '0'){
					state = "incorrect";
				}
				else if(res.questionData[i].correct == '-1'){
					state = "unattempted";
				}
			}
			html += "<p class='question-number "+state+"' data-state='"+state+"' data-quesno='"+qno+"'>"+qno+"</p>";
			var qquestion = res.questionData[i].question.question;
			qquestion = qquestion.replace(/<inlineformula>/g, "\\(").replace(/<\/inlineformula>/g, "\\)").replace("/attachment/", "/attachment.php?id=").replace(/<formula>/g, "$$$$").replace(/<\/formula>/g, "$$$$");
			//qdata = '<div class="eachQuestion quesHidden item ' + myQuiz + '" ques-no="' + qno + '" ques-Id="' + i + '">' + 
			var englishQData = '<div class="selectQuesLang"';	
			if(typeof res.questionData[i].questionHindi != "undefined")	
				englishQData += ' language="english"';	
			englishQData += '>'+
					'<div class="ques-outer"><div class="ques-title"><span class="questnNo" data-curntQues="' + (qno + 1) + '">' + qno + '.</span></div>' + 
					'<div class="ques-question">' + qquestion + '</div></div>';
			for (var j in res.questionData[i].question.answers) 
			{
				var str = ""+res.questionData[i].question.answers[j].text;
				str = str.replace(/<inlineformula>/g, "\\(").replace(/<\/inlineformula>/g, "\\)").replace("/attachment/", "/attachment.php?id=").replace(/<formula>/g, "$$$$").replace(/<\/formula>/g, "$$$$");
				//qdata = qdata + '<label class="quizlabel">' + 
				englishQData = englishQData+ '<label class="quizlabel">' + 
									'<input type="radio" class="radioButton" name="' + quizId + '+' + i + '" ques-no="' + qno + '" value="' + j + '"/>' +
									 '<div class="labelDiv container">' + 
									 '<div class="indexpadding">' + String.fromCharCode(65 + parseInt(j)) + '</div>' + 
									 '<div class="option_msg">' + 
									 '<div class="radioText">' + str + '</div>' +  
									 '<div class="indicator"></div>' + 
									 '</div>' + '</div>' + '</label>';
			}
			//qdata = qdata + '<div><div class="solutionTab" id="js-solutionTab">' + '</div><div class="CheckAnsspacing"></div>' + '</div>';
			englishQData= englishQData + '<div><div class="solutionTab english" id="js-solutionTab">' + '</div><div class="CheckAnsspacing"></div>' + '</div></div>';	
				
			var hindiQData = "";	
			if(typeof res.questionData[i].questionHindi != "undefined")	
			{	
				var qquestion = res.questionData[i].questionHindi.question;	
				qquestion = qquestion.replace(/<inlineformula>/g, "\\(").replace(/<\/inlineformula>/g, "\\)").replace("/attachment/", "/attachment.php?id=").replace(/<formula>/g, "$$$$").replace(/<\/formula>/g, "$$$$");	
					
				var hindiQData = '<div class="selectQuesLang" language="hindi">' +	
						'<div class="ques-outer"><div class="ques-title"><span class="questnNo" data-curntQues="' + (qno + 1) + '">' + qno + '.</span></div>' + 	
						'<div class="ques-question">' + qquestion + '</div></div>';	
				for (var j in res.questionData[i].questionHindi.answers) 	
				{	
					var str = ""+res.questionData[i].questionHindi.answers[j].text;	
					str = str.replace(/<inlineformula>/g, "\\(").replace(/<\/inlineformula>/g, "\\)").replace("/attachment/", "/attachment.php?id=").replace(/<formula>/g, "$$$$").replace(/<\/formula>/g, "$$$$");	
					hindiQData = hindiQData+ '<label class="quizlabel">' + 	
										'<input type="radio" class="radioButton" name="' + quizId + '+' + i + '" ques-no="' + qno + '" value="' + j + '"/>' +	
										 '<div class="labelDiv container">' + 	
										 '<div class="indexpadding">' + String.fromCharCode(65 + parseInt(j)) + '</div>' + 	
										 '<div class="option_msg">' + 	
										 '<div class="radioText">' + str + '</div>' +  	
										 '<div class="indicator"></div>' + 	
										 '</div>' + '</div>' + '</label>';	
				}	
				hindiQData= hindiQData + '<div><div class="solutionTab hindi" id="js-solutionTab">' + '</div><div class="CheckAnsspacing"></div>' + '</div></div>';	
			}	
				
			qdata = '<div class="eachQuestion quesHidden item ' + myQuiz + '" ques-no="' + qno + '" ques-Id="' + i + '">' +	
					englishQData + hindiQData + '</div>';
					
			$(qdata).appendTo('.quiz_content');
			if (myQuiz == 'active') {
				myQuiz = '';
			}
		} else {
			for (var j in res.questionData[i].question.subQuestion) {
				qno++;
				var state = "notvisited";
				if(typeof res.questionData[i].question.subQuestion[j].correct != 'undefined'){
					if(res.questionData[i].question.subQuestion[j].correct == '1'){
						state = "correct";
					}
					else if(res.questionData[i].question.subQuestion[j].correct == '0'){
						state = "incorrect";
					}
					else if(res.questionData[i].question.subQuestion[j].correct == '-1'){
						state = "unattempted";
					}
				}
				//html += "<p class='question-number "+state+"' data-state='"+state+"' data-quesno='"+qno+"'>"+qno+"</p>";	
				html += "<p class='question-number "+state+"' data-state='"+state+"' data-quesno='"+qno+"'>"+qno+"</p>";
				var qcommonText = res.questionData[i].question.commonText;
				qcommonText = qcommonText.replace(/<br>/g, "").replace(/<inlineformula>/g, "\\(").replace(/<\/inlineformula>/g, "\\)").replace("/attachment/", "/attachment.php?id=").replace(/<formula>/g, "$$$$").replace(/<\/formula>/g, "$$$$");
				var sqquestion = res.questionData[i].question.subQuestion[j].question;
				
				
				//sqquestion = sqquestion.replace(/<br>/g, "").replace(/<inlineformula>/g, "\\(").replace(/<\/inlineformula>/g, "\\)").replace("/attachment/", "/attachment.php?id=").replace(/<formula>/g, "$$$$").replace(/<\/formula>/g, "$$$$");
				//qdata = '<div class="eachQuestion quesHidden item ' + myQuiz + '" ques-no="' + qno + '" ques-Id="' + i + '" subques-no="' + j + '">' + '<div class="ques-outer"><div class="ques-title"><span class="questnNo"  data-curntQues="' + (qno + 1) + '">' + qno + '.</span></div>' + '<div class="ques-question">' + qcommonText + '</div></div>' + '<div class="ques-question">' + sqquestion + '</div>' + '<div class="subques-question" subques-no="' + j + '"></div>';
				sqquestion = sqquestion.replace(/<br>/g, "").replace(/<inlineformula>/g, "\\(").replace(/<\/inlineformula>/g, "\\)").replace("/attachment/", "/attachment.php?id=").replace(/<formula>/g, "$$$$").replace(/<\/formula>/g, "$$$$"); 	
				var englishQData = '<div class="selectQuesLang"';	
					
				var qInHindi = (typeof res.questionData[i].questionHindi != "undefined" && typeof res.questionData[i].questionHindi.commonText != "undefined")?true:false;	
				console.log({"qInHindi": qInHindi});	
				if(qInHindi)	
					englishQData += 'language="english"';	
				englishQData += '>' +	
					'<div class="ques-outer"><div class="ques-title"><span class="questnNo"  data-curntQues="' + (qno + 1) + '">' + qno + '.</span></div>' + 	
					'<div class="ques-question">' + qcommonText + '</div></div>' + 	
					'<div class="ques-question">' + sqquestion + '</div>' + '<div class="subques-question" subques-no="' + j + '"></div>';
					
				for (var k in res.questionData[i].question.subQuestion[j].answers) {
					var str = ""+res.questionData[i].question.subQuestion[j].answers[k].text;
					str = str.replace(/<inlineformula>/g, "\\(").replace(/<\/inlineformula>/g, "\\)").replace("/attachment/", "/attachment.php?id=").replace(/<formula>/g, "$$$$").replace(/<\/formula>/g, "$$$$");
					//qdata = qdata + '<label class="quizlabel">' + '<input class="radioButton" type="radio" name="' + quizId + '+' + i + '+' + j + '" ques-no="' + qno + '" value="' + k + '"/>' + '<div class="labelDiv container">' + '<div class="indexpadding">' + String.fromCharCode(65 + parseInt(k)) + '</div>' + '<div class="option_msg">' + '<div class="radioText">' + str + '</div>' + '<div class="indicator"></div>' + '</div>' + '</div>' + '</label>';
				//}
				//qdata = qdata + '<div class="solutionTab" id="js-solutionTab">' + '</div><div class="CheckAnsspacing"></div>' + '</div>' + '</div>';
					englishQData = englishQData + '<label class="quizlabel">' + '<input class="radioButton" type="radio" name="' + quizId + '+' + i + '+' + j + '" ques-no="' + qno + '" value="' + k + '"/>' + '<div class="labelDiv container">' + '<div class="indexpadding">' + String.fromCharCode(65 + parseInt(k)) + '</div>' + '<div class="option_msg">' + '<div class="radioText">' + str + '</div>' + '<div class="indicator"></div>' + '</div>' + '</div>' + '</label>';	
				}	
				englishQData = englishQData + '<div class="solutionTab english" id="js-solutionTab">' + '</div><div class="CheckAnsspacing"></div>' + '</div>';	
				var hindiQData = '';	
				if(qInHindi)	
				{	
					console.log(res.questionData[i]);	
					var qcommonText = res.questionData[i].questionHindi.commonText;	
					qcommonText = qcommonText.replace(/<br>/g, "").replace(/<inlineformula>/g, "\\(").replace(/<\/inlineformula>/g, "\\)").replace("/attachment/", "/attachment.php?id=").replace(/<formula>/g, "$$$$").replace(/<\/formula>/g, "$$$$");	
					var sqquestion = res.questionData[i].questionHindi.subQuestion[j].question;	
					sqquestion = sqquestion.replace(/<br>/g, "").replace(/<inlineformula>/g, "\\(").replace(/<\/inlineformula>/g, "\\)").replace("/attachment/", "/attachment.php?id=").replace(/<formula>/g, "$$$$").replace(/<\/formula>/g, "$$$$"); 	
					hindiQData = '<div class="selectQuesLang" language="hindi">' +	
						'<div class="ques-outer"><div class="ques-title"><span class="questnNo"  data-curntQues="' + (qno + 1) + '">' + qno + '.</span></div>' + 	
						'<div class="ques-question">' + qcommonText + '</div></div>' + 	
						'<div class="ques-question">' + sqquestion + '</div>' + '<div class="subques-question" subques-no="' + j + '"></div>';	
					for (var k in res.questionData[i].questionHindi.subQuestion[j].answers) {	
						var str = ""+res.questionData[i].questionHindi.subQuestion[j].answers[k].text;	
						str = str.replace(/<inlineformula>/g, "\\(").replace(/<\/inlineformula>/g, "\\)").replace("/attachment/", "/attachment.php?id=").replace(/<formula>/g, "$$$$").replace(/<\/formula>/g, "$$$$");	
						hindiQData = hindiQData + '<label class="quizlabel">' + '<input class="radioButton" type="radio" name="' + quizId + '+' + i + '+' + j + '" ques-no="' + qno + '" value="' + k + '"/>' + '<div class="labelDiv container">' + '<div class="indexpadding">' + String.fromCharCode(65 + parseInt(k)) + '</div>' + '<div class="option_msg">' + '<div class="radioText">' + str + '</div>' + '<div class="indicator"></div>' + '</div>' + '</div>' + '</label>';	
					}	
					hindiQData = hindiQData + '<div class="solutionTab hindi" id="js-solutionTab">' + '</div><div class="CheckAnsspacing"></div>' + '</div>' + '</div>';	
				}	
					
				qdata = '<div class="eachQuestion quesHidden item ' + myQuiz + '" ques-no="' + qno + '" ques-Id="' + i + '" subques-no="' + j + '">' +	
					englishQData + hindiQData + '</div>';
				
				
				$(qdata).appendTo('.quiz_content');
				if (myQuiz == 'active') {
					myQuiz = '';
				}
			}
		}
	}
	html += "</div>"+
			'<span class="glyphicon glyphicon-menu-right question-numberbtnright"></span>'+
			"</div>";
	html +=	"<div class='submitBtn'><button class='quiz-submit submit btn btn-default'>Submit Quiz</button></div>";
	$("#quiz-status-modal").find('.modal-body').html(html);
	MathJax.Hub.Queue(["Typeset", MathJax.Hub]);
	$('#quiz-status-modal').find('.statusbody').find('p[data-quesno='+QuestionPosition+']').removeClass('notvisited correct incorrect unattempted').addClass('current');
	
	tr$.appendRemoteHost($('#myQuiz'));
};
appquizController.prototype.incrementSeconds = function() {
	if (this.timer.TimeCountCheck) {
		this.timer.seconds += 1;
		if (this.timer.seconds < 60) {
			$('.timer .questionTimer').html(this.timer.seconds + " SECS");
		} else if (this.timer.seconds / 60 < 60) {
			$('.timer .questionTimer').html(parseInt(this.timer.seconds / 60) + " MINS " + this.timer.seconds % 60 + " SECS");
		} else {
			$('.timer .questionTimer').html(parseInt(this.timer.seconds / (60 * 60)) + " HRS " + this.timer.seconds(this.timer.seconds / 60) + " MINS " + this.timer.seconds % 60 + " SECS");
		}
	}
};
appquizController.prototype.BindEvents = function()
{
	$(this.dom).find('.quiz-header').find('.closeBtn').unbind().bind("click", this, function(e){
		e.data.timer.seconds = 0;
		clearInterval(e.data.timer.cancel);
		clearInterval(e.data.timer.questionTimer);
		if (viewFromNotification && UrlMgmt.getObj().actionStack.length == 1){
			viewFromNotification = false;
			UrlMgmt.getObj().PopView(function(){
				UrlMgmt.getObj().Route({route: 'common/home', needData: true, offlineAllowed: true});
			});			
		}
		else{
			UrlMgmt.getObj().PopView();
		}
	});
	//new code  start
	$(this.dom).find('.quiz-patti ').find('.js-SelectQuizLanguage').unbind().bind("click", this, function(e){	
		var selectedLanguage = $(this).attr("data-languageselected");	
		if(selectedLanguage == TestLanguageType.English)	
		{	
			$(this).attr("data-languageselected", TestLanguageType.Hindi);	
			$(this).find("img").attr('src', "img/hindi-eng.png");	
			$(e.data.dom).find('.eachQuestion [language="english"]').hide();	
			$(e.data.dom).find('.eachQuestion [language="hindi"]').show();	
		}	
		else	
		{	
			$(this).attr("data-languageselected", TestLanguageType.English);	
			$(this).find("img").attr('src', "img/eng-hindi.png");	
			$(e.data.dom).find('.eachQuestion [language="english"]').show();	
			$(e.data.dom).find('.eachQuestion [language="hindi"]').hide();	
		}	
	});
	//new code end
	
	$('.showQuesStatus').unbind().bind('click', function(){
		$('#quiz-status-modal').modal('show');
		//Question pallete slider
		if($('#quiz-status-modal').find('.statusbody').find(".questionsholder").length > 0){
			setTimeout(function(){
				slider("questionsholder","questionsslider","question-number");
			},200);
		}
	});
	this.TimeMgmt();
	
	//to check whether the Quiz is in resume state and start from the paused quiz question
	if(typeof this.data.quizSession.state !== undefined && this.data.quizSession.state == 1) {
		var nthquestion = parseInt(this.data.quizSession.lastQuestion);
		$('#myQuiz').carousel(nthquestion);
		$('#myQuiz').carousel('pause');
	}
	$(this.dom).find(".quizlabel").unbind().bind("change", this, function(e) {
		var current = $(e.data.dom).find(".item.active");
		
		var time = e.data.timer.seconds;
		e.data.takenTempTime = time;
		e.data.timer.seconds = 0;
		clearInterval(e.data.timer.cancel);
		clearInterval(e.data.timer.questionTimer);
		$(current).find(".quizlabel").unbind('change');
		$(current).find(".quizlabel").addClass("no_hover");
		var quesid = $(current).attr("ques-id");
		var option = $(current).find("input[type=radio]:checked").val();
		var quesno = $(current).attr("ques-no");
		var name = $(current).find("input[type=radio]:checked").attr('name');
		name = name.split("+");
		if ( typeof name[2] !== 'undefined') {
			var subquesno = name[2];
		} else {
			var subquesno = -1;
		}
		submit = (e.data.data.quizInfo.info.totalQuestions == QuestionPosition) ? 1 : 0;
		flag = true;
		var session = e.data.data.quizSession.id;
		
		var requestParams = {
			questionId: quesid,
			userAns: option,
			quesno: quesno,
			subquesno: subquesno,
			submit: submit,
			flag: flag,
			sessionId: session,
			timeTaken: time
		};
		e.data.SubmitQuestion(requestParams, function(response){
			try{
				if (response.result.state == "ok") {
					if (response.data.correct == 1) {
						$(current).find("input[value='" + response.data.answer + "'] ~ .labelDiv").addClass("correct");
						$(current).find(".labelDiv.correct").find(".indicator").addClass("glyphicon glyphicon-ok");
						$('#quiz-status-modal').find('.statusbody').find('p[data-quesno='+quesno+']').removeClass('notvisited current incorrect unattempted').addClass('correct');
					} else {
						$(current).find("input[value='" + option + "'] ~ .labelDiv").addClass("wrong");
						$(current).find("input[value='" + response.data.answer + "'] ~ .labelDiv").addClass("correct");
						$(current).find(".correct").find(".indicator").addClass("glyphicon glyphicon-ok");
						$(current).find(".wrong").find(".indicator").addClass("glyphicon glyphicon-remove");
						$('#quiz-status-modal').find('.statusbody').find('p[data-quesno='+quesno+']').removeClass('notvisited correct current unattempted').addClass('incorrect');
					}
					if (!submit) {
						$(e.data.dom).find(".nextQuestion").css('display', 'inline');
					} else {
						$(e.data.dom).find(".nextQuestion").hide();
						$(e.data.dom).find('.questionNavigation').find('.quiz-submit').show();
					}
					
					
					//var str = response.data.solution;
					//if ( typeof str == "object")
					//	str = str[0];
					//str = ""+str;
					//str = str.replace(/<inlineformula>/g, "\\(").replace(/<\/inlineformula>/g, "\\)").replace("/attachment/", "/attachment.php?id=").replace(/<formula>/g, "$$$$").replace(/<\/formula>/g, "$$$$");
					$(current).find(".solutionTab").hide();
					// if (str != "") {
						// $(e.data.dom).find(".checkSolution").show();
						// $(current).find(".solutionTab").html("<hr><h3 style='color:#1A94BA;'>Solution:<h3>" + str + "<hr>");
						// $(current).find(".solutionTab img").addClass("img-responsive");
						// MathJax.Hub.Queue(["Typeset", MathJax.Hub]);
					// }
					$(e.data.dom).find(".checkSolution").hide();	
					var englishSolution = response.data.solution;	
					if ( typeof englishSolution == "object")	
						englishSolution = englishSolution[0];	
					englishSolution = (typeof englishSolution == "undefined")?"":englishSolution;	
					englishSolution = englishSolution.replace(/<inlineformula>/g, "\\(").replace(/<\/inlineformula>/g, "\\)").replace("/attachment/", "/attachment.php?id=").replace(/<formula>/g, "$$$$").replace(/<\/formula>/g, "$$$$");	
					if (englishSolution != "") {	
						$(current).find(".solutionTab.english").html("<hr><h3 style='color:#1A94BA;'>Solution:<h3>" + englishSolution + "<hr>");	
					}	
						
					var hindiSolution = response.data.solutionHindi;	
					if ( typeof hindiSolution == "object")	
						hindiSolution = hindiSolution[0];	
					hindiSolution = (typeof hindiSolution == "undefined")?"":hindiSolution;	
					hindiSolution = hindiSolution.replace(/<inlineformula>/g, "\\(").replace(/<\/inlineformula>/g, "\\)").replace("/attachment/", "/attachment.php?id=").replace(/<formula>/g, "$$$$").replace(/<\/formula>/g, "$$$$");	
					if (hindiSolution != "") {	
						$(current).find(".solutionTab.hindi").html("<hr><h3 style='color:#1A94BA;'>Solution:<h3>" + hindiSolution + "<hr>");	
					}	
					if(englishSolution.length != 0 || hindiSolution.length != 0)	
					{	
						$(e.data.dom).find(".checkSolution").show();	
						$(current).find(".solutionTab img").addClass("img-responsive");	
						MathJax.Hub.Queue(["Typeset", MathJax.Hub]);	
					}
				}
			}
			catch(e){
				console.log("Exception: "+e);
			}
		});
	});
	$(".nextQuestion").unbind().bind("click", this, function(e) {
		if(!UrlMgmt.getObj().App.isOnline){
			UrlMgmt.getObj().App.onOffline();
			return false;
		}
		e.data.takenTempTime = undefined;
		var current = $('.eachQuestion.quesHidden.item.active');
		var option = $(current).find("input[type=radio]:checked").val();
		if(option == undefined){
			option = -1;
			var time = e.data.timer.seconds;
			e.data.timer.seconds = 0;
			clearInterval(e.data.timer.cancel);
			clearInterval(e.data.timer.questionTimer);
			$(current).find("label").unbind('click');
			$(current).find("label").addClass("no_hover");
			var quesid = $(current).attr("ques-id");
		
			var quesno = $(current).attr("ques-no");
			var name = $($(current).find("input[type=radio]")[0]).attr('name');
			name = name.split("+");
			if (typeof name[2] !== 'undefined') {
				var subquesno = name[2];
			} else {
				var subquesno = -1;
			}
			submit = (e.data.data.quizInfo.info.totalQuestions == QuestionPosition) ? 1 : 0;
			flag = true;
			var session = e.data.data.quizSession.id;
			var requestParams = {
				questionId: quesid,
				userAns: option,
				quesno: quesno,
				subquesno: subquesno,
				submit: submit,
				flag: flag,
				sessionId: session,
				timeTaken: time
			};
				
			e.data.SubmitQuestion(requestParams, function(response){
				try{
					if(response.result.state == "ok"){
						if($('#quiz-status-modal').find('.statusbody').find('p[data-quesno='+QuestionPosition+']').hasClass('current')){
							$('#quiz-status-modal').find('.statusbody').find('p[data-quesno='+QuestionPosition+']').removeClass('notvisited correct incorrect current').addClass('unattempted');
						}
						QuestionPosition++;
						$('#quiz-status-modal').find('.statusbody').find('p[data-quesno='+QuestionPosition+']').removeClass('notvisited correct incorrect unattempted').addClass('current');
						if(QuestionPosition == this.data.data.quizInfo.info.totalQuestions){
							$(this.data.dom).find(".nextQuestion").hide();
							$(this.data.dom).find('.questionNavigation').find(".quiz-submit").show();
						}
						
						$(this.event).siblings('.checkSolution').hide();
						$(this.data.dom).find('#myQuiz').carousel("next");
						$(this.data.dom).find('#myQuiz').carousel("pause");
						$('.quiz-patti .description .ongoingQues .quizquestnno').html(QuestionPosition);
						
						this.data.TimeMgmt();
					}	
				}
				catch(ex){
					console.log("Exception: "+ex);
				}
			}.bind({data:e.data, event:this}));
		}
		else{
			QuestionPosition++;
			$('#quiz-status-modal').find('.statusbody').find('p[data-quesno='+QuestionPosition+']').removeClass('notvisited correct incorrect unattempted').addClass('current');
			if(QuestionPosition == e.data.data.quizInfo.info.totalQuestions){
				$(this).hide();
				$(e.data.dom).find(".quiz-submit").show();
			}
			$(this).siblings('.checkSolution').hide();
			$(e.data.dom).find('#myQuiz').carousel("next");
			$(e.data.dom).find('#myQuiz').carousel("pause");
			$('.quiz-patti .description .ongoingQues .quizquestnno').html(QuestionPosition);
			e.data.TimeMgmt();
		}
	});
	// $('.checkSolution').unbind().bind('click', this, function(e) {
		// $('.eachQuestion.active .solutionTab').show();
		// tr$.appendRemoteHost($('.eachQuestion.active .solutionTab'));
		// var sdiff = $('.eachQuestion.active').scrollTop();
		// var dist = $('.eachQuestion.active').find(".solutionTab").position(0).top;
		// $(e.data.dom).animate({
			// scrollTop : (dist + sdiff)
		// }, 1000);
		// $('.checkSolution').hide();
	// });

	$('.checkSolution').unbind().bind('click', this, function(e) {	
		var hindiAndEnglish = $(".quiz-head").find(".js-SelectQuizLanguage").length;	
		var hindiSolutionAvailable = $('.eachQuestion.active .solutionTab.hindi').length;	
		var selectedLanguage = parseInt($(".quiz-head").find(".js-SelectQuizLanguage").attr("data-languageselected"));	
			
		$('.eachQuestion.active .solutionTab').show();	
		var dist = 0;	
		if(hindiAndEnglish && hindiSolutionAvailable && selectedLanguage == TestLanguageType.Hindi)	
		{	
			tr$.appendRemoteHost($('.eachQuestion.active .solutionTab.hindi'));	
			dist = $('.eachQuestion.active').find(".solutionTab.hindi").position(0).top;	
		}	
		else if(selectedLanguage == TestLanguageType.English)	
		{	
			tr$.appendRemoteHost($('.eachQuestion.active .solutionTab.english'));	
			dist = $('.eachQuestion.active').find(".solutionTab.english").position(0).top;	
		}	
			
		var sdiff = $('.eachQuestion.active').scrollTop();	
		$(e.data.dom).animate({	
			scrollTop : (dist + sdiff)	
		}, 1000);	
		$('.checkSolution').hide();	
	});
	
	$('.quiz-submit').unbind().bind('click', function(e) {
		if(this.submitted == true){
			return;
		}
		this.submitted = true;
		$('#quiz-status-modal').modal('hide');
		if(!UrlMgmt.getObj().App.isOnline){
			UrlMgmt.getObj().App.onOffline();
			return false;
		}
		var current = $(this.dom).find(".item.active");
		var option = $(current).find("input[type=radio]:checked").val();
		if(option == undefined){
			option = -1;
		}
		var time = this.takenTempTime;
		if(typeof time == 'undefined' || this.timer.seconds > time){
			time = this.timer.seconds;
		}
		clearInterval(this.timer.cancel);
		clearInterval(this.timer.questionTimer);
		$(current).find("label").unbind('click');
		$(current).find("label").addClass("no_hover");
		var quesid = $(current).attr("ques-id");
	
		var quesno = $(current).attr("ques-no");
		var name = $($(current).find("input[type=radio]")[0]).attr('name');
		name = name.split("+");
		if ( typeof name[2] !== 'undefined') {
			var subquesno = name[2];
		} else {
			var subquesno = -1;
		}
		submit = 1;
		flag = true;
		var session = this.data.quizSession.id;
		var requestParams = {
			questionId: quesid,
			userAns: option,
			quesno: quesno,
			subquesno: subquesno,
			submit: submit,
			sessionId: session,
			timeTaken: time,
			lastQues: $(this.dom).find(".item").length
		};
		var quizId = this.data.quizInfo.id;
		this.SubmitQuestion(requestParams, function(response){
			try{
				if(response.result.state == "ok"){
					UrlMgmt.getObj().PopView(function(){
						UrlMgmt.getObj().Route({
							route : "app/quizreport&id="+quizId,
							needData : false
						});	
					});
				}	
			}
			catch(ex){
				console.log("Exception: "+ex);
			}
		});
	}.bind(this));
};
appquizController.prototype.SubmitQuestion = function(requestParams, callback)
{
	tr$.ajax({
		mod : "tr2dquiz",
		ack : "checkAnswer",
		additionalParams : requestParams,
		successClb : function(response) {
			try {
				callback(response);
			}
			catch(e){
				console.log("error=" + e);
			}
		},
		errorClb : function() {
			//TODO show some relavent msg
		}
	});
};
appquizController.prototype.CheckAnswer = function(seconds) {
	$('.eachQuestion.quesHidden.item.active').find("label").unbind('click');
	$('.eachQuestion.quesHidden.item.active').find("label").css('pointer-events', 'none');
	$('.eachQuestion.quesHidden.item.active').find("label").addClass("no_hover");
	var quesId = $('.eachQuestion.quesHidden.item.active').attr('ques-id');
	var checkedOption = $('.eachQuestion.quesHidden.item.active').find("label").find("input[type=radio]:checked");
	var checkedAns = checkedOption.val();
	var quesno = $(checkedOption).attr('ques-no');
	var name = $(checkedOption).attr('name');
	name = name.split("+");
	if ( typeof name[2] !== 'undefined') {
		var subquesno = name[2];
	}
	var submit = ($(checkedOption).attr('ques-no') == Total_questions) ? 1 : 0;

	tr$.ajax({
		mod : "tr2dquiz",
		ack : "checkAnswer",
		additionalParams : {
			sessionId : this.data.quizSession.id,
			quesno : quesno,
			submit : submit,
			subquesno : subquesno,
			userAns : checkedAns,
			questionId : quesId,
			timeTaken : seconds
		},
		successClb : function(response) {
			try {
				if (response.result.state == "ok") {
					var str = response.data.solution;
					if(typeof str == "object")
						str = str[0];
					str = ""+str;
					str = str.replace(/<inlineformula>/g, "\\(").replace(/<\/inlineformula>/g, "\\)").replace("/attachment/", "/attachment.php?id=").replace(/<formula>/g, "$$$$").replace(/<\/formula>/g, "$$$$");
					if ($('.eachQuestion.quesHidden.item.active').find(".subques-question").length > 0) {
						$('.eachQuestion.quesHidden.item.active').find(".subques-question").find(".solutionTab").hide();
					} else {
						$('.eachQuestion.quesHidden.item.active').find(".solutionTab").hide();
					}
					if (response.data.correct != null) {
						if ($('.eachQuestion.quesHidden.item.active').find(".subques-question").length > 0) {
							if (response.data.correct == 1) {
								$('.eachQuestion.quesHidden.item.active').find(".subques-question").find('.quizlabel').find('.labelDiv.container.selected').addClass('correct');
								$('.eachQuestion.quesHidden.item.active').find(".subques-question").find('.quizlabel').find('.labelDiv.container.selected').removeClass('selected');
							} else {
								$('.eachQuestion.quesHidden.item.active').find(".subques-question").find('.quizlabel').find('.labelDiv.container.selected').addClass('wrong');
								$('.eachQuestion.quesHidden.item.active').find(".subques-question").find('.quizlabel').find('.labelDiv.container.selected').removeClass('selected');
								$('.eachQuestion.quesHidden.item.active').find(".subques-question").find(".quizlabel.no_hover").eq(response.data.answer).find('.labelDiv.container').addClass('correct');
								;
							}
							if(str != "" && str != null )
					    		{
					    			$('.eachQuestion.quesHidden.item.active').find(".subques-question").find(".solutionTab").html("<hr><h3 class=\"solution_heading\" style='color:#e48f2a;'>Solution:<h3>"+str+"<hr>");	
					    		}
					    		else
					    		{
					    			$('.eachQuestion.quesHidden.item.active').find(".subques-question").find(".solutionTab").html("<hr><h3 class=\"solution_heading\" style='color:#e48f2a;'>Solution Not Available<h3><hr>");		
					    		}
							tr$.appendRemoteHost($('.eachQuestion.quesHidden.item.active').find(".subques-question").find(".solutionTab"));
							$('.eachQuestion.quesHidden.item.active').find(".subques-question").find(".checkSolution").show();
						} else {
							if (response.data.correct == 1) {
								$('.eachQuestion.quesHidden.item').find('.quizlabel').find('.labelDiv.container.selected').addClass('correct');
								$('.eachQuestion.quesHidden.item').find('.quizlabel').find('.labelDiv.container.selected').removeClass('selected');
							} else {
								$('.eachQuestion.quesHidden.item').find('.quizlabel').find('.labelDiv.container.selected').addClass('wrong');
								$('.eachQuestion.quesHidden.item').find('.quizlabel').find('.labelDiv.container.selected').removeClass('selected');
								$('.eachQuestion.quesHidden.item.active').find(".quizlabel.no_hover").eq(response.data.answer).find('.labelDiv.container').addClass('correct');
								;
							}
							if(str != "" && str != null )
				    		{
				    			$('.eachQuestion.quesHidden.item.active').find(".solutionTab").html("<hr><h3 class=\"solution_heading\" style='color:#e48f2a;'>Solution:<h3>"+str+"<hr>");
				    		}
				    		else
				    		{
				    			$('.eachQuestion.quesHidden.item.active').find(".solutionTab").html("<hr><h3 class=\"solution_heading\" style='color:#e48f2a;'>Solution Not Available<h3><hr>");		
				    		}
							tr$.appendRemoteHost($('.eachQuestion.quesHidden.item.active').find(".solutionTab"));
							$('.eachQuestion.quesHidden.item.active').find(".checkSolution").show();
						}

						//$('.eachQuestion.quesHidden.item.active').find(".solutionTab").html("<hr><h3 style='color:#e48f2a;'>Solution:<h3>"+str+"<hr>");
						MathJax.Hub.Queue(["Typeset", MathJax.Hub]);
					}
					$('.labelDiv.correct .option_msg .indicator').html('<img src="img/quiz_correct.png">');
					$('.labelDiv.correct .option_msg .message').html('Correct Answer');
					$('.labelDiv.wrong .option_msg .indicator').html('<img src="img/quiz_wrong.png">');
					$('.labelDiv.wrong .option_msg .message').html('Your Answer');
				}
			} catch(e) {
				console.log("error=" + e);
			}
		}.bind(this),
		errorClb : function() {
			//TODO show some relavent msg
		}
	});
};
appquizController.prototype.QuestionTimer = function(quizid)
{
	var currentPointer = parseInt(QuestionPosition) - 1;
	var itemId = $($("#myQuiz").find('.item')[currentPointer]).attr('ques-id');
	var time = parseInt(this.data.questionData[itemId].time);
	$('.progress-div').width('inherit');
	$('.time-progress').width('inherit');
	$('.time-progress').css('background', 'linear-gradient(to right,#37BFDE,#17EB9A)');
	var totalSecs = parseInt(time);
	this.timer.questionTimer = setInterval(function() {
		this.timer.seconds += 1;
		totalSecs = parseInt(totalSecs) - 1;
		var mins =  parseInt(totalSecs / 60);
		var secs = parseInt(totalSecs % 60);
		var hrs =  parseInt(mins / 60);
		mins = parseInt(mins % 60);
		
		if(hrs<10){
			hrs = '0'+hrs;
		}
		if(mins<10){
			mins = '0'+mins;
		}
		if(secs<10){
			secs = '0'+secs;
		}
		var html = "";
		if(hrs > 0){
			html += hrs + " HRS ";
		}
		if(mins > 0){
			html += mins + " MINS ";
		}
		html += secs + " SECS";
		$('.timer .questionTimer').html(html);
		var totalWidth = $(this.dom).find('.progress-div').width();
		var secWidth = totalWidth/time;
		var newWidth = $(this.dom).find('.time-progress').width() - (secWidth);
		$('.time-progress').css('width', newWidth+"px");
		
		if(totalSecs <= 10){
			$('.time-progress').css('background', 'linear-gradient(to right, red, #FFFF00)');
		}
	  	if(totalSecs <= 0){
	  		$('.timer .questionTimer').html(html);
	  		$('.time-progress').css('width', '0px');
	  		setTimeout(function(){
	  			alert("Time's up !!");
	  		}, 10);
	  		$('#quiz-status-modal').modal('hide');
			clearInterval(this.timer.questionTimer);
			if(parseInt(QuestionPosition) == parseInt(this.data.quizInfo.info.totalQuestions)){
				$('.quiz-submit').click();
			}
			else{
				$(".nextQuestion").click();
			}
		}
	}.bind(this), 1000);
};
appquizController.prototype.TimeMgmt = function(){
	var quizid = this.data.quizInfo.id;
	clearInterval(this.timer.cancel);
	clearInterval(this.timer.questionTimer);
	if(this.data.quizInfo.quesTimeRestriction == 1){
		//Time restriction is there, display time left
		$('.progress-div').show();
		this.QuestionTimer(quizid);
	}
	else{
		//No time restriction, display time spent
		$('.progress-div').hide();
		this.timer.cancel = setInterval(this.incrementSeconds.bind(this), 1000);
		this.timer.TimeCountCheck = true;
	}
};