var appquizreportController = function() {
	this.view = "default";
	this.style = "default";
	this.dom = null;
	this.id = 0;
	this.data = null;
};
appquizreportController.prototype.Init = function(viewDom) {
	this.dom = viewDom;
	UrlMgmt.getObj().viewRefreshrequired = true;
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.showLoader();
	this.SetLayout();
	if (!UrlMgmt.getObj().App.isOnline) {
		this.OfflineInit();
	} else {
		this.OnlineInit();
	}
	urlMgmt.removeLoader();
};
appquizreportController.prototype.SetLayout = function() {
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.lockRotation();
	urlMgmt.menuAction.view.hide();
	urlMgmt.headerAction.view.hide();
};
appquizreportController.prototype.OfflineInit = function() {
	Factory.getObj().LoadViewForOffline(this);
};
appquizreportController.prototype.OnlineInit = function() {
	if ($(this.dom).find(".tryagain").length != 0)
		$(this.dom).find(".tryagain").remove();
	this.GetReportdata();
};

appquizreportController.prototype.GetReportdata = function() {
	$.ajax({
		type : "POST",
		url : remoteServer + "/?route=common/ajax",
		data : {
			mod : "tr2dquiz",
			ack : "getReportData",
			quizid : this.id,
		},
		xhrFields : {
			withCredentials : true
		},
		crossDomain : true,
		complete : function(reply) {
			var response = reply.responseJSON;
			this.data = response.data;
			this.PopulateViewQuizreport();
		}.bind(this)
	});
};
appquizreportController.prototype.TimeCalculating = function(time) {
	if(time < 0){
		time = 0;
	}
	if (time < 60) {
		return (time + " SECS");
	} else if (time / 60 < 60) {
		return (parseInt(time / 60) + " MINS " + time % 60 + " SECS");
	} else {
		return (parseInt(time / (60 * 60)) + " HRS " + time(time / 60) + " MINS " + time % 60 + " SECS");
	}
};
appquizreportController.prototype.PopulateViewQuizreport = function()
{
	var html = 	"<div class='question-status-info'>"+
					"<p class='correct-status'>CORRECT</p>"+
					"<p class='incorrect-status'>INCORRECT</p>"+
					"<p class='unattempted-status'>UNATTEMPTED</p>"+
				"</div>"+
				"<div class='question-status'>"+
				"<div class='questionsholder'>"+
				'<span class="glyphicon glyphicon-menu-left question-numberbtnleft"></span>'+
				"<div class='questionsslider'>";
	var totalMarks = 0,
	    totalQuestion = 0,
	    totaltimeSpent = 0;
    var correct = 0;
    var incorrect = 0;
    var unattempted = 0;
	if (this.data.reportAnswer != null) {
		for (var i in this.data.reportAnswer) {
			for(var j in this.data.reportAnswer[i]){
				var data = this.data.reportAnswer[i][j];
				totalQuestion++;
				var state = "notvisited";
				if(typeof data.correct != 'undefined'){
					if(data.correct == '1'){
						state = "correct";
						correct++;
					}
					else if(data.correct == '0'){
						state = "incorrect";
						incorrect++;
					}
					else if(data.correct == '-1'){
						state = "unattempted";
						unattempted++;
					}
				}
				html += "<p class='question-number "+state+"' data-state='"+state+"' data-quesno='"+totalQuestion+"'>"+totalQuestion+"</p>";
				if (data.correct == "1") {
					totalMarks++;
				}
				if(data.timeConsumed != null){
					totaltimeSpent += parseInt(data.timeConsumed);
				}
				var accuracy = Math.round(Math.round((parseFloat((totalMarks / totalQuestion) * 100)) * 100) / 100);
				$('.quiztitle').html(this.data.title.title);
				$('.attempted_Date').html(' Attempted on ' + tr$.dateFormatWithYear(this.data.updatedtime.updatedOn) + '<img src="img/quiz_correct.png">');
				$('.qreport_marks').html(totalMarks + ' Marks');
				$('.qreport_no_questions').html(totalQuestion + ' Qusestions');
				$('.qtime').html('<img src="img/quiz_timer.png">'+' Total Time Spent '+this.TimeCalculating(totaltimeSpent));
				$('.quiz_action_div').html('<button class="btn btn-primary reviewQuiz" data-action="app/quizreview&id=' + this.id + '">Review Question</button>');
				$('.reviewQuiz').unbind().bind('click', function() {
					if(!UrlMgmt.getObj().App.isOnline){
						UrlMgmt.getObj().App.onOffline();
						return false;
					}
					UrlMgmt.getObj().Route({
						route : $(this).data('action'),
						needData : false
					});
				});
			}
		}
		var accuracy = 0;
		if(totalQuestion-unattempted > 0){
			accuracy = (parseFloat((totalMarks / (totalQuestion-unattempted)) * 100).toFixed(2));
		}
		$('.qreport_accuracygraph').html('<span>' + accuracy + '%' + '</span>');
		$('.qreport_Incorrectgraph').html('<span>' + (incorrect) + '/' + totalQuestion + '</span>');
		$('.qreport_correctgraph').html('<span>' + totalMarks + '/' + totalQuestion + '</span>');
		$('.qreport_unattemptedgraph').html('<span>' + unattempted + '/' + totalQuestion + '</span>');
			
		html += "</div>"+
			'<span class="glyphicon glyphicon-menu-right question-numberbtnright"></span>'+
			"</div>";
		this.dom.find('.question-pallete').html(html);
	}
	//Question pallete slider
	if($(this.dom).find('.question-pallete').find(".questionsholder").length > 0){
		setTimeout(function(){
			slider("questionsholder","questionsslider","question-number");
		},200);
	}
	$(this.dom).find('.quiz-header').find('.closeBtn').unbind().bind("click", this, function(e){
		UrlMgmt.getObj().PopView(function(){
			var len = UrlMgmt.getObj().actionStack.length;
			if(len == 0){
				UrlMgmt.getObj().Route({route: "common/home", needData: true, offlineAllowed: true});
			}
		});
	});
};