var apptbsetestController = function()
{
	this.view = "default";
	this.style = "default";
	this.dom = null;
	this.data = null;
	this.id = 0;
	
	this.meta = [];
	this.sessionID = -1;
	this.questionOrder = [];
	this.userActivity = [];
	this.ansOrder = [];
	this.sectionName=[];
	this.startNewQuestionAt = "";
	this.ShowingQuestionNo = -1;
	this.submited = false;
	this.startedAt = "";
	this.pauseTime = "";
	if(this.totalTime == undefined)
		this.totalTime = $("#_totalTime_").text() * 60 * 1000;
	this.pandingForSave = {};
	this.paused = false;
	this.passedTime = 0;
	this.lastRes = -1;
	this.testId = null;
	this.tr2TestId = null;
	this.testState = null;
	this.parent = null;
	this.languageOptions = null;
	this.language = null;
	this.pauseDuration = 0;
	this.currentSectionId = 0;
};
apptbsetestController.prototype.Init = function(viewDom)
{
	this.dom = viewDom;
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.lockRotation();
	urlMgmt.menuAction.view.hide();
	//TODO: Header Change
	urlMgmt.headerAction.view.hide();//controler.DisplayHeader(this.dom, 'HOME', true, false, true);
};
apptbsetestController.prototype.LoadTest = function()
{
	loadExistingData({entity: "downloadtestdata", recordId: this.testId}, function(data){
		$('#testData').html($(data));
		//Load meta
		loadExistingData({entity: "testmeta", recordId: this.testId, fileErrorHandling: false}, function(data){
	 		this.meta = data;
	 		loadExistingData({entity: "passedTime", recordId: this.testId}, function(result) {
				if (result.passedTime > -1) {
					//means the test is resumed
					this.passedTime = result.passedTime;
					this.lastRes = this.passedTime;
					this.meta["startedAt"] = new Date(Date.now() - this.passedTime * 1000);
				}
	 		this.meta["theme"] = parseInt(3);
		 	if(this.testState == testState.Loaded)
		 	{
		 		this.meta["startedAt"] = new Date();
		 		this.meta["endAt"] = null;
				this.meta["language"] = this.language; 
				this.testState = testState.Started;
		 		this.parent.SetState(this.testId ,this.testState);
		 		this.SaveQuestion(-1);
		 	}
		 	if(this.meta["endAt"] != null)
		 	{
		 		alert("This test has been already taken");
		 		this.submited = true;
		 		this.testState = testState.Submitted;
				this.parent.SetState(this.testId ,this.testState);
		 		$('.btn-back.BackFromTest').click();
		 	}
		 	this.paused = false;
		 	this.sessionID = this.meta.sessionId;
		 	this.PopulateTestUI();
		}.bind(this));
    }.bind(this));
    }.bind(this));
};
apptbsetestController.prototype.PopulateTestUI = function()
{
	this.totalTime = $("#_totalTime_").text() * 60 * 1000;
	if (this.meta["startedAt"] == undefined || typeof this.meta["startedAt"] == "string") {
		this.startedAt = new Date().getTime() - this.passedTime * 1000;
	} else {
		this.startedAt = this.meta["startedAt"].getTime();
	}
	
	this.PopulateQuestionPalette();
	this.lastSavedQues();
	this.PopulateHeader();
	this.BindEvents();
	UrlMgmt.getObj().removeLoader();
	$("#TBSETest").show();
	$(".tbseElem").hide();
	$('#QPart').show();
	this.ResizeTestScreen();
	setTimeout(function(){ $(".QPalleteBtn").click(); }, 1000);
};
apptbsetestController.prototype.PopulateQuestionPalette = function()
{
	this.questionOrder = JSON.parse($("#_questionOrder_").text());
	for(s in this.questionOrder)
	{
		this.meta["sections"][s].allotedTime = this.questionOrder[s].allotedTime;
		this.meta["sections"][s].breakTime = this.questionOrder[s].breakTime;
		this.meta["sections"][s]["submitted"] = 0;
		this.meta["sections"][s]["breakEnded"] = 1; 
		if(this.meta["sections"][s].breakTime > 0)
			this.meta["sections"][s]["breakEnded"] = 0;
		if(this.meta["sections"][s]["sectionMeta"]=="")
		{
			if(s==0)
			{
				this.meta["sections"][s]["startedAt"] = new Date().getTime();
			}
			else
			{
				this.meta["sections"][s]["startedAt"] = this.meta["sections"][s-1]["breakStartTime"] + this.meta["sections"][s-1].breakTime * 60 * 1000; 
			}
			this.meta["sections"][s]["breakStartTime"] = this.meta["sections"][s]["startedAt"] + this.meta["sections"][s].allotedTime * 60 * 1000; 
			var obj  = {
				"startedAt":this.meta["sections"][s]["startedAt"],
				"submitted":this.meta["sections"][s]["submitted"],
				"breakStartTime":this.meta["sections"][s]["breakStartTime"],
				"breakEnded":this.meta["sections"][s]["breakEnded"],
				"allotedTime":this.meta["sections"][s]["allotedTime"]
				};
			this.meta["sections"][s]["sectionMeta"] = JSON.stringify(obj);
			this.UpdateSectionMeta(s, obj);
		}
		else
		{
			var sectionMeta = JSON.parse(this.meta["sections"][s]["sectionMeta"]);
			this.meta["sections"][s]["startedAt"] = sectionMeta["startedAt"];
			this.meta["sections"][s]["submitted"] = sectionMeta["submitted"];
			this.meta["sections"][s]["breakStartTime"] = sectionMeta["breakStartTime"];
			this.meta["sections"][s]["breakEnded"] = sectionMeta["breakEnded"];
			this.meta["sections"][s]["allotedTime"] = sectionMeta["allotedTime"];
		}
		this.sectionName[s] = this.questionOrder[s].name;
		var sBtn = $('<span>'+
						'<input type="button" class="SectionBtn" sectionId="'+s+'" '+
							'value="'+this.questionOrder[s].name+'" submitted="'+this.meta["sections"][s]["submitted"]+'"/>'+
						'<div class="SectionInfo">'+
							'<div class="SectionName">'+this.questionOrder[s].name+'</div>'+
							'<div class="SectionInfoCount Table">'+
								'<div class="Row"><div class="Cell">Answered: </div><div class="attemptedIcon Icon Cell">0</div></div>'+
								'<div class="Row"><div class="Cell">Not Answered: </div><div class="skippedIcon Icon Cell">0</div></div>'+
								'<div class="Row"><div class="Cell">Marked: </div><div class="reviewIcon Icon Cell">0</div></div>'+
								'<div class="Row"><div class="Cell">Not Visited: </div><div class="missedIcon Icon Cell">0</div></div>'+
							'</div>'+
						'</div>'+	
					'</span>').appendTo($(".sectionPanel .fieldset"));
	}
	var qNoInSection = 1;
	var currentSectionId = 0;
	for(var qNo in this.meta.questions)
	{
		var q = this.meta.questions[qNo];
		var qId = q.questionId;
		var sQId = q.subQuestionId;
		var sectionId = q.sectionId;
		if(sectionId != currentSectionId)
		{
			currentSectionId = sectionId;
			qNoInSection = 1;
		}
		var className= "Icon qIndicator";
		
		if(this.sessionID > 0)
		{	
			this.userActivity[qNo-1] = {ans:[], state: AnswerStatus.MISSED, questionNo:qId, sQId:sQId, 
							timeSpent:0, flaged:false};
			if(q.hasOwnProperty("answer") && q.answer.hasOwnProperty("ans"))
			{
				this.userActivity[qNo-1] = {ans:q.answer.ans, state: q.answer.state, questionNo:qId, 
											sQId:sQId, timeSpent:0, flaged:(q.flag==1)};
											
				if(q.flag==1 && q.answer.state == AnswerStatus.ANSWERED)
					className += " review_answeredIcon";
				else if(q.flag==1 && q.answer.state == AnswerStatus.SKIPED)
					className += " reviewIcon";
				else if(q.answer.state == AnswerStatus.ANSWERED)
					className += " attemptedIcon";
				else	
					className += " skippedIcon";
			}
			else
			{
				className += " missedIcon";
			}
			this.ansOrder[qNo-1] = q.meta;
		}
		
		var icon = '<div class="'+className+'" qNo="'+ qNo +'" qId="'+qId+'" sQId="'+sQId+'" '+
					'sectionId="'+sectionId+'" qNoInSection="'+qNoInSection+'">'+qNoInSection+'</div>';
		$("#QuestionPalette").append(icon);
		qNoInSection ++;
	}
	this.switchSection();
};
apptbsetestController.prototype.BindEvents = function()
{
	var self = this;
	$("#SectionSubmitConfirmedBtn").unbind().click(function(){
		$("#confirmSectionSubmit-modal").modal('hide');
		$(".tbseElem").hide();
		$(".SectionBtn[sectionid='"+self.currentSectionId+"']").attr("submitted",1);
		var sections = $(".SectionBtn[submitted='0']");
		if(sections.length > 0)
			self.resetTimeSlot(sections,true);
		self.SubmitSection();
	});
	$("#startNow").unbind().click(function(){
		$(".tbseElem").hide();
		var sections = $(".SectionBtn[submitted='0']");
		this.resetTimeSlot(sections);
		this.CloseInstruction();
	}.bind(this));
	$("#SubmitConfirmedBtn").unbind().click(function(){
		self.SaveQuestion(parseInt($("#Question").attr("qNo")));
		self.SavePrevQuestion(false);
		if(self.meta["questions"][self.ShowingQuestionNo]["answer"] == undefined)
		{
			self.meta["questions"][self.ShowingQuestionNo]["answer"] = {};
		}
		self.meta["questions"][self.ShowingQuestionNo]["answer"]["ans"] = self.userActivity[self.ShowingQuestionNo-1]["ans"];
		self.meta["questions"][self.ShowingQuestionNo]["answer"]["state"] = self.userActivity[self.ShowingQuestionNo-1]["state"];
		self.meta["questions"][self.ShowingQuestionNo].flag = self.userActivity[self.ShowingQuestionNo-1]["flaged"]?"true":"false";
		self.meta["questions"][self.ShowingQuestionNo]["timeSpent"] = self.userActivity[self.ShowingQuestionNo-1]["timeSpent"];
		self.SubmitTest();
	});
	$("#TBSESubmitBtn").unbind().click(function(){
		this.PopulatePreSubmissionInfo();
		$(".modal").modal('hide');
		$(".tbseElem").hide();
		$("#PreSubmitPart").show();
	}.bind(this));
	$(".fieldset span.selected").unbind("mouseenter").bind("mouseenter", this, function(e){
		var sectionId = $(this).attr("sectionId");
		var firstQNo = $('.qIndicator[sectionId="'+sectionId+'"]:first').attr("qNo");
		var lastQNo = $('.qIndicator[sectionId="'+sectionId+'"]:last').attr("qNo");
		var stats = [0,0,0,0,0,0];
		for(var i = (firstQNo-1); i < lastQNo; i++)
		{
			if(e.data.userActivity[i].flaged)
			{
				stats[AnswerStatus.FLAGED]++;
			}
			stats[e.data.userActivity[i].state]++;
		}
		$(".SectionInfoCount .missedIcon ").text(stats[AnswerStatus.MISSED]);
		$(".SectionInfoCount .skippedIcon ").text(stats[AnswerStatus.SKIPED]);
		$(".SectionInfoCount .attemptedIcon ").text(stats[AnswerStatus.ANSWERED]);
		$(".SectionInfoCount .reviewIcon ").text(stats[AnswerStatus.FLAGED]);
	});
	$("#SelectTestLanguageWithin option").each(function(){
		$(this).prop("selected", false);
	});
	$("#SelectTestLanguageWithin option[value='"+this.language+"']").prop("selected",true);
	$("#SelectTestLanguageWithin").bind("change", this, function(e){
		e.data.language = e.target.value;
		e.data.ShowQuestion(e.data.ShowingQuestionNo);
	});
	$("#TBSE-QuestionPaper").unbind().click(function(){
		$(".QPalleteBtn").click();
		$(".tbseElem").hide();
		self.PopulateQuestionPaper(self.language);
		$("#QusetionPaperPart").show();
		self.ResizeTestScreen();
	});
	$("#TBSE-Instruction").unbind().click(function(){
		$(".QPalleteBtn").click();
		$(".tbseElem").hide();
		$("#InstructionPart").show();
		self.ResizeTestScreen();
	});
	$(".BackBtn").unbind().click(function(){
		$(".modal").modal('hide');
		$(".tbseElem").hide();
		$("#QPart").show();
		self.ResizeTestScreen();
	});
	$("#TBSE-Profile").unbind().click(function(){
		$(".QPalleteBtn").click();
		$(".tbseElem").hide();
		$("#ProfilePart").show();
	});
	$(".qIndicator").unbind().click(function(){
		self.SavePrevQuestion(false);
		self.SaveQuestion(parseInt($("#Question").attr("qNo")));
		self.ShowQuestion($(this).attr("qNo"));
	});
	$("#MarkForReviewBtn").unbind().click(function(){
		this.SavePrevQuestion(true);
		this.SaveQuestion(this.ShowingQuestionNo);
		var qNo = (this.ShowingQuestionNo%this.userActivity.length) + 1;
		var q = $('.qIndicator[qNo="'+qNo+'"]');
		var sectionId = q.attr("sectionId");
		if(sectionId!=this.currentSectionId && this.meta.sections[this.currentSectionId].submitted!=true)
		{
			$("#confirmSectionSubmit-modal").modal('show');
			return;
		}
		self.ShowQuestion(qNo);
	}.bind(this));
	$("#CleanResponseBtn").unbind().click(function(){
		if($("#Question").attr("qType") == QuestionType.NIQ){
			$("#Question").find(".keyboardwrite").val("");
		}
		else{
			$('.Answer input').prop('checked', false);
		}
	});
	$("#SubmitSectionBtn").unbind().click(function(){
		$(".QPalleteBtn").click();
		$("#confirmSectionSubmit-modal").modal('show');
	}.bind(this));
	$("#SaveNextBtn").unbind().click(function(){
		this.SavePrevQuestion(false);
		self.SaveQuestion(this.ShowingQuestionNo);
		var qNo = (this.ShowingQuestionNo%this.userActivity.length) + 1;
		var q = $('.qIndicator[qNo="'+qNo+'"]');
		var sectionId = q.attr("sectionId");
		if(sectionId!=this.currentSectionId && this.meta["sections"][this.currentSectionId].submitted!=true)
		{
			$("#confirmSectionSubmit-modal").modal('show');
			return;
		}
		self.ShowQuestion(qNo);
	}.bind(this));
	$(".QPalleteBtn").unbind().bind("click",this,function(){
		var width = "100%";
		if($(this).hasClass("showedPallete"))
		{
			$(".rightPart").hide();
			$(this).removeClass("showedPallete");
			$(this).find(".open").removeClass("shownIcon");
			$(this).find(".closed").addClass("shownIcon");
		}
		else
		{
			$(".rightPart").show();
			$(this).addClass("showedPallete");
			$(this).find(".closed").removeClass("shownIcon");
			$(this).find(".open").addClass("shownIcon");
		}
		self.ResizeTestScreen();
	});
	$('.btn-back.BackFromTest').unbind("click").bind("click", this,function(e){
		e.data.paused = true;
		e.data.SaveQuestion(parseInt($("#Question").attr("qNo")));
		UrlMgmt.getObj().PopView();
		e.data.pauseTime = new Date().getTime();
	});
};
apptbsetestController.prototype.resetTimeSlot = function(sections,resetFlag)
{
	if(resetFlag == true)//Section Submit
	{
		this.meta["sections"][this.currentSectionId]["breakStartTime"] = new Date().getTime();
		var obj  = {
			"startedAt":this.meta["sections"][this.currentSectionId]["startedAt"],
			"submitted":this.meta["sections"][this.currentSectionId]["submitted"],
			"breakStartTime":this.meta["sections"][this.currentSectionId]["breakStartTime"],
			"breakEnded":this.meta["sections"][this.currentSectionId]["breakEnded"],
			"allotedTime":this.meta["sections"][this.currentSectionId]["allotedTime"]
			};
		this.meta["sections"][this.currentSectionId]["sectionMeta"] = JSON.stringify(obj);
	}
	for(var i=0; i<sections.length; i++) // Start From this.currentSectionId CurrentSection 
	{
		var sectionId = $(sections[i]).attr("sectionid");
		if(i==0 && typeof resetFlag=="undefined") //Instruction Submit
			this.meta["sections"][sectionId]["startedAt"] = new Date().getTime();
		else
			this.meta["sections"][sectionId]["startedAt"] = this.meta["sections"][sectionId-1]["breakStartTime"] + this.meta["sections"][sectionId-1].breakTime * 60 * 1000;
		
		this.meta["sections"][sectionId]["breakStartTime"] = this.meta["sections"][sectionId]["startedAt"] + this.meta["sections"][sectionId].allotedTime * 60 * 1000; 
		obj  = {
			"startedAt":this.meta["sections"][sectionId]["startedAt"],
			"submitted":this.meta["sections"][sectionId]["submitted"],
			"breakStartTime":this.meta["sections"][sectionId]["breakStartTime"],
			"breakEnded":this.meta["sections"][sectionId]["breakEnded"],
			"allotedTime":this.meta["sections"][sectionId]["allotedTime"]
			};
		this.meta["sections"][sectionId]["sectionMeta"] = JSON.stringify(obj);
		this.UpdateSectionMeta(sectionId, obj);
	}
};
apptbsetestController.prototype.PopulateHeader = function()
{
	var hideLeft = $('.QPalleteBtn');
	hideLeft.append('<x-icon class="leftHideShowBtn open shownIcon">'+arrowEIcon+'</x-icon><x-icon class="leftHideShowBtn closed">'+arrowWIcon+'</x-icon>');
	for(key in this.languageOptions)
	{
		var option = $('<option value="' + this.languageOptions[key] + '">' + TestLanguageType.Str[this.languageOptions[key]] + '</option>');
		if(option.val() == this.language)
			option.attr("selected","selected");
		$("#SelectTestLanguageWithin").append(option);
	}
	$('#SelectTestLanguageWithin').change(function(e){
		this.obj.language = e.target.value;
		selectedQuestion = parseInt($("#Question").attr("qNo"));
		this.obj.ShowQuestion(selectedQuestion, this.obj.language);
	}.bind({obj:this}));
	if(LoggedInUser.Auth())
	{
		var userData = UrlMgmt.getObj().userData;
		$(".TimeAndName .username").html(userData.displayName);
		$("#ProfilePart .profileName").html(": "+userData.displayName);
		$("#ProfilePart .profileEmail").html(": "+userData.emailId);
	}
	$("#InstructionPart .totalTime").html($("#_totalTime_").text());
};
apptbsetestController.prototype.PopulateQuestionPaper = function(viewLanguage)
{
	$(".QuestionPaper").empty();
	if(typeof(this.questionOrder[this.currentSectionId]) != "undefined")
	{
		$(".QuestionPaper").append('<h4 class="sectionNameInQPaper">Section : '+this.questionOrder[this.currentSectionId].name+'</h4>');			
		var qNo = 1;
		for(var g in this.questionOrder[this.currentSectionId]["groups"])
		{
			for(var q in this.questionOrder[this.currentSectionId]["groups"][g])
			{
				var qId = this.questionOrder[this.currentSectionId]["groups"][g][q]["id"];
				$("._question_[qId='"+qId+"'][language='"+TestLanguageType.Str[viewLanguage]+"']").each(function(){
					var questionText = $(this).find("._text_").html();
					var qtype = $(this).attr("qType");
					if(typeof qtype != undefined && parseInt(qtype) == QuestionType.BLANK)
				    {
				    	var parts = questionText.split("{BLANK}");
				    	questionText = "";	
						for(var i=0; i < parts.length; i++)
						{
							questionText += parts[i];
							if(i < parts.length - 1)
							{
								questionText += '<span><u><b><i>&nbsp;&nbsp;blank-'+(i+1)+'&nbsp;&nbsp;</i></b></u></span>';
							}
						}
				    }
				    
					var qText = '<div class="QuestionInPaper"><div>Q.'+ qNo +')</div>'+
								'<div>'+questionText+
							 '</div>';
					$(".QuestionPaper").append(qText);
					qNo ++;
				});
			}
		}
	}
};
apptbsetestController.prototype.ShowQuestion = function(qNo)
{
	$("#QPart").show();
	qNo = parseInt(qNo);
	this.startNewQuestionAt = new Date().getTime();
	this.ShowingQuestionNo = qNo;
	var q = $('.qIndicator[qNo="'+qNo+'"]');
	var state = AnswerStatus.MISSED;
	if(this.userActivity[qNo - 1] != null)
	{
		state = this.userActivity[qNo - 1].state;
	}
	if(state == AnswerStatus.MISSED)
	{
		q.removeClass("missedIcon");
		q.addClass("skippedIcon");
		this.userActivity[qNo - 1].state = AnswerStatus.SKIPED;
	}

	var sectionId = q.attr("sectionId");
			
	$(".viewingSection .sectionName").text(this.sectionName[sectionId]);
	var qNoInSection = q.attr("qNoInSection");
	$("#QuestionNo").text(qNoInSection);
	var qId = q.attr("qId");
	var sQId = q.attr("sQId");
	var qDiv = $("._question_[qId='"+qId+"'][sQId='"+sQId+"'][language='"+TestLanguageType.Str[this.language]+"']");
	if(!qDiv.length){
		qDiv = $("._question_[qId='"+qId+"'][sQId='"+sQId+"']:eq(0)");
	}
	$("#Question").attr("qNo", qNo);
	$("#Question").attr("qId", qId);
	$("#Question").attr("sQId", sQId);
	
	var qtype = qDiv.attr("qType");
	
	$("#QPart > .Question").attr("qactualtype", qtype);
	loadExistingData({entity: "testanswers", recordId: this.sessionID}, function(data){
		if(typeof qtype != undefined && parseInt(qtype) == QuestionType.BLANK)
	    {
	    	this.ShowFillInTheBankQuestion(qDiv, qNo, data);
	    }
	    else if(typeof qtype != undefined && parseInt(qtype) == QuestionType.NIQ)
	    {
	    	this.ShowNIQQuestion(qDiv, qNo, data);
	    }
	    else
	    {
	    	this.ShowMCQQuestion(qDiv, qNo, qId, sQId, parseInt(qtype), data);
	    }
	
		MathJax.Hub.Queue(["Typeset",MathJax.Hub, $("#Question").get(0)],
	    function () 
			{
				$("#Question span.MathJax, #Question span.MathJax_SVG").hide();
				var cWidth = $('#SBITest .SBILeftBottomPart').width() - 40; //40 px Buffer
				$("#Question span.MathJax, #Question span.MathJax_SVG").show();
				$("#Question span.MathJax, #Question span.MathJax_SVG").each(function(){
					if($(this).width() > cWidth)
					{
						$(this).addClass("OverFlowFormula");
						$(this).css({'max-width':cWidth+'px', 'display':'inline-block'});	
					}
				});
	
				$("#Question .questionText, #Question  .AnswerText span, #Question ._subQText").html(function(i,h){
					return h.replace(/&nbsp;/g,' '); 
				});
			}
		);
		
		
		this.ResizeTestScreen();
		var scrollPos = q.position().top - $('.qIndicator[sectionId="'+sectionId+'"][qNoInSection="1"]').position().top - 
							$("#QuestionPalette").height()/2.0;
		$("#QuestionPalette").scrollTop(scrollPos);
	}.bind(this));
};
apptbsetestController.prototype.switchSection = function(autoSubmit)
{
	var sections = $(".SectionBtn[submitted='0']");
	if(sections.length > 0)
	{
				
		this.SaveQuestion(this.ShowingQuestionNo, function(){
				var t = 0;
				for(var i=0; i<sections.length; i++)
				{
					var sectionId = $(sections[i]).attr("sectionid");
					t += this.meta["sections"][sectionId].allotedTime + this.meta["sections"][sectionId].breakTime;
				}
				this.totalTime = t * 60 *1000;
				$(".SectionBtn").removeClass("Selected");
				$(".SectionBtn").parent().removeClass("Selected");
				var sId = $(".SectionBtn[submitted='0']").first().attr("sectionId");
				if(sId!=0 && this.meta["sections"][sId-1]["submitted"] == 1 && this.meta["sections"][sId-1]["breakEnded"] == 0)
				{
					this.currentSectionId = sId-1;
					this.startedAt = this.meta["sections"][this.currentSectionId]["breakStartTime"];
					this.totalTime = this.totalTime + this.meta["sections"][this.currentSectionId]["breakTime"] * 60 * 1000;
					this.StartInstructionTimer();
					$(".tbseElem").hide();
					$("#sectionBreakTimer-modal").modal('show');
				}
				else
				{
					this.currentSectionId = sId;
					this.startedAt = this.meta["sections"][this.currentSectionId]["startedAt"];
					this.StartSectionTimer();
					$(".qIndicator:not([sectionId='"+this.currentSectionId+"'])").css("display", "none");
					$(".SectionBtn[sectionId='"+this.currentSectionId+"']").addClass("Selected");
					$(".SectionBtn.Selected").parent().addClass("Selected");
					$(".qIndicator[sectionId='"+this.currentSectionId+"']").css("display", "inline-block");
					var firstQNo = $('.qIndicator[sectionId="'+this.currentSectionId+'"]:first').attr("qNo");
					this.ShowQuestion(firstQNo);
				}
				this.StartTimer();
		}.bind(this));	

	}
	else
	{
		$("#SubmitSectionBtn").addClass("Submited");
		this.SubmitTest(autoSubmit);
	}
};
apptbsetestController.prototype.StartSectionTimer = function()
{
	if(this.meta["sections"][this.currentSectionId].submitted == true || this.paused==true)
		return;
	var milisecond = this.meta["sections"][this.currentSectionId].allotedTime * 60 * 1000 - new Date().getTime() + this.meta["sections"][this.currentSectionId].startedAt;
	var elem = $("#SectionTimeLeft");
	this.SetTime(milisecond,elem);
	if(milisecond >= 0)
	{
	    var t = setTimeout(function(){this.StartSectionTimer();}.bind(this),500);
	}
	else
	{
		this.SubmitSection(true);
	}
};
apptbsetestController.prototype.SubmitSection = function(autoSubmit)
{
	this.meta["sections"][this.currentSectionId]["submitted"] = 1;
	var obj = {
		"startedAt":this.meta["sections"][this.currentSectionId]["startedAt"],
		"submitted":this.meta["sections"][this.currentSectionId]["submitted"],
		"breakStartTime":this.meta["sections"][this.currentSectionId]["breakStartTime"],
		"breakEnded":this.meta["sections"][this.currentSectionId]["breakEnded"],
		"allotedTime":this.meta["sections"][this.currentSectionId]["allotedTime"]
	};
	this.meta["sections"][this.currentSectionId]["sectionMeta"] = JSON.stringify(obj);
	this.UpdateSectionMeta(this.currentSectionId, obj);
	$(".SectionBtn[sectionid='"+this.currentSectionId+"']").attr("submitted",this.meta["sections"][this.currentSectionId]["submitted"]);
	$(".SectionBtn[sectionid='"+this.currentSectionId+"']").removeClass("Selected");
	$(".SectionBtn").parent().removeClass("Selected");
	this.switchSection(autoSubmit);
	
};
apptbsetestController.prototype.UpdateSectionMeta = function(sectionId,obj)
{
	$.ajax({
		type:"POST",
		url: remoteServer + "/ajax",
		data:{ 
				mod: "test",
				ack: "updateSectionMeta",
				session: this.sessionID,
				sectionId: sectionId,
				meta: JSON.stringify(obj)
			},
		xhrFields : {
			withCredentials : true
		},
		crossDomain : true,
		success : function(reply) {
			if (reply.result.state == "ok") {
			
			}
		}
	});
};
apptbsetestController.prototype.StartTimer = function() {
	if(this.submited==true || this.paused==true)
		return;
	var milisecond = this.totalTime - new Date().getTime() + this.startedAt;
	var elem = $("#TimeLeft");
	this.SetTime(milisecond,elem);
	if(milisecond >= 0)
	{
	    var t = setTimeout(function(){this.StartTimer();}.bind(this),500);
	}
};
apptbsetestController.prototype.StartInstructionTimer = function()
{
	if(this.meta["sections"][this.currentSectionId].breakEnded == true)
		return;
	var milisecond = this.meta["sections"][this.currentSectionId].breakStartTime + this.meta["sections"][this.currentSectionId].breakTime * 60 * 1000 - new Date().getTime();
	var elem = $("#sectionBreakTimer-modal #InstructionTimeLeft");
	this.SetTime(milisecond,elem);
	if(milisecond >= 0)
	{
	    var t = setTimeout(function(){this.StartInstructionTimer();}.bind(this),500);
	}
	else
	{
		this.CloseInstruction();
	}
};
apptbsetestController.prototype.CloseInstruction = function()
{
	$("#sectionBreakTimer-modal").modal('hide');
	this.meta["sections"][this.currentSectionId]["breakEnded"] = 1;
	var obj = {
			"startedAt":this.meta["sections"][this.currentSectionId]["startedAt"],
			"submitted":this.meta["sections"][this.currentSectionId]["submitted"],
			"breakStartTime":this.meta["sections"][this.currentSectionId]["breakStartTime"],
			"breakEnded":this.meta["sections"][this.currentSectionId]["breakEnded"],
			"allotedTime":this.meta["sections"][this.currentSectionId]["allotedTime"]
			};
	this.meta["sections"][this.currentSectionId]["sectionMeta"] = JSON.stringify(obj);
	this.UpdateSectionMeta(this.currentSectionId, obj);
	this.switchSection();
};
apptbsetestController.prototype.SetTime = function(millisecond,elem)
{
	millisecond /= 1000;
	var s = parseInt(millisecond % 60);
	var m = parseInt((millisecond / 60 ) % 60);
	var h = parseInt((millisecond / (60 * 60) ) % 60);
	$(elem).text(this.TimeStr(h) + ":" + this.TimeStr(m) + ":" + this.TimeStr(s));
};
apptbsetestController.prototype.TimeStr = function(i) {
    if (i<10) {i = "0" + i;}  // add zero in front of numbers < 10
    return i;
};
apptbsetestController.prototype.SavePrevQuestion = function(flaged)
{
	var prevQuestion = parseInt($("#Question").attr("qNo"));
	if(prevQuestion > 0)
	{
		if( this.userActivity[prevQuestion - 1].questionNo == 0)
		{
			this.userActivity[prevQuestion - 1].questionNo = $("#QuestionBody .Question").attr("qId");
			this.userActivity[prevQuestion - 1].sQId = $("#QuestionBody .Question").attr("sQId");
		}
		this.userActivity[prevQuestion - 1].flaged = flaged;
		var prevState = this.userActivity[prevQuestion - 1].state;
		var prevAns = JSON.stringify(this.userActivity[prevQuestion - 1].ans);
		var prevFlag = this.userActivity[prevQuestion - 1].flaged;
		var state = AnswerStatus.SKIPED;
		
		var answered = false;
		var self = this;
		var counter = 0;
		var qType = parseInt($("#Question").attr("qtype"));
		if(qType == QuestionType.BLANK)
		{
			$(".Answers select").each(function(){
				var selectVal = $(this).val(); 
				self.userActivity[prevQuestion - 1].ans[counter] = selectVal;
				if(selectVal > -1)
				{
					answered = true;
				}
				counter++;
			});
		}
		else if(qType == QuestionType.NIQ){
			this.userActivity[prevQuestion - 1].ans[0]=$("#Question").find(".keyboardwrite").val();
			if($("#Question").find(".keyboardwrite").val()){
				answered=true;
			}
		}		
		else
		{	
			$(".Answers .Answer").each(function(){
				hasSelectedAns =  $(this).hasClass("selectedAns");
				self.userActivity[prevQuestion - 1].ans[counter] = hasSelectedAns;
				answered |= hasSelectedAns;
				counter++;
			});
		}	
		state = answered?AnswerStatus.ANSWERED:AnswerStatus.SKIPED;
		this.ChangeQuestionState(prevQuestion, state);
		this.userActivity[prevQuestion - 1]["answeredDate"] = new Date();
		this.userActivity[prevQuestion - 1].state = state;	
		if(this.startNewQuestionAt != "" && this.ShowingQuestionNo != -1){
			this.userActivity[prevQuestion - 1].timeSpent += parseInt((new Date().getTime() - this.startNewQuestionAt)/1000);
		}
	}
};
apptbsetestController.prototype.ChangeQuestionState = function(qNo, toState)
{	
	flaged = this.userActivity[qNo-1].flaged;
	this.userActivity[qNo-1].state =toState;
		if(toState == AnswerStatus.ANSWERED){
			answered = true;
		}
		var q = $('.qIndicator[qNo="'+qNo+'"]');
		
		if(toState == AnswerStatus.SKIPED)
		{
			q.removeClass("missedIcon attemptedIcon review_answeredIcon reviewIcon");
			q.addClass("skippedIcon");
		}
		if(flaged && toState == AnswerStatus.ANSWERED){
			q.removeClass("skippedIcon reviewIcon");
			q.addClass("attemptedIcon review_answeredIcon");
		}else if(flaged){
			q.removeClass("skippedIcon review_answeredIcon attemptedIcon");
			q.addClass("reviewIcon");
		}else if(toState == AnswerStatus.ANSWERED){
			q.removeClass("skippedIcon reviewIcon review_answeredIcon");
			q.addClass("attemptedIcon");
		}
};
apptbsetestController.prototype.SaveQuestion = function(qNumber, callback)
{
	if(this.submited == false)
	{
		if(qNumber > 0)
			{
				if (this.userActivity[qNumber - 1].questionNo == 0) {
					this.userActivity[qNumber - 1].questionNo = $("#QuestionBody .Question").attr("qId");
					this.userActivity[qNumber - 1].sQId = $("#QuestionBody .Question").attr("sQId");
				}
				//this.userActivity[qNumber - 1].flaged = flaged;
				var prevState = this.userActivity[qNumber - 1].state;
				var prevAns = JSON.stringify(this.userActivity[qNumber - 1].ans);
				//var prevFlag = this.userActivity[qNumber - 1].flaged;
				var state = AnswerStatus.SKIPED;
		
				var answered = false;
				var self = this;
				var counter = 0;
				var qType = parseInt($("#Question").attr("qtype"));
				if (qType == QuestionType.BLANK) {
					$("#Question .Answers select").each(function(){
					var selectVal = $(this).val(); 
					self.userActivity[qNumber - 1].ans[counter] = selectVal;
					if(selectVal > -1)
					{
						answered = true;
					}
					counter++;
				});
				} else if (qType == QuestionType.NIQ) {
					self.userActivity[qNumber - 1].ans[0]=$("#Question").find(".keyboardwrite").val();
					if($("#Question").find(".keyboardwrite").val()){
						answered=true;
					}
				} else {
					$(".Answers input").each(function(){
						var hasSelectedAns =  $(this).prop("checked");
						self.userActivity[qNumber - 1].ans[counter] = hasSelectedAns;
						answered |= hasSelectedAns;
						counter++;
					});
				}
				this.userActivity[qNumber-1]["answeredDate"] = new Date();
				state = answered ? AnswerStatus.ANSWERED : AnswerStatus.SKIPED;
				this.ChangeQuestionState(qNumber, state);
		
				this.userActivity[qNumber - 1].state = state;
				if(this.meta["questions"][qNumber]["answer"] == undefined)
				{
					this.meta["questions"][qNumber]["answer"] = {};
				}
				this.meta["questions"][qNumber]["answer"]["ans"] = this.userActivity[qNumber-1]["ans"];
				this.meta["questions"][qNumber]["answer"]["state"] = this.userActivity[qNumber-1]["state"];
				this.meta["questions"][qNumber].flaged = this.userActivity[qNumber-1]["flaged"]?"true":"false";
				this.meta["questions"][qNumber]["timeSpent"] = this.userActivity[qNumber-1]["timeSpent"];
				if(!UrlMgmt.getObj().App.isOnline){
					if(!this.meta.hasOwnProperty('questionsSubmit'))
						this.meta["questionsSubmit"] = false;
				}
				else{
					$.ajax({
						url : remoteServer + "/ajax",
						type : 'POST',
						data : {
							mod : "test",
							ack : "save",
							answer: JSON.stringify(this.meta["questions"][this.ShowingQuestionNo]["answer"]),
							flaged: this.meta["questions"][this.ShowingQuestionNo]["flaged"],
							qid: this.meta["questions"][this.ShowingQuestionNo]["questionId"],
							sqid: this.meta["questions"][this.ShowingQuestionNo]["subQuestionId"],
							session: this.meta["sessionId"],
							tempUserId: this.meta["tempUserId"],
							timespent: this.meta["questions"][this.ShowingQuestionNo]["timeSpent"],
						},
						xhrFields : {
							withCredentials : true
						},
						crossDomain : true,
						context : this,
						success : function(reply) {
							if (reply.result.state == "ok") {
							
							}
						}.bind(this),
						error : function(jqXHR, exception) {
							if (jqXHR.status === 0) {
								//alert("Connect to Internet");
							} else if (jqXHR.status == 404) {
								alert('Requested page not found. [404]');
							} else if (jqXHR.status == 500) {
								alert('Internal Server Error [500].');
							} else if (exception === 'parsererror') {
								alert('Requested JSON parse failed.');
							} else if (exception === 'timeout') {
								alert('Time out error.');
							} else if (exception === 'abort') {
								alert('Ajax request aborted.');
							} else {
								alert('Uncaught Error.\n' + jqXHR.responseText);
							}
						}
					});
				
					//last question number save in redis
					$.ajax({
						url : remoteServer + "/ajax",
						type : 'POST',
						data : {
							mod : "test",
							ack : "lastquestionsave",
							session : this.meta["sessionId"],
							qno : qNumber,
							testId : this.testId
						},
						xhrFields : {
							withCredentials : true
						},
						crossDomain : true,
						context : this,
						success : function(reply) {
							if (reply.result.state == "ok") {
		
							}
						}.bind(this),
						error : function(jqXHR, exception) {
							if (jqXHR.status === 0) {
								var alerted = localStorage.getItem('alerted') || '';
	   		 					if (alerted != 'yes') {
	     							alert("Data will be saved temporarily as you are not connected to Internet");
	     							localStorage.setItem('alerted','yes');
	    					 	}
							} else if (jqXHR.status == 404) {
								alert('Requested page not found. [404]');
							} else if (jqXHR.status == 500) {
								alert('Internal Server Error [500].');
							} else if (exception === 'parsererror') {
								alert('Requested JSON parse failed.');
							} else if (exception === 'timeout') {
								alert('Time out error.');
							} else if (exception === 'abort') {
								alert('Ajax request aborted.');
							} else {
								alert('Uncaught Error.\n' + jqXHR.responseText);
							}
						}
					});
				}
			}			
			writeData("testmeta_"+this.testId+".json", 'testmeta', this.testId, this.meta, function(){			
				if (callback) {
					console.log("callback",callback);
					callback();
		    	}
			}.bind(this,callback));	
	}
};
apptbsetestController.prototype.SubmitTest = function(autoSubmit)
{	
	if(this.submited == false)
	{
		this.meta["date"] = new Date();
		this.meta["endAt"] = new Date();
		if(!UrlMgmt.getObj().App.isOnline){
			this.meta["submitted"] = false;
		}
		//set section meta
		var sections = $(".SectionBtn");
		var obj = {};
		if(sections.length > 0)
		{
			for(var i=0; i<sections.length; i++)
			{
				var sectionId = $(sections[i]).attr("sectionid");
				if(sectionId < this.currentSectionId)
				{
					this.meta["sections"][sectionId]["submitted"] = 1;
					obj = {
						"startedAt":this.meta["sections"][sectionId]["startedAt"],
						"submitted":this.meta["sections"][sectionId]["submitted"],
						"breakStartTime":this.meta["sections"][sectionId]["breakStartTime"],
						"breakEnded":this.meta["sections"][sectionId]["breakEnded"],
						"allotedTime":this.meta["sections"][sectionId]["allotedTime"]
						};
					this.meta["sections"][sectionId]["sectionMeta"] = JSON.stringify(obj);
				}
			}
		}
		this.meta["sections"][this.currentSectionId]["submitted"] = 1;
		if(autoSubmit == undefined)
		{
			this.meta["sections"][this.currentSectionId]["breakStartTime"] = new Date().getTime();
		}
		obj = {
			"startedAt":this.meta["sections"][this.currentSectionId]["startedAt"],
			"submitted":this.meta["sections"][this.currentSectionId]["submitted"],
			"breakStartTime":this.meta["sections"][this.currentSectionId]["breakStartTime"],
			"breakEnded":this.meta["sections"][this.currentSectionId]["breakEnded"],
			"allotedTime":this.meta["sections"][this.currentSectionId]["allotedTime"]
			};
			
		this.meta["sections"][this.currentSectionId]["sectionMeta"] = JSON.stringify(obj);
		this.meta["sectionMeta"] = this.meta["sections"];
		this.metaUpdate();	
		writeData("testmeta_" + this.testId + ".json", 'testmeta', this.testId, this.meta, function() {
			this.submited = true;
			if(!UrlMgmt.getObj().App.isOnline){
				UrlMgmt.getObj().PopView();
				alert("Test will be auto saved whenever you connect to internet");
			}
			else{
				this.testState = testState.Submitted;
				this.parent.SetState(this.testId ,this.testState);
				this.parent.UploadTest(this.testId, this.tr2TestId, this.testState);
				this.testState = testState.Loaded;
				alert("Your test has been submitted");
			}
		}.bind(this));
		$(".modal").modal('hide');
	}
};
apptbsetestController.prototype.metaUpdate = function()
{
	writeData("testmeta_"+this.testId+".json", "testmeta", this.testId, this.meta, function(){			
			//console.log("write",this.meta);
		}.bind(this));
	
};
apptbsetestController.prototype.ShowFillInTheBankQuestion = function(qDiv, qNo, data)
{
		var answerData = data;
		$("#Question").attr("qType", QuestionType.BLANK);
		var parts = qDiv.find("._text_").html().split("{BLANK}");
		var qText = "";
		for(var i=0; i < parts.length; i++)
		{
			qText += parts[i];
			if(i < parts.length - 1)
			{
				qText += '<span><u><b><i>&nbsp;&nbsp;blank-'+(i+1)+'&nbsp;&nbsp;</i></b></u></span>';
			}
		}
		var answer = "<div class=\"Answers\">";
		var ans = qDiv.find("._answer_");
	    for (var i = 0; i < ans.length; i++) 
		{	
			ansClass = 	"AnswerSelect";
			answer += 	"<div class=\""+ansClass+"\">"+
						'<div class="BlankNumber">blank-'+(i+1)+'</div>'+
						$(ans[i]).html() +  
					"</div>";
		}
		answer += "</div>";
		$("#Question").html('<div class="questionText">' + qText + '</div>' + answer);
		
		var ques = $("#Question .Answers select");
		var serveransweredDate = (answerData && answerData[qNo - 1] && answerData[qNo-1]["answeredDate"] != undefined) ? new Date(answerData[qNo-1]["answeredDate"]).getTime() : 0;
		var localansweredDate = (this.userActivity && this.userActivity[qNo - 1] && this.userActivity[qNo-1]["answeredDate"] != undefined) ? this.userActivity[qNo-1]["answeredDate"].getTime() : 0;

		if (serveransweredDate > localansweredDate && answerData[qNo - 1] != null) {
			for (var i = 0; i < answerData[qNo - 1].ans.length; i++) {
				$(ques[i]).val(answerData[qNo - 1].ans[i]);
			}
		} else if (serveransweredDate < localansweredDate && this.userActivity[qNo - 1] != null) {
			for (var i = 0; i < this.userActivity[qNo - 1].ans.length; i++) {
				$(ques[i]).val(this.userActivity[qNo - 1].ans[i]);
			}
		}
};
apptbsetestController.prototype.ShowMCQQuestion = function(qDiv, qNo, qNumber, sQId, qtype, data)
{
	var serveransweredDate = 0;
	var localansweredDate = 0; 
		var answerData = data;

		$("#Question").attr("qType", QuestionType.MCQ);
		var answer = "<div class=\"Answers\" choiceMode=\"" + qDiv.attr("choicemode") + "\" >";
		var ans = qDiv.find("._answer_");
		var inputType = "radio";
		if(qDiv.attr("choicemode") > 0)
		{
			inputType = "checkbox";
		}
		var choice = 0;
		for (var i = 0; i < this.ansOrder[qNo-1].length; i++) 
		{	
			var ansClass = 	"Answer";
			var checked ="";
			//Check which activity is latest (server or file)
			serveransweredDate = (answerData && answerData[qNo-1] && answerData[qNo-1]["answeredDate"] != undefined) ? new Date(answerData[qNo-1]["answeredDate"]).getTime() : 0;
			localansweredDate = (this.userActivity && this.userActivity[qNo-1] && this.userActivity[qNo-1]["answeredDate"] != undefined) ? this.userActivity[qNo-1]["answeredDate"].getTime() : 0;
			
			if(serveransweredDate > localansweredDate && answerData[qNo-1] != null && answerData[qNo-1].ans != undefined && answerData[qNo-1].ans[choice]){
				ansClass = 	"Answer selectedAns";
			}
			else if(serveransweredDate < localansweredDate && this.userActivity[qNo - 1] != null && this.userActivity[qNo - 1].ans[choice])
			{
				ansClass = 	"Answer selectedAns";
			}
			
			answer += 	"<div class=\""+ansClass+"\">"+
					"<span>"+'<input type="'+inputType+'" name="ansOption" id="option'+qNo+'-'+i+'"'+ checked +'>'+
					"<label for=\"option"+qNo+"-"+i+"\" class=\"AnswerText\">" + $(ans[this.ansOrder[qNo-1][i]]).html() + "</label></span>"+ 
					"</div>";
			choice++;
		}
		answer += "</div>";
		var qText = qDiv.find("._text_").html();
		$("#Question").html('<div class="questionText">' + qText + '</div>' + answer);
		
		/* Update Answer options with saved values */
		var choice = 0;
		for (var i = 0; i < this.ansOrder[qNo-1].length; i++) 
		{	
			if (serveransweredDate > localansweredDate && answerData[qNo - 1] != null && answerData[qNo - 1].ans != undefined && answerData[qNo-1].ans[choice]) {
				$("#option" + qNo + "-" + i).prop("checked", true);
			} else if (serveransweredDate < localansweredDate && this.userActivity[qNo - 1] != null && this.userActivity[qNo - 1].ans[choice]) {
				$("#option" + qNo + "-" + i).prop("checked", true);
			}
			choice++;
		}	
			
		$(".Answer").unbind( "click" ).bind( "click", this, function(e){e.data.AnswerClicked(this);});
};
apptbsetestController.prototype.AnswerClicked = function(ans)
{
	var qNumber = parseInt($("#Question").attr("qNo"));
	if($(ans).hasClass("selectedAns") && $(ans).parent().attr("choiceMode") != 0)
	{
		$(ans).removeClass("selectedAns");
	}else
	{
		if($(ans).parent().attr("choiceMode") == 0)
		{
			$(ans).siblings().removeClass("selectedAns");
		}
		$(ans).addClass("selectedAns");	
	}
};
apptbsetestController.prototype.ShowNIQQuestion = function (qDiv, qNo, data)
{
		var answerData = data;
		$("#Question").attr("qType", QuestionType.NIQ);
		var answer = "<div class=\"Answers\" choiceMode=\"" + qDiv.attr("choicemode") + "\">";
		var ans = qDiv.find("._answer_");
		answer += this.KeyBoardHtml();
		answer += "</div>";
		var upToDecimalHtml='';
		if(qDiv.attr("upToDecimal") != undefined)
		{
			if(parseInt(qDiv.attr("upToDecimal"))!=0){
				upToDecimalHtml = '<div class="upToDecimal"><b>up to '+qDiv.attr("upToDecimal")+' decimal place</b></div>';
			}
		}  
		var qText = qDiv.find("._text_").html();
		$("#Question").html('<div class="questionText">' + qText + upToDecimalHtml + '</div>' + answer);
		$("#Question").find(".keyboardwrite").prop( "disabled", true );
		$("#Question").find(".keyboard li").bind("click", this.CreateAnsKeyBoardHtml.bind(this));
		var serveransweredDate = (answerData && answerData[qNo - 1] && answerData[qNo-1]["answeredDate"] != undefined) ? new Date(answerData[qNo-1]["answeredDate"]).getTime() : 0;
		var localansweredDate = (this.userActivity && this.userActivity[qNo - 1] && this.userActivity[qNo-1]["answeredDate"] != undefined) ? this.userActivity[qNo-1]["answeredDate"].getTime() : 0;
		if (serveransweredDate > localansweredDate && answerData[qNo - 1] != null && answerData[qNo-1].ans[0]) {
			$("#Question").find(".keyboardwrite").val(answerData[qNo - 1].ans[0]);
		} else if (serveransweredDate < localansweredDate && this.userActivity[qNo - 1] != null && this.userActivity[qNo - 1].ans[0]) {
			$("#Question").find(".keyboardwrite").val(this.userActivity[qNo - 1].ans[0]);
		}
};
apptbsetestController.prototype.ResizeTestScreen = function()
{
	var height = $(".headerNav").outerHeight();
	$(".leftPart,.rightPart").outerHeight($(window).height() - height);
	height = $(".LeftFooter").outerHeight() + $(".sectionPanel").outerHeight();
	$(".Question,#InstructionPart,#QusetionPaperPart").outerHeight($(".leftPart").height() - height);
	$("#Question").outerHeight($(".Question").height() - $(".QuestionInfo").height());
	height = $(".TimeAndName").outerHeight() + $(".viewingSection").outerHeight() + $(".RightFooter").outerHeight() - 2;
	$("#QuestionPalette").outerHeight($(".rightPart").height() - height);
	$(".TBSEInstructions").outerHeight($("#InstructionPart").height() - $(".BackFooter").outerHeight());
	$(".QuestionPaper").outerHeight($("#QusetionPaperPart").height() - $(".BackFooter").outerHeight() - 37);
	$(".QPalleteBtn").css("right","0px");
	if($(".QPalleteBtn").hasClass("showedPallete"))
		$(".QPalleteBtn").css("right",$(".rightPart").width());
};
apptbsetestController.prototype.PopulatePreSubmissionInfo = function()
{
	$("#PreSubmitPart .Table .Row").remove();
	var stats = [0,0,0,0,0,0];
	var currentSection = -1;
	var entry = 0;
	var qCount = 0;

	for(var qNo in this.meta.questions)
	{
		var section = this.meta.questions[qNo].sectionId;
		if(currentSection != section)
		{
			if(currentSection >=0)
			{
				entry += '<div class="Cell">'+qCount+'</div>';
				entry += '<div class="Cell">'+stats[AnswerStatus.ANSWERED]+'</div>';
				entry += '<div class="Cell">'+stats[AnswerStatus.SKIPED]+'</div>';
				entry += '<div class="Cell">'+stats[AnswerStatus.FLAGED]+'</div>';
				entry += '<div class="Cell">'+stats[AnswerStatus.MISSED]+'</div>';
				entry += '</div>';
				$("#PreSubmitPart .Table").append(entry);
			}
			entry = '<div class="Row"><div class="Cell">'+this.sectionName[section]+'</div>';
			currentSection = section;
			qCount = 0;
			stats = [0,0,0,0,0,0];
		}
		if(this.userActivity[qNo-1].flaged)
		{
			stats[AnswerStatus.FLAGED]++;
		}
		stats[this.userActivity[qNo-1].state]++;
		qCount++;
	}
	if(currentSection >=0)
	{
		entry += '<div class="Cell">'+qCount+'</div>';
		entry += '<div class="Cell">'+stats[AnswerStatus.ANSWERED]+'</div>';
		entry += '<div class="Cell">'+stats[AnswerStatus.SKIPED]+'</div>';
		entry += '<div class="Cell">'+stats[AnswerStatus.FLAGED]+'</div>';
		entry += '<div class="Cell">'+stats[AnswerStatus.MISSED]+'</div>';
		entry += '</div>';
		$("#PreSubmitPart .Table").append(entry);
	}
};
apptbsetestController.prototype.lastSavedQues = function()
{
	$.ajax({
		type: "POST",
		data:{
				mod: "test",
				ack: "lastsavedques",
				session:this.meta.sessionId,
				testId:this.testId,
			},
		xhrFields: {
	       withCredentials: true
	    },
	    crossDomain: true,
	    context:this, 
		complete: function( event){
			var reply = event.responseJSON;
		   	try
		   	{
		   		console.log("lastSavedQues",reply);
		   		var qno = reply.data;
		   		this.ShowQuestion(qno);
		   	}
		   catch(e)
		   {
		   	  this.ShowQuestion(1);
		   }		   
		}.bind(this),
		url: remoteServer+"/ajax"
	});
};