var commondashboardController = function() {
	this.view = "default";
	this.style = "default";
	this.dom = null;
	this.data = null;
	this.id = 0;
	this.userInfo = null;
	this.refresh = true;
};

commondashboardController.prototype.Init = function(viewDom)
{
	this.dom = viewDom;
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.showLoader();
	this.SetLayout();
	
	//pull to refresh
	urlMgmt.PullToRefresh($(this.dom).attr('id'));
	
	if (this.data != undefined && this.data.offline != undefined && this.data.offline == true) {
		this.OfflineInit();
	} else {
		this.GetData();
		//this.OnlineInit();
	}
	urlMgmt.removeLoader();
};

commondashboardController.prototype.SetLayout = function()
{
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.lockRotation();
	urlMgmt.menuAction.controler.View();
	urlMgmt.headerAction.controler.DisplayHeader(this.dom, 'Dashboard', true, false, true);
};

commondashboardController.prototype.OfflineInit = function() {
	Factory.getObj().LoadViewForOffline(this);
};

commondashboardController.prototype.OnlineInit = function() {
	//if($(this.dom).find(".tryagain").length != 0)
		//$(this.dom).find(".tryagain").remove();
	var urlMgmt = UrlMgmt.getObj();
	//HOME_silentLogin(function(){
		this.userInfo = urlMgmt.userData;
		//this.ProfileDetails();
		/*this.LoadScoreupCard();
			this.LoadCourseCard();
			this.BindEvents();
			this.getcourseattributes();*/
		if(this.data.userPackageLinks.packages.length > 0 )
		{
			this.LoadScoreupCard();
			this.LoadCourseCard();
			this.BindEvents();
			this.getcourseattributes();
		}
		else
		{
			// this.LoadEmptyPageView();
			this.BindEvents();
		}
		//this.accountId = $(".user-account-info").attr("data-account-id");
		//this.userBalance = $(".user-account-info").attr("data-user-balance");
	//}.bind(this));
	
};
commondashboardController.prototype.RefreshView = function() {
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.showLoader();
	//this.SetLayout();
	this.OnlineInit();
	urlMgmt.removeLoader();;
};
commondashboardController.prototype.BindEvents = function()
{
	//this.GetData();
	//this.ProfileDetails();
	console.log("inside dashboard bind events");
	$(this.dom).find('[packagetype="scoreup"]').unbind().bind('click', function(e){
		var pkgId = $(e.currentTarget).attr('data-item');
		var pkgDeliveryId = $(e.currentTarget).attr('data-delivery-Id');
		
		var allTags = null;
		for(var i=0; i< this.data.userPackageLinks.packages.length; i++)
		{
			pkgData = this.data.userPackageLinks.packages[i];
			if(pkgData["packageId"] == pkgId && pkgData["isPkgVersionSec"] == 1)
			{
				allTags = pkgData["tags"];
			}
		}
		
		var tag1 = Object.keys(allTags)[0];
		var tag2 = Object.keys(allTags[tag1]["subCategories"])[0];
		var seletedTags = {
			tag1:tag1,
			tag2:tag2
		};
		Factory.getObj().ScoreUpFilterModel({allTags:allTags,
											selectedTags: seletedTags, 
											pkgDeliveryId: pkgDeliveryId});

	}.bind(this));
	
	$(this.dom).find("a[data-action]").unbind().bind("click", function(e){
		e.preventDefault();
		var url = $(e.currentTarget).attr('href');
		var dataAction = $(e.currentTarget).attr('data-action');
		URLRedirection(url, dataAction);
	});
	$(this.dom).find('.js-batchlistpage').unbind().bind("click",function(e){
		e.preventDefault();
		if(typeof UrlMgmt.getObj().customHeader != "undefined")
		{
			UrlMgmt.getObj().customHeader.forEach(function(item,index){
				if((item.attributes).includes('data-listtype=batchlist'))
				{
					UrlMgmt.getObj().Route({route: "app/listing&id="+index, needData: false, emptyStack: true});
					return;
				}
			});
		}
	});
	$(this.dom).find('.js-scoreuplistpage').unbind().bind("click",function(e){
		e.preventDefault();
		if(typeof UrlMgmt.getObj().customHeader != "undefined")
		{
			UrlMgmt.getObj().customHeader.forEach(function(item,index){
				if((item.attributes).includes('data-listtype=scoreuplist') && item.url != '')
				{
					URLRedirection(item.url);
					//UrlMgmt.getObj().Route({route: "app/listing&id="+index, needData: false, emptyStack: true});
					return;
				}
			});
		}
	});
		$(this.dom).find('.packageview[data-packageview="course"]').find('.courseCard').unbind().bind("click",this,function(e){
		var deliveryid = $(this).attr('data-delivery-id');
		var subcategories = null;
		    
		if( $(this).attr('data-subcategory') != '' && $(this).attr('data-subcategory') != null && typeof $(this).attr('data-subcategory') != 'undefined' )
		{   //call model			
			subcategories = JSON.parse($(this).attr('data-subcategory'));
			console.log(subcategories);	  
			// console.log($(this).find('.course_list_title').html());   
			$("#explorableLinksCourseCard").find('.modal-title').html($(this).find('.course_list_title').html()); 
	    	Factory.getObj().PackageMenuModel(subcategories);
		}
		 else
		{  //get id and route
			UrlMgmt.getObj().Route({
				route : 'item/package&id='+deliveryid,
				needData : true,
				offlineAllowed : true
			});
			console.log("undefined");
		}
		

		
		// (e.data.userPackageLinks.packages).forEach(function(item){
		  	// console.log(item);
		// });
	});
	$('#app').find('.refreshDiv').remove();

};
commondashboardController.prototype.GetData = function()
{
	console.log("inside getdata");
	var url = remoteServer+"/route?route=common/profile&id="+UrlMgmt.getObj().userData.id+"&response-type=2&fromapp=1&loadall=1";
	tr$.ajax({
		url: url,
		timeout: 20000,
		offlineMode: false,
		progress: true,
		successClb: function(response){
			console.log("Inside success callback");
			this.data = response.data;
			this.OnlineInit();
		}.bind(this),
		errorClb: function(e){
			console.log('Inside error callback');
			console.log(e);
		},
	});
};
commondashboardController.prototype.LoadScoreupCard = function()
{
	var scoreupCardHTML = '';
	for( var pkg in this.data.userPackageLinks.packages)
	{
		var pkgData = this.data.userPackageLinks.packages[pkg];
		//console.log(pkgData);
		if(pkgData.isPkgVersionSec == 1 && Object.keys(pkgData.tags).length > 0)
		{
			if(pkg == 0)
			{
				scoreupCardHTML +=	  Factory.getObj().DashboardScoreupCard(pkgData, 1);	
			}	
			else
			{
				scoreupCardHTML +=	  Factory.getObj().DashboardScoreupCard(pkgData);
			}
		}
		
	}
	if(scoreupCardHTML != '')
	{
		$(this.dom).find('[data-packageview="scoreup"]').html(scoreupCardHTML);
	}
	else
	{
		$(this.dom).find('[data-packageview="scoreup"]').css("order","1");
	}	
	
};
commondashboardController.prototype.LoadCourseCard = function()
{
	var courseCardHTML = '';
	for( var pkg in this.data.userPackageLinks.packages)
	{
		
		var pkgData = this.data.userPackageLinks.packages[pkg];
		
		if(typeof pkgData.isPkgVersionSec == "undefined" || pkgData.isPkgVersionSec == 0)
		{
			courseCardHTML +=	  Factory.getObj().DashboardCourseCard(pkgData);
		}
	}
	if(courseCardHTML != '')
	{
		$(this.dom).find('[data-packageview="course"]').html(courseCardHTML);
	}
	else
	{
		$(this.dom).find('[data-packageview="course"]').css("order","1");
	}	
};
commondashboardController.prototype.getcourseattributes = function()
{
	var coursedom = $("[data-packageview='course']");
	var packageIds = [];
	var batches = [];
	coursedom.find('[type="package"]').each(function(i, obj){
		var id = $(obj).attr('data-itemid');
		packageIds.push(id);
	});
	coursedom.find('[type="batch"]').each(function(i, obj){
		var id = $(obj).attr('data-delivery-id');
		batches.push(id);
	});
	if(packageIds.length > 0)
	{
		this.GetUserattemptandwatchedDatafromPacakge(packageIds);
		this.GetlivestatusfromPacakge(packageIds,coursedom);
	}
	if(batches.length)
	{
		// this.GetUserWatchedVideoData(batches);
		// this.getpackageBatchattributes(batches,coursedom);
	}
};
commondashboardController.prototype.GetUserattemptandwatchedDatafromPacakge = function(packageids)
{
	console.log(packageids);
	tr$.ajax({
		mod: "tr2user",
		ack: "getuserwatchedattempteddatafromPackage",
		additionalParams:{
			packageids: packageids
		},
		xhrFields : {
			withCredentials : true
		},
		crossDomain : true,
		context : this,
		successClb: function(response){
			 var data = response.data;
			 var html = '';
				$.each(data, function( packageId, data ) {
					html ='';
					if((typeof data['tests'] != "undefined" && data['tests']['totalcount'] > 0) && (typeof data['videos'] != "undefined" && data['videos']['totalcount'] > 0))
					{
						
						$('[type="package"][data-itemId="'+packageId+'"] [data-info="test-total"]').html("<b>"+data['tests']['totalcount'] + "</b> Total Tests");
						$('[type="package"][data-itemId="'+packageId+'"] [data-info="video-total"]').html("<b>"+data['videos']['totalcount'] + "</b> Total Videos");
						if($('[type="package"][data-itemId="'+packageId+'"] [data-info="test-total"]').length > 0 && $('[type="package"][data-itemId="'+packageId+'"] [data-info="video-total"]').length > 0)
						{
							$('[type="package"][data-itemId="'+packageId+'"] [data-info="test-attempted"]').remove();
							$('[type="package"][data-itemId="'+packageId+'"] [data-info="test-unattempted"]').remove();
							$('[type="package"][data-itemId="'+packageId+'"] [data-info="video-watched"]').remove();
						}
						else
						{
							if($('[type="package"][data-itemId="'+packageId+'"] [data-info="test-total"]').length > 0)
							{
								$('[type="package"][data-itemId="'+packageId+'"] [data-info="test-attempted"]').html("<b>"+data['tests']['attemptcount'] + "</b> Attempted");;
								$('[type="package"][data-itemId="'+packageId+'"] [data-info="test-unattempted"]').html("<b>"+data['tests']['unattemptcount'] + "</b> UnAttempted");
							}
							if($('[type="package"][data-itemId="'+packageId+'"] [data-info="video-total"]').length > 0)
							{
								$('[type="package"][data-itemId="'+packageId+'"] [data-info="video-watched"]').html("<b>"+data['videos']['watchedcount'] + "</b> Videos Watched");;
							}
							
						}
						
					}
					else
					{
						if(typeof data['tests'] != "undefined" && data['tests']['totalcount'] > 0)
						 {
							$('[type="package"][data-itemId="'+packageId+'"] [data-info="test-attempted"]').html("<b>"+data['tests']['attemptcount'] + "</b> Attempted");
							$('[type="package"][data-itemId="'+packageId+'"] [data-info="test-unattempted"]').html("<b>"+data['tests']['unattemptcount'] + "</b> Unattempted");
						 	
						 }
						 else
						 {
						 	$('[type="package"][data-itemId="'+packageId+'"] [data-info="test-attempted"]').remove();
						 	$('[type="package"][data-itemId="'+packageId+'"] [data-info="test-unattempted"]').remove();
						 }
						 $('[type="package"][data-itemId="'+packageId+'"] [data-info="test-total"]').remove();
						 if(typeof data['videos'] != "undefined" && data['videos']['totalcount'] > 0)
						 {
							$('[type="package"][data-itemId="'+packageId+'"] [data-info="video-total"]').html("<b>"+data['videos']['totalcount'] + "</b> Total Videos");
							$('[type="package"][data-itemId="'+packageId+'"] [data-info="video-watched"]').html("<b>"+data['videos']['watchedcount'] + "</b> Videos Watched");							 
							
						 }
						 else
						 {
						 	$('[type="package"][data-itemId="'+packageId+'"] [data-info="video-total"]').remove();
						 	$('[type="package"][data-itemId="'+packageId+'"] [data-info="video-watched"]').remove();
						 }
					}
				 });
		}.bind(this),
		errorClb: function(){
			//do nothing
		}
	});
	
	
	
};
commondashboardController.prototype.GetlivestatusfromPacakge = function(packageIds, coursedom)
{
	console.log(packageIds);
	tr$.ajax({
		mod: "tr2user",
		ack: "getpackageStatus",
		additionalParams:{
			packageIds: packageIds
		},
		xhrFields : {
			withCredentials : true
		},
		crossDomain : true,
		context : this,
		successClb: function(response){
			var data = response.data;
			 $.each(data, function(index, packageData) {
				   
				  var dom = $('[data-card="course"][data-itemId="'+index+'"]');
				   
				 	if(typeof packageData.live != 'undefined')
				    {
				    	dom.find('[data-type="video"]').attr('video-status', 'live');
				    	//dom.find('[data-type="video"] [video-title="title"]').text(packageData.live.title);
				    	dom.find('[data-type="video"] [video-start-date="start-date"]').hide();
				    	dom.find('[data-type="video"] [video-start-date-text="start-date-text"]').hide();
				    	dom.find('[data-type="video"] [status-text="video-status"]').text('LIVE');
				    	dom.find('[data-type="video"] [status-text="video-status"]').removeClass('upcoming');
				    	dom.find('[data-type="video"] [status-text="video-status"]').addClass('live');
				   		$('[video-status="live"]').removeClass('display-none');
				   		
				    }
				    else if(typeof packageData.upcoming != 'undefined')
				    {
				    	if(dom.find('[data-type="video"]').attr('video-status') != 'live')
				    	{
				    		dom.find('[data-type="video"]').attr('video-status', 'upcoming');
				    		if(dom.find('[data-type="video"] [video-start-date="start-date"]').text() !='')
				    		{
				    			var d1 = new Date(dom.find('[data-type="video"] [video-start-date="start-date"]').text());
				    			var d2 = new Date(packageData.upcoming.startDate);
				    			if(d1 > d2)
				    			{
				    				//dom.find('[data-type="video"] [video-title="title"]').text(packageData.upcoming.title);
				    				dom.find('[data-type="video"] [video-start-date="start-date"]').text(Factory.getObj().getdateformat(packageData.upcoming.startDate));
				    			}
				    		}
				    		else
				    		{
				    			//dom.find('[data-type="video"] [video-title="title"]').text(packageData.upcoming.title);
				    			dom.find('[data-type="video"] [video-start-date="start-date"]').text(Factory.getObj().getdateformat(packageData.upcoming.startDate));
				    		}
				    		dom.find('[data-type="video"] [status-text="video-status"]').text('UPCOMING');
				    		dom.find('[data-type="video"] [status-text="video-status"]').addClass('upcoming');
				    	}
				    	$('[video-status="upcoming"]').removeClass('display-none');
				    }
				 }.bind(this));
		}.bind(this),
		errorClb: function(){
			//do nothing
		}
	});
};
// commondashboardController.prototype.GetlivestatusfromPacakge = function(batchIds)
// {
	// tr$.ajax({
		// mod: "tr2user",
		// ack: "getuserwatchedvideodata",
		// additionalParams:{
			// batchid: batchIds
		// },
		// xhrFields : {
			// withCredentials : true
		// },
		// crossDomain : true,
		// context : this,
		// successClb: function(response){
			 // var data = response.data;
			 // var html = '';
				// $.each(data, function( packageId, data ) {
					// html ='';
// 					
				 // });
		// }.bind(this),
		// errorClb: function(){
			// //do nothing
		// }
	// });
// };
commondashboardController.prototype.GetUserWatchedVideoData = function()
{
	/*
	 * 
	 */
	tr$.ajax({
		mod: "tr2user",
		ack: "getuserwatchedvideodata",
		additionalParams:{
			batchid: batchIds
		},
		xhrFields : {
			withCredentials : true
		},
		crossDomain : true,
		context : this,
		successClb: function(response){
			 var data = response.data;
			 var html = '';
				$.each(data, function( packageId, data ) {
					html ='';
					
				 });
		}.bind(this),
		errorClb: function(){
			//do nothing
		}
	});	
};
commondashboardController.prototype.LoadEmptyPageView = function()
{
			var profileDetails =		'<div class="nothing-bought">'+
												'<span class="nothing-bought-txt">You have not bought any test plan to  prepare for your exam</span>'+
												'<img src="https://cdn.toprankers.net/images/scoreup-logo_1-02489d9eb2056.png" />'+
											'<a class="buy-plans"href="/subscription-plans" data-action="lists/package&id=11">'+
												'<span class="text-blue">SUBSCRIBE</span>'+
											'</a>'+	
										'</div>'+
										'<div class="courcesnothing-bought">'+	
												'<span class="nothing-bought-txt">You have not bought any courses to prepare for your exams</span>'+
											'<a class="buy-plans" href="/subscription-plans" data-action="lists/package&id=11">'+
												'<span class="text-blue">EXPLORE ALL COURSES</span>'+
											'</a>'+	
										'</div>';
			$(this.dom).html(profileDetails);							
};
