var commontr2menuController = function()
{
	this.view = "default";
	this.style = "default";
	this.dom = null;
	this.ongoing_class_dom = null;
	this.selected = null;
};
commontr2menuController.prototype.Init = function(viewDom)
{
	this.dom = viewDom;
	this.RefreshMenuData(function(){
		this.PopulateMenu();
		this.MaintainMenuUrlMapping();
		this.BindEvents();
	}.bind(this));
};
commontr2menuController.prototype.View = function()
{
	this.dom.show();
	if($('.mainItem.dashboardInMenu').length > 0 && typeof UrlMgmt.getObj().userData != 'undefined' && UrlMgmt.getObj().userData != null && typeof UrlMgmt.getObj().userData.id != 'undefined'){
		$('.mainItem.dashboardInMenu').attr('data-action', 'common/profile&id='+UrlMgmt.getObj().userData.id);
	}
			
	var menuItem = "";
	var urlMgmt = UrlMgmt.getObj();
	//Remove activeness from all menuItems
	$(".menu-item li").removeClass('active');
	$(".menu-item li").css("pointer-events","auto");
	if(urlMgmt.actionStack[urlMgmt.actionStack.length-1].controler.urlForMenu != null){
		var urlForMenu = urlMgmt.actionStack[urlMgmt.actionStack.length-1].controler.urlForMenu.split('#')[0];
		menuItem = $("#menu-bar").find("li[data-menuItem="+urlMgmt.menuUrlMapping[urlForMenu]+"]");
	}
	if(menuItem.length == 0){
		var action = $(urlMgmt.actionStack[urlMgmt.actionStack.length-1].view).data('view-action');
		var menuItem = $("#menu-bar").find("li[data-action='"+action+"']");
		if(menuItem.length == 0){
			menuItem = $("#menu-bar").find("li[data-action='"+action.split('&')[0]+"']");
		}	
	}
	var action = $(urlMgmt.actionStack[urlMgmt.actionStack.length-1].view).data('view-action');
	var actionData = urlMgmt.actionStack[urlMgmt.actionStack.length-1].controler.data;
	var listType = 0;
	if(typeof actionData != 'undefined' && typeof actionData.listType != 'undefined'){
		listType = actionData.listType;
		action = TR2ListType[listType];
	}	
	if(menuItem.length > 0){
		this.MenuItemActive(menuItem);
	}
};
commontr2menuController.prototype.BindEvents = function()
{
	var urlMgmt = UrlMgmt.getObj();
	$(this.dom).find(".mainItem").unbind().bind('click', function(e) {
		this.selected = $(e.currentTarget);
		var id = $(e.currentTarget).attr('data-index');
		var url = $(e.currentTarget).attr('data-url');
		var action = $(e.currentTarget).attr('data-action');
		var openAction = $(e.currentTarget).attr('data-open-action');
		var child = parseInt($(e.currentTarget).attr('data-child'));
		if(typeof action != 'undefined' && action == "common/home"){
			urlMgmt.ClearActionStack();
		}
		if(typeof openAction != 'undefined' && openAction == "lists/test"){
			this.getMyTestAction();
		}
		else if(typeof openAction != 'undefined' && openAction == "common/tr2myassignments"){
			urlMgmt.Route({route: "common/tr2myassignments", needData: false, emptyStack: true});
		}
		else if(typeof openAction != 'undefined' && openAction == "common/tr2mycourseware"){
			urlMgmt.Route({route: "common/tr2mycourseware", needData: false, emptyStack: true});
		}
		else if(typeof openAction != 'undefined' && openAction == "item/batch"){
			urlMgmt.Route({route: "lists/batch", needData: true, emptyStack: true});
		}
		
		else if(child > 0){
			//Navigate to the listing page
			urlMgmt.Route({route: "app/listing&id="+id, needData: false, emptyStack: true});
		}
		else{
			if(typeof url == 'undefined' || url.length == 0){
				urlMgmt.Route({route: action, needData: true, emptyStack: true});
			}
			else{
				urlMgmt.ClearActionStack(false);
				URLRedirection(url);
			}
		}
	}.bind(this));
	$(this.dom).find(".mainItemDashboard").unbind().bind('click', function(e)
	{
		urlMgmt.Route({route: "common/dashboard", needData: false, emptyStack: true});
	});
	$('.modal').on('shown.bs.modal', function(){
		urlMgmt.modalObj = $(this);
	});
	$('.modal').on('hidden.bs.modal', function(){
		urlMgmt.modalObj = null;
	});
};
//decide the action on Mytest click from bottom menu
commontr2menuController.prototype.getMyTestAction = function()
{
	var urlMgmt = UrlMgmt.getObj();
	var actionObj = {route: "lists/test", needData: false, emptyStack: true};
	if(urlMgmt.userData == null){
		urlMgmt.Route(actionObj);
	}
	else{
		if(UrlMgmt.getObj().subscription == '1'){
			if(urlMgmt.menuData && urlMgmt.menuData.myExams && urlMgmt.menuData.myExams.length > 0){
				actionObj = {route: "common/tr2myexams", needData:false, emptyStack: true};
			}
		}
		else if(UrlMgmt.getObj().subscription == '0'){
			actionObj = {route: "common/tr2myexams", needData:false, emptyStack: true};
		}
		urlMgmt.Route(actionObj);
	}
};
commontr2menuController.prototype.SideMenuOpen = function()
{
	this.dom.addClass('slide-view-menu');
};
commontr2menuController.prototype.SideMenuClose = function()
{
	this.dom.removeClass('slide-view-menu');
};
commontr2menuController.prototype.RefreshMenuData = function(callback)
{
	var onSuccess = function(response){
		
		var resultObj = response.header;
		var categoryNew = sortObjectOnListIndex(resultObj.categories);
		resultObj.categories = [];
		resultObj.categories = categoryNew;
		
		var examNew = sortObjectOnListIndex(resultObj.exams);
		resultObj.exams = [];
		resultObj.exams = examNew;
		
		var testlistNew = sortObjectOnListIndex(resultObj.testLists);
		resultObj.testLists = [];
		resultObj.testLists = testlistNew;
		
		for(var category in resultObj.categories){
			var batchNew = sortObjectOnListIndex(resultObj.categories[category].batches);
			resultObj.categories[category].batches = [];
			resultObj.categories[category].batches = batchNew;
		}
		for(var exam in resultObj.exams){
			var testlistNew = sortObjectOnListIndex(resultObj.exams[exam].testListId);
			resultObj.exams[exam].testListId = [];
			resultObj.exams[exam].testListId = testlistNew;
		}
		UrlMgmt.getObj().menuData = resultObj;
		UrlMgmt.getObj().customHeader = response.customHeader;
		
		if(typeof callback != 'undefined')
			callback();
	}.bind(this);
	var onError = function(e){
		console.log(e);
		if(typeof callback != 'undefined')
			callback();
	};
	DataMgmt.GetData("common/header&0", {}, true, onSuccess, onError);
};
commontr2menuController.prototype.MenuItemActive = function(menuItem)
{
	$(".menu-item li").removeClass('active');
    $(menuItem).addClass('active');
    $(".menu-item li").css("pointer-events","auto");
    if(menuItem.data('event-none') == true){
		this.MenuItemEvent(menuItem);
	}
};
/* Pointer-event disable for clicked menu item */
commontr2menuController.prototype.MenuItemEvent = function(menuItem)
{
	$(menuItem).css("pointer-events","none");
};

commontr2menuController.prototype.PopulateMenu = function()
{
	var customMenu = UrlMgmt.getObj().customHeader;
	if(typeof customMenu != 'undefined' && customMenu != null){
		bottomMenu = "";
		if(UrlMgmt.getObj().userData != null && typeof UrlMgmt.getObj().userData.id != 'undefined')
		{
			bottomMenu += "<li class='mainItemDashboard' data-action='common/dashboard' data-index='0' data-child='0' data-event-none='true' data-url='' style='order:0;'>"+
						  	  "<span>"+
								"<img src='https://cdn.toprankers.net/images/dashboard1-0248a4e3a3a66.png' alt='Dashboard'>"+
							  "</span>"+
							  "<p class='menu-text'>dashboard</p>"+
						  "</li>";
		}
		if(typeof dashboardInMenu != 'undefined' && dashboardInMenu == true){
			bottomMenu += '<li class="mainItem dashboardInMenu" data-action="common/profile" data-index="-1" data-menuItem="-1" data-child="0" data-event-none="true" data-url="" style="order:-1;">'+
						  	'<span><img src="img/dashboard.png" alt="DASHBOARD"></span>'+
							'<p class="menu-text">DASHBOARD</p>'+
						  '</li>';
		}
		for(var menuItem in customMenu){
			var data = customMenu[menuItem];
			var dataEventNone = true;
			if(Array.isArray(data.children) && data.children.length > 0){
				dataEventNone = false;
			}
			bottomMenu += '<li class="mainItem" '+ data["attributes"] +' data-index="'+menuItem+'" data-menuItem="'+data["index"]+'" data-child="'+data.children.length+'" data-event-none="'+dataEventNone+'" data-url="'+data["url"]+'" style="order:'+data["index"]+';">'+
						  	'<span><img src="'+data["iconUrl"]+'" alt="'+data["title"]+'"></span>'+
							'<p class="menu-text">'+data["title"]+'</p>'+
						  '</li>';
		}
	}
	this.dom.find('#menu-bar').find('.menu-item').html(bottomMenu);
	if(typeof UrlMgmt.getObj().menuData.assignmentList == "undefined"){
		$(this.dom).find(".nav-my-assignments").remove();
	}
	var totalItems = this.dom.find('#menu-bar').find('.menu-item').find('li').length;
	this.dom.find('#menu-bar').find('.menu-item').find('li').css('width', (Math.floor(100/totalItems, 2))+"%");
	if(totalItems > 5){
		//scrollable menu
		this.dom.find('#menu-bar').find('.menu-item').find('li').css('width', '18%');
		this.dom.find("#menu-bar").css('overflow-x', 'auto');
		this.dom.find("#menu-bar").css('overflow-y', 'hidden');
		this.dom.find("#menu-bar").find('.menu-item').css('overflow-x', 'auto');
	}
	this.ongoing_class_dom = '<span class="headerongoing">'+
               				'<svg width="25px"  height="25px"  xmlns="http://www.w3.org/2000/svg" viewBox="0 0 100 100" preserveAspectRatio="xMidYMid" class="lds-ripple" style="background: none;position:absolute;">'+
	               				'<circle cx="50" cy="50" r="24.4497" fill="none" ng-attr-stroke="{{config.c1}}" ng-attr-stroke-width="{{config.width}}" stroke="#ff2424" stroke-width="3">'+
		               				'<animate attributeName="r" calcMode="spline" values="0;40" keyTimes="0;1" dur="2.1" keySplines="0 0.2 0.8 1" begin="-1.05s" repeatCount="indefinite">'+
		               				'</animate>'+
		               				'<animate attributeName="opacity" calcMode="spline" values="1;0" keyTimes="0;1" dur="2.1" keySplines="0.2 0 0.8 1" begin="-1.05s" repeatCount="indefinite">'+
		               				'</animate>'+
	               				'</circle>'+
	               				'<circle cx="50" cy="50" r="39.6889" fill="none" ng-attr-stroke="{{config.c2}}" ng-attr-stroke-width="{{config.width}}" stroke="#ff0000" stroke-width="3">'+
		               				'<animate attributeName="r" calcMode="spline" values="0;40" keyTimes="0;1" dur="2.1" keySplines="0 0.2 0.8 1" begin="0s" repeatCount="indefinite">'+
		               				'</animate>'+
		               				'<animate attributeName="opacity" calcMode="spline" values="1;0" keyTimes="0;1" dur="2.1" keySplines="0.2 0 0.8 1" begin="0s" repeatCount="indefinite">'+
		               				'</animate>'+
	               				'</circle>'+
               				'</svg>'+
               			'</span>';
	if((typeof UrlMgmt.getObj().menuData.batchStatus != 'undefined' && UrlMgmt.getObj().menuData.batchStatus != null ) && typeof UrlMgmt.getObj().menuData.batchStatus.ongoing != 'undefined' && $(this.dom).find('li[data-class-status="true"]').length > 0){
		$(this.dom).find('li[data-class-status="true"]').find('.headerongoing').remove();
		$(this.dom).find('li[data-class-status="true"]').prepend(this.ongoing_class_dom);
		$(this.dom).find('li[data-class-status="true"]').find('p').addClass('ongoing-class');
	}
};
commontr2menuController.prototype.MaintainMenuUrlMapping = function()
{
	var menuUrlMapping = {};
	var customHeader = UrlMgmt.getObj().customHeader;
	if(typeof customHeader != 'undefined' && customHeader != null){
		for(var menuItem in customHeader){
			var headerItem = customHeader[menuItem];
			if(headerItem.children.length == 0 && headerItem.url.length > 0){
				menuUrlMapping[headerItem.url.split('#')[0]] = headerItem.index;
			}
			else if(headerItem.children.length > 0){
				for(var child in headerItem.children){
					if(headerItem.children[child].url.length > 0){
						menuUrlMapping[headerItem.children[child].url.split('#')[0]] = headerItem.index;
					}
					if(headerItem.children[child].children.length > 0){
						for(var item in headerItem.children[child].children){
							if(headerItem.children[child].children[item].url.length > 0){
								menuUrlMapping[headerItem.children[child].children[item].url.split('#')[0]] = headerItem.index;
							}
						}
					}
				}
			}
		}
	}
	UrlMgmt.getObj().menuUrlMapping = menuUrlMapping;
};