var commontr2mycoursewareController = function() {
	this.view = "default";
	this.style = "default";
	this.dom = null;
	this.data = null;
	this.refresh = true;
	
	this.exams = {};
	this.categories = {};
	this.myExams = {};
	this.testLists = {};
	this.coursewareList = {};
	this.categoryObj = new Object();
};
commontr2mycoursewareController.prototype.Init = function(viewDom)
{
	this.dom = viewDom;
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.showLoader();
	this.data = urlMgmt.menuData;
	this.categories = this.data.categories;
	this.exams = this.data.exams;
	this.myExams = this.data.myExams;
	this.testLists = this.data.testLists;
	this.coursewareList = this.data.coursewareList;
	this.SetLayout();
	this.LoadData();
	// analytics_trackView("my_exams");
	// analytics_trackEvent("my_exams" , '/my-exams');
	
	urlMgmt.removeLoader();	
};
commontr2mycoursewareController.prototype.SetLayout = function()
{
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.lockRotation();
	urlMgmt.menuAction.view.hide();
	urlMgmt.headerAction.controler.DisplayHeader(this.dom, 'Courseware', false, true, false);
};
commontr2mycoursewareController.prototype.RefreshView = function()
{
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.showLoader();
	this.Init();
	urlMgmt.removeLoader();
};
commontr2mycoursewareController.prototype.LoadData = function()
{
	this.LoadMyObject();
	this.LoadMyCategories();
	this.BindEvents();
};
commontr2mycoursewareController.prototype.BindEvents = function()
{
	$(this.dom).find('.myexam-subscribe-btn').unbind().bind('click', this, function() {
		UrlMgmt.getObj().Route({route: 'common/tr2subscription', needData: false});
	});
};
commontr2mycoursewareController.prototype.LoadMyObject = function()
{
	
	for (var i in this.exams) {
		
		var examTemp = getMatchingValue(this.exams, "id", this.myExams[i]);
		var tempid = this.exams[i].categoryId;
		
		if (!this.categoryObj.hasOwnProperty(tempid)) {
			this.categoryObj[tempid] = new Object();
			this.categoryObj[tempid].title = getMatchingValue(this.categories, "id", tempid).title;
		}
		if (!this.categoryObj[tempid].hasOwnProperty('coursewareList')) {
			this.categoryObj[tempid].coursewareList = [];
		}
		for (var coursewareList in this.exams[i].coursewareListId) {
			this.categoryObj[tempid]["coursewareList"].push(new Object());
			var len = this.categoryObj[tempid]["coursewareList"].length;
			var coursewareListdata = this.exams[i].coursewareListId[coursewareList];
			this.categoryObj[tempid]["coursewareList"][len - 1].id = coursewareListdata;
			for(x in this.coursewareList)
			{
				if(x == coursewareListdata)
				{
					var coursewareListObj = this.coursewareList[x];
					// console.log("coursewareListObj",coursewareListObj);
				}
			}

			//var lessonListObj = getMatchingValue(this.lessonLists, "testListId", lessonListdata);
			
			this.categoryObj[tempid]["coursewareList"][len - 1].title = coursewareListObj.title;
		}
	}
	
};

commontr2mycoursewareController.prototype.LoadMyCategories = function()
{
	var container = $(this.dom).find('.nav-tabs');
	var tabcontainer = $(this.dom).find('.tab-content');
	if (Object.keys(this.categoryObj).length) {
		var catnamex = 'All exams';
		var catname = catnamex.replace(/ /g, '');
		var tab = '<li class="myCategory active" role="presentation">' + '<a class="' + catname + '" href="#' + catname + '" role="tab" data-toggle="tab"> ' + 'All Courseware'+ ' </a>' + '</li>';
		$(tab).appendTo(container);
		var tabcontent = '<div role="tabpanel" class="tab-pane active" id="' + catname + '">' + '</div>';
		$(tabcontent).appendTo(tabcontainer);
		console.log("this.categoryObj",this.categoryObj);
		for (var i in this.categoryObj) {
			if(this.categoryObj[i].coursewareList.length <= 0)
			{
				continue;
			}
			var catnamex = getMatchingValue(this.categories, "id", i).title;
			var catname = catnamex.replace(/ /g, '').replace(/\./g, '');
			var tab = '<li class="myCategory" role="presentation">' + '<a class="' + catname + '" href="#' + catname + '" role="tab" data-toggle="tab"> ' + catnamex + ' </a>' + '</li>';
			$(tab).appendTo(container);
			var tabcontent = '<div role="tabpanel" class="tab-pane" id="' + catname + '">' + '</div>';
			$(tabcontent).appendTo(tabcontainer);
			this.LoadMyExams(this.categoryObj[i], catname, tabcontainer);
		}
		$(".myCategory").unbind().bind('click', function(e){
			var calculate1 = $(".mytabList").scrollLeft() + $(e.currentTarget).offset().left-$(".mytabList").offset().left-$(".mytabList")[0].clientWidth/2 + $(e.currentTarget).outerWidth(true)/2;
			$('.mytabList').animate({
	        scrollLeft: calculate1
	    	}, 1000);
	    });    
		slider("myTests", 'mytabList', "myCategory");	
		var emptybottom = '<div class="emptygap"></div>';
		$(emptybottom).appendTo($(tabcontainer).find('#Allexams'));
		$(this.dom).find('.emptygap').height('79px');
	}
	else {
		alert("No exams subscribed");
	}
	$(this.dom).find('[role="tab"]').on('click', function(e) {
		var categoryTabId = $(e.currentTarget).attr('class');
		var length = this.ExamsTotalLength(categoryTabId);
		// $('.exam-patti').find("p").text("Total " + length + " exams subscribed");
		$(this.dom).scrollTop(0);
	}.bind(this));
	// $('.exam-patti').find("p").text("Total " + this.ExamsTotalLength('Allexams') + " exams subscribed");
};

commontr2mycoursewareController.prototype.LoadMyExams = function(objectid, catname, tabcontainer)
{
	var tabpopulate = $(tabcontainer).find('#' + catname);
	var tabpopulateAll = $(tabcontainer).find('#Allexams');
	var addedTestLists = [];
	// console.log("objectid",objectid);
	for (var x in objectid.coursewareList) {
		if(addedTestLists.indexOf(objectid.coursewareList[x].id) == -1){
			var testname = "<div class='examDiv' data-action='lists/test&id=" + objectid.coursewareList[x].id + "'>" + "<p>" + objectid.coursewareList[x].title + "</p>" + "<img src='img/right-nav-blue.png'" + "</div>";
			$(testname).appendTo(tabpopulate);
			$(testname).appendTo(tabpopulateAll);
			addedTestLists.push(objectid.coursewareList[x].id);
		}
	}
	var emptybottom = '<div class="emptygap"></div>';
	$(emptybottom).appendTo(tabpopulate);

	$(this.dom).find('.examDiv').unbind().bind('click', function(e) {
		var testlistAction = $(e.currentTarget).attr('data-action');
		UrlMgmt.getObj().Route({route: testlistAction, needData: true, offlineAllowed: true, emptyStack: true});
	}.bind(this));

};

commontr2mycoursewareController.prototype.ExamsTotalLength = function(listview)
{
	var content = $(this.dom).find(".tab-content");
	var current = $(content).find('#' + listview);
	var length = $(current).find('.examDiv').length;
	return length;
};
commontr2mycoursewareController.prototype.RefreshView = function()
{
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.showLoader();
	this.LoadData();
	urlMgmt.removeLoader();
};