var commontr2myexamsController = function() {
	this.view = "default";
	this.style = "default";
	this.dom = null;
	this.data = null;
	this.refresh = true;
	
	this.exams = {};
	this.categories = {};
	this.myExams = {};
	this.testLists = {};
	this.categoryObj = new Object();
};
commontr2myexamsController.prototype.Init = function(viewDom)
{
	this.dom = viewDom;
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.showLoader();
	this.data = urlMgmt.menuData;
	this.categories = this.data.categories;
	this.exams = this.data.exams;
	this.myExams = this.data.myExams;
	this.testLists = this.data.testLists;
	
	this.SetLayout();
	this.LoadData();
	
	analytics_trackView("my_exams");
	analytics_trackEvent("my_exams" , '/my-exams');
	urlMgmt.removeLoader();	
};
commontr2myexamsController.prototype.SetLayout = function()
{
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.lockRotation();
	urlMgmt.menuAction.view.hide();
	var title = "My Exams";
	if(urlMgmt.subscription == "0"){
		title = "Exams";
	}
	urlMgmt.headerAction.controler.DisplayHeader(this.dom, title, false, true, false);
};
commontr2myexamsController.prototype.RefreshView = function()
{
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.showLoader();
	this.Init();
	urlMgmt.removeLoader();
};
commontr2myexamsController.prototype.LoadData = function()
{
	this.LoadMyObject();
	this.LoadMyCategories();
	this.BindEvents();
};
commontr2myexamsController.prototype.BindEvents = function()
{
	$(this.dom).find('.myexam-subscribe-btn').unbind().bind('click', this, function() {
		UrlMgmt.getObj().Route({route: 'common/tr2subscription', needData: false});
	});
};
commontr2myexamsController.prototype.LoadMyObject = function()
{
	if(UrlMgmt.getObj().subscription == '1'){
		$(".myexam-subscribe-btn").show();
		$(".exam-patti").show();
		for (var i in this.myExams) {
			
			var examTemp = getMatchingValue(this.exams, "id", this.myExams[i]);
			if(typeof examTemp == "undefined")
			{
				continue;
			}
			var tempid = examTemp.categoryId;
			
			if (!this.categoryObj.hasOwnProperty(tempid)) {
				this.categoryObj[tempid] = new Object();
				this.categoryObj[tempid].title = getMatchingValue(this.categories, "id", tempid).title;
			}
			if (!this.categoryObj[tempid].hasOwnProperty('testLists')) {
				this.categoryObj[tempid].testLists = [];
			}
	
			for (var testList in examTemp.testListId) {
				this.categoryObj[tempid]["testLists"].push(new Object());
				var len = this.categoryObj[tempid]["testLists"].length;
				var testlistdata = examTemp.testListId[testList];
				this.categoryObj[tempid]["testLists"][len - 1].id = testlistdata;
				var testListObj = getMatchingValue(this.testLists, "testListId", testlistdata);
				
				this.categoryObj[tempid]["testLists"][len - 1].title = testListObj.title;
			}
		}
	}
	else if(UrlMgmt.getObj().subscription == '0'){
		$(".myexam-subscribe-btn").hide();
		$(".exam-patti").hide();
		for (var i in this.exams) {
			var examTemp = getMatchingValue(this.exams, "id", this.exams[i].id);
			var tempid = examTemp.categoryId;
			
			if (!this.categoryObj.hasOwnProperty(tempid)) {
				this.categoryObj[tempid] = new Object();
				this.categoryObj[tempid].title = getMatchingValue(this.categories, "id", tempid).title;
			}
			if (!this.categoryObj[tempid].hasOwnProperty('testLists')) {
				this.categoryObj[tempid].testLists = [];
			}
	
			for (var testList in examTemp.testListId) {
				this.categoryObj[tempid]["testLists"].push(new Object());
				var len = this.categoryObj[tempid]["testLists"].length;
				var testlistdata = examTemp.testListId[testList];
				this.categoryObj[tempid]["testLists"][len - 1].id = testlistdata;
				var testListObj = getMatchingValue(this.testLists, "testListId", testlistdata);
				this.categoryObj[tempid]["testLists"][len - 1].title = testListObj.title;
			}
		}
	}
};

commontr2myexamsController.prototype.LoadMyCategories = function()
{
	var container = $(this.dom).find('.nav-tabs');
	var tabcontainer = $(this.dom).find('.tab-content');
	if (Object.keys(this.categoryObj).length) {
		var catnamex = 'All exams';
		var catname = catnamex.replace(/ /g, '');
		
		var j = undefined,onlyonecategory = true;  
		// this is to check weather there is only one category or not. if only one category is 
		// there then "allExam" tab must not be there
		for(var i in UrlMgmt.getObj().menuData.exams)
		{  
			if(typeof j == "undefined"){
				j = UrlMgmt.getObj().menuData.exams[i]['categoryId'];
			}
			if(j == UrlMgmt.getObj().menuData.exams[i]['categoryId'] )
			{
				continue;
			}
			else{
				onlyonecategory = false;
				break;
			}
		}
		if(onlyonecategory == false)
		{
			var tab = '<li class="myCategory active" role="presentation">' + '<a class="' + catname + '" href="#' + catname + '" role="tab" data-toggle="tab"> ' + catnamex + ' </a>' + '</li>';
			 $(tab).appendTo(container);
		}
		
		var tabcontent = '<div role="tabpanel" class="tab-pane active" id="' + catname + '">' + '</div>';
		$(tabcontent).appendTo(tabcontainer);
		//this.LoadMyExams(this.categoryObj[i], catname, tabcontainer);
		for (var i in this.categoryObj) {
			var catnamex = getMatchingValue(this.categories, "id", i).title;
			var catname = tr$.strReplace(catnamex);
			var tab = '<li class="myCategory '+(onlyonecategory?'active':'')+'" role="presentation">' + '<a class="' + catname + '" href="#' + catname + '" role="tab" data-toggle="tab"> ' + catnamex + ' </a>' + '</li>';
			onlyonecategory=false;
			$(tab).appendTo(container);
			var tabcontent = '<div role="tabpanel" class="tab-pane" id="' + catname + '">' + '</div>';
			$(tabcontent).appendTo(tabcontainer);
			this.LoadMyExams(this.categoryObj[i], catname, tabcontainer);
		}
		$(".myCategory").unbind().bind('click', function(e){
			var calculate1 = $(".mytabList").scrollLeft() + $(e.currentTarget).offset().left-$(".mytabList").offset().left-$(".mytabList")[0].clientWidth/2 + $(e.currentTarget).outerWidth(true)/2;
			$('.mytabList').animate({
	        scrollLeft: calculate1
	    	}, 1000);
	    });    
		slider("myTests", 'mytabList', "myCategory");	
		var emptybottom = '<div class="emptygap"></div>';
		$(emptybottom).appendTo($(tabcontainer).find('#Allexams'));
		$(this.dom).find('.emptygap').height('79px');
	}
	else {
		alert("No exams subscribed");
	}
	$(this.dom).find('[role="tab"]').on('click', function(e) {
		var categoryTabId = $(e.currentTarget).attr('class');
		var length = this.ExamsTotalLength(categoryTabId);
		$('.exam-patti').find("p").text("Total " + length + " exams selected");
		$(this.dom).scrollTop(0);
	}.bind(this));
	$('.exam-patti').find("p").text("Total " + this.ExamsTotalLength('Allexams') + " exams selected");
};

commontr2myexamsController.prototype.LoadMyExams = function(objectid, catname, tabcontainer)
{
	var tabpopulate = $(tabcontainer).find('#' + catname);
	var tabpopulateAll = $(tabcontainer).find('#Allexams');
	var addedTestLists = [];
	for (var x in objectid.testLists) {
		if(addedTestLists.indexOf(objectid.testLists[x].id) == -1){
			var testname = "<div class='examDiv' data-action='lists/test&id=" + objectid.testLists[x].id + "'>" + "<p>" + objectid.testLists[x].title + "</p>" + "<img src='img/right-nav-blue.png'" + "</div>";
			$(testname).appendTo(tabpopulate);
			$(testname).appendTo(tabpopulateAll);
			addedTestLists.push(objectid.testLists[x].id);
		}
	}
	var emptybottom = '<div class="emptygap"></div>';
	$(emptybottom).appendTo(tabpopulate);

	$(this.dom).find('.examDiv').unbind().bind('click', function(e) {
		var testlistAction = $(e.currentTarget).attr('data-action');
		UrlMgmt.getObj().Route({route: testlistAction, needData: true, offlineAllowed: true, emptyStack: true});
	}.bind(this));

};

commontr2myexamsController.prototype.ExamsTotalLength = function(listview)
{
	var content = $(this.dom).find(".tab-content");
	var current = $(content).find('#' + listview);
	var length = $(current).find('.examDiv').length;
	return length;
};
commontr2myexamsController.prototype.RefreshView = function()
{
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.showLoader();
	this.LoadData();
	urlMgmt.removeLoader();
};