/************ EXAM SUBSCRIPTION *************/
var commontr2subscriptionController = function()
{
	this.view = "default";
	this.style = "default";
	this.dom = null;
	this.data = null;
	
	this.categories = null;
	this.exams = null;
	this.myExams = null;
	this.selectedExams = [];
};
commontr2subscriptionController.prototype.Init = function(viewDom)
{
	this.dom = viewDom;
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.showLoader();
	this.data = urlMgmt.menuData;
	this.categories = this.data.categories;
	this.exams = this.data.exams;
	this.myExams = this.data.myExams;
	
	this.SetLayout();
	this.PopulateUI();
	this.BindEvents();
	analytics_trackView("exam_subscription");
	analytics_trackEvent("exam_subscription" , '/exam-subscription');
	urlMgmt.removeLoader();
};
commontr2subscriptionController.prototype.SetLayout = function()
{
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.lockRotation();
	urlMgmt.menuAction.view.hide();
	//urlMgmt.headerAction.controler.DisplayHeader(this.dom, 'Subscribe Exams', false, true, true);
	urlMgmt.headerAction.view.hide();
};
commontr2subscriptionController.prototype.BindEvents = function()
{
	this.dom.find('.imgclose').unbind().bind('click',function(){
		UrlMgmt.getObj().PopView();
	});
	//select all
	this.dom.find(".categoryCheckbox").change(this,function(e){ 
		var categoryId = $(this).data('category');
		e.data.dom.find("[data-exam-cat='"+categoryId+"']").prop('checked', $(this).prop("checked"));
		$(this).is(":checked") ? $(this).parents().siblings(".exams").find(".examname").addClass("selectedexam") : $(this).parents().siblings(".exams").find(".examname").removeClass("selectedexam");
		changeExamCount(e.data.dom);
	});
	
	this.dom.find(".examCheckbox").change(this,function(e){
		$(this).is(":checked") ? $(this).parents().siblings(".examname").addClass("selectedexam") : $(this).parents().siblings(".examname").removeClass("selectedexam");
		var categoryId = $(this).data('exam-cat');
	    if(false == $(this).prop("checked")){
	        e.data.dom.find("[data-category='"+categoryId+"']").prop('checked', false);
	    }
	    if (e.data.dom.find("[data-exam-cat='"+categoryId+"']:checked").length == e.data.dom.find("[data-exam-cat='"+categoryId+"']").length ){
	        e.data.dom.find("[data-category='"+categoryId+"']").prop('checked', true);
	    }
	});
	
	//subscribe
	this.dom.find("[data-trigger='subscribe']").unbind().bind("click",this, function(e){
		$.each(e.data.dom.find(".examCheckbox:checked"), function(){
			var examId = parseInt($(this).data("exam-id"));  
			e.data.selectedExams.push(examId);
		});
		if(tr$.length(e.data.selectedExams) > 0)
		{
			e.data.Subscribe();
		}
	});
	
	//when examCheckbox changes
	this.dom.find(".examCheckbox").change(this,function(e){
		changeExamCount(e.data.dom);
	});
	function changeExamCount(viewDom)
	{
		var count = 0;
		$.each(viewDom.find(".examCheckbox:checked"), function(){
			count++;
		});
		viewDom.find(".esContainer").data('exam-cnt',count);
		viewDom.find(".show-exam-cnt").text(count);
		if(count > 0)
		{
			viewDom.find('[data-trigger="subscribe"]').show();
		}
		else
		{
			viewDom.find('[data-trigger="subscribe"]').hide();
		}
	}
	$(".js-myexams").unbind().bind("click",function(){
		var urlMgmt = UrlMgmt.getObj();
		var action = urlMgmt.actionStack[urlMgmt.actionStack.length - 1].route;
		if(action == 'common/tr2myexams'){
			urlMgmt.RemoveView();
		}
		UrlMgmt.getObj().Route({route: 'common/tr2myexams', needData: false});
	});
};
commontr2subscriptionController.prototype.PopulateUI = function()
{
	var navTabs = '';
		tabContent = '';
		once = true;
	for(var categoryId in this.categories)
	{	
		once = true;
		var category = this.categories[categoryId];
		var catId = this.categories[categoryId].id;
		var Category_exams = "";
		for(var index in category.exams)
		{
			var examId = category.exams[index];
			var exam = getMatchingValue(this.exams, "id", examId);

			Category_exams +=
					'<div>'+
						'<span class="examname">'+exam.title+'</span>'+
						'<label class="switch">'+
							'<input type="checkbox" data-exam-id="'+examId+'" data-exam-cat="'+catId+'" class = "examCheckbox" >'+
							'<span class="slider round"></span>'+
						'</label>'+
					'</div>';
		}	
		if(Category_exams != "")
		{
			navTabs += 
			'<li class="categoryTab '+(once?'active':'')+'"><a href="#esCategory'+catId+'" data-toggle="tab">'+category.title+'</a></li>';
			tabContent +=
				'<div class="tab-pane '+(once?'active':'')+'" id="esCategory'+catId+'">'+
					'<div class="selectExam">'+
						'<div class="msgHolder">'+
						'<span class = "examMsg">Select to subscribe the exams</span>'+
						'<span class="selectholder">'+
						'<label class="checkboxround selectAll">'+
					   '<input class="categoryCheckbox" data-category="'+catId+'"type="checkbox" id="checkbox"  value="">'+				  
					     '<span class="checkmark"></span>'+
					    '</label>'+
					    '<span class="selecttext">Select All</span>'+
						'</span>'+
						'</div>'+
						'<div class = "examsSelected">(<span class="show-exam-cnt">0</span> Exams Selected)</div>'+
					'</div>'+
					'<div class="exams">'+ Category_exams ;
					tabContent +=
					'</div>'+
				'</div>';
			
		}	
		
		once = false;
	}
	this.dom.find(".nav-tabs").append(navTabs);
	$(".esContainer .headerholder .catDiv .cattabList .categoryTab").unbind().bind('click', function(e){
	var calculate1 = $(".esContainer .headerholder .catDiv .cattabList").scrollLeft() + $(e.currentTarget).offset().left-$(".esContainer .headerholder .catDiv .cattabList").offset().left-$(".esContainer .headerholder .catDiv .cattabList")[0].clientWidth/2 + $(e.currentTarget).outerWidth(true)/2;
	$('.esContainer .headerholder .catDiv .cattabList').animate({
    scrollLeft: calculate1
	}, 1000);
	});    
	//slider for category tabs
	slider("catDiv", 'cattabList', "categoryTab");
	this.dom.find(".tab-content").append(tabContent);
	
	$('[data-trigger="subscribe"]').hide();
	
	var myExamsCount = tr$.length(this.myExams);

	if(myExamsCount > 0)
	{
		this.dom.find(".esContainer").data('exam-cnt',myExamsCount);
		this.dom.find(".show-exam-cnt").text(myExamsCount);
		
		for(var i=0; i < this.myExams.length; i++)
		{
			$('[data-exam-id="'+this.myExams[i]+'"]').parents().siblings(".examname").addClass("selectedexam");
			$('[data-exam-id="'+this.myExams[i]+'"]').prop('checked', true);
		}
	}
	
	//check select all if all exam are selected
	for(var categoryId in this.categories)
	{
		var categoryId = this.categories[categoryId].id;;
		if (this.dom.find("[data-exam-cat='"+categoryId+"']:checked").length == this.dom.find("[data-exam-cat='"+categoryId+"']").length )
		{
	   	this.dom.find("[data-category='"+categoryId+"']").prop('checked', true);
		}
	}
};
commontr2subscriptionController.prototype.Subscribe = function(){
	var uniqueExamIds = [];
		subscribeIds = [];
		myExams = [];
	
	//convert exmIds into integers
	for(var i=0; i < this.myExams.length ; i++)
	{
		myExams.push(parseInt(this.myExams[i]));
	}
	
	//delete duplicate examIds, one exam can be in multiple categories
	for(var i=0; i < this.selectedExams.length; i++ )
	{
		if(uniqueExamIds.indexOf(this.selectedExams[i]) == -1)
		{
			uniqueExamIds.push(this.selectedExams[i]);
			//keep a copy of selected exams
			subscribeIds.push(this.selectedExams[i]);
		}
	}

	//remove already subscribed exams
	for(var i = 0; i < uniqueExamIds.length; i++)
	{
		if ( myExams.indexOf(uniqueExamIds[i]) > -1)
		{
			myExams.splice(myExams.indexOf(uniqueExamIds[i]), 1);
			subscribeIds.splice(subscribeIds.indexOf(uniqueExamIds[i]), 1);
		}
	}
	
	//exam data ["examId":"isSubscribed"]
	var examData = [];

	//myExams are now exams to be unsubscribed
	for(var i = 0; i < myExams.length; i++)
	{
		var obj = {};
		obj[myExams[i]] = 0;
		examData.push(obj);
	}
	
	//subscribeIds are now exams to be subscribed
	for(var i = 0; i < subscribeIds.length; i++)
	{
		var obj = {};
		obj[subscribeIds[i]] = 1;
		examData.push(obj);
	}
	
	if(tr$.length(examData) >0)
	{
		if(LoggedInUser.Auth())
		{
			tr$.ajax({
				mod: "tr2app",
				ack: "subscribeMultipleExams",
				additionalParams:{
					exams:examData
				},
				successClb: function(response){
					if(response.data == 'subscribed')
					{
						UrlMgmt.getObj().menuAction.controler.RefreshMenuData();
						UrlMgmt.getObj().PopView();
						$("#subscription-alert-modal").modal("show");
					}
					else
					{
						alert("internal error");
					}
				}
			});
		}
		else
		{
			LoggedInUser.onLoginSuccess = function(examData){
				getSubscribedExams(function(subscribedExams){
					var myExamIds = [];
					for(var i=0; i <  subscribedExams.length; i++)
					{
						myExamIds.push(subscribedExams[i].examId);
						
					}
					this.myExams = myExamIds;
					UrlMgmt.getObj().PopView();
					this.Subscribe();
				}.bind(this));
			}.bind(this);
			UrlMgmt.getObj().Route({route: 'common/tr2login', needData: false});
		}
	}
	else
	{
		UrlMgmt.getObj().PopView();
	}
};