/**** Package Item ****/
var itempackageController = function()
{
	this.view = "default";
	this.style = "default";
	this.dom = null;
	this.data = null;
	this.id = 0;
	this.refresh = true;
	this.stableDom = null;
	this.tests = {};
	this.selectedtag1 = null;
	this.selectedtag2 = null;
	this.showFilterOnOpen = false;
};
itempackageController.prototype.Init = function(viewDom)
{	
	this.dom = viewDom;
	this.stableDom = this.dom;
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.showLoader();
	this.SetLayout();
	var urlsplit = (UrlMgmt.getObj().actionStack[UrlMgmt.getObj().actionStack.length -1 ].route).split("=");
	if((urlsplit[0]).includes('item/package&id') &&
		   (urlsplit[1]).includes('tag1') )
	{
		 var tag1name = ((urlsplit[2]).split("="))[0];
		 var tag2name = (urlsplit[3]);
		 this.selectedtag1 = tag1name;
		 this.selectedtag2 = tag2name;
	}
	else{
		this.showFilterOnOpen = true;
	}
	//pull to refresh
	urlMgmt.PullToRefresh($(this.dom).attr('id'));
	
	if(this.data != undefined && this.data.offline != undefined && this.data.offline == true){
		this.OfflineInit();	
	}
	else{
		this.OnlineInit();
	}
	urlMgmt.removeLoader();
};
itempackageController.prototype.SetLayout = function()
{
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.lockRotation();
	if(typeof vidu != 'undefined' && vidu == 1){
		urlMgmt.menuAction.controler.View();
		urlMgmt.headerAction.controler.DisplayHeader(this.dom, 'Package Explore', true, false, true);
		$('#itempackageController').css('padding-bottom', '55px');
	}
	else{
		urlMgmt.menuAction.view.hide();
		urlMgmt.headerAction.controler.DisplayHeader(this.dom, 'Package Explore', false, true, true);
	}
   if(this.data.isPkgVersionSec == 1)
   {
   	urlMgmt.menuAction.controler.View();
	urlMgmt.headerAction.controler.DisplayHeader(this.dom, this.data.title, true, false, true);// , true, false, false
	var Roptions = '<td><span class="js-coursefilter" ><img src="img/filter.png"></span></td>';
    UrlMgmt.getObj().headerAction.controler.AddHeaderOptions(Roptions);
   }
};
itempackageController.prototype.OfflineInit = function()
{
	Factory.getObj().LoadViewForOffline(this);
};
itempackageController.prototype.OnlineInit = function()
{
	if(typeof vidu != 'undefined' && vidu == 1){
		$('.pkg-desc').remove();
		this.LoadBannerVidu();
		this.LoadLiveClassTabs();
		this.LoadTestTabs();
		this.LoadstudyMaterialTabs();
		this.LoadPackagesVidu();
		this.PopulateDescription();
		this.LoadPackageSubmenu();
		this.LoadIntroVideo();
		this.BindEvents();
	}
	else{
		$('.pkg-desc-vidu').remove();
		$('.batchIntroVideo').remove();
		$('.batchPostBannerInfo').remove();
		this.LoadBanner();
		this.LoadDescription();
		this.LoadLiveClassTabs();
		this.LoadTestTabs();
		this.LoadstudyMaterialTabs();
		this.LoadPackages();
		this.BindEvents();
	}
};
itempackageController.prototype.RefreshView = function()
{
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.showLoader();
	this.OnlineInit();
	urlMgmt.removeLoader();
};
itempackageController.prototype.BindEvents = function()
{
	this.dom.find('._eventListener').unbind().bind('click',this,function(e){
		var urlMgmt = UrlMgmt.getObj();
		var action = (urlMgmt.actionStack[urlMgmt.actionStack.length - 1].route).split('&')[0];
		if(action == $(this).data('action').split('&')[0]){
			urlMgmt.RemoveView();
		}
		UrlMgmt.getObj().Route({route: $(this).data('action'), needData: true, offlineAllowed: true});
	});
	
	//checkout page
	if(typeof payment_policies != "undefined" && parseInt(payment_policies) == 2 )
	{
		this.dom.find('.js-checkout').unbind().bind('click',function(e){
				$('#purchaseredirect-modal').modal("show");
				$('#purchaseredirect-modal .js-remoteserver').html(remoteServer);
	        });
	    this.dom.find('.js-checkout').html("More");
	}
	else
	{
		this.dom.find('.js-checkout').unbind().bind('click',this,function(e){
			UrlMgmt.getObj().Route({route: $(this).data('action'), needData: true, offlineAllowed: false});
		});		
	}	

	
	//show hide lists
	Factory.getObj().ShowHideList(this.dom);
		//package explore links
	this.dom.find('.js-explore').off().on('click',function(){
		var exploreLinks =  $(this).data("links");
		Factory.getObj().ShowExploreModal(exploreLinks);
	});
	
	
	/* course filter code */
	var filter = $('.js-coursefilter').unbind().bind('click',this,function(e){
		var packageData = e.data.data;
			
			pkgId = packageData.id;
		
			mrp = parseFloat(packageData.mrp);

			cost = parseFloat(packageData.packageDetails.cost);
	
			maxCostOfPaidRelatedPackage = parseFloat(packageData.packageDetails.maxCostOfPaidRelatedPackage);
	
			finalCost = maxCostOfPaidRelatedPackage > 0 ? Math.max(cost - maxCostOfPaidRelatedPackage,0):cost;
	
			curTimestamp = Date.parse(new Date);
	
			validTill = packageData.packageDetails.tillDate;
	
			unlockValidity = typeof packageData.packageDetails.unlockValidity !== 'undefined' ? packageData.packageDetails.unlockValidity : null;
			
			buyObj = {showBuy:false};
			
			if( finalCost > 0 && ((packageData.packageDetails.reverted == null || (packageData.packageDetails.reverted == 1)) 
				|| (packageData.packageDetails.reverted == 0 && unlockValidity != null && Date.parse(unlockValidity) < curTimestamp)) )
			{
				buyObj.showBuy	= true;
				buyObj.mrp	= mrp;
				buyObj.cost	= cost;
				buyObj.discount	= Math.round(100 - (100 *cost/mrp),2);
				buyObj.checkoutAction = "common/checkout&for="+packageData.urlKey+"&pkgexploreid="+packageData.id;
			}
		
		Factory.getObj().ScoreUpFilterModel({allTags:packageData.allTags,
											selectedTags:packageData.seletedTags,
											pkgDeliveryId: pkgId,
											buyObj:buyObj});
	});
	if(this.showFilterOnOpen)
	{
		filter.trigger('click');
		this.showFilterOnOpen = false;
	}
};

itempackageController.prototype.LoadBanner = function()
{
	if(this.data.isPkgVersionSec != 1)
	{
			var mrp = parseFloat(this.data.mrp);
		
			cost = parseFloat(this.data.packageDetails.cost);
			
			maxCostOfPaidRelatedPackage = parseFloat(this.data.packageDetails.maxCostOfPaidRelatedPackage);
			
			finalCost = maxCostOfPaidRelatedPackage > 0 ? Math.max(cost - maxCostOfPaidRelatedPackage,0):cost;
			
			curTimestamp = Date.parse(new Date);
			
			validTill = this.data.packageDetails.tillDate;
			
			unlockValidity = typeof this.data.packageDetails.unlockValidity !== 'undefined' ? this.data.packageDetails.unlockValidity : null;
			
		
		
		var html =
				'<div class="pkg-title">'+this.data.title+'</div>';
		
		var validFrom = null;
		if(typeof this.data.packageDetails.validFrom != undefined && this.data.packageDetails.validFrom != null && this.data.packageDetails.validFrom.length > 0){
	  		validFrom = new Date(this.data.packageDetails.validFrom);
	 	}
	  	var tillDate = null;
	  	if(typeof this.data.packageDetails.tillDate != undefined && this.data.packageDetails.tillDate != null && this.data.packageDetails.tillDate.length > 0){
	  		tillDate = new Date(this.data.packageDetails.tillDate);
	  	}
	  	var presentDate = new Date();
	  	var monthNames = [
	  					  "January", "February", "March", "April", "May", "June",
						  "July", "August", "September", "October", "November", "December"
					     ];
		if( finalCost > 0 && ((this.data.packageDetails.reverted == null || (this.data.packageDetails.reverted == 1)) || (this.data.packageDetails.reverted == 0 && unlockValidity != null && Date.parse(unlockValidity) < curTimestamp)))
		{
			if(mrp > cost)
			{
				html +=
				'<div class="pkg-price-info">'+
					'<div class="pkg-mrp"><s class="Number">&#8377;'+mrp+'</s></div>'+
					'<div>'+
						'<span class="Number BuyingPrice">&#8377;'+cost+'</span>'+
						'<span class="discount">'+Math.round(100 - (100 *cost/mrp),2)+'% OFF</span>';
			}
			else
			{
				html +=
					'<div><span class="BuyingPrice Number">&#8377;' +cost+'</span>';
			}
			if((validFrom == null || (validFrom != null && validFrom <= presentDate)) && (tillDate == null || (tillDate != null && tillDate >= presentDate))){
				if(typeof payment_policies != "undefined" && parseInt(payment_policies) == 0)
				{
					html += '<div class="paymentpolocies_div"><span>This content can be consumed on our website as well.</span></div>';
				}
				html +=	'<a class="btn btn-primary  js-checkout" data-action="common/checkout&for='+this.data.urlKey+'">';
				html += (maxCostOfPaidRelatedPackage > 0)? 'Upgrade Now' : 'Buy Now' ;
				html += '</a>';
			}
			html += '</div>';
		}
		if(validFrom != null && validFrom > presentDate){
			html += '<span class="validity-message">Enrollment starts from '+validFrom.getDate()+' '+monthNames[validFrom.getMonth()]+' '+validFrom.getFullYear()+'</span>';
		}
		else if(tillDate != null && tillDate < presentDate){
			html += '<span class="validity-message">Enrollment closed on '+tillDate.getDate()+' '+monthNames[tillDate.getMonth()]+' '+tillDate.getFullYear()+'</span>';
		}
		if(validTill != null && new Date(validTill) > new Date())
		{
			html +=
				'<div class="pkg-dates">Subscription Closes On : '+tr$.dateFormat(validTill)+'</div>';
		}
		if(unlockValidity != null && new Date(unlockValidity) > new Date())
		{
			html +=
				'<div class="pkg-dates errorMsg">Expires on : '+tr$.dateFormat(unlockValidity) +'</div>';
		}
		html +=	
		'</div>';
		this.dom.find('.pkg-banner').html(html);
	}
	else{
		this.dom.find('.pkg-banner').remove();
		this.dom.find('.pkg-desc-vidu').remove();
	}
};

itempackageController.prototype.LoadDescription = function()
{
	if(typeof this.data.shortdescription !== 'undefined' && tr$.length(this.data.shortdescription) && this.data.isPkgVersionSec != 1)
	{
		var shortDescription = 
			'<div>'+
				'<h2 class="sub-heading">What you get inside?</h2>'+
				'<ul>';
		for(var i in this.data.shortdescription)
		{
			shortDescription +=
					'<li>'+this.data.shortdescription[i]+'</li>';
		}
		shortDescription +=
				'</ul>'+
				'<div class="desc-btns">'+ 
					//btns will be appended from LoadTestTabs and LoadLiveClassTabs
				'</div>'+
			'</div>';
		var descDom = this.dom.find('.pkg-desc').html(shortDescription);
		
		//remove striked short description.
		descDom.find('s').remove();
		descDom.find('strike').remove();
	}else{
		this.dom.find('.pkg-banner').remove();
		this.dom.find('.pkg-desc-vidu').remove();
	}
};

itempackageController.prototype.LoadTestTabs = function()
{
	this.dom.find('.pkg-tests').empty();
	
	if(typeof this.data.isTestAvailable !== 'undefined' && this.data.isTestAvailable)
	{
		this.dom.find('.pkg-tests').append('<h1>Tests</h1>');
		this.dom.find('.desc-btns').find('.js-scroll-to-tests').remove();	
		this.dom.find('.desc-btns').append('<a class="btn btn-primary js-scroll-to-tests">TESTS</a>');
		
		var testTabs = Factory.getObj().TestTabs({
							testGroupCount: this.data.testGroupCount,
							activeTab: this.data.TestActiveTab,
							tests: this.data
						});
		this.dom.find('.pkg-tests').append(testTabs);	
		this.BindTestEvents();
	}
};

itempackageController.prototype.BindTestEvents = function()
{
	//nav tabs left right btns show hide on scroll
	slider(this.dom.find(".tabDiv"), 'tabList', "testTab");
	
	//scroll tabs to center on click
	Factory.getObj().scrollToCenter('.pkg-tests .nav-tabs li');
	
	this.dom.find('.js-scroll-to-tests').unbind().bind('click',this,function(e){
		var dist = $(e.data.dom).find(".pkg-tests").position(0).top;   //solutioin tab is the respective tab.
		$(e.data.dom).animate({
		    scrollTop : (dist)
		}, 1000);
	});
	
	//TODO - For now we are not displaying available soon test 
	delete this.data["testGroups"]["AvailableSoon"];
	for(var type in this.data["testGroups"]){
		for(var section in this.data["testGroups"][type]){
			for(var test in this.data["testGroups"][type][section]){
				var testData = this.data["testGroups"][type][section][test];
				this.tests[testData["itemId"]] = testData;
			}
		}
	}
	UrlMgmt.getObj().Route({
		route : 'common/testlisting',
		needData : false
	}, function(object) {
		object.controler.view = this.dom;
		object.controler.id = this.id;
		object.controler.parent = this;
		object.controler.tests = this.tests;
		object.controler.type = "packageexplore";
		object.controler.testShortReport = this.data.testShortReport;
		object.controler.Init();
	}.bind(this));
	//var testListing = new testlisting(this.dom, this.tests, this.id, "packageexplore", this, this.data.testShortReport);
};
itempackageController.prototype.LoadstudyMaterialTabs = function()
{
	this.dom.find('.pkg-studyMaterials').empty();
	if(typeof this.data.isStudyMaterialAvailable !== 'undefined' && this.data.isStudyMaterialAvailable)
	{
		this.dom.find('.pkg-studyMaterials').append('<h1>Study Materials</h1>');
		this.dom.find('.desc-btns').find('.js-scroll-to-studyMaterials').remove();	
		this.dom.find('.desc-btns').append('<a class="btn btn-primary js-scroll-to-studyMaterials">STUDY MATERIALS</a>');
		
		var studyMaterialTabs = Factory.getObj().studyMaterialTabs({
							studymaterialGroupCount: this.data.studymaterialGroupCount,
							studyMaterials: this.data.studyMaterials,
							studyMaterialEcomm: this.data.studyMaterialEcomm,
							activeTab: this.data.studyMaterialActiveTab,
							baseUrl: this.data.urlKey
						});
		this.dom.find('.pkg-studyMaterials').append(studyMaterialTabs);	
		this.BindstudyMaterialEvents();
	}
};
itempackageController.prototype.BindstudyMaterialEvents = function()
{
	//scroll tabs to center on click
	Factory.getObj().scrollToCenter('.pkg-studyMaterials .nav-tabs li');
	
	this.dom.find('.js-scroll-to-studyMaterials').unbind().bind('click',this,function(e){
		var dist = $(e.data.dom).find(".pkg-studyMaterials").position(0).top;   //solution tab is the respective tab.
		$(e.data.dom).animate({
		    scrollTop : (dist)
		}, 1000);
	});
	
	var urlMgmt = UrlMgmt.getObj();
	$(this.dom).find(".studyMaterialContent[data-action=_eventListener]").unbind().bind("click",this, function(e) {
		e.preventDefault();
		if (LoggedInUser.Auth()) {
			var StudyMaterialId = $(e.currentTarget).attr("data-itemId");
			if (($(e.currentTarget).find(".studyMaterialaction a").length) == 0) {
				tr$.ajax({
					mod : "tr2package",
					ack : "getListOfAttachments",
					additionalParams : {
						itemId : StudyMaterialId
					},
				successClb: function(reply) {
					try {
						var studyMaterialData = $(e.currentTarget).find(".studyMaterialaction ul");
						if (studyMaterialData.find("a").length == 0) {
							for ( i = 0; i < reply.data.attachments.length; i++) {
								var attachmentName = reply.data.attachments[i]["name"];
								var key = reply.data.attachments[i]["key"];
								$('<li><a class="display_pdf" href-data="/?route=item/descriptivetest&file=' + key + '" target="_blank">"' + attachmentName + '"</a></li>').appendTo(studyMaterialData);
							}
							$(e.data.dom).find(".display_pdf").unbind().bind("click",this,function(event){
								event.preventDefault();
								event.stopPropagation();
								var link = $(this).attr("href-data");
								var serverAddress = remoteServer;
								if(typeof UrlMgmt.getObj().menuData != 'undefined' && 
								   typeof UrlMgmt.getObj().menuData.domainmeta != 'undefined' && 
								   typeof UrlMgmt.getObj().menuData.domainmeta.homeUrl != 'undefined' && 
								   UrlMgmt.getObj().menuData.domainmeta.homeUrl.length > 0)
								{
									serverAddress = 'http://'+UrlMgmt.getObj().menuData.domainmeta.homeUrl;
								}
								window.open(serverAddress+link, '_system');
								//createTempSession(link);
								console.log("Display Pdf Event");
								// URLRedirection(remoteServer+link);
							});
						}
					} catch(e) {
						console.log(e);
					}
				},
				errorClb: function(){
					
				}
			});
		} else {
			return;
		}
		} else {
			LoggedInUser.onLoginSuccess = function() {
				UrlMgmt.getObj().PopView(function() {
					UrlMgmt.getObj().Route({
						route : 'common/tr2subscription',
						needData : false
					});
				});
			};
			UrlMgmt.getObj().Route({
				route : 'common/tr2login',
				needData : false
			});
		}
	});
	
	if(typeof payment_policies != "undefined" && parseInt(payment_policies) == 2 )
	{
		$(this.dom).find('a[data-event=js-checkout]').unbind().bind('click',function(e){
				$('#purchaseredirect-modal').modal("show");
				$('#purchaseredirect-modal .js-remoteserver').html(remoteServer);
	        });
	    $(this.dom).find('a[data-event=js-checkout]').html("More");
	}
	else
	{
		$(this.dom).find('a[data-event=js-checkout]').unbind().bind('click', function(e){
			UrlMgmt.getObj().Route({
			    route: $(this).data('action'),
			    needData: true,
			    offlineAllowed: false
			  });
		});		
	}	


};
itempackageController.prototype.LoadLiveClassTabs = function()
{
	this.dom.find('.pkg-live-classes').empty();
	
	if(typeof this.data.isVideoAvailable !== 'undefined' && this.data.isVideoAvailable == true)
	{
		this.dom.find('.pkg-live-classes').append('<h1>Classes</h1>');
		this.dom.find('.desc-btns').find('.js-scroll-to-videos').remove();
		this.dom.find('.desc-btns').append('<a class="btn btn-primary js-scroll-to-videos">CLASSES</a>');
		
		var videoTabs = Factory.getObj().VideoTabs({
							videoCount: this.data.videocount,
							videoActiveTab: this.data.LivClsActiveTab,
							videoGroup: this.data.videoGroup,
							liveClassesEcomData: this.data.liveClassesEcomData
						});
		this.dom.find('.pkg-live-classes').append(videoTabs);
		this.BindLiveClassEvents();
	}
};

itempackageController.prototype.BindLiveClassEvents = function()
{
	//nav tabs left right btns show hide on scroll
	slider(this.dom.find(".videotabDiv"), 'tabList', "videoTab");
	
	//scroll tabs to center on click
	Factory.getObj().scrollToCenter('.pkg-live-classes .nav-tabs li');
	
	this.dom.find('.js-scroll-to-videos').unbind().bind('click',this,function(e){
		var dist = $(e.data.dom).find(".pkg-live-classes").position(0).top;   //solutioin tab is the respective tab.
		$(e.data.dom).animate({
		    scrollTop : (dist)
		}, 1000);
	});
};

itempackageController.prototype.LoadPackages = function()
{
	var suggestedPackages = '';
		packagesData = this.data.suggestedPackages;
		
	if(typeof packagesData !== undefined && tr$.length(packagesData) > 0)
	{
			suggestedPackages +=
				'<div class="packageDiv">'+
					'<h1>Suggested Test Series</h1>'+
					'<div class="packageList">'+
						'<div class="packageposition">';
		for(var i in packagesData)
		{
			suggestedPackages += Factory.getObj().PackageCard(packagesData[i]);
		}
		suggestedPackages+=
						'</div>'+
					'</div>'+
				'</div>';
	}
	this.dom.find('.pkg-packages').html(suggestedPackages);
};

//Vidu functions
itempackageController.prototype.LoadBannerVidu = function()
{
	if(this.data.isPkgVersionSec != 1)
	{
		var mrp = parseFloat(this.data.mrp);
		
			cost = parseFloat(this.data.packageDetails.cost);
			
			maxCostOfPaidRelatedPackage = parseFloat(this.data.packageDetails.maxCostOfPaidRelatedPackage);
			
			finalCost = maxCostOfPaidRelatedPackage > 0 ? Math.max(cost - maxCostOfPaidRelatedPackage,0):cost;
			
			curTimestamp = Date.parse(new Date);
			
			validTill = this.data.packageDetails.tillDate;
			
			unlockValidity = typeof this.data.packageDetails.unlockValidity !== 'undefined' ? this.data.packageDetails.unlockValidity : null;
			
		
		
		var html ='<div class="packageInfoTop">'+
							'<span class="pkg-title">'+this.data.title+'</span>';
		if($('<div>'+this.data.description+'</div>').find('#course-hilights').length > 0){
			html += '<span class="packageinfobutn exploreinfo" id="packageinfobtn"  data-target="#packageinfo-modal"><img src="img/examinfo.png"/></span>'; 
		}
		var validFrom = null;
		if(typeof this.data.packageDetails.validFrom != undefined && this.data.packageDetails.validFrom != null && this.data.packageDetails.validFrom.length > 0){
	  		validFrom = new Date(this.data.packageDetails.validFrom);
	 	}
	  	var tillDate = null;
	  	if(typeof this.data.packageDetails.tillDate != undefined && this.data.packageDetails.tillDate != null && this.data.packageDetails.tillDate.length > 0){
	  		tillDate = new Date(this.data.packageDetails.tillDate);
	  	}
	  	var presentDate = new Date();
	  	var monthNames = [
	  					  "January", "February", "March", "April", "May", "June",
						  "July", "August", "September", "October", "November", "December"
					     ];
		if( finalCost > 0 && ((this.data.packageDetails.reverted == null || (this.data.packageDetails.reverted == 1)) || (this.data.packageDetails.reverted == 0 && unlockValidity != null && Date.parse(unlockValidity) < curTimestamp)))
		{
			if(mrp > cost)
			{
				html +=
				'</div>'+
				'<div class="pkg-price-info">'+
					'<div class="pkg-mrp"><s class="Number">&#8377;'+mrp+'</s></div>'+
					'<div>'+
						'<span class="Number BuyingPrice">&#8377;'+cost+'</span>'+
						'<span class="discount">'+Math.round(100 - (100 *cost/mrp),2)+'% OFF</span>';
			}
			else
			{
				html +=
					'<div><span class="BuyingPrice Number">&#8377;' +cost+'</span>';
			}
			if((validFrom == null || (validFrom != null && validFrom <= presentDate)) && (tillDate == null || (tillDate != null && tillDate >= presentDate))){
				if(typeof payment_policies != "undefined" && parseInt(payment_policies) == 0)
				{
					html += '<div class="paymentpolocies_div"><span>This content can be consumed on our website as well.</span></div>';
				}				
				html += '<a class="btn btn-primary  js-checkout" data-action="common/checkout&for='+this.data.urlKey+'">';
				html += (maxCostOfPaidRelatedPackage > 0)? 'Upgrade Now' : 'Buy Now' ;
				html += '</a>';
			}
			html += '</div>';
		}
		if(validFrom != null && validFrom > presentDate){
			html += '<div class="validity-message"><span>Enrollment starts from '+validFrom.getDate()+' '+monthNames[validFrom.getMonth()]+' '+validFrom.getFullYear()+'</span></div>';
		}
		else if(tillDate != null && tillDate < presentDate){
			html += '<div class="validity-message"><span>Enrollment closed on '+tillDate.getDate()+' '+monthNames[tillDate.getMonth()]+' '+tillDate.getFullYear()+'</span></div>';
		}
		if(validTill != null && new Date(validTill) > new Date())
		{
			html +=
				'<div class="pkg-dates">Subscription Closes On : '+tr$.dateFormat(validTill)+'</div>';
		}
		if(unlockValidity != null && new Date(unlockValidity) > new Date())
		{
			html +=
				'<div class="pkg-dates errorMsg">Expires on : '+tr$.dateFormat(unlockValidity) +'</div>';
		}
		html +=	
		'</div>';
		this.dom.find('.pkg-banner').html(html);
	}
	else{
		this.dom.find('.pkg-banner').remove();
		this.dom.find('.pkg-desc-vidu').remove();
		this.dom.find('.pkg-tests h1').remove();
	}
};
itempackageController.prototype.LoadPackagesVidu = function()
{
	var suggestedPackages = '';
		packagesData = this.data.suggestedPackages;
		currentpkgData = {id: this.data.id, itemId: this.data.itemId, title:this.data.title, type:this.data.type , mrp : this.data.mrp,
						  isPkgVersionSec : this.data.isPkgVersionSec ,noExplore : 1, shortdescription : this.data.shortdescription , urlKey: this.data.urlKey ,details : this.data.packageDetails  }; 	
	if(typeof currentpkgData !== undefined && tr$.length(currentpkgData) > 0)
	{
			suggestedPackages +=
				'<div class="packageDiv">'+
					'<h1>Plans & Packages</h1>'+
					'<div class="packageList">'+
						'<div class="packageposition">';
			suggestedPackages += Factory.getObj().PackageCard(currentpkgData);
		if(typeof packagesData !== undefined && tr$.length(packagesData) > 0)
		{
			for(var i in packagesData)
			{
				suggestedPackages += Factory.getObj().PackageCard(packagesData[i]);
			}
		}
		suggestedPackages+=
						'</div>'+
					'</div>'+
				'</div>';
	}
	this.dom.find('.pkg-packages').html(suggestedPackages);
	var pkgdescriptionslide = new Array();

	for(c = 0;c < this.dom.find('.packageposition .pkgDetail').length; c++)
	{
		pkgdescriptionslide[c] = new slideVertical();
	 	pkgdescriptionslide[c].Init("pkgDetail", "pkgDescription", "descriptionlines",c);
	 
	}
};
itempackageController.prototype.PopulateDescription = function()
{
	var descHolder ='<div>'+this.data.description+'</div>';
	if($(descHolder).find(".faculties").length > 0)
	{
		var carouselfac = 
		$('<div id="facCarousel" class="carousel slide" data-interval="false">'+
		'<p class="facultyhead">Our Teachers - <span style="color:#30B8E2">India\'s Top Faculties</span></p>'+
		'</div>');
		
		var desDom = $(descHolder).find(".faculties").appendTo(carouselfac);
		$(this.dom).find('.batchPostBannerInfo').html(carouselfac);
		
		$('.facultyposition').addClass("carousel-inner");
		$('.faculty').addClass("item");
		$(".faculty.item").first().addClass("active");
		var sidenav=
		'<a class="left carousel-control facultyslide" href="#facCarousel" data-slide="prev">'+
	      '<span class="facultyslider"><img src="img/right-nav-blue2left.png"/></span>'+
	      '<span class="sr-only">Previous</span>'+
	    '</a>'+
	    '<a class="right carousel-control facultyslide" href="#facCarousel" data-slide="next">'+
	      '<span class="facultyslider"><img src="img/right-nav-blue2.png"/></span>'+
	      '<span class="sr-only">Next</span>'+
	    '</a>';	 
		$(this.dom).find('.batchPostBannerInfo').append($(sidenav));
		var carouselDom = this.dom.find('#facCarousel');
		tr$.carouselSet(carouselDom,this.dom,false);	
	}
	if($(descHolder).find("#course-hilights").length > 0){
		var exploreBtn = $('<button class="btn btn-primary btn-block exploreinfo">EXPLORE COURSE INFO</button>');
		if($(this.dom).find('#facCarousel').length > 0){
			$(exploreBtn).insertAfter("#facCarousel");
		}
		else{
			$(this.dom).find('.batchPostBannerInfo').html(exploreBtn);
		}
		$(".exploreinfo").on('click', this, function(e){ 
	    	$('#package-hilights-modal').find('.course-hilights-body').empty();
 	        $('#package-hilights-modal').find('.course-hilights-body').html('<h2>'+e.data.data.title+'</h2>'+'<div id="description">'+e.data.data.description+'</div>');
	  	 	$('#package-hilights-modal').modal("show");
	  	 	if($('#package-hilights-modal').find(".faculties").length > 0)
				 {
				  	$('#package-hilights-modal').find(".faculties").remove();	
				 }
	  	 });
	}
};
itempackageController.prototype.LoadPackageSubmenu = function()
{
	var submenuHtml = '<div class="submenuDiv submenupackageDiv">' + '<div class="submenuList">' + '<div class="submenuPosition submenuPositionDiv">' + '</div>' + '</div>' + '</div>';
	$(submenuHtml).insertAfter( ".packageInfoTop" );
	Factory.getObj().LoadSubMenus(this.data.submenuList, $(this.dom).find('.submenuPosition'));
	slider("submenuDiv", 'submenuList', "submenu");
};
itempackageController.prototype.LoadIntroVideo = function()
{
	var videoImage = this.data.videoImage.trim();
	if(typeof videoImage == 'undefined' || videoImage == null || videoImage.length == 0){
		$(this.dom).find('.batchIntroVideo').hide();
	}	
	else{
		$(this.dom).find('.batchIntroVideo').show();
		var overlay = '<div class="videooverlay"></div>';	
		$(this.dom).find('.batchIntroVideo').empty();
		$(this.dom).find('.batchIntroVideo').append(videoImage);
	}
};
