/**** Static Page ****/
var itemstaticpageController = function() {
	this.view = "default";
	this.style = "default";
	this.dom = null;
	this.data = null;
	this.id = 0;
	this.refresh = true;

	/* For pdf Reader */
	this.pdfDoc = new Array();
	this.pageNum = new Array();
	this.pageRendering = new Array();
	this.pageNumPending = new Array();
	this.scale = new Array();
	this.tstart = new Array();
	this.tflag = new Array();
	this.tmove = new Array();
	this.zwidth = new Array();
	this.zdefault = new Array();
	this.zmax = new Array();
	this.basewidth = new Array();
	this.modalmode = new Array();
	this.canvas = new Array();
	this.cparent = new Array();
	this.ctx = new Array();
	this.url = new Array();
	this.flag = new Array();
	/* End of pdf Reader variables */
};
itemstaticpageController.prototype.Init = function(viewDom) {
	this.dom = viewDom;
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.showLoader();
	this.SetLayout();
	if (this.data != undefined && this.data.offline != undefined && this.data.offline == true) {
		this.OfflineInit();
	} else {
		this.OnlineInit();
	}
	urlMgmt.removeLoader();

};
itemstaticpageController.prototype.SetLayout = function() {
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.lockRotation();
	urlMgmt.menuAction.view.hide();
	urlMgmt.headerAction.controler.DisplayHeader(this.dom, 'Article', false, true, false);
};
itemstaticpageController.prototype.OfflineInit = function() {
	$(this.dom).find(".static-page-view").hide();
	Factory.getObj().LoadViewForOffline(this);
};
itemstaticpageController.prototype.OnlineInit = function() {
	$(this.dom).find(".static-page-view").show();
	if ($(this.dom).find(".tryagain").length != 0)
		$(this.dom).find(".tryagain").remove();
	this.PopulateBanner();
	this.PopulateDescription();
	this.QuickAccess();
	this.LoadFeaturedArticles();
	Factory.getObj().LoadDiscussions(this.data, this.dom);
	this.pdfInit();

	var urlKey = '';
	if (this.data != null && typeof this.data.urlKey != 'undefined') {
		urlKey = this.data.urlKey;
	}
	if(typeof webengage != 'undefined' && webengage == true){
		TRTracker.getObj().TrackWEEvent("PageView_TestList", urlKey);
	}
	//Google Analytics
	analytics_trackView("staticpage");
	analytics_trackEvent("staticpage", '/' + urlKey);
};
itemstaticpageController.prototype.RefreshView = function() {
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.showLoader();
	this.SetLayout();
	this.OnlineInit();
	urlMgmt.removeLoader();
};
itemstaticpageController.prototype.PopulateBanner = function() {
	var html = '<div class="spg-title">' + this.data.title + '</div>' + '<div class="quick-access-btn" ><img src="img/examinfo.png"></div>' + '<div class="clearfix"></div>';

	this.dom.find(".spg-banner").append(html);

	var submenuHtml = '<div class="submenuDiv">' + '<div class="submenuList">' + '<div class="submenuPosition">' + '</div>' + '</div>' + '</div>';
	this.dom.find(".spg-banner").append(submenuHtml);
	Factory.getObj().LoadSubMenus(this.data.submenuList, $(this.dom).find('.submenuPosition'));
};
itemstaticpageController.prototype.PopulateDescription = function() {
	var parentDom = this.dom.find(".spg-description").html(this.data.description);

	//open all links in AppBrowser
	tr$.OpenAllLinksInAppBrowser(parentDom);
};
itemstaticpageController.prototype.QuickAccess = function() {
	Factory.getObj().QuickAccess({
		title : 'QUICK ACCESS',
		view : this.dom,
		buttonDom : this.dom.find(".quick-access-btn"),
		quickaccessList : this.data.quickaccessList,
		bindevents : function() {
			$(".examQuickAccessCard").unbind().bind('click', this.dom, function(e) {
				$('#info-modal').modal('hide');
				var regex = /^#/;
				var url = $(this).data('url');
				if (regex.test(url)) {
					var id = url.split("#")[1];
					var elem = e.data.find('#' + id);
					e.data.animate({
						scrollTop : Math.max(elem.offset().top - 70, 0)
					}, 1000);
				} else {
					AppBrowser.getObj().OpenWPBlog(url);
				}
			});
		}
	});
};
itemstaticpageController.prototype.LoadFeaturedArticles = function() {
	if ( typeof this.data.wpArticleList !== 'undefined' && tr$.length(this.data.wpArticleList) > 0) {
		var fArticlesHTML = Factory.getObj().LoadFeaturedArticles(this.data.wpArticleList);
		parentDom = this.dom.find('.spg-featured-articles').html(fArticlesHTML);
		carouselDom = parentDom.find('.carousel');
		tr$.carouselSet(carouselDom, this.dom);
		tr$.OpenAllLinksInAppBrowser(parentDom);
	}
};
itemstaticpageController.prototype.RefreshView = function() {
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.showLoader();
	this.OnlineInit();
	urlMgmt.removeLoader();
};

itemstaticpageController.prototype.pdfInit = function() {
	if ($('canvas.pdfFrame').length == 0)
		return;
	else {
		var canvasDom = $('canvas.pdfFrame');
		for (var i = 0; i < canvasDom.length; i++) {
			this.canvas[i] = canvasDom[i];
			this.Defaults(i);
		}
	}
};

itemstaticpageController.prototype.Defaults = function(id) {
	this.pdfDoc[id] = null;
	this.pageNum[id] = 1;
	this.pageRendering[id] = false;
	this.pageNumPending[id] = null;
	this.scale[id] = 0.75;
	this.tstart[id] = null;
	this.tflag[id] = true;
	this.tmove[id] = null;
	this.zwidth[id] = 100;
	this.zdefault[id] = 100;
	this.zmax[id] = 500;
	this.modalmode[id] = false;
	this.ctx[id] = this.canvas[id].getContext('2d');
	this.url[id] = $(this.canvas[id]).attr("data-src");
	this.cparent[id] = $(this.canvas[id]).parent(".pdfWrapper");
	this.flag[id] = true;
	this.RenderSetup(id);
};

itemstaticpageController.prototype.RenderSetup = function(id) {
	var controldiv = '<div class ="controldiv">' + '<button class="pdfprev btn"><span class="glyphicon glyphicon-arrow-left"></span></button>' + '<span class="pdfpindic">Page: <span class="page_num"></span> / <span class="page_count"></span></span>' + 
	'<button class="pdfnext btn"><span class="glyphicon glyphicon-arrow-right"></span></button><button class="openPdf btn"><span class="glyphicon glyphicon-download-alt"></span></button>' + '</div>';
	$(controldiv).prependTo(this.cparent[id]);
	$(controldiv).appendTo(this.cparent[id]);
	$('.controldiv').hide();
	//$(this.cparent[id]).addClass("row");
	$(this.cparent[id]).css("margin", "auto");
	$(this.canvas[id]).css({
		"width" : "100%",
		"height" : "auto"
	});
	this.RenderCall(id);
};

itemstaticpageController.prototype.RenderCall = function(id) {

	var pdfaction = this;
	pdfjsLib.GlobalWorkerOptions.workerSrc = 'https://cdn.toprankers.net/js/pdf.worker.min.js';
	pdfjsLib.getDocument(this.url[id]).then(function(pdfDoc_) {
		pdfaction.pdfDoc[id] = pdfDoc_;
		var pcitr = pdfaction.cparent[id][0].getElementsByClassName('page_count');
		for (var i = 0; i < pcitr.length; i++)
			pcitr[i].textContent = pdfaction.pdfDoc[id].numPages;
		// Initial/first page rendering
		pdfaction.RenderFunctions(id, pdfaction.pageNum[id]);
	});
};

itemstaticpageController.prototype.RenderFunctions = function(id, num) {
	var pdfaction = this;
	this.pageRendering[id] = true;
	// Using promise to fetch the page
	this.pdfDoc[id].getPage(num).then(function(page) {
		var viewport = page.getViewport(pdfaction.scale[id]);
		pdfaction.canvas[id].height = viewport.height;
		pdfaction.canvas[id].width = viewport.width;

		// Render PDF page into canvas context
		var renderContext = {
			canvasContext : pdfaction.ctx[id],
			viewport : viewport
		};
		var renderTask = page.render(renderContext);

		// Wait for rendering to finish
		renderTask.promise.then(function() {
			pdfaction.pageRendering[id] = false;
			if (pdfaction.pageNumPending[id] !== null) {
				// New page rendering is pending
				pdfaction.RenderFunctions(id, pdfaction.pageNumPending[id]);
				pdfaction.pageNumPending[id] = null;
			}
			$(pdfaction.cparent[id]).find('.controldiv').show();
		});
	});

	// Update page counters
	var pgnumitr = pdfaction.cparent[id][0].getElementsByClassName('page_num');
	for (var i = 0; i < pgnumitr.length; i++)
		pgnumitr[i].textContent = num;

	if (this.flag[id] == true) {
		this.BindPDFEvents(id);
		this.flag[id] = false;
	}

};

itemstaticpageController.prototype.BindPDFEvents = function(id) {
	var pdfaction = this;
	var previtr = this.cparent[id][0].getElementsByClassName('pdfprev');
	for (var i = 0; i < previtr.length; i++)
		previtr[i].addEventListener('click', function(e) {
			pdfaction.onPrevPage(id);
		});

	var nxtitr = this.cparent[id][0].getElementsByClassName('pdfnext');
	for (var i = 0; i < nxtitr.length; i++)
		nxtitr[i].addEventListener('click', function(e) {
			pdfaction.onNextPage(id);
		});
	
	var openitr = this.cparent[id][0].getElementsByClassName('openPdf');
	for (var i = 0; i < openitr.length; i++)
		openitr[i].addEventListener('click', function(e) {
			AppBrowser.getObj().OpenWPBlog(pdfaction.url[id]);
		});

	this.BindPDFTouchEvents(id);
};

itemstaticpageController.prototype.queueRenderPage = function(id, num) {
	if (this.pageRendering[id]) {
		this.pageNumPending[id] = num;
	} else {
		this.RenderFunctions(id, num);
	}
};

itemstaticpageController.prototype.onPrevPage = function(id) {
	var pdfaction = this;
	if (this.pageNum[id] <= 1) {
		return;
	}
	this.pageNum[id]--;
	this.queueRenderPage(id, pdfaction.pageNum[id]);
};

itemstaticpageController.prototype.onNextPage = function(id) {
	var pdfaction = this;
	if (this.pageNum[id] >= this.pdfDoc[id].numPages) {
		return;
	}
	this.pageNum[id]++;
	this.queueRenderPage(id, pdfaction.pageNum[id]);
};

itemstaticpageController.prototype.BindPDFTouchEvents = function(id) {
	var pdfaction = this;
	var tflag = true;
	var tstartx = null;
	var tstarty = null;
	var evCache = new Array();
	var prevDiff = -1;
	
	
	function pointerdown_handler(ev) {
		evCache.push(ev);
		tstartx = evCache[0].clientX;
		tstarty = evCache[0].clientY;
		$(pdfaction.cparent[id]).find('.controldiv').last().hide();
		//console.log("pointerDown", ev);
	}

	function pointermove_handler(ev) {
		//console.log("pointerMove", ev);

		// Find this event in the cache and update its record with this event
		for (var i = 0; i < evCache.length; i++) {
			if (ev.pointerId == evCache[i].pointerId) {
				evCache[i] = ev;
				break;
			}
		}
		// If two pointers are down, check for pinch gestures
		if (evCache.length == 2 && pdfaction.modalmode[id] == true) {
			// Calculate the distance between the two pointers
			var curDiffx = Math.pow(Math.abs(evCache[0].clientX - evCache[1].clientX), 2);
			//x2-x1 ^2
			var curDiffy = Math.pow(Math.abs(evCache[0].clientY - evCache[1].clientY), 2);
			//y2-y1 ^2
			var curDiff = Math.sqrt(curDiffx + curDiffy);
			//distance between 2 points
			if (prevDiff > 0) {
				if (curDiff > prevDiff) {
					// The distance between the two pointers has increased
					//console.log("Pinch moving OUT -> Zoom in", ev);
					pdfaction.zwidth[id] = pdfaction.zwidth[id] + 50;
					if (pdfaction.zwidth[id] <= pdfaction.zmax[id] && pdfaction.zwidth[id] >= pdfaction.zdefault[id]) {
						$(pdfaction.canvas[id]).animate({width : ""+ pdfaction.zwidth[id] + "%"}, 100);
					} else {

					}
				}
				if (curDiff < prevDiff) {
					// The distance between the two pointers has decreased
					//console.log("Pinch moving IN -> Zoom out", ev);
					pdfaction.zwidth[id] = pdfaction.zwidth[id] - 50;
					if (pdfaction.zwidth[id] <= pdfaction.zmax[id] && pdfaction.zwidth[id] >= pdfaction.zdefault[id]) {
						$(pdfaction.canvas[id]).animate({width : ""+ pdfaction.zwidth[id] + "%"}, 100);
					} else {

					}
				}
			}
			// Cache the distance for the next move event
			prevDiff = curDiff;
		} else if (evCache.length == 1 && pdfaction.zwidth[id] == pdfaction.zdefault[id]) {
			if (tflag == true) {
				tmovex = evCache[0].clientX;
				tmovey = evCache[0].clientY;
			if (tmovey < tstarty - 3 || tmovey > tstarty + 3)
				tflag = false;
			if (tmovex < tstartx - 5) {
				tflag = false;
				pdfaction.onNextPage(id);
				$(pdfaction.cparent[id]).find('.controldiv').last().hide();
			}
			if (tmovex > tstartx + 5) {
				tflag = false;
				pdfaction.onPrevPage(id);
				$(pdfaction.cparent[id]).find('.controldiv').last().hide();
			}
		}
				
		}
	}

	function remove_event(ev) {
		// Remove this event from the target's cache
		for (var i = 0; i < evCache.length; i++) {
			if (evCache[i].pointerId == ev.pointerId) {
				evCache.splice(i, 1);
				break;
			}
		}
	}

	function pointerup_handler(ev) {
		//console.log(ev.type, ev);
		// Remove this pointer from the cache and reset the target's
		// background and border
		tflag = true;
		remove_event(ev);
		// If the number of pointers down is less than two then reset diff tracker
		if (evCache.length < 2)
			prevDiff = -1;
	}

	function pinchinit() {
		el = pdfaction.canvas[id];
		el.addEventListener("pointerdown", pointerdown_handler, false);
		el.addEventListener("pointermove", pointermove_handler, false);
		el.addEventListener("pointerup", pointerup_handler, false);
		el.addEventListener("pointercancel", pointerup_handler, false);
		el.addEventListener("pointerout", pointerup_handler, false);
		el.addEventListener("pointerleave", pointerup_handler, false);
	}

	this.canvas[id].addEventListener("click", function(e) {
		pdfaction.ModalSet(id);
	}, false);
	this.canvas[id].addEventListener("dblclick", function(e) {
		if (pdfaction.modalmode[id] == true) {
			pdfaction.zwidth[id] = 100;
			$(pdfaction.canvas[id]).css("width", "100%");
		}
	}, false);
	pinchinit();
};

itemstaticpageController.prototype.ModalSet = function(id) {
	var pdfaction = this;

	function bodyCalc() {
		var windowheight = $(window).height();
		console.log(windowheight);
		var bodyheight = windowheight - (59);
		$('#pdfModal').find('.modal-body').css("height", bodyheight);
	}

	function closeModal() {
		pdfaction.modalmode[id] = false;
		$('#pdfModal').modal('hide');
		$(pdfaction.cparent[id]).empty();
		$('.controldiv').remove();
		$('.modal-backdrop.fade.in').remove();
		$('body').removeClass('modal-open');
		var reset = '<canvas class="pdfFrame" data-src="' + pdfaction.url[id] + '" height="0" width="0">' + '</canvas>';
		$(reset).appendTo(pdfaction.cparent[id]);
		pdfaction.pdfInit();
	}

	function myModal(id) {
		if (pdfaction.modalmode[id] == false) {
			var pdfmodal = '<div id="pdfModal" class="modal fade" role="dialog">' + '<div class="modal-dialog">' + '<div class="modal-content">' + '</div></div></div>';
			var mcontrols = '<div class="modal-header">' + '</div>';
			var pdfbody = '<div class="modal-body">' + '</div>';
			$(pdfaction.cparent[id]).find('.pdfFrame, .controldiv').wrapAll(pdfmodal);
			$(pdfaction.cparent[id]).find('.controldiv').first().wrap(mcontrols);
			$(pdfaction.cparent[id]).find('.controldiv').last().hide();
			var tempcontrol = $(pdfaction.cparent[id]).find('.controldiv');
			$('<button type="button" class="close" data-dismiss="modal">&times;</button>').appendTo('.controldiv');
			$(pdfaction.canvas[id]).wrap(pdfbody);
			$('#pdfModal').modal('show');
			bodyCalc();
			var pdfid = document.getElementById("pdfModal");
			var close = pdfid.getElementsByClassName("close");
			$(window).resize(function() {
				bodyCalc();
			});
			close[0].addEventListener("click", closeModal, false);
			pdfaction.modalmode[id] = true;
		}
	}
	myModal(id);
};
