/**** Report and Solutions ****/
var ItemTestType =
{
	Report :1,
	Solution :0,
    Str : [
        'Report',
        'Solution',
    ]
};
var itemtestController = function()
{
	this.view = "default";
	this.style = "default";
	this.data = null;
	this.dom = null;
	this.id = 0;
	this.refresh = true;
	this.type = null;
};


itemtestController.prototype.Init = function(viewDom)
{
	this.dom = viewDom;
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.showLoader();
	this.SetLayout();
	var action = urlMgmt.actionStack[urlMgmt.actionStack.length-1].route;
	var actionSegments = action.split('&');
	if(actionSegments.length > 0){
		for(var i = 0;i < actionSegments.length ;i++){
			var str = actionSegments[i].split('=');
			if(str[0] == 'report'){
				this.type = ItemTestType.Report;
			}
			else if(str[0] == 'solution'){
				this.type = ItemTestType.Solution;
			}
		}
	}
	if(this.data != undefined && this.data.offline != undefined && this.data.offline == true){
		this.OfflineInit();	
	}
	else{
		this.OnlineInit();
	}
	urlMgmt.removeLoader();
};
itemtestController.prototype.SetLayout = function()
{
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.lockRotation();
	if(this.type == ItemTestType.Report){
		urlMgmt.headerAction.controler.DisplayHeader(this.dom, 'Report', false, true, false);
	}
	else if(this.type == ItemTestType.Solution){
		urlMgmt.headerAction.controler.DisplayHeader(this.dom, 'Solutions', false, true, false);
	}
	else{
		urlMgmt.headerAction.controler.DisplayHeader(this.dom, 'Report', false, true, false);
	}
	urlMgmt.menuAction.view.hide();
};
itemtestController.prototype.OnlineInit = function()
{
	if($(this.dom).find(".tryagain").length != 0)
		$(this.dom).find(".tryagain").remove();	
	var reportHeadDiv = this.dom.find(".reportDiv");
	reportHeadDiv.attr("testId",this.data.testMeta.testId);
	reportHeadDiv.attr("sessionId",this.data.sessionId);
	
	if(typeof this.data.reportError !== 'undefined' &&  this.data.reportError == true)
	{
		this.ReportError();
	}
	else if(typeof this.data.testData !== 'undefined' && tr$.length(this.data.testData) > 0)
	{
		this.PopulateSolution();
		
		var reviewSol = new Review();
		reviewSol.Init();
		reviewSol.DisplayQuestion(1);
		reviewSol.ValidateQNav();
		//to default question 1 wrong question color
		$(".OptionCorrectness.wrong").parent().addClass("selected-wrong-option");
		$(".SectionList .section-element[value='"+SectionFilter.ALL+"']").addClass("selected-section");
		$(".answer-status .status-element[value='"+QuestionFilter.ALL+"']").addClass("selected-status");
		$(".QuestionList").attr({
			section:-1,
			qStatus:0,
			bookmarkLabel:-1
		});
		$(".QuestionList .qIndex").addClass("noDisplayIndex");
		$(".QuestionList .sectionQues").addClass("noDisplayIndex");
		$(".QuestionList .qIndex,.QuestionList .AllSecQues").removeClass("noDisplayIndex");
		reviewSol.ValidateNavigator();
		$('.QuestionDiv').swipe({
			swipe:function(event, direction, distance, duration, fingerCount) {
				if($(this).find('span.scroll-x')){
					if($(event.srcElement).is('[class^=MathJax]') || $(event.srcElement).is('[class^=MJXc]')) {
						return false;
					}
				}
				if(direction == 'left'){
					$(".qNavigation.nextBtn").click();
				}
				if(direction == 'right'){
					$(".qNavigation.previousBtn").click();
				}
			},
			threshold: 70,
			allowPageScroll:"auto"
		});
		
	}
	else
	{
		this.PopulateReport();
		
		var reportTest = new Report(this.dom);
		reportTest.Init();
	}
	
	if($(".QuestionIndexWrapper").length > 0){
		slider("QuestionIndexWrapper","SessionQuestionList","qIndex");
	}
	this.BindEvents();
};
itemtestController.prototype.OfflineInit = function()
{
	Factory.getObj().LoadViewForOffline(this);
};
itemtestController.prototype.RefreshView = function()
{
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.showLoader();
	this.OnlineInit();
	urlMgmt.removeLoader();
};
itemtestController.prototype.BindEvents = function()
{
	setTimeout(function(){
		AppRate.getObj().CheckIfRated();
	},10000);
	this.dom.find('.infobutn').unbind().bind("click",function(){
		$("#questionboard-heading-modal").modal('show');
	});
	$(".heatmap-click").unbind().bind("click",function(){
		$('#question-heatmap-modal').modal('show');
	});
	$(".QuestionHeatmap-close").unbind().bind("click",function(){
	});
	
	//app report events
	$(".analysis-info-btn img").unbind().bind('click',function(){
		console.log('clicked');
		$('#report-info-modal').modal('show');
	});
	
	slider("SectionTab", "SectionList", "section-element");
	slider("testSectionTab", "testCategoryTab", "testCategory");
	slider("test-comparision-div", "comparisonCategoryTab", "comparisonCategory");
	
	
	$(".TopperComparisionsCTA").unbind().bind('click',this,function(e) {
	 	e.data.dom.animate({scrollTop: $(".test-comparision-div").offset().top}, 1000);
	    $(".comparisonCategoryTab li[comaparisontype='toppers'] a").click();
	});
	
	$(".js-take-similar-test").unbind().bind("click",function(){
		UrlMgmt.getObj().PopView();
	});
	
	$(".js-report").unbind().bind("click",function(e){
		UrlMgmt.getObj().RemoveView();
		UrlMgmt.getObj().Route({route: $(e.currentTarget).data('action'), needData: true, offlineAllowed: true});
	});
	
	this.dom.find(".js-sectional-full-view").unbind().bind('click',function(){
		$("#sectional-comparision-hc").modal('show');
	});
	
	this.dom.find(".js-time-full-view").unbind().bind('click',function(){
		$("#time-analysis-hc").modal('show');
	});
	
	$(".selected-section-image").empty();
	$(".selected-section-image").append('<img src="img/all-view.png">');
	$(".selected-section-name").html($(".selected-section").html());
};
itemtestController.prototype.ReportError = function()
{
	console.log(this.type);
	if(this.type == ItemTestType.Report){
		UrlMgmt.getObj().headerAction.controler.DisplayHeader(this.dom, 'Report', false, true, false);
	}
	else if(this.type == ItemTestType.Solution){
		UrlMgmt.getObj().headerAction.controler.DisplayHeader(this.dom, 'Solutions', false, true, false);
	}
	else{
		UrlMgmt.getObj().headerAction.controler.DisplayHeader(this.dom, 'Report', false, true, false);
	}
	var html =
		'<div class="report-error text-center">'+
		  	'<h2>'+this.data.errorMsg+'</h2>'+
		'</div>';
	this.dom.append(html);
};

itemtestController.prototype.PopulateSolution = function()
{
	UrlMgmt.getObj().headerAction.controler.DisplayHeader(this.dom, 'Solutions', false, true, false);
	var TestLanguages = this.data.testMeta.languages;
		qData = this.data.testData.dataQuestion;
		sData = this.data.testData.dataSolution;
		secq = this.data.testData.sequecce;
		shuffleInterSection = false;
		if(typeof this.data.testMeta.shuffleInterSection != "undefined")
		{
			 shuffleInterSection = (typeof this.data.testMeta.shuffleInterSection != "undefined" && parseInt(this.data.testMeta.shuffleInterSection) == 1)?this.data.testMeta.shuffleInterSection:false;
		}
		html = '';
	
	var Roptions ='<td><span class="heatmap-click"><img src="img/hitmap.png"></span></td>'+
				  '<td><span class="ask-doubt"><img src="img/doubt.png"></span></td>'+
				  '<td><span class="bookmarkQuesClick"><img src="img/bookmark.png"></span></td>'+
				  '<td><span class="js-report" data-action="item/test&id='+this.id+'&session='+this.data.sessionId+'&report=1"><img src="img/reports.png"></span></td>';		  
	UrlMgmt.getObj().headerAction.controler.AddHeaderOptions(Roptions);
	
	html +=
		'<div class="solution-test-title"><p>'+this.data.testData.testTitle+'</p></div><div class="reviewQuestionDiv" '+
		'testLanguage="'+this.data.testData.language+'" '+
		'hideExplanation="'+this.data.HideExplanation+'" '+ 
		'dicussionBucket="'+this.data.discussionBucket+'" '+ 
		'bucketPath="'+this.data.bucketPath+'" >'+
		'<div class="SectionTab">'+
		'<span class="section-elementbtnleft"><img src="img/slideleft.png"></span>'+
		'<div class="SectionList">'+
			'<div class="section-element" value="-1">All sections</div>';
	for(var i=0; i < tr$.length(this.data.testData.sections); i++)
	{
		html += '<div class="section-element" value="'+i+'">'+this.data.testData.sections[i]+'</div>';
	}
	html +=
			'</div>'+
			'<span class="section-elementbtnright"><img src="img/slideright.png"></span>	'+
		'</div>'+
		'<div class="QuestionDiv">'+
			'<div class="review-panel Questionboard">'+
			    '<div class="Questionboard-heading">'+
			    	'<div class="text-center reviewHeading " data-serlNo="serlNo"></div>'+
			    	'<div class="text-center reviewHeading " data-ansStatus="ansStatus"></div>'+
			    	'<span class="infobutn" id="infobtn" data-target="#questionboard-heading-modal">'+
			    	'<img src="img/examinfo.png"></span>'+
			    	// '<div class="text-center reviewHeading timeTaken ">'+
						// '<span><img src="https://cdn.toprankers.net/images/time-taken-023a7e387c98d.png" /></span>'+
						// '<span class="text-bold">Time Taken:</span>'+
						// '<span data-timeTaken="timeTaken"></span>'+
			    	// '</div>'+
			    	// '<div class="bookmarkDiv ">'+
			    		// '<span class="bookmarkBtn">Bookmark</span>'+
			    	// '</div>'+
			    '</div>'+
			    '<div class="Questionboard-body">'+
			        '<div class="row">'+
				    	'<div class="col-md-12 col-sm-12 col-xs-12 text-center">';
	if(tr$.length(this.data.testMeta.languages) > 1)
	{
		html += 
			'<label>See Solution In: </label> <select class="langOption">';
			for(var i = 0; i < tr$.length(this.data.testMeta.languages); i++)
			{
				var lang = this.data.testMeta.languages[i];
				if(lang == this.data.testData.language)
				{
					html +=
						'<option value="'+lang+'" selected="selected">'+this.data.TestLanguageType[lang]+'</option>';
				}
				else
				{
					html +=
						'<option value="'+lang+'">'+this.data.TestLanguageType[lang]+'</option>';
				}
			}
		html +=
			'</select>';	
	}
	
	html +=
				    	'</div>'+
				    '</div>'+
			        '<div class="QuestionText">'+
				    	'<div class="qText"></div>'+
				    '</div>'+
				     '<div class="QuestionOptions" hideAnswer="false"></div>'+
				     '<div class="row QuestionSolution" hideAnswer="false">'+
				     	'<button class="showSolutionBtn btn btn-primary-alt">Show Solution</button>'+
				     	'<div class="QuestionCorrectOptions text-center"></div>'+
				     	'<div class="DetailedSolution text-center"></div>'+
				     '</div>'+
				'</div>';
	var QuestionIndex  =	'<div class="QuestionIndexWrapper">'+
			    			'<div class="SessionQuestionList">';

			for (var key in secq) {
				//console.log(secq[key].questionId);
			    if (secq.hasOwnProperty(key))
			    {
					    	QuestionIndex +=
								'<div class="qIndex" sno='+key+' qid='+secq[key].questionId+' sqid='+secq[key].subQuestionId+'>'+
									 '<span class="AllSecQues" sec="-1">'+key+'</span>'+
								'</div>';
			    }
			}
			QuestionIndex +=
							'</div>'+
							'<span class="previousBtn qNavigation glyphicon glyphicon-chevron-left"></span>'+
					    	'<span class="nextBtn qNavigation glyphicon glyphicon-chevron-right"></span>'+
						'</div>';	
	html +='</div>';
	console.log("this.view.find('.reviewQuestionDiv').append(QuestionIndex)= "+this.dom.find('.reviewQuestionDiv').append(QuestionIndex));
	var QuestionHeatmapHtml = 
			'<div class="QuestionHeatmap">'+
				'<div><span class="selected-section-image"></span>'+
				'<span class="selected-section-name text-bold"></span></div>'+
		    	'<div class="QuestionList" section="-1" qStatus="all" bookmarkLabel="-1">';

	var currentSectionId = -1 ;
		qNoInSection = 1 ;
	for(var key in secq)
	{
		if(secq.hasOwnProperty(key))
		{
			var value = secq[key];
				secId = parseInt(value.sectionId);
			
			if(!shuffleInterSection)
			{
				if(secId != currentSectionId)
				{
					currentSectionId = secId;
					qNoInSection = 1;
				}
			}
			else
			{
				qNoInSection = secq[key]['qNoInSection'];
			}
			var hideAnswer = !(parseInt(value.resultState) == this.data.AnswerStatus.CORRECT);
				tag = 0;
				bookmarklabel = -1;
			if(typeof this.data.testData.bookmarkedQuestions[value.questionId] !== 'undefined'
				&& this.data.testData.bookmarkedQuestions[value.questionId] != null
				&& typeof this.data.testData.bookmarkedQuestions[value.questionId][value.subQuestionId] !== 'undefined'
				&& this.data.testData.bookmarkedQuestions[value.questionId][value.subQuestionId] != null)
			{
				tag = 1;
				bookmarklabel = this.data.testData.bookmarkedQuestions[value.questionId][value.subQuestionId];
			}
			if(value.flag == true){
				value.flag = 1;
			}
			else if(value.flag == false){
				value.flag = 0;
			}
			QuestionHeatmapHtml +=
				'<div class="qIndex"'+
				'qnosec="'+qNoInSection+'"'+
				'sno="'+key+'" '+ 
				'qid="'+value.questionId+'" '+
				'sqid="'+value.subQuestionId+'" '+
				'resultstate="'+value.resultState+'" '+
				'flag="'+value.flag+'" '+
				'bookmarked="'+tag+'" '+
				'section="'+secId+'" '+
				'icon="'+this.data.AnswerStatus.Str[parseInt(value.resultState)].toLowerCase()+'" '+
				'hideAnswer="'+hideAnswer+'" '+
				'bookmarklabel="'+bookmarklabel+'">'+
					'<span class="AllSecQues" sec="-1">'+key+'</span>'+
					'<span class="sectionQues noDisplayIndex" sec="'+secId+'">'+qNoInSection+'</span>'+
					'<span class="icon"></span>'+
				'</div>';
			qNoInSection++;
		} 
	}
	QuestionHeatmapHtml +=
				'</div>'+
				'<div class="answer-status">'+
					'<span class="status-element" value="0"><img src="img/all-view.png"><span>ALL STATUS</span></span>'+
					'<span class="status-element" value="1"><img src="img/missed-sml.png"><span>MISSED QUESTION</span></span>'+
					'<span class="status-element" value="2"><img src="img/skipped-report.png"><span>SKIPPED QUESTION</span></span>'+
					'<span class="status-element" value="3"><img src="img/wrong-attempts.png"><span>WRONG ATTEMPT</span></span>'+
					'<span class="status-element" value="4"><img src="img/mark-for-review.png"><span>MARKED FOR REVIEW</span></span>'+
					'<span class="status-element" value="5"><img src="img/bookmarked.png"><span>BOOKMARKED</span></span>'+
				'</div>'+
			'</div>'+
		'</div>';
	$('#question-heatmap-modal').find('.modal-body').html(QuestionHeatmapHtml);
	html +=
		'<div class="modificationDiv hideModificationPanel">'+
			'<div class="seeModification">This Question has been Modified after you attempt this test.Click here to see modified question</div>'+
			'<div class="panel panel-default modification-panel">'+
			  '<div class="panel-body Questionboard-body"></div>'+
			'</div>'+
		'</div>'+
		'<div class="discussionheader">'+
			'<h3 class="text-bold doubt-heading">All doubts on this Question</h3>'+
		'</div>'+
		'<div class="discussionDiv">'+
			'<div class="discussionPanel"></div>'+
		'</div>'+
		
	'</div>'+
	'<div class="qData">'+qData+'</div>'+
	'<div class="ansData">'+sData+'</div>'+
	'<div class="secq">'+JSON.stringify(secq)+'</div>'+
	'<div class="userBookmark">'+JSON.stringify(this.data.testData.userBookmarks)+'</div>';
	// html += QuestionIndex;
	
	this.dom.append(html);
	tr$.appendRemoteHost($('.qData'));
	tr$.appendRemoteHost($('.ansData'));
	
	if(UrlMgmt.getObj().App.isOnline){
		tr$.StoreSolutionImagesInBase64($('.qData'));
		tr$.StoreSolutionImagesInBase64($('.ansData'));
	}
	else{
		populateOfflineSolutionImages($('.qData'));
		populateOfflineSolutionImages($('.ansData'));
	}
	$(QuestionIndex).insertAfter('.reviewQuestionDiv');
};

itemtestController.prototype.PopulateReport = function()
{
	UrlMgmt.getObj().headerAction.controler.DisplayHeader(this.dom, 'Report', false, true, false);
	var sessionFlag = 0;
	var sessionCount = tr$.length(this.data.sessions);
	
	//header options
	var Roptions = '<td><span class="js-report" data-action="item/test&id='+this.id+'&session='+this.data.sessionId+'&solution=1"><img src="img/report-to-solution.png"></span></td>';
	
	UrlMgmt.getObj().headerAction.controler.AddHeaderOptions(Roptions);
	
	//temp hack for rank
	if(tr$.length(this.data.rankComparison))
	{
		for(var key in this.data.rankComparison)
		{
			if(this.data.rankComparison.hasOwnProperty(key))
			{
				var value =this.data.rankComparison[key];
				if(typeof value.posMeta !== 'undefined' && value.posMeta == 'MyRank' && typeof value.rank !=='undefined')
				{
					this.data.sessionReport.result.rank = value.rank;
				}
				
			}
		}
	}
	
	//SessionHeader(
	var myrank = this.data.sessionReport.result.rank;
	for(var rankC in this.data.rankComparison){
		if(rankC.posMeta == 'MyRank'){
			myrank = rankC.rank;
		}
	}
	this.PopulateSessionHeader(
		{
			sessionReport : this.data.sessionReport,
			testMeta : this.data.testMeta,
			topper : this.data.topper,
			user : UrlMgmt.getObj().userData,
			weightage : this.data.weightage,
			redirectUrl : this.data.redirectUrl,
			myReport : this.data.myReport,
			session : this.data.sessions,
			lastRank: this.data.looser.rank,
			myRank: myrank
		});
	
	//Rank
	this.PopulateRank(
		{
		testCutoff : this.data.testCutoff,
		testMeta : this.data.testMeta,
	 	cast : this.data.cast,
	  	AIRRank : this.data.AIRRank,
	   	SAASRank : this.data.SAASRank,
		msgForFutureTest : this.data.msgForFutureTest
		});
	
	//AIRBank				 
	if(typeof this.data.IsAIRTest && this.data.IsAIRTest)
	{
		this.PopulateAIRBank(
			{
				AIRBank:this.data.AIRBank,
				cast:this.data.cast,
			});
	}
	
	//ReportTable
	this.PopulateReportTable(
		{
			sessionReport:this.data.sessionReport,
			testMeta:this.data.testMeta,
			timeSpent:this.data.timeSpent,
			testSection:this.data.testSection,
			sectionalFlagdQuestion:this.data.sectionalFlagdQuestion,
			weightage:this.data.weightage,
			chartDetail:this.data.chartDetail 
		});
	
	//ReportText
	this.PopulateReportText(
		{
			sessionReport:this.data.sessionReport,
			timeSpent:this.data.timeSpent
		});
	
	//TestComparison
	this.PopulateTestComparison(
		{
			testMeta:this.data.testMeta,
			weightage:this.data.weightage,
			sectionalComparison:this.data.sectionalComparison,
			timeComparison:this.data.timeComparison,
			rankComparison:this.data.rankComparison,
			testSection:this.data.testSection
		});
		
	//Pre SessionList
	if(this.data.myReport == 1 && sessionCount > 0)
	{
		for(var i=0; i < sessionCount; i++)
		{
			var session = this.data.sessions[i];
			var sessionEndDate = new Date(session.endedAt).getTime();
			var reportEndDate = new Date(this.data.sessionReport.result.endedAt).getTime();
			
			if(sessionEndDate > reportEndDate)
			{
				if(i == 0)
				{
					this.dom.append('<h3 class="text-center">Recent Attempt</h3>');
				}
				else if(i == 1)
				{
					this.dom.append('<h3 class="text-center">Past Attempts</h3>');
					sessionFlag++;
				}
				this.PopulateSessionList(
					{
						session:session,
						testMeta: this.data.testMeta
					});	
			}
		}
	}
	//Post Sessionlist
	if(this.data.myReport == 1 && sessionCount > 0)
	{
		for(var i=0; i < sessionCount; i++)
		{
			var session = this.data.sessions[i];
			if(session.endedAt < this.data.sessionReport.result.endedAt)
			{
				if(sessionFlag == 0)
				{
					this.dom.append('<h3 class="text-center">Past Attempts</h3>');
					sessionFlag++;
				}
				
				this.PopulateSessionList(
					{
						session:session,
						testMeta: this.data.testMeta
					});
			}
		}
	}
};

itemtestController.prototype.PopulateSessionList = function(data)
{
	var html =
	'<div class="session-index">'+
		'<div class="session-details score-details past-attempt-div js-report" data-action="item/test&id='+this.id+'&session='+data.session.id+'&report=1">'+
			'<div class="session-test-date">'+
				'<span class="value-number test-date">'+tr$.dateFormat(data.session.endedAt)+'</span>'+
			'</div>';
	if(typeof data.testMeta.ShowWeightageScore === 'undefined' || data.testMeta.ShowWeightageScore == null)
	{
		var score = scorePercent = 0;
		if(typeof data.session.totalScore !== 'undefined' && data.session.totalScore != 0)
		{
			score = parseFloat(data.session.score);
			scorePercent = 	Math.abs(score * 100 /parseFloat(data.session.totalScore)).toFixed(2);
		}
		var negativeScore = (score < 0);
		
		html +=
			'<div class="past-score">'+
				'<img src="img/mark-2x.png" />'+
				'<span class="session-details-title">Score</span>'+
				'<span class="float-right"><span class="value-number">'+score+'/'+data.session.totalScore+'</span>'+
				'<span><img src="img/right-nav-blue.png" /></span></span>'+
			'</div>'+
			'<div class="detail-value">'+
				'<span class="progress-track"><span class="progress-percent" data-negative="'+negativeScore+'" style="width:'+scorePercent+'%;"></span></span>'+
			'</div>';
	}
	html +=
		'</div>'+
	'</div>';
	this.dom.append(html);
};

itemtestController.prototype.PopulateSessionHeader = function(data)
{
	var testTitle =
		'<div class="report-test-title"><span>'+data.sessionReport.result.title+'</span></div>';
	this.dom.append(testTitle);
	
	
	var html = 
		'<div class="reportHeader text-center">'+
			'<div class="reports_head">'+
				'<div class="session-index">'+
					'<div class="session-details score-details">'+
						'<div class="session-details-header"><img src="img/score-2x.png" /><span class="session-details-title">Score</span></div>'+
						'<div class="detail-value">';
	var score = scorePercent = 0;
	if(typeof data.weightage.score !== 'undefined' && data.weightage.score != null)
	{
		score = parseFloat(data.weightage.score);
		scorePercent = score;
	}
	else
	{
		score = parseFloat(data.sessionReport.result.score);
		scorePercent = 	Math.abs(score * 100 /parseFloat(data.sessionReport.result.totalScore)).toFixed(2);
	}
	var negativeScore = (score < 0);
	
	html +=
							'<span class="progress-track"><span class="progress-percent" data-negative="'+negativeScore+'" style="width:'+scorePercent+'%;"></span></span>'+
							'<span class="value-number">'+score+'/'+ data.sessionReport.result.totalScore+
							'</span>'+
						'</div>'+
					'</div>'+
					'<div class="session-details">'+
						'<div class="session-details-header"><img src="img/time-taken-big-2x.png" /><span class="session-details-title">Time</span></div>'+
						'<div class="detail-value">'+
							'<span class="progress-track"><span class="progress-percent" style="width:'+(data.sessionReport.result.timeTaken * 100 / data.testMeta.time)+'%"></span></span>'+
							'<span class="value-number">'+data.sessionReport.result.timeTaken+'/'+data.testMeta.time+' Min</span>'+
						'</div>'+
					'</div>';
	if(typeof data.testMeta.IsAIRTest === 'undefined' || data.testMeta.IsAIRTest!=1)
	{
		html+= 	'<div class="session-details">'+
						'<div class="session-details-header"><img src="img/rank-2x.png" /><span class="session-details-title">Rank</span></div>'+
						'<div class="detail-value">'+
							'<span class="progress-track"><span class="progress-percent" style="width:'+(100 - parseInt(data.myRank) * 100 / parseInt(data.lastRank))+'%"></span></span>'+
							'<span class="value-number">'+data.sessionReport.result.rank+'</span>'+
						'</div>'+
					'</div>';
	}
	html += '<div class="session-details">'+
						'<div class="session-details-header"><img src="img/accuracy-2x.png" /><span class="session-details-title">Accuracy</span></div>'+
						'<div class="detail-value" >'+
							'<span class="progress-track"><span class="progress-percent" style="width:'+tr$.round(data.sessionReport.result.accuracy,2)+'%"></span></span>'+
							'<span class="value-number">'+data.sessionReport.result.accuracy+'</span>'+
						'</div>'+
					'</div>';
	if(typeof data.testMeta.IsAIRTest === 'undefined' || data.testMeta.IsAIRTest!=1)
	{
		html+= 
					'<div class="session-details">'+
						'<div class="session-details-header"><img src="img/percentile-2x.png" /><span class="session-details-title">Percentile</span></div>'+
						'<div class="detail-value">'+
							'<span class="progress-track"><span class="progress-percent" style="width:'+tr$.round(data.sessionReport.result.percentile,2)+'%"></span></span>'+
							'<span class="value-number">'+tr$.round(data.sessionReport.result.percentile,2)+'</span>'+
						'</div>'+
					'</div>';
	}
	if(typeof data.testMeta.ToprankersComparision !== 'undefined'
		&& data.testMeta.ToprankersComparision != null
		&& (typeof data.weightage.score === 'undefined'
		|| data.weightage.score == null))
	{
		html+=
					'<div class="session-details">'+
						'<div class="session-details-header"><img src="img/toppers-score-2x.png" /><span class="session-details-title">Topper\'s Score</span></div>'+
						'<div class="detail-value">';
				
					var negativeScore = false;
					var topperPercent = (data.topper.score * 100 / data.sessionReport.result.totalScore);
					if(topperPercent > 100){
						topperPercent = 100;
					}
					else if(topperPercent < 0){
						negativeScore = true;
						topperPercent = Math.abs(topperPercent);
					}
					
		html +=
							'<span class="progress-track"><span class="progress-percent" data-negative="'+negativeScore+'" style="width:'+topperPercent+'%;"></span></span>'+
	
							'<span class="value-number">'+data.topper.score+'/'+data.sessionReport.result.totalScore+'</span>'+
						'</div>'+
					'</div>'+
					'<div class="session-details">'+
						'<div class="session-details-header"><img src="img/toppers-time-2x.png" /><span class="session-details-title">Topper\'s Time</span></div>'+
						'<div class="detail-value">'+
							'<span class="progress-track"><span class="progress-percent" style="width:'+(data.topper.timeTaken * 100 / data.testMeta.time)+'%"></span></span>'+
							'<span class="value-number">'+data.topper.timeTaken+'/'+data.testMeta.time+' Min</span>'+
						'</div>'+
					'</div>';
	}
				
	if(typeof  data.testMeta.ToprankersComparision !== 'undefined')
	{
		html +=
		'<div class="session-details session-btns">'+
			'<span class="TopperComparisionsCTA "> TOPPER\'S COMPARISION</span>'+
		'</div>';
	}
	html +=
	'<div class="session-details  session-btns">'+
		'<span class="js-take-similar-test ">TAKE SIMILAR TEST</span>'+
	'</div>';

		html +=
				'</div>'+
			'</div>'+
		'</div>';
	this.dom.append(html);
};

itemtestController.prototype.PopulateRank = function(data)
{
	var html ='';
	if(typeof data.AIRRank !== 'undefined' && tr$.length(data.AIRRank) > 0)
	{
		html +=
			'<div class="AIRrankDiv text-center">'+
				'<h2>AIR is '+data.AIRRank[0]+'</h2>'+
			'</div>';
	}
	if(typeof data.SAASRank !== 'undefined' && tr$.length(data.SAASRank) > 0)
	{
		html +=
			'<div class="SAASrankDiv text-center">'+
				'<h2><span class="text-uppercase">'+data.SAASRank.domainName+'</span> Rank is '+data.SAASRank.rank+'</h2>'+
			'</div>';
	}
	if(typeof data.AIRRank !== 'undefined' && tr$.length(data.AIRRank) > 0 && tr$.length(data.msgForFutureTest) > 0)
	{
		html +=
			'<div class="futureTestMsgDiv text-center">'+
				'<h2 style="font-size:100%; color:rgba(222, 146, 0, 1);">'+data.msgForFutureTest+'</h2>'+
			'</div>';
	}
	html +=
		'<div class="cutoffSectionDiv text-center">';
	if(typeof data.testCutoff !== 'undefined'
		&& typeof data.testCutoff.overall !== 'undefined' 
		&& data.testCutoff.overall != null
		&& typeof data.testMeta.nocutoff === 'undefined')
	{
		html +=
			'<p>Choose Category <select id="cast">';
		for(var key in data.testCutoff.overall)
		{
			if(data.testCutoff.overall.hasOwnProperty(key))
			{
				html +=
					'<option value="'+key+'">'+data.cast[key]+'</option>';
			}
		}
		html +=
			'</select></p>';
	}
	html +=
		'</div>';
	this.dom.append(html);
};

itemtestController.prototype.PopulateAIRBank = function(data)
{
	var html = '';
	
	if(typeof data.AIRBank !== 'undefined' && tr$.length(data.AIRBank) > 0)
	{
		var srNo=0;
			TestScoreCalc = data.AIRBank.testScoreCalc.section;
			lastRow = data.AIRBank.testScoreCalc.total;

		html +=
			'<div class="AIRBankHeader text-center">'+
				'<table class="AIRTestReportTable table-bordered">'+
					'<tr>'+
					  '<td class="textcenter" colspan="3"><h3 class="testName">'+data.AIRBank["headerMsg"]+'</h3></td>'+
				    '</tr>'+
				    '<tr>'+
					   '<td class="textleft" colspan="2">Name: '+data.AIRBank["userName"]+'</td>'+
				        '<td class="textleft">Category: '+
							'<select class="AIRBankSelectCat">';
				for(var key in data.cast)
				{
					if(data.cast.hasOwnProperty(key))
					{
						var value = data.cast[key];
						html +=
							'<option value="'+value+'">'+value+'</option>';	
					}
				}
				html +=
						'</select>'+
				        '</td>'+
				    '</tr>'+
				    '<tr>'+
					    '<td class="textleft">Roll No:</td>'+
						'<td class="textleft">Reg No:</td>'+
						'<td class="textleft">Date of Birth:</td>'+
				    '</tr>'+
				'</table>'+
			'</div>'+
			'<div class="AIRBankReportDiv">'+
				'<br/>'+
				'<table class="table-bordered AIRBankReportTable">'+
					'<tr>'+
						'<th class="textcenter" rowspan="2">Sr.No.</th>'+
						'<th class="textcenter" rowspan="2">Subject</th>'+
						'<th class="textcenter" rowspan="2">Total Marks</th>'+
				        '<th class="minimizespan" colspan="'+tr$.length(data.cast)+'">Minimum Qualifying Marks</th>'+
				        '<th class="textcenter" rowspan="2">Marks Secured by you</th>'+
				    '</tr>'+
				    '<tr>';
				for(var key in data.cast)
				{
					if(data.cast.hasOwnProperty(key))
					{
						var value = data.cast[key];
						html +=
							'<th class="innerTD" categoryN="'+value+'">'+value+'</th>';	
					}
				}
				html +=
					'</tr>';
			for(var seckey in TestScoreCalc)
			{
				if(TestScoreCalc.hasOwnProperty(seckey))
				{
					var section = TestScoreCalc[seckey];
					var attributes='';
					srNo++;
					html +=
						'<tr>'+
							'<td class="textleft" >'+srNo+'</td>'+
							'<td class="textcenter">'+section.name+'</td>'+
							'<td class="textcenter">'+section.totalScore+'</td>';
					for(var castkey in data.cast)
					{
						if(data.cast.hasOwnProperty(castkey))
						{
							var value = data.cast[castkey];
							
							attributes = attributes+' '+value+'='+section[value].iscrosscutoff;
							html +=
								'<td class="innerTD" categoryN="'+value+'">'+section[value].iscrosscutoff+'</td>';
						}
					}
					html +=
							'<td class="textcenter candidatescore" '+attributes+'>'+section.score+'</td>'+
						'</tr>';
				}	
			}
			attributes='';
			for(var castKey in data.cast)
			{
				if(data.cast.hasOwnProperty(castKey))
				{
					var value = data.cast[castKey];
					attributes = attributes+' '+value+'='+lastRow[value].iscrosscutoff;
				}
			}
			html +=
					'<tr>'+
						'<td class="textcenter minimizespan" colspan="9"><b>Total Marks (out of '+lastRow.totalTestMark+')</b></td>'+
						'<td class="textcenter candidatescore candidatetotalscore" '+attributes+' >'+lastRow.totalUserMark+'</td>'+
					'</tr>'+
					'<tr>'+
						'<td class="textcenter" colspan="3" rowspan="2">Over All cut-off (out of '+lastRow.totalTestMark+')</td>';
			for(var castKey in data.cast)
			{
				if(data.cast.hasOwnProperty(castKey))
				{
					var value = data.cast[castKey];
					html +=
					'<th class="innerTD" categoryN="'+value+'" >'+value+'</th>';
				}
			}
			html +=
						'<th rowspan="2"></th>'+
					'</tr>'+
					'<tr>';
			attributes='';
			for(var castKey in data.cast)
			{
				if(data.cast.hasOwnProperty(castKey))
				{
					var value = data.cast[castKey];
					html +=
					'<td class="innerTD" categoryN"='+value+'">'+lastRow[value].cutoffscore+'</td>';
					attributes = attributes+' '+value+'='+lastRow[value].isPass;
				}
			}
			html +=
					'</tr>'+
					'<tr>'+
						'<td colspan="4" class="textcenter minimizespan" ><h3>Candidate Status</h3></td>'+
						'<td colspan="6" class="textcenter candidateStatus minimizespan" '+attributes+'><span class="candidateStatusSpan"></span></td>'+
					'</tr>'+
				'</table>'+
			'</div>'+
			'<div class="AIRBankDisclaimer text-center">'+
				'<h3 class="Disclaimer">*Disclaimer: The cut-off has been finalized by our experts, it may vary in the original exam.</h3>'+
			'</div>';		
	}
	this.dom.append(html);
};
itemtestController.prototype.PopulateReportTable = function(data)
{
	var switchViewDiv = 
		'<div class="switch-view">'+
			'<span>Switch View</span>'+
			'<span class="graph-view"><img src="img/graph-view-2x.png" />Graph</span>'+
			'<span>'+
				'<label class="switch">'+
					'<input type="checkbox">'+
					'<span class="slider round"></span>'+
				'</label>'+
			'</span>'+
			'<span class="table-view faded"><img src="img/table-view-2x.png" />Table</span>'+
		'</div>';
	this.dom.append(switchViewDiv);
	var html = '';
		differentialMarking = (data.testMeta.differentialMarking)?true:false;
		table_values1 = data.sessionReport.section ;
		table_values2 = data.sessionReport.result ;
	html +=	
		'<div class="reportDefault text-center">'+
			'<div class="testSectionTab">'+
			'<span class="testCategorybtnleft"><img src="img/slideleft.png"></span>'+
				'<ul class="nav nav-tabs testCategoryTab">'+
					'<li class="testCategory active" section="overall"><a data-toggle="tab" href="#section-overall">Over All Analysis</a></li>';
		for(var key in data.testSection.name)
		{
			if(data.testSection.name.hasOwnProperty(key))
			{
				var value = data.testSection.name[key];
				var sectionAttr = value.replace(/\s+/g, '-').toLowerCase();
				html +=
					'<li class="testCategory" section="'+sectionAttr+'"><a data-toggle="tab" href=#section-'+sectionAttr.replace(/[^a-zA-Z0-9_]+/g, "_")+'>'+value+'</a></li>';		
			}
		}
		html +=
				'</ul>'+
			'<span class="testCategorybtnright"><img src="img/slideright.png"></span>'+
			'</div>'+
			'<div class="testScoreOverview">'+
				'<div class="analysis-info-btn"><img src="img/examinfo.png" /></div>'+
				'<div class="tab-content col-md-8 col-sm-8">';

		var answerDistribution = data.chartDetail.answerDistribution;
			timeSpent = data.chartDetail.timeSpent;
		for(var key in answerDistribution)
		{
			if(answerDistribution.hasOwnProperty(key))
			{
				var value = answerDistribution[key];
				var sectionAttr = key.replace(/\s+/g, '-').toLowerCase();
				html +=
					'<div id=section-'+sectionAttr.replace(/[^a-zA-Z0-9_]+/g, "_")+' class="tab-pane fade in" section='+sectionAttr+'>'+
				 		"<data class='answerDistribution' title='"+value.title+"' valueSuffix='"+value.valueSuffix+"' seriesData='"+value.data+"'>"+
				 			'<div class="canvas"></div>'+
				 		'</data>'+
				 		"<data class='timeSpent' title='"+timeSpent[key].title+"' valueSuffix='"+timeSpent[key].valueSuffix+"' seriesData='"+timeSpent[key].data+"'>"+
				 			'<div class="canvas"></div>'+
				 		'</data>'+
				    '</div>';
			}
		}
		html +=
				'</div>'+
				'<div class="tabularView ">';
		if(typeof data.weightage.score === 'undefined' || data.weightage.score == null)
		{
			html +=
					'<table class="main_table">'+
			    		'<thead>'+
				            '<tr>'+
				              '<th>Sections</th>'+
				              '<th>Score</th>'+
				             ' <th>Time Spent</th>'+
				            '</tr>'+
				        '</thead>'+
			    		'<tbody>';
			for(var key in data.testSection.name)
			{
				if(data.testSection.name.hasOwnProperty(key))
				{
					var value = data.testSection.name[key];
					html +=
						'<tr>'+
					    	'<td>'+value+'</td>'+
					    	'<td>'+data.testSection.absScore[key]+'</td>'+
					    	'<td>'+parseInt(data.testSection.actualTimeTaken[key]/60)+' min, '+parseInt(data.testSection.actualTimeTaken[key]%60)+' sec</td>'+
					    '</tr>';
				}
			}
			html +=
							'<tr>'+
				              '<td>Total</td>'+
						      '<td>'+table_values2.score+'/'+table_values2.totalScore+'</td>'+
							  '<td>'+table_values2.timeTaken+'/'+table_values2.totalTime+' Min</td>'+
				            '</tr>'+
			    		'</tbody>'+
			    	'</table>';
		}
		html +=
			    '</div>'+
			'</div>'+
		'</div>'+
		'<div class="reporttable text-center">'+
			'<table class="table-bordered tableformat">'+
				 '<thead>'+
				 	'<tr>'+
				 		'<th rowspan="3">Sections</th>'+
		              	'<th rowspan="3">Score</th>'+
		              	'<th rowspan="3">Time Spent</th>'+
			            '<th colspan="4">All Questions Summary</th>'+
		((differentialMarking)?'':'<th colspan="2">Mark Summary</th>')+
				 	'</tr>'+
				    '<tr>'+
			            '<th colspan="2">Attempted Questions</th>'+
			            '<th rowspan="2">Not Attempted</th>'+
			            '<th rowspan="2">Marked for Review</th>'+
		((differentialMarking)?'':'<th rowspan="2">(+ve)</th><th rowspan="2">(-ve)</th>')+
			        '</tr>'+
			        '<tr>'+
			            '<th>Correct</th>'+
			            '<th>Incorrect</th>'+
			        '</tr>'+
			       '<tbody>';
		var totalFlagedQuestion = 0;
		for(var key in data.testSection.name)
		{
			if(data.testSection.name.hasOwnProperty(key))
			{
				var value = data.testSection.name[key];
					totalFlagedQuestion += data.sectionalFlagdQuestion[key];
				html +=
						'<tr>'+
					    	'<td>'+value+'</td>'+
					    	'<td>'+data.testSection.absScore[key]+'</td>'+
					    	'<td>'+parseInt(data.testSection.actualTimeTaken[key]/60)+' min, '+parseInt(data.testSection.actualTimeTaken[key]%60)+' sec</td>'+
					    	'<td>'+table_values1[key].correctCount+'</td>'+
					    	'<td>'+table_values1[key].incorrectCount+'</td>'+
					    	'<td>'+(parseInt(table_values1[key].missedCount)+parseInt(table_values1[key].skippedCount))+'</td>'+
					    	'<td>'+data.sectionalFlagdQuestion[key]+'</td>'+
				((differentialMarking)?'':'<td>'+data.timeSpent.sectionResult[key].correct+'</td><td>'+data.timeSpent.sectionResult[key].wrong+'</td>')+
					    '</tr>';
			}
		}
		html +=
					'<tr>'+
						'<td>Total</td>'+
						'<td>'+table_values2.score+'/'+table_values2.totalScore+'</td>'+
						'<td>'+table_values2.timeTaken+'/'+table_values2.totalTime+' Min</td>'+
						'<td>'+table_values2.correctCount+'</td>'+
						'<td>'+table_values2.incorrectCount+'</td>'+
						'<td>'+(parseInt(table_values2.missedCount)+parseInt(table_values2.skippedCount))+'</td>'+
						'<td>'+totalFlagedQuestion+'</td>'+
		((differentialMarking)?'':'<td>'+data.timeSpent.sectionResult.correct.total+'</td><td>'+data.timeSpent.sectionResult.wrong.total+'</td>')+
					'</tr>'+
			       '</tbody>'+
				 '</thead>'+     
			'</table>'+
		'</div>';
	this.dom.append(html);	
	
};

itemtestController.prototype.PopulateReportText = function(data)
{
	var remainingTime = data.sessionReport.result.totalTime - data.sessionReport.result.timeTaken;
		html = 
		'<div class="TestAnswerText">'+
			'<h3>Answer Distribution</h3>'+
			'<p>You have attempted '+
			data.sessionReport.result.attempted+
			' questions out of which '+
			data.sessionReport.result.correctCount+
			' questions are correct, '+
			data.sessionReport.result.incorrectCount+
			' questions are incorrect and '+
			(parseInt(data.sessionReport.result.missedCount) +parseInt(data.sessionReport.result.skippedCount))+
			' questions are unattempted.</p>'+
		'</div>'+
		'<div class="TestTimeText">'+
			'<h3>Time Distribution</h3>'+
			'<p>Out of the total duration of '+
			data.sessionReport.result.totalTime+
			' minutes, '+data.sessionReport.result.timeTaken+
			' minutes have been utilized throughout.'+
			' A time duration of '+
			(parseFloat(data.timeSpent.correct).toFixed(2))+
			' minutes have been utilized for correct answers and '+
			(parseFloat(data.timeSpent.inCorrect).toFixed(2))+
			' minutes have been utilized for incorrect answers.'+
		((remainingTime != 0)?' A duration of '+remainingTime+' minutes is unused.':'')+		
			'</p>'+
		'</div>';
	$("#report-info-modal").find(".modal-body").html(html);
};

itemtestController.prototype.PopulateTestComparison = function(data)
{
	var html = 
	'<h2 id="comparisonTitle"></h2>'+
	'<div class="test-comparision-div">'+
		'<span class="comparisonCategorybtnleft"><img src="img/slideleft.png"></span>'+
		'<ul class="nav nav-tabs comparisonCategoryTab">'+
			'<li class="comparisonCategory active" comaparisontype="sectional"><a data-toggle="tab" href="#SectionalComparison">Sectional Comparison</a></li>'+
			'<li class="comparisonCategory" comaparisontype="time"><a data-toggle="tab" href="#TimeAnalysis">Time Analysis</a></li>';
	if(typeof data.testMeta.ToprankersComparision !== 'undefined' && data.testMeta.ToprankersComparision != null)
	{
		var weightedScore = '0';
		if(typeof data.weightage.score !== 'undefined' && data.weightage.score != null)
		{
			weightedScore = '1';
		}
		html +=
			'<li class="comparisonCategory" weightedScore="'+weightedScore+'" comaparisontype="toppers"><a data-toggle="tab" href="#ToprankersComparison">Topper\'s Comparison</a></li>';
	}
	html +=
		'</ul>'+
		'<span class="comparisonCategorybtnright"><img src="img/slideright.png"></span>'+
	'</div>'+
	'<div id="testcomparisonOverview" class="testcomparisonOverview">'+
		'<div class="tab-content col-md-12 col-sm-12">'+
			'<div id="SectionalComparison" class="tab-pane fade in active" comaparisontype="sectional">'+
				'<div class="full-view-div"><span class="js-sectional-full-view"><img src="img/fs-icon-2x.png"></span></div>'+
				"<data comparisontype='sectional' type='column' title='"+data.sectionalComparison.title+"' xAxisLabel='"+data.sectionalComparison.xAxisLabel+"' "+
				"yAxisLabel='"+data.sectionalComparison.yAxisLabel+"' valueSuffix='"+data.sectionalComparison.valueSuffix+"' yMax='"+data.sectionalComparison.yMax+"' "+
				"absolute='"+data.sectionalComparison.absolute+" lagend='"+data.sectionalComparison.lagend+"' categoryInToolTip='"+data.sectionalComparison.categoryInToolTip+"' "+
				"data='"+data.sectionalComparison.data+"'>"+
					'<div class="canvas"></div>'+ 
				'</data>'+
			'</div>'+
			'<div id="TimeAnalysis" class="tab-pane fade in" comaparisontype="time">'+
				'<div class="full-view-div"><span class="js-time-full-view"><img src="img/fs-icon-2x.png"></span></div>'+
				"<data comparisontype='time' type='columnSP' title='"+data.timeComparison.title+"' xAxisLabel='"+data.timeComparison.xAxisLabel+"' yAxisLabel='"+data.timeComparison.yAxisLabel+"' "+
				 "valueSuffix='"+data.timeComparison.valueSuffix+"' tooltipString='"+data.timeComparison.tooltipString+"' maxValue='"+data.timeComparison.maxValue+"' "+ 
				 "totalNrQuestion='"+data.timeComparison.totalNrQuestion+"' data='"+data.timeComparison.data+"'> "+
					'<div class="canvas"></div>'+
				'</data>'+
			'</div>'+
			'<div id="ToprankersComparison" class="tab-pane fade in" comaparisontype="toppers">'+ 
				'<h2 class="comparison-title">Over All Comparison</h2>';
	var rankDiv = markDiv = timeDiv = accDiv = attDiv = '';
	for(var rank in data.rankComparison)
	{
		if(data.rankComparison.hasOwnProperty(rank))
		{
			var cssClass =  'userPos';
			var value = data.rankComparison[rank];
			if(typeof value.posMeta !== 'undefined' && value.posMeta != null)
				cssClass = cssClass+' '+value.posMeta;
			
			if(typeof value.lastRank !== 'undefined' && value.lastRank != null)
			{
				rankDiv += '<div class="'+cssClass+'" rank="'+rank+'"><span class="pic" style="left:'+(100*rank/value.lastRank)+'%;"></span><span  style="left:'+(100*rank/value.lastRank)+'%;"><div>Rank</div><div>'+rank+'</div></span></div>';
				markDiv += '<div class="'+cssClass+'" rank="'+rank+'"><span class="pic" style="left:'+(100*rank/value.lastRank)+'%;"></span><span style="left:'+(100*rank/value.lastRank)+'%;"><div>Score</div><div>'+tr$.round(value.score,2)+'</div></span></div>';
				timeDiv +=((value.totalTime != 0)?
					'<div class="'+cssClass+'" rank="'+rank+'"><span class="pic" style="left:'+(100 - 100*value.timeTaken/value.totalTime)+'%"></span><span style="left:'+(100 - 100*value.timeTaken/value.totalTime)+'%"><div>Time</div><div>'+value.timeTaken+'</div></span></div>':
					'<div class="'+cssClass+' Rank" rank="'+rank+'"><span class="pic" style="left:0%"></span><span style="left:0%"><div>Time</div><div>'+value.timeTaken+'</div></span></div>');
				accDiv += '<div class="'+cssClass+'" rank="'+rank+'"><span class="pic" style="left:'+(100-value.accuracy)+'%;"></span><span style="left:'+(100-value.accuracy)+'%;"><div>Accuracy</div><div>'+value.accuracy+'</div></span></div>';
				attDiv += '<div class="'+cssClass+'" rank="'+rank+'"><span class="pic" style="left:'+(100-value.attemptRate)+'%;"></span><span style="left:'+(100-value.attemptRate)+'%;"><div>Attempt Rate</div><div>'+value.attemptRate+'</div></span></div>';
			}
			else
			{
				rankDiv +='<div class="'+cssClass+' Rank" rank="'+rank+'"><span class="pic"></span><span>'+rank+'</span></div>';
				markDiv += '<div class="'+cssClass+' Score" rank="'+rank+'"><span class="pic"></span><span>'+tr$.round(value.score,2)+'</span></div>';
				timeDiv += '<div class="'+cssClass+' TimeTaken" rank="'+rank+'"><span class="pic"></span><span>'+value.timeTaken+'</span></div>';
				accDiv += '<div class="'+cssClass+' Accuracy" rank="'+rank+'"><span class="pic"></span><span>'+value.accuracy+'</span></div>';
				attDiv += '<div class="'+cssClass+' AttempRate" rank="'+rank+'"><span class="pic"></span><span>'+value.attemptRate+'</span></div>';
			}
		}
	}
	rankDiv = '<div class="row-attribute"><div class="ComparasionName"><img src="img/rank-2x.png" /><span>Rank</span><span class="tooltip">Rank</span></div>'+rankDiv+'</div>';
	html +=
				'<div class="comaparision-container">'+
				'	<div class="rankComparisonTable">'+rankDiv;
	if( weightedScore == 0)
	{
		markDiv = '<div class="row-attribute"><div class="ComparasionName"><img src="img/mark-2x.png" /><span>Marks</span><span class="tooltip">Total marks obtained</span></div>'+markDiv+'</div>';
		html += markDiv;
	}
	timeDiv = '<div class="row-attribute"><div class="ComparasionName"><img src="img/time-taken-big-2x.png" /><span>Time In Minutes</span><span class="tooltip">Total time spent</span></div>'+timeDiv+'</div>';
	accDiv = '<div class="row-attribute"><div class="ComparasionName"><img src="img/accuracy-2x.png" /><span>Accuracy (%)</span><span class="tooltip">Rartio of correct vs incorrect answers</span></div>'+accDiv+'</div>';
	attDiv = '<div class="row-attribute"><div class="ComparasionName"><img src="img/attempt-rate-2x.png" /><span>Attempt Rate (%)</span><span class="tooltip">Ratio of attempted vs total questions</span></div>'+attDiv+'</div>';
	html += timeDiv + accDiv + attDiv+
					'</div>'+
				'</div>'+
				'<br/>';

	if(typeof data.testSection !== 'undefined'
		&& typeof data.testSection.name !== 'undefined'
		&& tr$.length(data.testSection.name) > 1)
	{
		for(var section in data.testSection.name)
		{
			if(data.testSection.name.hasOwnProperty(section))
			{
				var name = data.testSection.name[section];
				html +=
						'<div class="panel panel-default">'+
						  '<div class="panel-heading sectionComparisonPanel comparison-title" data-toggle="collapse" data-target="#sectionPanel-'+section+'" section="'+section+'"><span class="comp-title">'+name+'</span><span class="panel-img"></span></div>'+
						  '<div class="panel-body collapse" id="sectionPanel-'+section+'" data-loaded="false"></div>'+
						'</div>';
			}
		}
	}
	html +=
			'</div>'+
		'</div>'+
	'</div>';
	this.dom.append(html);
};

/*********** Report Events ************/
function Report(view){
	this.view = view;
}

Report.prototype.Init = function(){
	this.BindEvents();
	$(".testScoreOverview .tab-content > div:first-child").addClass("active");
	setTimeout(function(){
		this.DrawPieChart($(".testScoreOverview .tab-pane.active .answerDistribution"));
    	this.DrawPieChart($(".testScoreOverview .tab-pane.active .timeSpent"));
	}.bind(this), 200);
    this.ChangeCategoryResult();
    
    this.DrawColumnChart($("#SectionalComparison data"));
    this.DrawColumnSPChart($("#TimeAnalysis data"));
};
Report.prototype.BindEvents = function(){
	
	//switch view
	$(".switch-view input").change(this,function(e){
		$(".reportDefault,.reporttable").toggle();
		$(".graph-view, .table-view").toggleClass("faded");
		if($(".graph-view").hasClass("faded"))
		{
			Factory.getObj().blinkIndicators(this.view,'.reporttable','.reporttable');
		}
		else
		{
			$('.reporttable').find('.rightblink').remove();
			$('.reporttable').find('.leftblink').remove();
		}
	}.bind(this));
	
	Factory.getObj().scrollToCenter(".testCategoryTab li");
	
	$(".testCategoryTab li").bind("click",this,function(e)
	{
		if(!$(this).hasClass('active'))
		{
			var section = $(this).attr("section");
			var elems = $(".testScoreOverview").find(".tab-pane[section='"+section+"'] data");
			$(elems).each(function(i,elem){
				this.DrawPieChart(elem);
			}.bind(e.data));	
		}
	});
	$(".AIRBankSelectCat").unbind("change").bind("change", this,function(e) {
		e.data.ChangeCategoryResult();
	});
	Factory.getObj().scrollToCenter(".comparisonCategoryTab li");
	
	$(".comparisonCategoryTab li[comaparisontype='sectional']").bind('click',this,function(e){
		if(!$(this).hasClass("active"))
		{
			e.data.DrawColumnChart($("#SectionalComparison data"));
		}
	});
	
	$('#cast').bind("change", this, function(e){
		e.data.DrawColumnChart($(".testcomparisonOverview data[comparisontype='sectional']"));
	});
	$(".sectionComparisonPanel").unbind().bind("click",this,function(e){
		var elem = $(this).find(".glyphicon");
		if($(elem).hasClass("glyphicon-chevron-down"))
		{
			$(elem).removeClass("glyphicon-chevron-down").addClass("glyphicon-chevron-up");
		}
		else{
			$(elem).removeClass("glyphicon-chevron-up").addClass("glyphicon-chevron-down");
		}
		if($(this).siblings(".panel-body").attr("data-loaded") == "false")
		{
			var reportDiv = $(".reportDiv");
			e.data.GetSectionalComparison($(this).attr("section"),$(reportDiv).attr("testId"),$(reportDiv).attr("sessionId"));
		}
	});
	$(".DownloadQuestions").unbind().bind("click",function(){
		this.DownloadReport();
	}.bind(this));
};
Report.prototype.DownloadReport = function()
{
	//TODO Temp user Id
	$('body').append('<div class="loader"></div>');
	$.ajax({
		type : "POST",
		data : {
			mod : "tr2report",
			ack : "DownloadReport",
			sessionId : $(".reportDiv").attr("sessionid"),
			tempUser:userData.tempId
		},
		xhrFields : {
			withCredentials : true
		},
		crossDomain : true,
		complete : function(event) {
			var reply = event.responseJSON;
			if(reply.result.state == "ok")
			{
				try{
					var qData = '<div>' + reply.data.dataQuestion + '</div>';
					var printableHtml = $('<div></div>');
					
					var logoUrl = $(".DownloadQuestions").attr("data-logoUrl");
					if(logoUrl != "")
					{
						printableHtml.append($('<div class="Logo"><img src="'+logoUrl+'" alt="Logo"></div>'));
					}
					
					printableHtml.append('<div class="reports_head">'+$(".reports_head").html()+'</div>');
					if($(".DownloadQuestions").attr("data-wei") != "1")
					{
						printableHtml.append('<div>'+$(".reporttable table").html()+'</div>');
					}
					printableHtml.find('.button').remove();
					var secq = reply.data.sequecce;
					for(var s in secq)
					{
						var qId = secq[s].questionId;
						var sQId = secq[s].subQuestionId;
						var sNO = s;
						var entry = $('<div><table><tbody><tr><td>Question No</td><td>'+ sNO + '</td></tr><tr><td>Question Id</td><td>'+ qId + '-'+ sQId +'</td></tr><tr><td>Answer Status</td><td>'+
								AnswerStatus.Str[secq[s].resultState]+'</td></tr><tr><td>Flaged</td><td>'+secq[s].flag+'</td></tr></tbody></table></div>');
						
						var question = $(qData).find('._question_[qId="'+secq[s].questionId+'"][sQId="'+secq[s].subQuestionId+'"][language="'+ TestLanguageType.Str[this.language]+'"]');
						
						if(!question.length){
							question = $(qData).find('._question_[qId="'+secq[s].questionId+'"][sQId="'+secq[s].subQuestionId+'"]:eq(0)');
						}
						var qType = question.attr("qType");
						
						var qDiv = $('<div class="Question"></div>');
						if(typeof qType != undefined && parseInt(qType) == QuestionType.BLANK)
						{
							//this.DisplayFillInTheBlanksQuestion(question, qId, sQId, sNO, qData);
						}
						else if(typeof qType != undefined && parseInt(qType) == QuestionType.NIQ)
						{
							//this.DisplayNIQQuestion(question, qId, sQId, sNO, qData);
						}
						else
						{
							
							var text = question.find("._text_").html();
							qDiv.append($('<div class="QuestionText">'+text+'</div>'));
							var sData = reply.data.dataSolution;
							//var secq = reply.data.sequecce;
					
							var ansOptions = question.find("._answer_");
							var correctAnsSeq = $(sData).find('._correctAnsSeq_[qId="'+qId+'"][sQId="'+sQId+'"]').children();
							var givenAns = JSON.parse(secq[sNO].answer).ans;
							var meta = JSON.parse(secq[sNO].meta);
							var ans = "";
							var correctOtions = "";
							
							for(var a = 0; a < correctAnsSeq.length; a++)
							{ 
								var correctness = "";
								var correct = false;
								var correctOptionHtml = "";
								if($(correctAnsSeq[a]).text() == "1")
								{
									if(correctOtions != "")
										correctOtions += ", ";
									correctOtions += String.fromCharCode(65 + a);
									if(typeof givenAns != "undefined" && givenAns[meta.indexOf(a)] == true)	
									{		
										correctness = '<span class="OptionCorrectness Correct">Correct attempt</span>';
									}
									correct = true; 
									correctOptionHtml = '<span class="CorrectOption">Correct Option</span>';
								}
								else if(typeof givenAns != "undefined" && givenAns[meta.indexOf(a)] == true)
								{
									correctness = '<span class="OptionCorrectness Wrong">Wrong attempt</span>';
								}
								
								var ansOption = '<div correct="'+correct+'"><span class="OptionIndicator">'+String.fromCharCode(65 + a) + 
										'</span><span>' + ansOptions[a].innerHTML + '</span>'+correctOptionHtml + correctness+'</div>';
								
								ans += ansOption;
							}
							
							qDiv.append('<div class="QuestionOptions">'+ans+'</div>');
					
							var slnDiv = $(sData).find('._soln_[qId="'+qId+'"][sQId="'+sQId+'"][language="'+TestLanguageType.Str[this.language]+'"]');
							if(!slnDiv.length){
								slnDiv = $(sData).find('._soln_[qId="'+qId+'"][sQId="'+sQId+'"]:eq(0)');
							}
							qDiv.append('<div class="Solution"><div><b>SOLUTION:</b></div>'+$(slnDiv).html()+'</div>');
						}
						entry.append(qDiv);
						printableHtml.append(entry);
					}
					
					var html = '<html><head><title>Download report</title>'+
								'<script type="text/javascript" src="https://ajax.googleapis.com/ajax/libs/jquery/2.1.1/jquery.min.js"></script>'+
								'<script src="/MathJax/MathJax.js?config=TeX-AMS-MML_SVG"></script>'+
				    			'<script type="text/x-mathjax-config">'+
									'MathJax.Hub.Config({'+
				  						'config: ["MMLorHTML.js"],'+
				  						'jax: ["input/TeX","input/MathML","input/AsciiMath"],'+
				  						'extensions: ["tex2jax.js","mml2jax.js","asciimath2jax.js","MathMenu.js","MathZoom.js"],'+
				  						'TeX: {'+
				    						'extensions: ["autoload-all.js"]'+
				  						'}'+
									'});'+
								'</script>';
							
				  		html += '<style>'+
				  				'#pdf-content {'+
									'border: 1px solid #ddd;'+
									'margin: auto;'+
									'max-width: 1024px;'+
									'padding: 10px;'+
									'position: relative;'+
								'}'+
								'.Logo {'+
									'padding-bottom: 10px;'+
									'text-align: center;'+
									'background: #fff;'+
								'}'+
					  			'th, td {'+
					    			'border: 1px solid #ccc;'+
					    			'padding: 4px;'+
					    		'}'+
					    		'table {'+
					    			'border-collapse: collapse;'+
					    			'margin: 20px 0px;'+
					    		'}'+
					    		'.OptionIndicator {'+
				    				'font-weight: bold;'+
				    				'padding-right: 10px;'+
								'}'+
								'.OptionCorrectness {'+
				    				'font-weight: bold;'+
				    				'margin-left: 15px;'+
								'}'+
								'.QuestionOptions > div[correct="true"] {'+
				    				'background: #cfc'+
								'}'+
								'.QuestionOptions > div {'+
				    				'padding: 5px;'+
								'}'+
								'.OptionCorrectness.Wrong {'+
				    				'color: red;'+
								'}'+
								'.OptionCorrectness.Correct {'+
				    				'color: green;'+
								'}'+
								'.Question {'+
									'border-bottom: 1px dashed #666;'+
									'padding-bottom: 10px;'+
								'}'+
								'.reports_head {'+
				    				'background-color: #ddd;'+
				    				'padding: 10px 5px;'+
				    				'text-align: center;'+
								'}'+
								'.reports_head table {'+
				    				'width: 100%;'+
								'}'+
								'.reports_head table td{'+
				    				'text-align:center;'+
				    				'border:none;'+
								'}'+
								'.reports_head table td > span{'+
				    				'display:block;'+
				    			'}'+
								'.CorrectOption {'+
			    					'color: green;'+
									'font-weight: bold;'+
									'padding: 0 10px;'+
								'}';
				    
				    
				    var waterMarkUrl = $(".DownloadQuestions").attr("data-waterMarkUrl");
					if(waterMarkUrl != "")
					{
						html += '#pdf-content > div:not(.reports_head)'+
								'{'+
									'position: relative;'+
								'}'+
								'#pdf-content > div:not(.reports_head)::before, #pdf-content > div:not(.reports_head)::after {'+
									'content: url("'+waterMarkUrl+'");'+
									'left: 0;'+
									'position: absolute;'+
									'right: 0;'+
									'text-align: left;'+
									'transform: rotate(-45deg);'+
									'opacity: 0.4;'+
								'}'+
								'#pdf-content > div:not(.reports_head)::after'+
								'{'+
									'bottom: 0;'+
									'text-align: right;'+
								'}'+
								'.Logo::before, .Logo::after {'+
									'content: "" !important;'+
								'}';
					}
				    
					html += '</style></head>';
			
					html += '<body>'+
							'<div id="pdf-content">'+printableHtml.html()+'</div>';
					html += '<script> MathJax.Hub.Queue(["Typeset", MathJax.Hub]);</script>';
					html += '</body></html>';
							
					
					var w = window.open();
					if(!w || w.closed || typeof w.closed=='undefined')  
					{
						alert("Pop-up is blocked by your browser! Please add this site to your exception list.");
					}
					else
					{
						w.document.writeln(html);
						w.document.close();
					}
				}
				catch(e)
				{
					console.log(e);
				}
			}
			else{
				alert(reply.result.meta);
			}
			$(".loader").remove();
		},
		url : remoteServer + "/?route=common/ajax"
	});
};
Report.prototype.GetSectionalComparison = function(sectionId,testId,sessionId)
{
	var urlMgmt = UrlMgmt.getObj();	
	urlMgmt.showLoader();
	tr$.ajax({
        mod : "tr2report",
		ack : "GetSectionalRankComparison",
        additionalParams: {
            sectionId : sectionId,
			testId : testId,
			sessionId : sessionId
        },
        offlineMode:{
			tablename: 'sectional_comparison',
			filename: 'sectional_comparison.json',
			recordId: sectionId+sessionId,
		},
        successClb: function (reply, obj) {
        	try
        	{
            	if (reply.result.state == 'ok')
				{
					var weightageEnabled = $(".comparisonCategoryTab li[comaparisontype='toppers']").attr("weightedscore");
					var rankDiv = markDiv = timeDiv = accDiv = attDiv = '';
					for(var rank in reply.data)
					{
						var cssClass = 'userPos';
						if(typeof reply.data[rank]["posMeta"]!= "undefined")
						{
							cssClass += " "+reply.data[rank]["posMeta"];
						}
						if(typeof reply.data[rank]["lastRank"] !== "undefined")
						{
							rankDiv += '<div class="'+cssClass+'" rank="'+rank+'"><span class="pic" style="left:'+ 100*rank/reply.data[rank]["lastRank"]+'%;"></span><span style="left:'+ 100*rank/reply.data[rank]["lastRank"]+'%;"><div>Rank</div><div>'+rank+'</div></span></div>';
							markDiv += '<div class="'+cssClass+'" rank="'+rank+'"><span class="pic" style="left:'+ 100*rank/reply.data[rank]["lastRank"]+'%;"></span><span style="left:'+ 100*rank/reply.data[rank]["lastRank"]+'%;"><div>Score</div><div>'+tr$.round(reply.data[rank]["score"],2)+'</div></span></div>';
							if(reply.data[rank]["totalTime"] != 0)
							{
								timeDiv += '<div class="'+cssClass+'" rank="'+rank+'"><span class="pic" style="left:'+ (100 - 100*reply.data[rank]["timeTaken"]/reply.data[rank]["totalTime"])+'%;"></span><span style="left:'+ (100 - 100*reply.data[rank]["timeTaken"]/reply.data[rank]["totalTime"])+'%;"><div>Time</div><div>'+reply.data[rank]["timeTaken"]+'</div></span></div>';
							}
							else
							{
								timeDiv += '<div class="'+cssClass+'" rank="'+rank+'"><span class="pic" style="left:0%;"></span><span style="left:0%;"><div>Time</div><div>'+reply.data[rank]["timeTaken"]+'</div></span></div>';
							}
							accDiv += '<div class="'+cssClass+'" rank="'+rank+'"><span class="pic" style="left:'+ (100 - reply.data[rank]["accuracy"])+'%;"></span><span style="left:'+ (100 - reply.data[rank]["accuracy"])+'%;"><div>Accuracy</div><div>'+reply.data[rank]["accuracy"]+'</div></span></div>';
							attDiv += '<div class="'+cssClass+'" rank="'+rank+'"><span class="pic" style="left:'+ (100 - reply.data[rank]["attemptRate"])+'%;"></span><span style="left:'+ (100 - reply.data[rank]["attemptRate"])+'%;"><div>Attempt Rate</div><div>'+reply.data[rank]["attemptRate"]+'</div></span></div>';
						}
						else {
							rankDiv += '<div class="'+cssClass+' Rank" rank="'+rank+'"><span>'+rank+'</span></div>';
							markDiv += '<div class="'+cssClass+' Score" rank="'+rank+'"><span>'+tr$.round(reply.data[rank]["score"],2)+'</span></div>';
							timeDiv += '<div class="'+cssClass+' TimeTaken" rank="'+rank+'"><span>'+reply.data[rank]["timeTaken"]+'</span></div>';
							accDiv += '<div class="'+cssClass+' Accuracy" rank="'+rank+'"><span>'+reply.data[rank]["accuracy"]+'</span></div>';
							attDiv += '<div class="'+cssClass+' AttempRate" rank="'+rank+'"><span>'+reply.data[rank]["attemptRate"]+'</span></div>';
						}
					}
					var table = '<div class="rankComparisonTable">';
					rankDiv = '<div class="row-attribute"><div class="ComparasionName"><img src="https://cdn.toprankers.net/images/rank-023a7e387ee21.png" /><span>Rank</span><span class="tooltip">Rank</span></div>'+rankDiv+'</div>';
					table += rankDiv;
					if(weightageEnabled == 0)
					{
						markDiv = '<div class="row-attribute"><div class="ComparasionName"><img src="https://cdn.toprankers.net/images/mark-023a7e42a4f40.png" /><span>Marks</span><span class="tooltip">Total marks obtained</span></div>'+markDiv+'</div>';
						table += markDiv;
					}
					timeDiv = '<div class="row-attribute"><div class="ComparasionName"><img src="https://cdn.toprankers.net/images/time-in-minute-023a7e387cf61.png" /><span>Time In Minutes</span><span class="tooltip">Total time spent</span></div>'+timeDiv+'</div>';
					accDiv = '<div class="row-attribute"><div class="ComparasionName"><img src="https://cdn.toprankers.net/images/accuracy-023a7e42a82a0.png" /><span>Accuracy (%)</span><span class="tooltip">Rartio of correct vs incorrect answers</span></div>'+accDiv+'</div>';
					attDiv = '<div class="row-attribute"><div class="ComparasionName"><img src="https://cdn.toprankers.net/images/attempt-rate-023a7e42a79c0.png" /><span>Attempt Rate (%)</span><span class="tooltip">Ratio of attempted vs total questions</span></div>'+attDiv+'</div>';
					table += timeDiv+accDiv+attDiv;
					table += '</div>';
					var container = $("#ToprankersComparison #sectionPanel-"+sectionId);
					$(container).append(table);
					$(container).attr("data-loaded","true");
                }
        	}
        	catch(e)
        	{
        		console.log(e);
        	}
        	urlMgmt.removeLoader();
        },
        errorClb: function(){
        	urlMgmt.removeLoader();
        	tr$.alert("Internal error!");
        }
    });
};
Report.prototype.DrawColumnSPChart = function(dataElem){
	var data = JSON.parse($(dataElem).attr("data"));
	var y_data = data["y-axis"];
	var x_data = JSON.parse(data["x-axis"]);
	var x_data1 = JSON.parse(data["x-axis1"]);
	var tickPositions = JSON.parse(data["tickPositions"]);
	var maxValue = parseInt($(dataElem).attr("maxValue")) + 10;
	var series = [];
	var view = JSON.parse(data["views"]);
	var chartWidth = $(window).width();
	var chartHeight = $(window).height();
	
	for(var i=0;i<y_data.length;i++)
	{
		y_data[i]["value"] = JSON.parse(y_data[i]["value"]);
		for(var j=0;j<y_data[i]["value"].length;j++){
			y_data[i]["value"][j]["y"] = parseFloat(y_data[i]["value"][j]["y"]);
		}
		series.push({name:y_data[i]["legend"] ,
					data:(y_data[i]["value"]),
					color: y_data[i]["color"]});
	}
	
	if(typeof series[0] !== 'undefined')
	{
		var xAxisCount = series[0].data.length;
		chartWidth = Math.max((xAxisCount * 25),chartWidth);
		landscapeWidth = Math.max((xAxisCount * 25),chartWidth);
	}

	var chartingOptions = {
			credits: {
				enabled: false
			},
			chart: {
				type: 'column',
				backgroundColor: null,
				width:chartWidth,
				height:chartHeight,
				events: {
					load: function () {
						var tickWidth = this.xAxis[1].width / this.xAxis[1].categories.length;
						var lastTick = -1;
						for (var i = 0; i < this.xAxis[1].categories.length; i++) {
							if (this.xAxis[1].ticks[i]) {
								var left = this.xAxis[1].chart.plotLeft + ((lastTick + 1) * tickWidth);
								var	label = this.xAxis[1].ticks[i].label;
								var	newX = left + (((this.xAxis[1].ticks[i].pos - lastTick) / 2) * tickWidth);
								var x = newX - label.xy.x;
								label.attr({
									translateX: x,
								});
								lastTick = i;
							}
						}
					}, redraw: function () {
						var tickWidth = this.xAxis[1].width / this.xAxis[1].categories.length;
						var lastTick = -1;
						for (var i = 0; i < this.xAxis[1].categories.length; i++) {
							if (this.xAxis[1].ticks[i]) {
								var left = this.xAxis[1].chart.plotLeft + ((lastTick + 1) * tickWidth);
								var	label = this.xAxis[1].ticks[i].label;
								var	newX = left + (((this.xAxis[1].ticks[i].pos - lastTick) / 2) * tickWidth);
								var x = newX - label.xy.x;
								label.attr({
									translateX: x,
								});
								lastTick = i;
							}
						}
					}
				},
			},
			plotOptions: {
				column: {
					events: {
						legendItemClick: function () { return PreventLastLagentHide(this);}
					}
				},
			},
			title: {
				text: $(dataElem).attr("title"),
				align:'left',
			},
			xAxis: [
				{
					categories: x_data,
					title: {
						text: $(dataElem).attr("xAxisLabel")
					}
				},
				{
					linkedTo: 0,
					opposite: true,
					gridLineWidth: 1,
					gridLineColor: 'green',
					alternateGridColor:'#FDFFD5',
					categories: x_data1,
					tickPositions: tickPositions,
					title: {
					//	text: tickPositions.length > 0 ? 'Sections':''
					},
					labels: {
						rotation:0,
        		    }
				}
			],
			yAxis: {
				min:-maxValue,
				max: maxValue,
                title: {
                    text: $(dataElem).attr("yAxisLabel")
                },
				labels: {
					overflow: 'justify',
					formatter: function() {
						var value = this.value;
						value = Math.abs(value);
		               return value + " " + $(dataElem).attr("valueSuffix");
			        }
				},
				plotLines: [
					{
						value: 0,
						color: '#666',
						width: 2,
					},
				],
            },
			tooltip: {
				 formatter: function () {
				 	if(this.point.showTooloTip)
				 	{
						var value = this.y;
						value = Math.abs(value);
						var lagend = this.series.name;
						var views = view[this.key-1];

	                    return '<b>' + lagend + '</b><br/>' +
	                     		this.series.xAxis.axisTitle.textStr + ": <b>"+ this.point.category + '</b><br/>'+$(dataElem).attr("tooltipString")+': <b>' +
								value + " " + $(dataElem).attr("valueSuffix") + "</b><br/>Number of visits: <b>" +views+"</b>";
					}
					else
						return false;
                },
				column: {
					stacking: true,
				},
				followPointer: false,
               	followTouchMove: false,
			},
			legend: {
				align:'left',
		        style:{
		        	color: '#627A80',
		        	fontSize:'14px',
		        	fontFamily:'muli',
		        	marginLeft:'15px',
		        },
		        
		        //circle legend symbols
		        symbolHeight: 12,
		        symbolWidth: 12,
		        symbolRadius: 6,
			},
			series: series
	};
	
	
	var tabChartingOptions = chartingOptions;
	var windowWidth =  $(window).width();
	var windowHeight =  $(window).height();
	//In tab view Min Chart width = window Width
	tabChartingOptions.chart.width = (chartWidth < windowWidth) ? windowWidth : chartWidth;
	//In tab view Max Chart height = 400px
	tabChartingOptions.chart.height = (chartHeight < 400) ? chartHeight:400;
	$(dataElem).find(".canvas").highcharts(tabChartingOptions);

	chartingOptions.chart.height = windowWidth;
	chartingOptions.chart.width = (landscapeWidth < windowHeight) ? windowHeight:landscapeWidth;
	$("#time-analysis-hc").find(".canvas").highcharts(chartingOptions);
};
Report.prototype.ChangeCategoryResult = function(){
	var category = $(".AIRBankSelectCat").val(); 
	if(typeof category == 'undefined')//if AIRBank is not enable
	{
		return;
	}
	$(".candidatescore").each(function(){
  		var isCrossCutoff = $(this).attr(category);
  		if(isCrossCutoff=='Y'){
  			$(this).removeClass("cutoffNotCross cutoffNotReq").addClass("cutoffCross");
  		}
  		else if(isCrossCutoff=='N'){
  			$(this).removeClass("cutoffCross cutoffNotReq").addClass("cutoffNotCross");
  		}
  		else{
  			$(this).removeClass("cutoffCross cutoffNotCross").addClass("cutoffNotReq");
  		}
	 });
	var isCrossOverAllCutoff = $(".candidateStatus").attr(category);
 	if(isCrossOverAllCutoff=='Y'){
 		$(".candidateStatusSpan").html("CONGRATULATIONS-You have been shortlisted for the "+$(".testName").text());
		$(".candidateStatusSpan").removeClass("cutoffNotCross cutoffNotReq").addClass("cutoffCross");
	}
	else if(isCrossOverAllCutoff=='N'){
		$(".candidateStatusSpan").html("SORRY-You have not been shortlisted for the "+$(".testName").text());
		$(".candidateStatusSpan").removeClass("cutoffCross cutoffNotReq").addClass("cutoffNotCross");
	}
	else{
		$(".candidateStatusSpan").html();
		$(".candidateStatusSpan").removeClass("cutoffCross cutoffNotCross").addClass("cutoffNotReq");
	}
	$( ".innerTD" ).each(function(){
		$(this).removeClass("LabelColor");
	});
	$( ".innerTD[categoryN='"+category+"']" ).each(function(){
		$(this).addClass("LabelColor");
	});
};
Report.prototype.DrawColumnChart = function(dataElem){
	//var dataElem = document.getElementById(dataElemId);
	var data = JSON.parse($(dataElem).attr("data"));
	var cutoffSection = JSON.parse(data["x-axisCutoff"]["value"]);
	var x_data = JSON.parse(data["x-axis"]);
	var selectedCast = $('#cast :selected').val();
	var series = [];
	var cutoff = [];
	var plotLines = [];
	var plotSectionLine = [];
	var newline = new Array;

	var absolute = $(dataElem).attr("absolute");
	var lagend = $(dataElem).attr("lagend");
	var categoryInToolTip = $(dataElem).attr("categoryInToolTip");
	var windowHeight = $(window).height();
	var windowWidth = $(window).width();
	if(cutoffSection.length > 0)
	{
		var totalScore = [];
		for(var i=0;i<Object.keys(data["y-axis"]).length;i++)
		{
			if(data["y-axis"][i]["legend"] == 'Score')
			{
				var per = JSON.parse(data["y-axis"][i]["value"]);
				for(var j=0;j<per.length;j++){
					if(per[j].meta != 0)
						totalScore.push(per[j].meta.split('/')[1]);
					else
						totalScore.push(per[j].meta);
				}
			}
		}
		for(var i=0;i<cutoffSection.length; i++)
		{
			cutOffPer = (cutoffSection[i][selectedCast] * 100)/totalScore[i];
			cutoff[i] = Math.round(cutOffPer * 100) / 100;
			if(data["x-axisCutoff"]["legend"] == "overall"){
				plotLines.push({
	                    value:cutoff[i],
	                    color: '#ff0000',
	                    width:1,
	                    zIndex:4,
	                    label:{text:'Cut-Off: '+cutoff[i]+'%'}
	                });
			}
			plotSectionLine.push(cutoff[i]);
		}
	}
	for(var i=0;i<Object.keys(data["y-axis"]).length;i++)
	{
		series.push({name:data["y-axis"][i]["legend"],
					data:JSON.parse(data["y-axis"][i]["value"]),
					color: data["y-axis"][i]["color"]});
	}
	var chartingOptions = {
     chart: {
               type: 'column',
               backgroundColor: null,
               width:windowHeight,
               height:windowWidth,
             },
    credits: {
				enabled: false
			},
    title: {
           text: $(dataElem).attr("title") ,
           align:'left',
    	 },
    xAxis: {
            categories: x_data,
			title: {
				text: $(dataElem).attr("xaxislabel")
			},
			labels: {
            	enabled: true
        	}
		},
	yAxis: {
                title: {
                    text: $(dataElem).attr("yaxislabel")
                },
				labels: {
					overflow: 'justify',
					formatter: function() {
						var value = this.value;
						if(absolute)
							value = Math.abs(value);
						return value + $(dataElem).attr("valuesuffix");
			        }
				},
				plotLines: plotLines,
    			max:$(dataElem).attr("ymax")
            },
     tooltip: {
				 formatter: function () {
					var value = this.y;
					if(absolute)
						value = Math.abs(value);
					var meta = "";
                    if(this.point.meta)
						meta = " ("+ this.point.meta +") ";

					var category = "";
					if(categoryInToolTip == "true")
						category =  this.point.category + '<br/>';

					return  category + this.series.name+ ': <b>' + value + $(dataElem).attr("valuesuffix") + meta + "</b>";
               },
               followPointer: false,
               followTouchMove: false,
			},
	legend: {
				enabled: $(dataElem).attr("lagend")=="false"?false:true,
				align:'left',
		        style:{
		        	color: '#627A80',
		        	fontSize:'14px',
		        	fontFamily:'muli',
		        	marginLeft:'15px',
		        },
		        
		        //circle legend symbols
		        symbolHeight: 12,
		        symbolWidth: 12,
		        symbolRadius: 6,
			},
	plotOptions: {
				column: {
					stacking: "",
					events: {
						legendItemClick: function (e) {
							var attrCutOff = {
				    			class: "cutOffLine",
					            'stroke-width': 1,
					            stroke: "#ff0000",
					            zIndex: 5,
					            visibility: $(".cutOffText").attr("visibility")
					        };
							switch(this.name){
								case "Score":
										if($(".cutOffText").attr("visibility")=='visible' && PreventLastLagentHide(this)== undefined){
											$(".cutOffText").attr("visibility","hidden");
											$(".cutOffLine").attr("visibility","hidden");
										}else{
											$(".cutOffText").attr("visibility","visible");
											$(".cutOffLine").attr("visibility","visible");
										}
									break;
								default :
										var updateline = new Array;
										newline.forEach(function(line){
											dArray = line.d.split(" ");
											dArray[4] = Number(dArray[1])+this.chart.series[0].barW +2;
											dArray.join(" ");
											updateline.push(this.chart.renderer.path(dArray).attr(attrCutOff).add());
											line.destroy();
										}.bind(this));
										newline = updateline;
									break;
							}
							return PreventLastLagentHide(this);}
					}
				}
			},
		series: series,
	};
	var chartFunction = function (chart) {
		    if(plotSectionLine.length>0){
		    	var xStart = chart.plotBox.x;
	    		var attrCutOff = {
	    			class: "cutOffLine",
		            'stroke-width': 1,
		            stroke: "#ff0000",
		            zIndex: 5,
		            visibility: "visible"
		        };

			     var width = chart.series[0].barW+2;
			     var baseline = (chart.yAxis[0].ticks[0].label.xy.y - 3);
			     var interval = chart.yAxis[0].tickInterval;
			     var intervalHeight = chart.yAxis[0].ticks[0].label.xy.y - chart.yAxis[0].ticks[interval].label.xy.y;
			   $.each(plotSectionLine, function (pointIndex, point) {
		    		var yStart = baseline-((point * intervalHeight)/interval);
			        var actualsectionWidth = xStart + (chart.plotBox.width / x_data.length);
			        var start = xStart + ((chart.plotBox.width / x_data.length)/4.8);
			        // path = ['MoveTo', Start-position-left, start-position-from-top, 'Horizontal', Width]
			        var path = ['M', start, yStart, 'H', (width+start)];
			        text = chart.renderer.text('Cut-Off: '+ point +'%',((2*start+width)/2)-40, yStart-5).attr({zIndex:4}).attr({class: "cutOffText", "visibility":"visible"}).add();
			        newline.push(chart.renderer.path(path).attr(attrCutOff).add());
			        xStart = actualsectionWidth;
			    });
		    }
		};
		
		//In tab view Max Chart height = 400px
		var tabChartingOptions = chartingOptions;
		tabChartingOptions.chart.height = (windowWidth < 400) ? windowWidth:400;
		$(dataElem).find(".canvas").highcharts(tabChartingOptions, chartFunction);
		chartingOptions.legend.align = 'center';
		chartingOptions.title.align = 'center';
	    $("#sectional-comparision-hc").find(".canvas").highcharts(chartingOptions,chartFunction);
	    //Factory.getObj().blinkIndicators(this.view,$(dataElem).parent(),'.canvas'); 
};
Report.prototype.DrawPieChart = function(dataElem){
	var title = $(dataElem).attr("title");
	var valueSuffix = $(dataElem).attr("valuesuffix");
	var data = JSON.parse($(dataElem).attr('seriesData'));
	var seriesData = [];
	for(var i in data)
	{
		seriesData.push({name:data[i].legend,
							y:data[i].value,
							color:data[i].color,
							sliced:(typeof(data[i].isOpened) !== 'undefined')?true:false,
							selected:(typeof(data[i].isOpened) !== 'undefined')?true:false
							});

	}
	var chartingOptions = {
     chart: {
               type: 'pie',
               margin:[10, 0, 70, 0],
              // renderTo: $(dataElem).find(".canvas"),
              	options3d: {
					enabled: false,
					alpha: 45,
					beta: 0
				},
             },
     credits: {
	    enabled: false
	},
    title: {
           text: title ,
           align: 'center',
           verticalAlign: 'middle',
		    floating:true,
		    widthAdjust: -300,
		    x: 0,
       	    y: -27,
		   style: {
	            color: '#333333',
	            fontWeight: 'bold',
	            fontSize:'12px',
	        }
		 },
    tooltip: {
				formatter: function () {
					var percent = Math.round(this.percentage * 100) / 100;
					var y = Math.round(this.y * 100) / 100;
					return this.key +": <b>"+ percent +"% </b> <br/> <b> " + y + "</b> " + valueSuffix ;
            	},
            	followPointer: false,
            	followTouchMove: false,
			},
	legend : {
		//align legend in right
		symbolRadius: 0,
        style:{
        	color: '#627A80',
        	fontSize:'12px',
        	fontFamily:'muli',
        },
        
        //circle legend symbols
        symbolHeight: 12,
        symbolWidth: 12,
        symbolRadius: 6,
	},
    plotOptions:  {
               pie: {
					dataLabels: {
						enabled: false
					},
					size: '100%',
					depth: 10,
                    showInLegend: true,
					allowPointSelect: true,
					cursor: 'pointer',
				}
            },
    series: [{
                data: seriesData,
                innerSize: '75%',
                size: '100%'
            }],
    };
    $(dataElem).find(".canvas").highcharts(chartingOptions);
   //var chart = new Highcharts.Chart(chartingOptions);
};

/*********** Solution Events *****************/

function Review(){
	this.testLanguage = 0;
	this.qData = '';
	this.sData = '';
	this.secq = {};
	this.hideExplanation = false;
	this.userBookmarks = {};
	this.modifiedQuestion = {};
	this.showApprove = 0;
	this.statusClick = 0;
}

Review.prototype.Init = function(){
	this.testLanguage = $(".reviewQuestionDiv").attr("testLanguage");
	this.qData = $(".qData");
	this.sData = $(".ansData");
	this.secq = JSON.parse($(".secq").text());
	this.hideExplanation = $(".reviewQuestionDiv").attr("hideExplanation");
	if($(".userBookmark").text() !== "null")
	{
		this.userBookmarks = JSON.parse($(".userBookmark").text());
	}
	this.PopulateUserBookmarks();
	this.ValidateNavigator();
	this.ValidateFilter();
	this.BindReviewEvents();
	this.FilterByStatus();
	this.BindDiscussionEvents();
};
Review.prototype.ResizeQuestionPanel = function(){
	var h = $(window).height() - ($(".review-panel.Questionboard .Questionboard-heading").outerHeight() + $(".review-panel .panel-footer").outerHeight() +
							 $(".reviewQuestionDiv h2").outerHeight() + $(".raiseIssueBtn").outerHeight() + 130);
	$(".review-panel .Questionboard-body").outerHeight(h);
};
Review.prototype.PopulateUserBookmarks = function()
{
	var bookmarkOptions = '<option value="-1" selected="selected">--Bookmark List--</option>';
	for(var i in this.userBookmarks)
	{
		bookmarkOptions += '<option value="'+this.userBookmarks[i].id+'">'+this.userBookmarks[i].name+'</option>';
	}
	$("#questionBookmark-modal .bookmarkList").empty();
	$("#questionBookmark-modal .bookmarkList").append(bookmarkOptions);
};
Review.prototype.BindReviewEvents = function(){
	$(".qIndex").unbind().bind("click",this,function(e)
	{
		$(".review-panel.Questionboard").addClass("animatepanel");
		setTimeout(function(){
			$(".review-panel.Questionboard").removeClass("animatepanel");
		},400);
		$(".QuestionHeatmap .QuestionList,.QuestionIndexWrapper .SessionQuestionList,html body").stop(true,true);
		var sno = $(this).attr("sno");
		e.data.DisplayQuestion(sno);
		if($(".qIndex.noDisplayIndex.selectedIndex").length>0)
		{
			$(".QuestionList .qIndex").addClass("noDisplayIndex");
			$(".selected-status").removeClass("selected-status");
			$(".answer-status .status-element[value='"+QuestionFilter.ALL+"']").addClass("selected-status");
			var currSection = $(".selected-section").attr("value");
			if(currSection != SectionFilter.ALL){
				$(".selected-section").removeClass("selected-section");
				var qsection = $('.QuestionList [sno="'+sno+'"]').attr("section");
				$(".SectionList .section-element[value='"+qsection+"']").addClass("selected-section");	
				$(".QuestionList").attr({
					section:qsection,
		    		qStatus:0,
		    		bookmarkLabel:-1
				});
				$(".QuestionList .AllSecQues").addClass("noDisplayIndex");
				$(".QuestionList .qIndex[section='"+qsection+"'],.QuestionList .sectionQues").removeClass("noDisplayIndex");
			}
			else
			{	$(".QuestionList").attr({
					section:-1,
		    		qStatus:0,
		    		bookmarkLabel:-1
				});
				$(".QuestionList .sectionQues").addClass("noDisplayIndex");
				$(".QuestionList .qIndex,.QuestionList .AllSecQues").removeClass("noDisplayIndex");
			}
			e.data.ValidateNavigator();
			$(".selected-section-name").html($(".selected-section").html());
		}
		e.data.ValidateQNav();
		$(".OptionCorrectness.wrong").parent().addClass("selected-wrong-option");
		
		if(e.data.statusClick != 1){
	    	setTimeout(function(){
				$('#question-heatmap-modal').find('.modal-footer').find('.infoclose').click();
			}, 100);
	    }
	    else
		e.data.statusClick = 0;

		$('html, body').animate({
	        scrollTop: $(".Questionboard-heading").offset().top - 60
	    }, 500);
	});
	$(".bookmarkBtn").unbind().bind("click",function(){
		if(UrlMgmt.getObj().App.isOnline){
			$("#questionboard-heading-modal").modal("hide");
			$("#questionBookmark-modal").modal("show");
			$("#questionBookmark-modal").find(".bookmarkMsg").text(" ");
			$("#questionBookmark-modal").find(".bookmarkName").val('');
		}
		else{
			if (!UrlMgmt.getObj().App.isOnline) 
			{
		    	UrlMgmt.getObj().App.onOffline();
		  	} 
		}
	}.bind(this));
	$(".bookmarkQuesClick").unbind().bind("click", function(){
		if(UrlMgmt.getObj().App.isOnline){
			$("#questionBookmark-modal").modal("show");
			$("#questionBookmark-modal").find(".bookmarkMsg").text(" ");
			$("#questionBookmark-modal").find(".bookmarkName").val('');
		}
		else{
			if (!UrlMgmt.getObj().App.isOnline) 
			{
		    	UrlMgmt.getObj().App.onOffline();
		  	} 
		  	
		}
	});
	$(".bookmarkToggle").unbind().bind("click",function(){

		if(UrlMgmt.getObj().App.isOnline){
			$(this).hide();
			$(".newBookmarkDiv").show();
			$('.bookmarkName').val('');
		}
		else{
			if (!UrlMgmt.getObj().App.isOnline) 
			{
		    	UrlMgmt.getObj().App.onOffline();
		  	} 
		  	
		}
	});
	$(".addBookmarkBtn").unbind().bind("click",this,function(e){

		if(UrlMgmt.getObj().App.isOnline)
		{
				var selElement = $('#questionBookmark-modal .bookmarkList').val();
				if(selElement == -1)
				{
					alert("Please select a valid bookmark");
					return;
				}
				e.data.BookmarkQuestion(selElement);
				$(".bookmarkMsg").html("Question Bookmarked Successfully");
		}
		else{
			if (!UrlMgmt.getObj().App.isOnline) 
			{
		    	UrlMgmt.getObj().App.onOffline();
		  	} 
		  	
		}
	});
	$(".removeBookmarkBtn").unbind().bind("click",this,function(e){
		 if(UrlMgmt.getObj().App.isOnline){
			e.data.BookmarkQuestion(-1);
			$(".bookmarkMsg").html("Bookmarked Removed Successfully");
		}
		else{
			if (!UrlMgmt.getObj().App.isOnline) 
			{
		    	UrlMgmt.getObj().App.onOffline();
		  	} 
		  	
		}
	});
	$(".submitBookmarkBtn").unbind('click').bind('click', this, function(e){
		 if(UrlMgmt.getObj().App.isOnline){
			var newBookmarkLabel = $.trim($(".bookmarkName").val());
			if(!newBookmarkLabel.length)
			{
				alert("Name cannot be empty!");
				return;
			}
			e.data.setNewBookmark(newBookmarkLabel);
		}
		else{
			if (!UrlMgmt.getObj().App.isOnline) 
			{
		    	UrlMgmt.getObj().App.onOffline();
		  	} 
		  	
		}
	});
	$(".close-filter").unbind().bind("click",function()
	{
		$(".filterContainer").addClass("hideFilter");
	});
	$(".showFilterBtn").unbind().bind("click",this,function(e)
	{
		$(".filterContainer").removeClass("hideFilter");
	});
	$(".answer-status .status-element").unbind().bind("click",this,function(e)
	{
		e.data.statusClick = 1;
		$(".selected-status").removeClass("selected-status");
		e.currentTarget.classList.add("selected-status");
		var section = $(".selected-section").attr("value");
		var qStatus = e.currentTarget.getAttribute("value");
		var bookmarkLabel = -1;
		$(".QuestionList").attr({
			section:section,
    		qStatus:qStatus,
    		bookmarkLabel:bookmarkLabel
		});
		console.log(section,qStatus);
		e.data.FilterQIndex(section,qStatus);
		e.data.ValidateNavigator();
	});
	
	
	// Factory.getObj().scrollToCenter(".section-element");
	$(".SectionList .section-element").bind("click",this,function(e)
	{
		$(".selected-section").removeClass("selected-section");
		e.currentTarget.classList.add("selected-section");
		var parentDom = $(".section-element.selected-section").parent();
		var offset = parentDom.scrollLeft() + $(".section-element.selected-section").offset().left - parentDom.offset().left - parentDom[0].clientWidth/2 + $(".section-element.selected-section").outerWidth(true)/2;
		parentDom.animate({scrollLeft: offset}, 600);
		var section = e.currentTarget.getAttribute("value"); //target  currentTarget
		var qStatus = $(".selected-status").attr("value");
		if(qStatus == null){
			$(".answer-status .status-element[value='"+QuestionFilter.ALL+"']").click();
			qStatus = $(".selected-status").attr("value");
		}
		
		var bookmarkLabel = -1;
		$(".QuestionList").attr({
			section:section,
    		qStatus:qStatus,
    		bookmarkLabel:bookmarkLabel
		});
		e.data.FilterQIndex(section,qStatus);
		e.data.ValidateFilter();
		e.data.ValidateNavigator();
		// console.log(e.currentTarget.getAttribute("value"),$(".selected-status").attr("value"));
		
		if($(".selected-status").attr("disabled") !== undefined){
			$(".selected-status").removeClass("selected-status");
			$(".answer-status .status-element[value='"+QuestionFilter.ALL+"']").click();
		}
		$(".selected-section-name").html($(".selected-section").html());
		
	});
	$(".qNav").unbind().bind("click",this,function(e){
		e.data.ValidateNavigator();
	});
	$(".langOption").unbind().bind("change",this,function(e){
		e.data.testLanguage = $(this).val();
		e.data.DisplayQuestion($(".QuestionList .selectedIndex").attr("sno"));
	});
	$(".qNavigation").unbind().bind("click",this,function(e){
		var elem = '';
		if($(this).hasClass("previousBtn"))
		{
			elem = $(".qIndex.selectedIndex").prev().not(".noDisplayIndex");
			if(elem.length > 0){
				$(elem).click();
				e.data.gotoposition();
			}
		}
		else{
			elem = $(".qIndex.selectedIndex").next().not(".noDisplayIndex");
			if(elem.length > 0){
				$(elem).click();
				e.data.gotoposition();
			}
		}
		e.data.ValidateQNav();
	});
};
Review.prototype.FilterByStatus = function(){
	
};
Review.prototype.gotoposition = function(){
	var calculate1 = $(".SessionQuestionList").scrollLeft() + $(".SessionQuestionList .qIndex.selectedIndex").offset().left-$(".SessionQuestionList").offset().left-$(".SessionQuestionList")[0].clientWidth/2 + $(".qIndex.selectedIndex").eq(1).outerWidth(true)/(1.5);
	$('.SessionQuestionList').animate({
	        scrollLeft: calculate1
	    }, 600);
	var calculate2 = $(".QuestionList").scrollTop() + $(".QuestionList .qIndex.selectedIndex").offset().top-$(".QuestionList").offset().top-$(".QuestionList")[0].clientHeight/2 + $(".qIndex.selectedIndex").eq(0).outerHeight(true)/2;
	$('.QuestionList').animate({
	        scrollTop: calculate2
	    }, 1500);
};
/* Bookmark Question */
Review.prototype.setNewBookmark = function(bookmarkLable)
{
	$.ajax({
		type : "POST",
		data:{
			mod: "user",
			ack: "newBookmark",
			bookmarkName: bookmarkLable,
		},
		xhrFields : {
				withCredentials : true
			},
		crossDomain : true,
		context : this,
		timeout : 30000,
		complete: function(event){
			try{
				var reply = event.responseJSON;
				if(reply.result.state == "ok")
				{
					$('.bookmarkList , .bookmarkFilter > select').append("<option value="+reply.data+">"+this.bookmarkLable+"</option>");
					this.obj.BookmarkQuestion(reply.data);
					$(".bookmarkMsg").html("Bookmark Created Successfully");
					this.obj.ValidateFilter();
				}
				else{
					alert(reply.result.meta);
				}
			}
			catch(e)
			{
				console.log(e);
			}
		}.bind({obj:this,bookmarkLable:bookmarkLable}),
		url : remoteServer+"/?route=common/ajax"
	});
};
Review.prototype.BookmarkQuestion = function(bookmarkLable)
{
	var elem = $(".QuestionList .qIndex.selectedIndex");
	var tag = 1;
	if(bookmarkLable == -1)
		tag = 0;
	$.ajax({
		type : "POST",
		data:{
			mod: "user",
			ack: "tagQuestion",
			bookmarkId: bookmarkLable,
			qId:elem.attr("qid"),
			sQId:elem.attr("sqid"),
			sessionId:$(".reportDiv").attr("sessionid"),
			tag:tag,
			BucketPath:$(".reviewQuestionDiv").attr("bucketPath")
		},
		xhrFields : {
			withCredentials : true
		},
		crossDomain : true,
		complete: function(event){
			try{
				var reply = event.responseJSON;
				if(reply.result.state == "ok")
				{
					$("#questionBookmark-modal .bookmarkList").find('option[value='+reply.data+']').prop("selected","selected");
					$(this.elem).attr("bookmarkLabel",reply.data);

					if(reply.data == -1)
					{
						$(this.elem).attr('bookmarked','0');
						$('.bookmarkBtn').html('<span><img src="https://cdn.toprankers.net/images/toppers-time-023a7e387bb68.png" /></span>Bookmark');
						$('.removeBookmarkBtn').css("display","none");
						$('.addBookmarkBtn').css("display","block");
						section = $(".section-element.selected-section").attr("value");
						if(section == SectionFilter.ALL){
							if($('.QuestionList .qIndex[bookmarked="1"]').length == 0)
								$(".answer-status .status-element[value='"+QuestionFilter.BOOKMARKED+"']").attr("disabled",true);
						}
						else
						{
							if($('.QuestionList .qIndex[bookmarked="1"][section="'+section+'"]').length == 0)
								$(".answer-status .status-element[value='"+QuestionFilter.BOOKMARKED+"']").attr("disabled",true);
						}
					}
					else
					{
						$(this.elem).attr('bookmarked','1');
						$('.bookmarkBtn').html(' <span><img src="https://cdn.toprankers.net/images/toppers-time-023a7e387bb68.png" /></span> <span> Bookmarked as:</span>'+$("#questionBookmark-modal .bookmarkList").find('option[value='+reply.data+']').html());
						$('.removeBookmarkBtn').css("display","block");
						$('.addBookmarkBtn').css("display","none");
						$(".answer-status .status-element[value='"+QuestionFilter.BOOKMARKED+"']").attr("disabled",false);
					}
				}
			}
			catch(e)
			{
				console.log(e);
			}
		}.bind({obj:this,tag:tag,elem:elem}),
		url : remoteServer+"/?route=common/ajax"
	});
};
/* Bookmark question ends */
Review.prototype.FilterQIndex = function(section,qStatus)
{
	$(".QuestionList .qIndex").addClass("noDisplayIndex");
	var sectionFilter = section;
	if(sectionFilter == SectionFilter.ALL)
	{		
		$(".QuestionList .sectionQues").addClass("noDisplayIndex");
		$(".selected-section-image").empty();
		if(qStatus == QuestionFilter.ALL){
			$(".QuestionList .qIndex,.QuestionList .AllSecQues").removeClass("noDisplayIndex");
			$(".QuestionList [sno='1']").click();
				$(".selected-section-image").append('<img src="img/all-view.png">');
		}
		else if(qStatus == QuestionFilter.MISSED)
		{
			$(".QuestionList .qIndex[resultstate='0'],.QuestionList .qIndex[resultstate='0'] .AllSecQues").removeClass("noDisplayIndex");
			$("[resultstate='0']").eq(0).click();
				$(".selected-section-image").append('<img src="img/missed-sml.png">');
		}
		else if(qStatus == QuestionFilter.SKIPPED)
		{
			$(".QuestionList .qIndex[resultstate='1'],.QuestionList .qIndex[resultstate='1'] .AllSecQues").removeClass("noDisplayIndex");
			$("[resultstate='1']").eq(0).click();
				$(".selected-section-image").append('<img src="img/skipped-report.png">');
		}
		else if(qStatus == QuestionFilter.WRONG)
		{
			$(".QuestionList .qIndex[resultstate='4'],.QuestionList .qIndex[resultstate='4'] .AllSecQues").removeClass("noDisplayIndex");
				$("[resultstate='4']").eq(0).click();
				$(".selected-section-image").append('<img src="img/wrong-attempts.png">');
		}
		else if(qStatus == QuestionFilter.FLAGGED)
		{
			$(".QuestionList .qIndex[flag='1'],.QuestionList .qIndex[flag='1'] .AllSecQues").removeClass("noDisplayIndex");
				$("[flag='1']").eq(0).click();
				$(".selected-section-image").append('<img src="img/mark-for-review.png">');
		}
		else if(qStatus == QuestionFilter.BOOKMARKED)
		{
			$(".QuestionList .qIndex[bookmarked='1'],.QuestionList .qIndex[bookmarked='1'] .AllSecQues").removeClass("noDisplayIndex");
			$("[bookmarked='1']").eq(0).click();
			$(".selected-section-image").append('<img src="img/bookmarked.png">');
		}
	}
	else
	{
		$(".QuestionList .AllSecQues").addClass("noDisplayIndex");
		$(".selected-section-image").empty();
		if(qStatus == QuestionFilter.ALL){
			$(".QuestionList .qIndex[section='"+sectionFilter+"'],.QuestionList .sectionQues").removeClass("noDisplayIndex");
			$('[qnosec="1"][section="'+section+'"]').click();  //select the first question of the selected section	
			$(".selected-section-image").append('<img src="img/all-view.png">');
		}
		else if(qStatus == QuestionFilter.MISSED)
		{
			$(".QuestionList .qIndex[section='"+sectionFilter+"'][resultstate='0'],.QuestionList .qIndex[section='"+sectionFilter+"'][resultstate='0'] .sectionQues").removeClass("noDisplayIndex");
			$('[resultstate="0"][section="'+section+'"]').eq(0).click();
			$(".selected-section-image").append('<img src="img/missed-sml.png">');
		}
		else if(qStatus == QuestionFilter.SKIPPED)
		{
			$(".QuestionList .qIndex[section='"+sectionFilter+"'][resultstate='1'],.QuestionList .qIndex[section='"+sectionFilter+"'][resultstate='1'] .sectionQues").removeClass("noDisplayIndex");
			$('[resultstate="1"][section="'+section+'"]').eq(0).click();
			$(".selected-section-image").append('<img src="img/skipped-report.png">');
		}
		else if(qStatus == QuestionFilter.WRONG)
		{
			$(".QuestionList .qIndex[section='"+sectionFilter+"'][resultstate='4'],.QuestionList .qIndex[section='"+sectionFilter+"'][resultstate='4'] .sectionQues").removeClass("noDisplayIndex");
			$('[resultstate="4"][section="'+section+'"]').eq(0).click();
			$(".selected-section-image").append('<img src="img/wrong-attempts.png">');
		}
		else if(qStatus == QuestionFilter.FLAGGED)// Mark for review
		{
			$(".QuestionList .qIndex[section='"+sectionFilter+"'][flag='1'],.QuestionList .qIndex[section='"+sectionFilter+"'][flag='1'] .sectionQues").removeClass("noDisplayIndex");
			$('[flag="1"][section="'+section+'"]').eq(0).click();
			$(".selected-section-image").append('<img src="img/mark-for-review.png">');
		}
		else if(qStatus == QuestionFilter.BOOKMARKED)
		{
			$(".QuestionList .qIndex[section='"+sectionFilter+"'][bookmarked='1'],.QuestionList .qIndex[section='"+sectionFilter+"'][bookmarked='1'] .sectionQues").removeClass("noDisplayIndex");
			$('[bookmarked="1"][section="'+section+'"]').eq(0).click();
			$(".selected-section-image").append('<img src="img/bookmarked.png">');
		}
	}
};
Review.prototype.ValidateQNav = function()
{
	$(".qNavigation").addClass("disable");
	var selected = $(".selectedIndex");
	if($(selected).prev(".qIndex").not(".noDisplayIndex").length > 0)
		$(".previousBtn").removeClass("disable");
	if($(selected).next(".qIndex").not(".noDisplayIndex").length > 0)
		$(".nextBtn").removeClass("disable");
};
Review.prototype.ValidateNavigator = function()
{
	var dom = $(".SessionQuestionList")[0];
	var maxScrollLeft = dom.scrollWidth - dom.clientWidth;
	if(dom.scrollLeft == 0)
		$(dom).siblings(".qNav.prev").find(".glyphicon").addClass("disable");
	else
		$(dom).siblings(".qNav.prev").find(".glyphicon").removeClass("disable");

	if(maxScrollLeft <= dom.scrollLeft + 1)
		$(dom).siblings(".qNav.next").find(".glyphicon").addClass("disable");
	else
		$(dom).siblings(".qNav.next").find(".glyphicon").removeClass("disable");
};
Review.prototype.ValidateFilter = function()
{
	var section = $(".QuestionList").attr("section");
	
	$('.answer-status .status-element').attr('disabled',false);
	if(section != SectionFilter.ALL){
		if($('.QuestionList .qIndex[resultState="'+AnswerStatus.WRONG+'"][section="'+section+'"]').length == 0)
			$(".answer-status .status-element[value='"+QuestionFilter.WRONG+"']").attr("disabled",true);
		if($('.QuestionList .qIndex[resultState="'+AnswerStatus.MISSED+'"][section="'+section+'"]').length == 0)
			$(".answer-status .status-element[value='"+QuestionFilter.MISSED+"']").attr("disabled",true);
		if($('.QuestionList .qIndex[resultState="'+AnswerStatus.SKIPED+'"][section="'+section+'"]').length == 0)
			$(".answer-status .status-element[value='"+QuestionFilter.SKIPPED+"']").attr("disabled",true);
		if($('.QuestionList .qIndex[flag="1"][section="'+section+'"]').length == 0)
			$(".answer-status .status-element[value='"+QuestionFilter.FLAGGED+"']").attr("disabled",true);
		if($('.QuestionList .qIndex[bookmarked="1"][section="'+section+'"]').length == 0)
			$(".answer-status .status-element[value='"+QuestionFilter.BOOKMARKED+"']").attr("disabled",true);
	}
	else
	{
		if($('.QuestionList .qIndex[resultState="'+AnswerStatus.WRONG+'"]').length == 0)
			$(".answer-status .status-element[value='"+QuestionFilter.WRONG+"']").attr("disabled",true);
		if($('.QuestionList .qIndex[resultState="'+AnswerStatus.MISSED+'"]').length == 0)
			$(".answer-status .status-element[value='"+QuestionFilter.MISSED+"']").attr("disabled",true);
		if($('.QuestionList .qIndex[resultState="'+AnswerStatus.SKIPED+'"]').length == 0)
			$(".answer-status .status-element[value='"+QuestionFilter.SKIPPED+"']").attr("disabled",true);
		if($('.QuestionList .qIndex[flag="1"]').length == 0)
			$(".answer-status .status-element[value='"+QuestionFilter.FLAGGED+"']").attr("disabled",true);
		if($('.QuestionList .qIndex[bookmarked="1"]').length == 0)
			$(".answer-status .status-element[value='"+QuestionFilter.BOOKMARKED+"']").attr("disabled",true);
	}

	var qFilter = $(".questionFilter select > option:selected");
	if($(qFilter).is(":disabled"))
	{
		$('.questionFilter select > option[value="0"]').prop('selected',true);
		$('.questionFilter select > option[value="0"]').trigger('change');
	}

	var currentBookmark = $(".bookmarkFilter select > option:selected");
	if($(currentBookmark).is(":disabled"))
	{
		$('.bookmarkFilter select > option[value="-1"]').prop('selected',true);
		$('.bookmarkFilter select > option[value="-1"]').trigger('change');
	}
};
Review.prototype.DisplayQuestion = function(sNumber){
	$(".selectedIndex").removeClass("selectedIndex");
	$('.qIndex[sno="'+sNumber+'"]').addClass("selectedIndex");
	var qIndex = $(".QuestionList .selectedIndex");
	this.gotoposition();
	var qId = $(qIndex).attr("qId");
	var sQId = $(qIndex).attr("sQId");
	var sNO = $(qIndex).attr("sNo");
	console.log(question, qId, sQId, sNO, qIndex);
	var question = $(this.qData).find('._question_[qId="'+qId+'"][sQId="'+sQId+'"][language="'+ TestLanguageType.Str[this.testLanguage]+'"]');
	if(!question.length){
		question = $(this.qData).find('._question_[qId="'+qId+'"][sQId="'+sQId+'"]:eq(0)');
	}

	//check question modification
	$(".modificationDiv").hide();
	this.CheckQuestionModification(qId);

	$(".QuestionCorrectOptions,.DetailedSolution").empty();
	var qType = question.attr("qType");
	if(typeof qType != undefined && parseInt(qType) == QuestionType.BLANK)
	{
		this.DisplayFillInTheBlanksQuestion(question, qId, sQId, sNO, qIndex);
	}
	else if(typeof qType != undefined && parseInt(qType) == QuestionType.NIQ)
	{
		this.DisplayNIQQuestion(question, qId, sQId, sNO, qIndex);
	}
	else
	{
		this.DisplayMCQQuestion(question, qId, sQId, sNO, qIndex);
	}
	var currentQuestion = $('.QuestionList .qIndex.selectedIndex');
	
	if($(".bookmarkBtn").length == 1){
		var bookmarkLable =currentQuestion.attr("bookmarklabel");
		if(currentQuestion.attr("bookmarked") == 1)
		{
			$(".bookmarkBtn").html("<span><img src=\"https://cdn.toprankers.net/images/toppers-time-023a7e387bb68.png\" /></span><span> Bookmarked as:</span>"+$("#questionBookmark-modal .bookmarkList option[value='"+bookmarkLable+"']").html());
			$("#questionBookmark-modal .bookmarkList option[value='"+bookmarkLable+"']").prop("selected",true);
			$("#questionBookmark-modal .removeBookmarkBtn").show();
			$("#questionBookmark-modal .addBookmarkBtn").hide();
		}
		else
		{
			$(".bookmarkBtn").html('<span><img src="https://cdn.toprankers.net/images/toppers-time-023a7e387bb68.png" /></span>Bookmark');
			$("#questionBookmark-modal .bookmarkList option[value='-1']").prop("selected",true);
			$("#questionBookmark-modal .removeBookmarkBtn").hide();
			$("#questionBookmark-modal .addBookmarkBtn").show();
		}
	}
	/*
	$('.QuestionText img, .DetailedSolution img, .qReviewHCell img').each(function(){
			var src = $(this).attr('src');
			if(src.startsWith('data:image')){}
			else{
				$(this).attr('src',remoteServer+src);
			}
		});*/
	
	
	MathJax.Hub.Queue(["Typeset",MathJax.Hub, $(".review-panel").get(0)],
		function () 
			{
	  			$(".review-panel span.MathJax, .review-panel span.MathJax_SVG").hide();
	  			var cWidth = $('.review-panel .Questionboard-body').width();
	  			$(".review-panel span.MathJax, .review-panel span.MathJax_SVG").show();
	  			$(".review-panel span.MathJax, .review-panel span.MathJax_SVG").each(function(){
					if($(this).width() > cWidth)
					{
						$(this).addClass("OverFlowFormula");
						$(this).css({'max-width':cWidth+'px', 'display':'inline-block'});	
					}
				});
				$(".review-panel .Questionboard-body .QuestionText span.MathJax_CHTML").each(function() {
					if ($(this).width() > cWidth) {
						$(this).css({
							'max-width' : cWidth + 'px'
						});
						$(this).addClass("scroll-x");
					}
				});
				$(".review-panel .Questionboard-body .QuestionOptions span.MathJax_CHTML").each(function() {
					if ($(this).width() > cWidth) {
						$(this).css({
							'max-width' : cWidth - 100 + 'px'
						});
						$(this).addClass("scroll-x");
					}
				});
	  			$('.review-panel .qText, .review-panel .QuestionOptions, .review-panel .DetailedSolution').html(function(i,h){
		  			return h.replace(/&nbsp;/g,' '); 
				});
			}
		);
	if(LoggedInUser.Auth())
	{
		this.GetDiscussions(qId,sQId,0,true);
	}
	else
	{
		UrlMgmt.getObj().Route({route: 'common/tr2login', needData: false});
	}
};
Review.prototype.GetDiscussions = function(qId, sQId, start,showMoreTopic)
{
	$.ajax({
		type : "POST",
		data:{
			mod: "discussion",
			ack: "getquestiondiscussions",
			qId:qId,
			sQId:sQId,
			bucketId:$(".reviewQuestionDiv").attr("dicussionBucket"),
			groupId:DiscussionType.ISSUE,
			start:start
		},
		xhrFields : {
			withCredentials : true
		},
		crossDomain : true,
		complete: function(event){
			try{
				var reply = event.responseJSON;
				if(Object.keys(reply.data.result).length > 0)
				{
					$(".discussionheader .doubt-heading").css("visibility", "visible");
					this.obj.PopulateDiscussion(reply.data,this.showMoreTopic);
					$(".discussionDiv").show();
					this.obj.BindDiscussionEvents();
				}
				else{
					$(".discussionheader .doubt-heading").css("visibility", "hidden");
					$(".discussionDiv").hide();
				}
			}
			catch(e)
			{
				console.log(e);
			}
		}.bind({obj:this,showMoreTopic:showMoreTopic}),
		url : remoteServer+"/?route=common/ajax"
	});
};
Review.prototype.BindDiscussionEvents = function()
{
	$(".addComments").unbind().bind("click",function()
	{
		if(LoggedInUser.Auth())
		{
			$(this).css("display","none");
			$(this).siblings(".newComment").css("display","block");
		}
		else
		{
			UrlMgmt.getObj().Route({action: 'common/tr2login', needData: false});
		}
	});
	$(".ask-doubt").unbind().bind('click', function(e) {
		
		if(UrlMgmt.getObj().App.isOnline){
			if(LoggedInUser.Auth())
			{
				$("#ask-doubt-Modal").modal('show');
				$('#ask-doubt-Modal .error').text("");
			}
			else
			{
				UrlMgmt.getObj().Route({action: 'common/tr2login', needData: false});
			}
		}
		else{
			  if (!UrlMgmt.getObj().App.isOnline) {
			    UrlMgmt.getObj().App.onOffline();
			  } else {
			    var urlMgmt = UrlMgmt.getObj();
			    urlMgmt.Refresh();
			  }
		}
		
	}.bind(this));
	$(".commentBtn").unbind().bind("click",this,function(e){
		//show login dialog if not loggedIn
		e.data.SubmitComment(this);
		$(this).parent().css("display","none");
		$(this).parent().siblings(".addComments").css("display","block");
		$(this).siblings(".newCommentDesc").val("");
	});
	$(".moreComments").unbind().bind("click",this,function(e){
		$(this).hide();
		e.data.GetMoreComments(this);
	});
	$(".moreTopics").unbind().bind("click",this,function(e){
		$(this).hide();
		var qIndex = $(".qIndex.selectedIndex");
		e.data.GetDiscussions($(qIndex).attr("qid"),$(qIndex).attr("sqid"),$(".topic").length,false);
	});
	$("[data-action='submit-doubt']").unbind().bind("click", function(){
		 if(UrlMgmt.getObj().App.isOnline){
			this.SubmitIssue();
		}
		else{
			if (!UrlMgmt.getObj().App.isOnline) 
			{
		    	UrlMgmt.getObj().App.onOffline();
		  	} 
		  	else 
		  	{
		    var urlMgmt = UrlMgmt.getObj();
		    urlMgmt.Refresh();
		  	}
		}
	}.bind(this));
	$(".discussionPanel .approveTopic, .discussionPanel .approveComment").unbind().bind("click",this,function(e){
		e.data.SetApprove(this);
	});
};
Review.prototype.SetApprove = function(elem)
{
	$.ajax({
		type : "POST",
		data:{
			mod: "discussion",
			ack: "setapprove",
			id:$(elem).attr("dId"),
			type:$(elem).attr("type"),
			approve:$(elem).find("input").prop("checked")?1:0
		},
		xhrFields : {
			withCredentials : true
		},
		crossDomain : true,
		complete: function(event){
			try{
				reply = event.responseJSON;
				if(reply.result.state != "ok")
				{
					alert(reply.result.meta);
				}
			}
			catch(e)
			{
				console.log(e);
			}
		},
		url : remoteServer+"/?route=common/ajax"
	});
};
Review.prototype.SubmitIssue = function()
{
	var title = $(".dis-title").val();
	if(title.length == 0 || title.length > 120)
	{
		$('#ask-doubt-Modal .error').html("Title should contain atleast 1 and atmost 120 charecter");
		return;
	}
	var desc = $(".dis-description").val();
	if(desc.length == 0 || desc.length > 1024)
	{
		$('#ask-doubt-Modal .error').html("Description should contain atleast 1 and atmost 1024 charecter");
		return;
	}
	var questionId = subQuestionId = 0;
	var selectedQues = $(".selectedIndex");
	if(selectedQues.length > 0)
	{
		questionId = selectedQues.attr("qid");
		subQuestionId = selectedQues.attr("sqid");
		title = title + "  (Question:" + questionId+"."+subQuestionId +")";
	}
	var currentSession = $(".reportDiv").attr("sessionid");
	$('body').append('<div class="loader"></div>');
	$.ajax({
		type : "POST",
		data:{
			mod: "discussion",
			ack: "addtopics",
			bucketId:$(".reviewQuestionDiv").attr("dicussionbucket"),
			sessionId:$(".reportDiv").attr("sessionid"),
			title:title,
			topic:desc,
			groupId:DiscussionType.ISSUE,
			qId:questionId,
			sQId:subQuestionId,
			topictype:0,
			platform:'app'
		},
		xhrFields : {
			withCredentials : true
		},
		crossDomain : true,
		complete: function(event){
			try{
				reply = event.responseJSON;
				if(reply.result.state == "ok")
				{
					$("#ask-doubt-Modal").modal('hide');
					$("#ask-doubt-Modal .dis-title").val("");
					$("#ask-doubt-Modal .dis-description").val("");
					this.obj.GetDiscussions(this.qId,this.sQId,0,true);
				}
				else
				{
					$(".userError").text(reply.result.meta);
				}
				$(".loader").remove();
			}
			catch(e)
			{
				console.log(e);
			}
		}.bind({obj:this,qId:questionId,sQId:subQuestionId}),
		url : remoteServer+"/?route=common/ajax"
	});
};
Review.prototype.GetMoreComments = function(elem)
{
	var parent = $(elem).parents(".topic");
	var topic = $(parent).attr("topicId");
	var start = $(parent).find(".commentContent").length;
	var commentDiv = $(parent).find(".comments");
	$('body').append('<div class="loader"></div>');
	$.ajax({
		type : "POST",
		data:{
			mod: "discussion",
			ack: "getcomments",
			start:start,
			topic:topic
		},
		xhrFields : {
			withCredentials : true
		},
		crossDomain : true,
		complete: function(event){
			try{
				var reply = event.responseJSON;
				var tempCmnt = reply.data.result;
				for(c in tempCmnt)
				{
					if(tempCmnt[c].commentContent != "")
					{
						tempCmnt[c].commentContent = tempCmnt[c].commentContent.replace(new RegExp('\r?\n','g'), '<br />');
						var isApproved = (tempCmnt[c].isApproved == '1')||tempCmnt[c].showApprove || tempCmnt[c].isItMine;
						var commentContent = $('<div class="commentContent" isApproved="'+isApproved+'" cId="'+tempCmnt[c].commentId+'">'+
												'<div class="commentInfo">'+
													reply.data["users"][tempCmnt[c].commentOwner]+'</span>'+
													'<span class="time"><span class="glyphicon glyphicon-time"></span>'+tempCmnt[c].commentCreatedOn+' ago</span>'+
												'</div>'+
												'<div class="detail">'+tempCmnt[c].commentContent+'</div>'+
											'</div>');
					    if(tempCmnt[c].showApprove == 1)
						{
							var Capprove = $('<span class="approveComment" dId="'+tempCmnt[c].commentId+'" type="'+TopicType.COMMENT+'">Approved</span>');
							var cCheck = $('<input type="checkbox">');
							if(tempCmnt[c].cIsApproved == 1)
								$(cCheck).prop("checked",true);
							$(Capprove).append(cCheck);
							$(commentContent).find(".commentInfo").append(Capprove);
						}
						$(commentDiv).append(commentContent);
					}
				}
				$(".loader").remove();
			}
			catch(e)
			{
				$(".loader").remove();
			}
		}.bind({obj:this,}),
		url : remoteServer+"/?route=common/ajax"
	});
};
Review.prototype.SubmitComment = function(btn)
{
	var comment = $(btn).siblings(".newCommentDesc").val();
	if(comment.length == 0 || comment.length > 2000 )
	{
		alert("comment should contain atleast 1 and atmost 2000 charecter");
		return;
	}
	var parent = $(btn).parents(".topic");
	var tId = $(parent).attr("topicId");
	var commentDiv = $(parent).find(".comments");
	$('body').append('<div class="loader"></div>');
	$.ajax({
		type : "POST",
		data:{
			mod: "discussion",
			ack: "addcomment",
			comment:comment,
			topic:tId,
			bucketId:$(".reviewQuestionDiv").attr("dicussionBucket"),
			platform:'app'
		},
		xhrFields : {
			withCredentials : true
		},
		crossDomain : true,
		complete: function(event){
			try{
				var reply = event.responseJSON;
				if(reply.result.state == "ok")
				{
					var comment = this.comment.replace(new RegExp('\r?\n','g'), '<br />');
					var cIsApproved = (reply.data["groupId"]=='1')?"true":"false";
					$(this.commentDiv).prepend('<div class="commentContent" isApproved="'+cIsApproved+'" cId="'+reply.data.id+'">'+
										'<div class="commentInfo">'+
											'<span class="user"><span class="glyphicon glyphicon-user"></span> You</span>'+
											'<span class="time"><span class="glyphicon glyphicon-time"></span>'+reply.data.createdon+' ago</span>'+
										'</div>'+
										'<div class="commentDetail">'+comment+'</div>'+
									'</div>');
					if(this.obj.showApprove == 1)
					{
						var Capprove = $('<span class="approveComment" dId="'+reply.data.id+'" type="'+TopicType.COMMENT+'"></span>');
						var cCheck = $('<input type="checkbox">');
						if(reply.data.groupId == 1)
							$(cCheck).prop("checked",true);
						$(Capprove).append(cCheck);
						$(this.commentDiv).find(".commentContent[cId='"+reply.data.id+"'] .commentInfo").append(Capprove);
					}
				}
				else{
					alert(reply.result.meta);
				}
				$(".loader").remove();
			}
			catch(e)
			{
				$(".loader").remove();
			}
		}.bind({obj:this,comment:comment,commentDiv:commentDiv}),
		url : remoteServer+"/?route=common/ajax"
	});
};
Review.prototype.PopulateDiscussion = function(data,showMoreTopic)
{
	var discussionDiv = $(".discussionDiv .discussionPanel");
	$(discussionDiv).empty();
	for(var i in data["result"])
	{
		data.result[i].topicContent =  data.result[i].topicContent.replace(new RegExp('\r?\n','g'), '<br />');
		data.result[i].commentContent = data.result[i].commentContent.replace(new RegExp('\r?\n','g'), '<br />');
		this.showApprove = data["result"][i].showApprove;
		var tIsApproved = (data["result"][i].tIsApproved == 1 || data["result"][i].showApprove == 1)?"true":"false";
		var cIsApproved = (data["result"][i].cIsApproved == 1 || data["result"][i].showApprove == 1)?"true":"false";
		var topicDiv = $('<div class="topic" isApproved="'+tIsApproved+'" topicId="'+data["result"][i].tId+'">'+
							'<div class="topicContent" noOfComments="'+data["result"][i].noOfComments+'">'+
								'<div class="title"><a href="#">'+data["result"][i].title+'</a></div>'+
								'<div class="topicInfo">'+
									data["users"][data["result"][i].topicOwner]+'</span>'+
									'<span class="time"><span class="glyphicon glyphicon-time"></span>'+data["result"][i].topicCreatedOn+' ago</span>'+
								'</div>'+
								'<div class="detail">'+data["result"][i].topicContent+'</div>'+
							'</div>'+
							'<div class="addReply">'+
								'<a class="addComments"><span class="glyphicon glyphicon-share-alt icon-flipped"></span> Reply</a>'+
								'<div class="newComment">'+
									'<textarea rows="1" class="newCommentDesc" placeholder="Comment on this...." onkeyup="textAreaAdjust(this)"></textarea>'+
									'<button class="btn commentBtn">Comment</button>'+
								'</div>'+
							'</div>'+
							'<div class="comments">'+
							'</div>'+
						'</div>');
		if(this.showApprove == 1)
		{
			var approve = $('<span class="approveTopic" dId="'+data["result"][i].tId+'" type="'+TopicType.TOPIC+'">Approved</span>');
			var check = $('<input type="checkbox">');
			if(data["result"][i].tIsApproved == 1)
				$(check).prop("checked",true);
			$(approve).append(check);
			$(topicDiv).find(".topicInfo").append(approve);
		}
		if(data["result"][i].noOfComments > 0)
		{
			$(topicDiv).find(".comments").append('<div class="commentContent" isApproved="'+cIsApproved+'" cId="'+data["result"][i].commentId+'">'+
													'<div class="commentInfo">'+
														data["users"][data["result"][i].commentOwner]+'</span>'+
														'<span class="time"><span class="glyphicon glyphicon-time"></span>'+data["result"][i].commentCreatedOn+' ago</span>'+
													'</div>'+
													'<div class="detail">'+data["result"][i].commentContent+'</div>'+
												'</div>');
			if(this.showApprove == 1)
			{
				var Capprove = $('<span class="approveComment" dId="'+data["result"][i].commentId+'" type="'+TopicType.COMMENT+'">Approved</span>');
				var cCheck = $('<input type="checkbox">');
				if(data["result"][i].cIsApproved == 1)
					$(cCheck).prop("checked",true);
				$(Capprove).append(cCheck);
				$(topicDiv).find(".commentInfo").append(Capprove);
			}
		}
		if(data["result"][i].noOfComments > 1)
		{
			$(topicDiv).append('<a class="moreComments">More Comments <span class="glyphicon glyphicon-circle-arrow-down"></span></a>');
		}
		$(discussionDiv).append(topicDiv);
	}
	if(showMoreTopic && data["result"].length < data["topicCount"])
	{
		$(discussionDiv).append('<a class="moreTopics">More Topics <span class="glyphicon glyphicon-circle-arrow-down"></span></a>');
	}
};
Review.prototype.CheckQuestionModification = function(qId)
{
	var today = new Date();
	var todayDate = today.getDate()+"-"+(today.getMonth()+1)+"-"+today.getFullYear();
	var getData = true;
	if(qId in this.modifiedQuestion && this.modifiedQuestion[qId].hasOwnProperty("checkedOn") && this.modifiedQuestion[qId]["checkedOn"] == todayDate)
	{
		getData = false;
		if(this.modifiedQuestion[qId].hasOwnProperty("dataQuestion") && this.modifiedQuestion[qId].hasOwnProperty("dataSolution"))
		{
			var elem = $(".qIndex.selectedIndex");
			if($(elem).attr("qid") == qId)
			{
				this.PopulateModifiedData(qId,$(elem).attr("sqid"));
				$(".modificationDiv").show();
			}
		}
	}
	if(getData)
		this.GetModifiedData(qId);
};
Review.prototype.GetModifiedData = function(qId){
	$.ajax({
		type : "POST",
		data : {
			mod : "bucket",
			ack : "getQuestionModification",
			sessionId:$(".reportDiv").attr("sessionid"),
			qId:qId
		},
		xhrFields : {
			withCredentials : true
		},
		crossDomain : true,
		complete: function(event)
		{
			try
			{
				var reply = event.responseJSON;
				if(!(this.qId in this.obj["modifiedQuestion"]))
					this.obj.modifiedQuestion[this.qId] = {};
				var today = new Date();
				var todayDate = today.getDate()+"-"+(today.getMonth()+1)+"-"+today.getFullYear();
				this.obj["modifiedQuestion"][this.qId]["checkedOn"] = todayDate;
				if(reply.data.length != 0)
				{
					this.obj.modifiedQuestion[this.qId]["dataQuestion"] = reply.data["dataQuestion"];
					this.obj.modifiedQuestion[this.qId]["dataSolution"] = reply.data["dataSolution"];
					var elem = $(".QuestionList .qIndex.selectedIndex");
					if(elem.attr("qid") == this.qId)
					{
						this.obj.PopulateModifiedData(this.qId,$(elem).attr("sqid"));
					}
					$(".modificationDiv").show();
				}
				else{
					$(".modificationDiv").hide();
				}
				$(".loader").remove();
			}
			catch(e)
			{
				$(".loader").remove();
			}
		}.bind({obj:this,qId:qId}),
		url : remoteServer+"/?route=common/ajax"
	});
};
Review.prototype.PopulateModifiedData = function(qId, sQId)
{
	var dataQuestion = '<div>' + this.modifiedQuestion[qId].dataQuestion + '</div>';
	var question = $(dataQuestion).find('._question_[qId="'+qId+'"][sQId="'+sQId+'"][language="'+ TestLanguageType.Str[this.language]+'"]');
	if(!question.length){
		question = $(dataQuestion).find('._question_[qId="'+qId+'"][sQId="'+sQId+'"]:eq(0)');
	}
	var qType = question.attr("qType");
	if(typeof qType != undefined && parseInt(qType) == QuestionType.BLANK)
	{
		this.ShowModifiedFillInTheBlanks(question,qId, sQId,dataQuestion);
	}
	else if(typeof qType != undefined && parseInt(qType) == QuestionType.NIQ)
	{
	 	this.ShowModifiedNIQ(question,qId, sQId,dataQuestion);
	}
	else if(typeof qType != undefined && parseInt(qType) == QuestionType.MMQ)
	{
	 	this.ShowModifiedMMQ(question,qId, sQId,dataQuestion);
	}
	else
	{
		this.ShowModifiedMCQ(question,qId, sQId,dataQuestion,qType);
	}
	$(".seeModification").unbind().bind("click",function(){
		$(".modificationDiv").toggleClass("hideModificationPanel");
		if(!$(".modificationDiv").hasClass("hideModificationPanel"))
		{
			$(".modification-panel span.MathJax, .modification-panel span.MathJax_SVG").hide();
			var cWidth = $('.modification-panel .Questionboard-body').width() - 40 ; //40 px buffer for MathJX
			$(".modification-panel span.MathJax, .modification-panel span.MathJax_SVG").show();
			$(".modification-panel span.MathJax, .modification-panel span.MathJax_SVG").each(function(){
				if($(this).width() > cWidth)
				{
					$(this).addClass("OverFlowFormula");
					$(this).css({'max-width':cWidth+'px', 'display':'inline-block'});	
				}
			});
		}
	});
	tr$.appendRemoteHost($('.modificationDiv'));
	MathJax.Hub.Queue(["Typeset",MathJax.Hub, $(".modification-panel").get(0)],
	function () 
		{
  			$('.modification-panel').html(function(i,h){
  					return h.replace(/&nbsp;/g,' '); 
			});
		}
	);
};
Review.prototype.ShowModifiedMMQ = function(question,qId, sQId,dataQuestion)
{
	var text = question.find("._text_").html();
	var dataSolution = this.modifiedQuestion[qId].dataSolution;
	var correctAnsSeq = $(dataSolution).find('._correctAnsSeq_[qId="'+qId+'"][sQId="'+sQId+'"]').children();
	
	var modificationPanel = $(".modification-panel .Questionboard-body");
	$(modificationPanel).empty();
	$(modificationPanel).append('<div class="qText">'+text+'</div>');
	
	var correctArr = [];
	correctAnsSeq.each(function(index,elem){
		var row = $(elem).attr("row");
		if(!(row in correctArr))
		{
			correctArr[row] = [];
		}
		var correctOption = false;
		if($(elem).text() == 1)
			correctOption = true;
		correctArr[row].push(correctOption);
	
	});
	var answerTable = $('<table class="matrixTable"><thead><tr><td></td></tr></thead><tbody></tbody></table>');
	for(var i = 0; i < correctArr.length; i++) 
	{
		charCode = 65;
		charCode = charCode + $(answerTable).find('tbody tr.optionRow').length;
		var tr = $('<tr class="optionRow"><td>'+String.fromCharCode(charCode)+'</td></tr>');
		var th = '';
		for(var j = 0; j<correctArr[i].length;j++) 
		{
			var cls = '';
			if(correctArr[i][j] == true)
			{
				cls = "correct";
			}
			charCode = 80;
			var td = $('<td><span class="optionMark '+cls+'"></span></td>'); 
			th += '<th></th>';
			$(tr).append(td);
			if($(answerTable).find('thead tr td').length <= correctArr[i].length)   
			{
				charCode = charCode+$(answerTable).find('thead tr td').not(":first").length; 
				$(answerTable).find('thead tr').append('<td>'+String.fromCharCode(charCode)+'</td>');
			}
		}
		$(answerTable).find('tbody').append(tr);
		$(answerTable).find('tbody').append('<tr>'+th+'</tr>');
	}
	$(modificationPanel).find("._columnOption_").append(answerTable);
	
	if(this.hideExplanation == "false")
	{
		var slnDiv = $(dataSolution).find('._soln_[qId="'+qId+'"][sQId="'+sQId+'"][language="'+TestLanguageType.Str[this.testLanguage]+'"]');
		if(!slnDiv.length){
			slnDiv = $(dataSolution).find('._soln_[qId="'+qId+'"][sQId="'+sQId+'"]:eq(0)');
		}
		sln = $(slnDiv).html();
		$(modificationPanel).append('<div class="QuestionSolution text-center"><h4>DETAILED SOLUTION</h4><div class="solution text-left">'+sln+'</div></div>');
	}
};
Review.prototype.ShowModifiedMCQ = function(question,qId, sQId,dataQuestion,qType)
{
	var text = question.find("._text_").html();
	var dataSolution = this.modifiedQuestion[qId].dataSolution;
	var ansOptions = question.find("._answer_");
	var correctAnsSeq = $(dataSolution).find('._correctAnsSeq_[qId="'+qId+'"][sQId="'+sQId+'"]').children();
	var ansOption = "";
	var ans = "";
	var correctOtions = "";
	var totalCompetency = $(dataQuestion).find('#_totalCompetency_');
	var hideAnswer = $(".QuestionList .qIndex.selectedIndex").attr("hideanswer");

	for(var a = 0; a < correctAnsSeq.length; a++)
	{
		var correctness = "";
		var correct = false;

		if(totalCompetency.length == 0)
		{
			if($(correctAnsSeq[a]).text() == "1")
			{
				if(correctOtions != "")
					correctOtions += ", ";
				correctOtions += String.fromCharCode(65 + a);
				if(typeof givenAns!="undefined" && givenAns[meta.indexOf(a)] == true)
				{
					correctness = '<span class="OptionCorrectness correct pull-right"></span>';
				}
				correct = true;
			}
			else if(typeof givenAns!="undefined" && givenAns[meta.indexOf(a)] == true)
			{
				correctness = '<span class="OptionCorrectness wrong pull-right"></span>';				 
			}
		}

		if(correct && !hideAnswer || correct && this.hideExplanation == "true")
			var qClass = " correct";
		else
			var qClass = "";

		var ansOption = '<div class="answerText qReviewHCell '+qClass+'" correct="'+correct+'"><span class="OptionIndicator">'+String.fromCharCode(65 + a) +
						'</span><span>' + ansOptions[a].innerHTML + '</span>'+correctness+'</div>';
		if(a % 2 == 0)
		{
			ansOption = '<div class="qReviewHRaw">' + ansOption;
			if(a > 0)
			{
				ansOption = '</div>' + ansOption;
			}
		}
		ans += ansOption;
	}
	if(ans != "")
		ans += '</div>';

	var modificationPanel = $(".modification-panel .Questionboard-body");
	var entity = '';
	if(qType == QuestionType.COMP)
		entity = '<p class="additionalNotes"><span>Note: </span>This is Compound Question only few SubQuestions has been changed</p>';
	entity = '<div class="qText">'+text+'</div>' +
				 '<div class="QuestionOptions">'+ans+'</div>';
	if(this.hideExplanation == "false")
	{
		var slnDiv = $(dataSolution).find('._soln_[qId="'+qId+'"][sQId="'+sQId+'"][language="'+TestLanguageType.Str[this.testLanguage]+'"]');
		if(!slnDiv.length){
			slnDiv = $(dataSolution).find('._soln_[qId="'+qId+'"][sQId="'+sQId+'"]:eq(0)');
		}
		sln = $(slnDiv).html();
		entity += '<div class="QuestionSolution text-center"><h4>DETAILED SOLUTION</h4><div class="solution text-left">'+sln+'</div></div>';
	}
	$(modificationPanel).empty().append(entity);
};
Review.prototype.ShowModifiedNIQ = function(question,qId, sQId,dataQuestion)
{
	var text = question.find("._text_").html();
	var dataSolution = this.modifiedQuestion[qId].dataSolution;
	var answerOptions = question.find("._answer_");
	var correctAnswerSeq = $(dataSolution).find('._correctAnsSeq_[qId="'+qId+'"][sQId="'+sQId+'"]').children();
	var answer = "";
	var correctOtion = "";
	var totalCompetency = $(dataQuestion).find('#_totalCompetency_');
	var correct = false;

	var entity = '';
	entity = '<div class="qText">'+text+'</div>' ;

	if(totalCompetency.length == 0)
	{
		var correctOtion = '<div class="qReviewHCell NIQAnswer">The Correct Answer is <span class="CorrectOtions">'+
								$(correctAnswerSeq[0]).text() + '</span></div>';
		entity +=  '<div class="QuestionOptions">'+correctOtion+'</div>';

		if(this.hideExplanation == "false")
		{
			var solutionDiv = $(dataSolution).find('._soln_[qId="'+qId+'"][sQId="'+sQId+'"][language="'+TestLanguageType.Str[this.testLanguage]+'"]');
			if(!solutionDiv.length){
				solutionDiv = $(dataSolution).find('._soln_[qId="'+qId+'"][sQId="'+sQId+'"]:eq(0)');
			}
			solution = $(solutionDiv).html();
		}
		entity += '<div class="QuestionSolution text-center"><h4>DETAILED SOLUTION</h4><div class="solution">'+solution+'</div></div>';
	}
	var modificationPanel = $(".modification-panel .Questionboard-body");
	$(modificationPanel).empty().append(entity);
};
Review.prototype.ShowModifiedFillInTheBlanks = function(question,qId, sQId,dataQuestion)
{
	var text = question.find("._text_").html();
	var parts = text.split("{BLANK}");
	text = "";
	for(var i=0; i < parts.length; i++)
	{
		text += parts[i];
		if(i < parts.length - 1)
		{
			text += '<span><u><b><i>&nbsp;&nbsp;blank-'+(i+1)+'&nbsp;&nbsp;</i></b></u></span>';
		}
	}
	var dataSolution = this.modifiedQuestion[qId].dataSolution;
	var correctAnswerSeq = $(dataSolution).find('._correctAnsSeq_[qId="'+qId+'"][sQId="'+sQId+'"]').children();
	var answerOptions = question.find("._answer_");
	var answer = "";
	var correctOtions="";
	for(var a = 0; a < correctAnswerSeq.length; a++)
	{
		var blankOptions = "";
		var bOptions = $(answerOptions[a]).find("option");
		var correctOptionnumber = parseInt($(correctAnswerSeq[a]).text());
		for(var o = 1; o < bOptions.length; o++)
		{
			var correctness = "";
			var correct = false;
			var qClass = "";
			if((o-1) == correctOptionnumber)
			{
				qClass = "correct";
				if(correctOtions != "")
					correctOtions += ", ";
				correctOtions += 'blank-'+(a+1)+': '+$(bOptions[o]).html();
			}
			blankOptions += '<div class="blankOption '+qClass+'"><span>'+$(bOptions[o]).html() + "</span>" + correctness + '</div>';
		}
		var answerOption = '<div class="qReviewHCell answerText"><div class="BlankOptionIndicator">blank-'+(a+1) +
						'</div><div>' + blankOptions + '</div></div>';
		if(a % 2 == 0)
		{
			answerOption = '<div class="qReviewHRaw">' + answerOption;
			if(a > 0)
			{
				answerOption = '</div>' + answerOption;
			}
		}
		answer += answerOption;
	}
	if(answer != "")
		answer += '</div>';

	var entity = '';
	entity = '<div class="qText">'+text+'</div>' +
			'<div class="QuestionOptions">'+answer+'</div>';
	if(this.hideExplanation == "false")
	{
		var solutionDiv = $(dataSolution).find('._soln_[qId="'+qId+'"][sQId="'+sQId+'"][language="'+TestLanguageType.Str[this.testLanguage]+'"]');
		if(!solutionDiv.length){
			solutionDiv = $(dataSolution).find('._soln_[qId="'+qId+'"][sQId="'+sQId+'"]:eq(0)');
		}
		solution = $(solutionDiv).html();
		entity += '<div class="QuestionSolution text-center"><h4>DETAILED SOLUTION</h4><div class="solution text-left">'+solution+'</div></div>';
	}
	var modificationPanel = $(".modification-panel .Questionboard-body");
	$(modificationPanel).empty().append(entity);
};
Review.prototype.DisplayFillInTheBlanksQuestion = function(question, qId, sQId, sNO, qIndex){
	var text = question.find("._text_").html();
	var parts = text.split("{BLANK}");
	text = "";
	for(var i=0; i < parts.length; i++)
	{
		text += parts[i];
		if(i < parts.length - 1)
		{
			text += '<span><u><b><i>&nbsp;&nbsp;blank-'+(i+1)+'&nbsp;&nbsp;</i></b></u></span>';
		}
	}
	var correctAnsSeq = $(this.sData).find('._correctAnsSeq_[qId="'+qId+'"][sQId="'+sQId+'"]').children();
	var givenAns = JSON.parse(this.secq[sNO].answer).ans;
	var ansOptions = question.find("._answer_");
	var ans = "";
	var correctOtions="";
	var hideAnswer = $(qIndex).attr("hideanswer");
	var icon = $(qIndex).attr("icon");

	var sec = $(qIndex).find(".noDisplayIndex").attr("sec");
	var serlNo = sNO;
	if(parseInt(sec) == -1)
	{
		serlNo = parseInt($(qIndex).attr("qnosec"));
	}

	var panelHead = $(".review-panel.Questionboard .Questionboard-heading");
	panelHead.find("[data-serlNo='serlNo']").html(sNO+".");
	panelHead.find("[data-ansStatus='ansStatus']").html('<span class="'+icon+'"></span>'+AnswerStatus.Str[this.secq[sNO].resultState]);
	// panelHead.find("[data-timeTaken='timeTaken']").html(this.secq[sNO].totalTimeSpent+' sec');
	
	var modal = $("#questionboard-heading-modal");
	modal.find("[data-serlNo='serlNo']").html(sNO+".");
	modal.find("[data-ansStatus='ansStatus']").html('<span class="'+icon+'"></span>'+AnswerStatus.Str[this.secq[sNO].resultState]);
	modal.find("[data-timeTaken='timeTaken']").html(this.secq[sNO].totalTimeSpent+' sec');
	
	var panelBody = $(".review-panel .Questionboard-body");
	panelBody.find(".qText").html(text);

	for(var a = 0; a < correctAnsSeq.length; a++)
	{
		var blankOptions = "";
		var bOptions = $(ansOptions[a]).find("option");
		var correctOptionnumber = parseInt($(correctAnsSeq[a]).text());
		var givenOptionnumber = (typeof givenAns != "undefined")?parseInt(givenAns[a]):-1;
		for(var o = 1; o < bOptions.length; o++)
		{
			var correctness = "";
			var correct = false;
			var qClass = "";
			if((o-1) == correctOptionnumber)
			{
				correct = true;
				if(!hideAnswer || this.hideExplanation == "true")
					qClass = "correct";
				if(correctOtions != "")
					correctOtions += ", ";
				correctOtions += 'blank-'+(a+1)+': '+$(bOptions[o]).html();
			}
			if((o-1) == givenOptionnumber)
			{	
				if((o-1) == correctOptionnumber)
				{
					correctness = '<span class="OptionCorrectness correct pull-right"></span>';
				}
				else
				{
					correctness = '<span class="OptionCorrectness wrong pull-right"></span>';
				}				
			}
			blankOptions += '<div class="blankOption '+qClass+'" correct="'+correct+'"><span>'+$(bOptions[o]).html() + "</span>" + correctness + '</div>';
		}
		var ansOption = '<div class="qReviewHCell answerText"><div class="BlankOptionIndicator">blank-'+(a+1) + 
						'</div><div>' + blankOptions + '</div></div>';
		if(a % 2 == 0)
		{
			ansOption = '<div class="qReviewHRaw">' + ansOption;
			if(a > 0)
			{
				ansOption = '</div>' + ansOption;
			}
		}
		ans += ansOption;
	}
	if(ans != "")
		ans += '</div>';
	$(panelBody).find(".QuestionOptions").html(ans);
	if(this.hideExplanation == "false")
	{
		var slnDiv = $(this.sData).find('._soln_[qId="'+qId+'"][sQId="'+sQId+'"][language="'+TestLanguageType.Str[this.testLanguage]+'"]');
		if(!slnDiv.length){
			slnDiv = $(this.sData).find('._soln_[qId="'+qId+'"][sQId="'+sQId+'"]:eq(0)');
		}
		sln = $(slnDiv).html();
		if(sln == " " || sln == null)
		{
			$(".DetailedSolution").html('The Correct Answer is <span class="CorrectOtions">'+correctOtions + '</span>');
		}
		else
		{
			$(".DetailedSolution").html('<h4>DETAILED SOLUTION</h4><div class="solution">'+sln+'</div>');
		}
	}
	$(".QuestionSolution,.QuestionOptions").attr("hideAnswer",hideAnswer);
	$(".showSolutionBtn").click(function(){
			$(".QuestionSolution,.QuestionOptions").attr("hideAnswer",false);
	});
	
};
Review.prototype.DisplayNIQQuestion = function(question, qId, sQId, sNO, qIndex){
	var text = question.find("._text_").html();
	var ansOptions = question.find("._answer_");
	var correctAnsSeq = $(this.sData).find('._correctAnsSeq_[qId="'+qId+'"][sQId="'+sQId+'"]').children();
	givenAnsD = '';
	if(!$.isEmptyObject(JSON.parse(this.secq[sNO].answer))){
		var givenAns = JSON.parse(this.secq[sNO].answer).ans;
		givenAnsD = givenAns[0];
	}
	var meta = JSON.parse(this.secq[sNO].meta);
	var ans = "";
	var correctOtions = "";
	var totalCompetency = $(this.qData).find('#_totalCompetency_');
	var hideAnswer = $(qIndex).attr("hideanswer");
	var icon = $(qIndex).attr("icon");

	var sec = $(qIndex).find(".noDisplayIndex").attr("sec");
	var serlNo = sNO;
	if(parseInt(sec) == -1)
	{
		serlNo = parseInt($(qIndex).attr("qnosec"));
	}

	var panelHead = $(".review-panel.Questionboard .Questionboard-heading");
	panelHead.find("[data-serlNo='serlNo']").html(sNO+".");
	panelHead.find("[data-ansStatus='ansStatus']").html('<span class="'+icon+'"></span>'+AnswerStatus.Str[this.secq[sNO].resultState]);
	// panelHead.find("[data-timeTaken='timeTaken']").html(this.secq[sNO].totalTimeSpent+' sec');
	
	
	
	
	var modal = $("#questionboard-heading-modal");
	modal.find("[data-serlNo='serlNo']").html(sNO+".");
	modal.find("[data-ansStatus='ansStatus']").html('<span class="'+icon+'"></span>'+AnswerStatus.Str[this.secq[sNO].resultState]);
	modal.find("[data-timeTaken='timeTaken']").html(this.secq[sNO].totalTimeSpent+' sec');

	var panelBody = $(".review-panel .Questionboard-body");
	$(panelBody).find(".qNo").html("Q."+serlNo);
	$(panelBody).find(".qText").html(text);

	var correctness = "";
	var correct = false;
	a=0;
	if(givenAnsD==''){
		correctness = "";
	}
	else if($(correctAnsSeq[a]).text() == givenAnsD)
	{
		correctness = '<span class="OptionCorrectness correct pull-right"></span>';
		correct = true;
	}
	else{
		correctness = '<span class="OptionCorrectness wrong pull-right"></span>';
	}
	var qClass = "";
	if(correct && !hideAnswer || correct && this.hideExplanation == "true")
			var qClass = " correct";
	if(givenAnsD!='')
	{
		var ansOption = '<div class="qReviewHCell answerText '+qClass+'" correct="'+correct+'">' + 'Your Answer is <span><b>' + givenAnsD + '</b></span>' +correctness+'</div>';
		ansOption = '<div class="qReviewHRaw">' + ansOption;
		ans += ansOption;
		ans += '</div>';
	}
	$(panelBody).find(".QuestionOptions").html(ans);
	if(totalCompetency.length == 0)
	{
		var tolerance = correctAnsSeq.length > 1 ? $(correctAnsSeq[1]).text() : 0;
		var toleranceStr = tolerance > 0 ? " &#x00B1; "+tolerance + " ":"";
		$(".QuestionCorrectOptions ").html('<div class="qReviewHCell">The Correct Answer is <span class="CorrectOtions">'+
								$(correctAnsSeq[0]).text() + toleranceStr +'</span></div>');

		if(this.hideExplanation == "false")
		{
			var slnDiv = $(this.sData).find('._soln_[qId="'+qId+'"][sQId="'+sQId+'"][language="'+TestLanguageType.Str[this.testLanguage]+'"]');
			if(!slnDiv.length){
				slnDiv = $(this.sData).find('._soln_[qId="'+qId+'"][sQId="'+sQId+'"]:eq(0)');
			}
			sln = $(slnDiv).html();
			if(sln == " " || sln == null)
			{

				$(".QuestionCorrectOptions").html('The Correct Answer is <span class="CorrectOtions"><b>'+$(correctAnsSeq[0]).text() + toleranceStr + '</b></span>');
			}
			else
			{
				$(".DetailedSolution").html('<h4>DETAILED SOLUTION</h4><div class="solution">'+sln+'</div>');
			}
		}
		$(".QuestionSolution,.QuestionOptions").attr("hideAnswer",hideAnswer);
		$(".showSolutionBtn").click(function(){
				$(".QuestionSolution,.QuestionOptions").attr("hideAnswer",false);
		});
	}
};
Review.prototype.DisplayMCQQuestion = function(question, qId, sQId, sNO, qIndex){
	var text = question.find("._text_").html();
	var ansOptions = question.find("._answer_");
	var correctAnsSeq = $(this.sData).find('._correctAnsSeq_[qId="'+qId+'"][sQId="'+sQId+'"]').children();
	var givenAns = JSON.parse(this.secq[sNO].answer).ans;
	var totalCompetency = $(this.qData).find('#_totalCompetency_');
	var meta = JSON.parse(this.secq[sNO].meta);
	var ans = "";
	var correctOtions = "";
	var totalCompetency = $(this.qData).find('#_totalCompetency_');
	var elem = $(qIndex);
	var hideAnswer = $(qIndex).attr("hideanswer");
	var icon = $(qIndex).attr("icon");

	var sec = $(qIndex).find(".noDisplayIndex").attr("sec");
	var serlNo = sNO;
	if(parseInt(sec) == -1)
	{
		serlNo = parseInt($(qIndex).attr("qnosec"));
	}

	var panelHead = $(".review-panel.Questionboard .Questionboard-heading");
	panelHead.find("[data-serlNo='serlNo']").html(sNO+".");
	panelHead.find("[data-ansStatus='ansStatus']").html('<span class="'+icon+'"></span>'+AnswerStatus.Str[this.secq[sNO].resultState]);
	// panelHead.find("[data-timeTaken='timeTaken']").html(this.secq[sNO].totalTimeSpent+' sec');

	var modal = $("#questionboard-heading-modal");
	modal.find("[data-serlNo='serlNo']").html(sNO+".");
	modal.find("[data-ansStatus='ansStatus']").html('<span class="'+icon+'"></span>'+AnswerStatus.Str[this.secq[sNO].resultState]);
	modal.find("[data-timeTaken='timeTaken']").html(this.secq[sNO].totalTimeSpent+' sec');

	var panelBody = $(".review-panel .Questionboard-body");
	$(panelBody).find(".qNo").html("Q."+serlNo);
	$(panelBody).find(".qText").html(text);


	for(var a = 0; a < correctAnsSeq.length; a++)
	{
		var correctness = "";
		var correct = false;

		if(totalCompetency.length == 0)
		{
			if($(correctAnsSeq[a]).text() == "1")
			{
				if(correctOtions != "")
					correctOtions += ", ";
				correctOtions += String.fromCharCode(65 + a);
				correctness = '<span class="OptionCorrectness correct pull-right"></span>';
				correct = true;
			}
			else if(typeof givenAns!="undefined" && givenAns[meta.indexOf(a)] == true)
			{
				correctness = '<span class="OptionCorrectness wrong pull-right"></span>';
			}
		}

		if(correct && !hideAnswer || correct && this.hideExplanation == "true")
			var qClass = " correct";
		else
			var qClass = "";

		var ansOption = '<div class="answerText qReviewHCell '+qClass+'" correct="'+correct+'"><span class="OptionIndicator">'+String.fromCharCode(65 + a) +
						'</span><span>' + ansOptions[a].innerHTML + '</span>'+correctness+'</div>';
		if(a % 2 == 0)
		{
			ansOption = '<div class="qReviewHRaw">' + ansOption;
			if(a > 0)
			{
				ansOption = '</div>' + ansOption;
			}
		}
		ans += ansOption;
	}
	if(ans != "")
		ans += '</div>';
	$(panelBody).find(".QuestionOptions").html(ans);
	if(totalCompetency.length == 0)
	{
		$(".QuestionCorrectOptions ").html('The Correct Answer is <span class="CorrectOtions">'+correctOtions + '</span>');
		if(this.hideExplanation == "false")
		{
			var slnDiv = $(this.sData).find('._soln_[qId="'+qId+'"][sQId="'+sQId+'"][language="'+TestLanguageType.Str[this.testLanguage]+'"]');
			if(!slnDiv.length){
				slnDiv = $(this.sData).find('._soln_[qId="'+qId+'"][sQId="'+sQId+'"]:eq(0)');
			}
			sln = $(slnDiv).html();
			$(".DetailedSolution").html('<h4>DETAILED SOLUTION</h4><div class="solution">'+sln+'</div>');
		}
		$(".QuestionSolution,.QuestionOptions").attr("hideAnswer",hideAnswer);
		$(".showSolutionBtn").unbind().bind('click', function(){
			$(".QuestionSolution,.QuestionOptions").attr("hideAnswer",false);
			var cWidth = $('.review-panel .Questionboard-body').width();
			$(".review-panel .Questionboard-body .DetailedSolution span.MathJax_CHTML").each(function() {
					if ($(this).width() > cWidth) {
						$(this).css({
							'max-width' : cWidth + 'px'
						});
						$(this).addClass("scroll-x");
					}
				});
		});
	}
};
//Helper Functions
function PreventLastLagentHide(lagend) {
	if(lagend.visible)
	{
		var totalVisible = 0;
		$.each(lagend.chart.series,function(i,serie){
			if(serie.visible)totalVisible += 1;
		});
		if(totalVisible < 2)
			return false;
	}
}

function textAreaAdjust(o) {
	if(o.scrollTop != 0){
			o.style.height = o.scrollHeight + "px";
		}
}