
var listsbatchController = function()
{
	this.view = "default";
	this.style = "default";
	this.dom = null;
	this.data = null;
	
	this.categories = null;
	this.exams = null;
	this.myExams = null;
	this.selectedExams = [];
	this.upcoming_time = [],
	this.upcoming_timestamp = [];
	this.upcoming_batch = [];
};
listsbatchController.prototype.Init = function(viewDom)
{
	this.dom = viewDom;
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.showLoader();
	this.data = urlMgmt.menuData;
	this.categories = this.data.categories;
	this.SetLayout();
	this.PopulateUI();
	this.BindEvents();
	urlMgmt.removeLoader();
};
listsbatchController.prototype.SetLayout = function()
{
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.lockRotation();
	urlMgmt.menuAction.view.hide();
	urlMgmt.headerAction.controler.DisplayHeader(this.dom, 'ONLINE COACHING', false, true, false);
};
listsbatchController.prototype.BindEvents = function()
{
	var urlMgmt = UrlMgmt.getObj();
	$('[data-action="batchPage"]').unbind().bind('click',function(e){
		if(typeof this.upcoming_timestamp != "undefined" && this.upcoming_timestamp.length > 0)
		{
			for(var i in this.upcoming_time)
			{
				clearInterval(this.upcoming_time[i]);
			}
		}
		var batchId = $(e.currentTarget).attr('batch-id');
		urlMgmt.Route({route: "item/batch&id="+batchId, needData: true, offlineAllowed: false, emptyStack: true});
	}.bind(this));
	this.dom.find('.imgclose').unbind().bind('click',function(){
		urlMgmt.PopView();
	});
	$('.header-back-btn').bind('click',function(){
		if(typeof this.upcoming_timestamp != "undefined" && this.upcoming_timestamp.length > 0)
		{
			for(var i in this.upcoming_time)
			{
				clearInterval(this.upcoming_time[i]);
			}
		}
	}.bind(this));
	if(typeof this.upcoming_timestamp != "undefined" && this.upcoming_timestamp.length > 0)
	{
		for(var i in this.upcoming_timestamp)
		{
			this.upcoming_time[i] = setInterval(this.runTimer.bind(this), 1000);
		}
	}
	console.log(this.upcoming_timestamp);
};
listsbatchController.prototype.PopulateUI = function()
{
	var batchStatus = UrlMgmt.getObj().menuData.batchStatus; 
	var navTabs = '';
	var	tabContent = '';
	var	once = true;
	var ongoing_class = '<span class="headerongoing">'+
           				'<svg width="25px"  height="25px"  xmlns="http://www.w3.org/2000/svg" viewBox="0 0 100 100" preserveAspectRatio="xMidYMid" class="lds-ripple" style="background: none;position:absolute;">'+
               				'<circle cx="50" cy="50" r="24.4497" fill="none" ng-attr-stroke="{{config.c1}}" ng-attr-stroke-width="{{config.width}}" stroke="#ff2424" stroke-width="3">'+
	               				'<animate attributeName="r" calcMode="spline" values="0;40" keyTimes="0;1" dur="2.1" keySplines="0 0.2 0.8 1" begin="-1.05s" repeatCount="indefinite">'+
	               				'</animate>'+
	               				'<animate attributeName="opacity" calcMode="spline" values="1;0" keyTimes="0;1" dur="2.1" keySplines="0.2 0 0.8 1" begin="-1.05s" repeatCount="indefinite">'+
	               				'</animate>'+
               				'</circle>'+
               				'<circle cx="50" cy="50" r="39.6889" fill="none" ng-attr-stroke="{{config.c2}}" ng-attr-stroke-width="{{config.width}}" stroke="#ff0000" stroke-width="3">'+
	               				'<animate attributeName="r" calcMode="spline" values="0;40" keyTimes="0;1" dur="2.1" keySplines="0 0.2 0.8 1" begin="0s" repeatCount="indefinite">'+
	               				'</animate>'+
	               				'<animate attributeName="opacity" calcMode="spline" values="1;0" keyTimes="0;1" dur="2.1" keySplines="0.2 0 0.8 1" begin="0s" repeatCount="indefinite">'+
	               				'</animate>'+
               				'</circle>'+
           				'</svg>'+
           			'</span>';
	for(var categoryId in this.categories)
	{	
		var category = this.categories[categoryId];		
		if((typeof category.batches != 'undefined') && Object.keys(category.batches).length > 0)
		{	
			navTabs += 
				'<li class="categoryTab '+(once?'active':'')+'"><a href="#batchCategory'+categoryId+'" data-toggle="tab">'+category.title+'</a></li>';
			tabContent +=
				'<div class="tab-pane '+(once?'active':'')+'" id="batchCategory'+categoryId+'">'+
					'<div class="batchs">';
			for(var index in category.batches)
			{
				 var batch = category.batches[index];
				 tabContent += '<div class="batchname" batch-id='+batch.id+' data-action="batchPage">';
				 if(typeof batchStatus['ongoing'] != 'undefined' && typeof batchStatus['ongoing'][batch.id] != 'undefined'){
				 	//tabContent += '<p class="ongoing">'+batch.title+'</p>';
				 	tabContent += '<span class="ongoing_span">'+batch.title+'</span>'+ongoing_class;
				 }
				 else if(typeof batchStatus['upcoming'] != 'undefined' && typeof batchStatus['upcoming'][batch.id] != 'undefined'){
				 	console.log("batchStatus['upcoming'][batch.id]",batchStatus['upcoming'][batch.id]);
				 	
				 				
	 				var upcoming_Time = new Date(batchStatus['upcoming'][batch.id]).getTime();
	 				var now = $.now();
					var distance = upcoming_Time - now;
					var days = Math.floor(distance / (1000 * 60 * 60 * 24));
					var hours = Math.floor((distance % (1000 * 60 * 60 * 24)) / (1000 * 60 * 60));
					var minutes = Math.floor((distance % (1000 * 60 * 60)) / (1000 * 60));
					var seconds = Math.floor((distance % (1000 * 60)) / 1000);
					if (distance < 0) {
						tabContent += '<span class="ongoing_span">'+batch.title+'</span>'+ongoing_class;
					} 
					else 
					{
						tabContent += '<span class="upcoming">'+batch.title+'</span><span class="upcoming-onchange"></span><span class="timeicon_upcoming"></span> <span class="countdown"></span>';
						if(days == 0 && hours == 0 ) // && hours == 0 && hours == 0
						{
						this.upcoming_timestamp[batch.id] =  {'upcoming':new Date(batchStatus['upcoming'][batch.id]).getTime(),'present':undefined};
				
						}
						else{
							
						}
						
					}
				 }
				 else{
				 	tabContent += '<p>'+batch.title+'</p>';
				 }
				 tabContent += '<img src="img/right-nav-blue.png">'+
				 			   '</div>';			
			}
			tabContent += '</div></div>';
			once = false;
		}
	}
	this.dom.find(".nav-tabs").append(navTabs);
	$(".categoryTab").unbind().bind('click', function(e){
	var calculate1 = $(".cattabList").scrollLeft() + $(e.currentTarget).offset().left-$(".cattabList").offset().left-$(".cattabList")[0].clientWidth/2 + $(e.currentTarget).outerWidth(true)/2;
	$('.cattabList').animate({
    scrollLeft: calculate1
	}, 1000);
	});    
	//slider for category tabs
	slider("catDiv", 'cattabList', "categoryTab");
	this.dom.find(".tab-content").append(tabContent);
	
		
};

listsbatchController.prototype.runTimer = function()
{
	if(typeof this.upcoming_timestamp != "undefined" && this.upcoming_timestamp.length > 0)
	{
		
		for(var i in this.upcoming_timestamp)
		{
			var now = typeof this.upcoming_timestamp[i]['present'] !== 'undefined' ? this.upcoming_timestamp[i]['present']*1000 : $.now();
			var distance = this.upcoming_timestamp[i]['upcoming'] - now;
			var days = Math.floor(distance / (1000 * 60 * 60 * 24));
			var hours = Math.floor((distance % (1000 * 60 * 60 * 24)) / (1000 * 60 * 60));
			var minutes = Math.floor((distance % (1000 * 60 * 60)) / (1000 * 60));
			minutes = minutes < 10 ? '0'+minutes : minutes;
			var seconds = Math.floor((distance % (1000 * 60)) / 1000);
			seconds = seconds < 10 ? '0'+seconds : seconds;
			if (distance < 0) {
				var ongoing_class =	'<svg width="25px"  height="25px"  xmlns="http://www.w3.org/2000/svg" viewBox="0 0 100 100" preserveAspectRatio="xMidYMid" class="lds-ripple" style="background: none;position:absolute;">'+
               				'<circle cx="50" cy="50" r="24.4497" fill="none" ng-attr-stroke="{{config.c1}}" ng-attr-stroke-width="{{config.width}}" stroke="#ff2424" stroke-width="3">'+
	               				'<animate attributeName="r" calcMode="spline" values="0;40" keyTimes="0;1" dur="2.1" keySplines="0 0.2 0.8 1" begin="-1.05s" repeatCount="indefinite">'+
	               				'</animate>'+
	               				'<animate attributeName="opacity" calcMode="spline" values="1;0" keyTimes="0;1" dur="2.1" keySplines="0.2 0 0.8 1" begin="-1.05s" repeatCount="indefinite">'+
	               				'</animate>'+
               				'</circle>'+
               				'<circle cx="50" cy="50" r="39.6889" fill="none" ng-attr-stroke="{{config.c2}}" ng-attr-stroke-width="{{config.width}}" stroke="#ff0000" stroke-width="3">'+
	               				'<animate attributeName="r" calcMode="spline" values="0;40" keyTimes="0;1" dur="2.1" keySplines="0 0.2 0.8 1" begin="0s" repeatCount="indefinite">'+
	               				'</animate>'+
	               				'<animate attributeName="opacity" calcMode="spline" values="1;0" keyTimes="0;1" dur="2.1" keySplines="0.2 0 0.8 1" begin="0s" repeatCount="indefinite">'+
	               				'</animate>'+
               				'</circle>'+
           				'</svg>';
           			
				clearInterval(this.upcoming_time[i]);
				$("#listsbatchController .batchContainer .tab-content-align .tab-content .tab-pane .batchs").find("[batch-id|='"+i+"']").find('.timeicon_upcoming').remove();	
				$("#listsbatchController .batchContainer .tab-content-align .tab-content .tab-pane .batchs").find("[batch-id|='"+i+"']").find('.countdown').remove();
				$("#listsbatchController .batchContainer .tab-content-align .tab-content .tab-pane .batchs").find("[batch-id|='"+i+"']").find('.upcoming-onchange').append(ongoing_class);
				$("#listsbatchController .batchContainer .tab-content-align .tab-content .tab-pane .batchs").find("[batch-id|='"+i+"']").find('.upcoming-onchange').addClass('headerongoing');			
			} 
			else 
			{
				if(days == 0 && hours == 0 ) // && hours == 0
				{
				var countdown_time = '00:'+minutes+':'+seconds; //hours+':' 'Starts in '+
				$("#listsbatchController .batchContainer .tab-content-align .tab-content .tab-pane .batchs").find("[batch-id|='"+i+"']").find('.countdown').show();
				$("#listsbatchController .batchContainer .tab-content-align .tab-content .tab-pane .batchs").find("[batch-id|='"+i+"']").find('.countdown').html(countdown_time);
				}
				else{
					$("#listsbatchController .batchContainer .tab-content-align .tab-content .tab-pane .batchs").find("[batch-id|='"+i+"']").find('.countdown').hide();
					$("#listsbatchController .batchContainer .tab-content-align .tab-content .tab-pane .batchs").find("[batch-id|='"+i+"']").find('.timeicon_upcoming').show();
				}
				
			}
		}
	}
	else{
		console.log(typeof this.upcoming_timestamp != "undefined" && this.upcoming_timestamp.length > 0);
	}	
};
