/**** Package List ****/
var listspackageController = function()
{
	this.view = "default";
	this.style = "default";
	this.dom = null;
	this.data = null;
	this.id = 0;
	this.refresh = true;
};
listspackageController.prototype.Init = function(viewDom)
{
	this.dom = viewDom;
	var urlMgmt = UrlMgmt.getObj();
	
	urlMgmt.showLoader();
	this.SetLayout();
	
	//pull to refresh
	urlMgmt.PullToRefresh($(this.dom).attr('id'));
	
	if(this.data != undefined && this.data.offline != undefined && this.data.offline == true){
		this.OfflineInit();	
	}
	else{
		this.OnlineInit();
	}
	urlMgmt.removeLoader();
	
};
listspackageController.prototype.SetLayout = function()
{
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.lockRotation();
	urlMgmt.menuAction.controler.View();
	urlMgmt.headerAction.controler.DisplayHeader(this.dom, 'Plans & Packages', true, false, true);
};
listspackageController.prototype.OnlineInit = function()
{
	if($(this.dom).find(".tryagain").length != 0)
		$(this.dom).find(".tryagain").remove();
	
	tr$.touchScrollAnimation(this.dom);
	this.LoadPackageGroups();
	this.LoadFaqs();
	this.BindEvents();
	
	var urlKey = typeof this.data.urlKey != 'undefined' ? this.data.urlKey : '';
	
	//Analytics
	analytics_trackView("package_listing");
	analytics_trackEvent("package_listing" , '/'+urlKey);
};
listspackageController.prototype.OfflineInit = function()
{
	Factory.getObj().LoadViewForOffline(this);
};
listspackageController.prototype.RefreshView = function()
{
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.showLoader();
	this.OnlineInit();
	urlMgmt.removeLoader();
};
listspackageController.prototype.BindEvents = function()
{
	this.dom.find('._eventListener').unbind().bind('click',this,function(e){
		UrlMgmt.getObj().Route({route: $(this).data('action'), needData: true});
	});
	if(typeof payment_policies != "undefined" && parseInt(payment_policies) == 2 )
	{
		this.dom.find('.js-checkout').unbind().bind('click',function(e){
				$('#purchaseredirect-modal').modal("show");
				$('#purchaseredirect-modal .js-remoteserver').html(remoteServer);
	        });
	    this.dom.find('.js-checkout').html("More");
	}
	else
	{
		this.dom.find('.js-checkout').unbind().bind('click',function(){
			UrlMgmt.getObj().Route({route: $(this).data('action'), needData: true, offlineAllowed: false});
		});		
	}	


};
listspackageController.prototype.LoadPackageGroups = function()
{
	packageGroups = '';
	if (typeof this.data.groups !== "undefined" && tr$.length(this.data.groups) > 0)
	{
		for(var i in this.data.groups)
		{
			var group = this.data.groups[i];
			var packagecount = 0;
			var plancount = 0;
			packageGroups +=
				'<div class="packageDiv">'+
				'<div class="packtitle">'+
					'<p id="'+group.title.replace(' ','-')+'" class ="TextDark text-center">'+group.title+'</p>';
			for(var j in this.data.packageGroups[group.id])
			{
				if(this.data.packageGroups[group.id][j].type == 0)
				{
					packagecount++;
				}
			}
			var plancount = this.data.packageGroups[group.id].length - packagecount;
			if(packagecount > 0 && plancount > 0)
			{
				packageGroups +=
				'<p>'+"("+packagecount+" Packages"+" & "+plancount+" Plans"+")"+'</p>';
			}
			else if(packagecount > 0)
			{
				packageGroups +=
				'<p>'+"("+packagecount+" Packages"+")"+'</p>';
			}
			else
			{
				packageGroups +=
				'<p>'+"("+plancount+" Plans"+")"+'</p>';
			}
			packageGroups +=
			'</div>';
			packageGroups +=
				'<div class="packageList">'+
				'<div class="packageposition">';
			for(var i in this.data.packageGroups[group.id])
			{
				packageGroups += Factory.getObj().PackageCard(this.data.packageGroups[group.id][i]);
			}
			packageGroups +=
						'</div>'+
					'</div>'+
				'</div>';
		}
	}
	this.dom.find('.PkgGroupsContainer').html(packageGroups);
		var pkgdescriptionslide = new Array();

		for(c = 0;c < this.dom.find('.PkgGroupsContainer .pkgDetail').length; c++)
		{
		 	pkgdescriptionslide[c] = new slideVertical();
		 	pkgdescriptionslide[c].Init("pkgDetail", "pkgDescription", "descriptionlines",c);
		}
};
listspackageController.prototype.LoadFaqs = function()
{
	if(typeof this.data.faqs !== 'undefied' && tr$.length(this.data.faqs) > 0)
	{
		var faqs = Factory.getObj().Faqs(this.data.faqs);
		this.dom.find('.FaqsContainer').html(faqs.html);
		faqs.bindEvents();
	}
};