var listsquizController = function() {
	this.view = "default";
	this.style = "default";
	this.dom = null;
	this.data = null;
	this.id = 0;
	this.refresh = true;
};
listsquizController.prototype.Init = function(viewDom) {
	this.dom = viewDom;
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.showLoader();
	this.SetLayout();
	
	//pull to refresh
	urlMgmt.PullToRefresh($(this.dom).attr('id'));
	
	if (this.data != undefined && this.data.offline != undefined && this.data.offline == true) {
		this.OfflineInit();
	} else {
		this.OnlineInit();
	}
	urlMgmt.removeLoader();
};
listsquizController.prototype.SetLayout = function()
{
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.lockRotation();
	urlMgmt.menuAction.view.hide();
	urlMgmt.headerAction.controler.DisplayHeader(this.dom, this.data.title, false, true, false);
	
	if(Array.isArray(this.data.quizFilter) && (this.data.quizFilter).length < 1)
	{ 
		
	}
	else{		
		var Roptions = '<td><span class="js-filter" ><img src="img/filter.png"></span></td>';
		UrlMgmt.getObj().headerAction.controler.AddHeaderOptions(Roptions);
	}
};
listsquizController.prototype.OfflineInit = function() {
	$('.quizlistbanner').hide();
	Factory.getObj().LoadViewForOffline(this);
};
listsquizController.prototype.OnlineInit = function() {
	$('.quizlistbanner').show();
	if ($(this.dom).find(".tryagain").length != 0)
		$(this.dom).find(".tryagain").remove();
	
	this.LoadBanner();
	this.LoadSubmenu();
	this.LoadQuiz();
	this.LoadPackageTabs();
	this.BindEvents();
	var urlKey = '';
	if(this.data != null && typeof this.data.urlKey != 'undefined'){
		urlKey = this.data.urlKey;
	}
	if(typeof webengage != 'undefined' && webengage == true){
		TRTracker.getObj().TrackWEEvent("PageView_QuizList", urlKey);
	}
	analytics_trackView("quiz_listing");
	analytics_trackEvent("quiz_listing" , '/'+urlKey);
};
listsquizController.prototype.RefreshView = function() {
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.showLoader();
	this.SetLayout();
	this.OnlineInit();
	urlMgmt.removeLoader();
};
listsquizController.prototype.BindEvents = function()
{
	this.dom.find('._eventListener').unbind().bind('click', this, function(e) {
		var urlMgmt = UrlMgmt.getObj();
		var action = (urlMgmt.actionStack[urlMgmt.actionStack.length - 1].route).split('&')[0];
		if(action == $(this).data('action').split('&')[0]){
			urlMgmt.RemoveView();
		}
		UrlMgmt.getObj().Route({
			route : $(this).data('action'),
			needData : true,
			offlineAllowed : true
		});
	});
	if(typeof payment_policies != "undefined" && parseInt(payment_policies) == 2 )
	{
		this.dom.find('.js-checkout').unbind().bind('click',function(e){
				$('#purchaseredirect-modal').modal("show");
				$('#purchaseredirect-modal .js-remoteserver').html(remoteServer);
	        });
	    this.dom.find('.js-checkout').html("More");
	}
	else
	{
		this.dom.find('.js-checkout').unbind().bind('click', this, function(e) {
			UrlMgmt.getObj().Route({
				route : $(this).data('action'),
				needData : true,
				offlineAllowed : false
			});
		});
	}		

	this.dom.find('.takeQuiz').unbind().bind('click',function(){
		if(!UrlMgmt.getObj().App.isOnline){
			UrlMgmt.getObj().App.onOffline();
			return false;
		}
		if(!LoggedInUser.Auth()){
			UrlMgmt.getObj().Route({route: 'common/tr2login', needData: false});
			return false;		
		}
		UrlMgmt.getObj().Route({route : $(this).data('action'), needData: false});
	});
	this.dom.find('.report').unbind().bind('click',function(){
		if(!UrlMgmt.getObj().App.isOnline){
			UrlMgmt.getObj().App.onOffline();
			return false;
		}
		if(!LoggedInUser.Auth()){
			UrlMgmt.getObj().Route({route: 'common/tr2login', needData: false});
			return false;		
		}
		UrlMgmt.getObj().Route({route : $(this).data('action'), needData: false});
	});
	/* Quiz filter code */
	 $('.js-filter').unbind().bind('click',this,function(e){
		var filterhtml =   '<div class="quizfilter">';
		var quizlistid  = e.data.id;
		var filter_is_empty = true;

		for (var x in e.data.data.quizFilter) 
		{
			filter_is_empty = false;
			filterhtml +='<div class="js-filtername_div" >'+
				         '<span class="filtername">'+e.data.data.quizFilter[x].name+'</span>'+
				         '<label class="switch">'+
						 '<input type="checkbox"  value="'+e.data.data.quizFilter[x].name+'" class="quizfilterCheckbox ">'+
						 '</label>'+
						 '<img class="selectedfiltername" src="img/quiz_correct.png">'+
				    	 '</div>';
		}
		 filterhtml += '</div>';
		 
		 if(filter_is_empty){
		 	alert("There is no Filter for this quiz");
		 	return;
		 }
		$('#quizFilter').find('.Filteroption').html(filterhtml);
		
			for (var x in e.data.data.activeFilters){
				//find("[data-category='"+categoryId+"']").prop('checked', true);
				$("#quizFilter .Filteroption .quizfilter div .switch").find('input[value="'+e.data.data.activeFilters[x]+'"]').prop( "checked", true );
				$("#quizFilter .Filteroption .quizfilter div .switch").find('input[value="'+e.data.data.activeFilters[x]+'"]').parents().siblings(".filtername").addClass("selectedquizfilter");	
				$("#quizFilter .Filteroption .quizfilter div .switch").find('input[value="'+e.data.data.activeFilters[x]+'"]').parents().siblings(".selectedfiltername").toggleClass("displayimg");
			}
		
		$('#quizFilter').modal('show');	

		$(".js-filtername_div").unbind().bind('click',this,function(e){
			$(this).find('.selectedfiltername').toggleClass("displayimg");
			//$(this).find('.switch .quizfilterCheckbox').click();
			$(this).find('.switch .quizfilterCheckbox').is(":checked") ? $(this).find('.switch .quizfilterCheckbox').prop( "checked", false ):$(this).find('.switch .quizfilterCheckbox').prop( "checked", true );
			$(this).find('.switch .quizfilterCheckbox').is(":checked") ? $(this).find(".filtername").addClass("selectedquizfilter") : $(this).find(".filtername").removeClass("selectedquizfilter");
		});
		$(".js-quiz_filter").unbind().bind('click',this,function(e){
			var checkboxes = $("#quizFilter .Filteroption .quizfilter div .switch").find('input[type=checkbox]');
	        var filters = [];
	        $(checkboxes).each(function(key, value) {
	            if ($(value).prop('checked') == true) {
	                filters.push($(value).val());
	            }
	        });
	        var route_url= 'lists/quiz&id='+quizlistid+'&filter='+filters.join(',');
	        $('#quizFilter').modal('hide');
	        var urlMgmt = UrlMgmt.getObj();
	        urlMgmt.Route({route: route_url, needData: true}, function(){
	        	urlMgmt.RemoveView($(urlMgmt.actionStack[urlMgmt.actionStack.length-2].controler.dom).attr('id'));
	        });	 
		});
		$('.js-quiz_filter_reset').unbind().bind('click',this,function(e){
			var route_url= 'lists/quiz&id='+quizlistid ;
			$('#quizFilter').modal('hide');
			var urlMgmt = UrlMgmt.getObj();
	        urlMgmt.Route({route: route_url, needData: true}, function(){
	        	urlMgmt.RemoveView($(urlMgmt.actionStack[urlMgmt.actionStack.length-2].controler.dom).attr('id'));
	        });
		});
	});
	
	if(typeof this.data.activeFilters != 'undefined' && this.data.activeFilters.length > 0){
		var html = "<sup>("+this.data.activeFilters.length+")</sup>";
		$('.js-filter').append(html);
	}
	else{
		var html = "<sup></sup>";
		$('.js-filter').append(html);
	}
	
	//package explore links
	this.dom.find('.js-explore').off().on('click',function(){
		var exploreLinks =  $(this).data("links");
		Factory.getObj().ShowExploreModal(exploreLinks);
	});
};
listsquizController.prototype.LoadBanner = function()
{
	$(this.dom).find('.quizInfoTop').find('.quizlist-title').text(this.data.title);
};
listsquizController.prototype.LoadSubmenu = function() {
	Factory.getObj().LoadSubMenus(this.data.submenuList, $(this.dom).find('.submenuPosition'));

	slider("submenuDiv", 'submenuList', "submenu");
	if(this.data.submenuList.length == 0){
		$('.quizlistbanner').hide();
	}
};
listsquizController.prototype.LoadQuiz = function()
{
	var QuizHTML = '';
	if(this.data != null && typeof this.data.noQuiz != 'undefined' && this.data.noQuiz == true){
		QuizHTML +=  '<h2 class="daily-quiz-head">Daily Quizzes</h2>'+
					 '<span class="msg"> No Quizzes for Selected Filter!!</span>'+
					 '<h2 class="daily-quiz-head">Other Quizzes</h2>';
	}
	else{
		QuizHTML +=  '<h2 class="daily-quiz-head">Daily Quizzes</h2>';
	}
	if(this.data != null && typeof this.data.dquizcount != "undefined" && this.data.dquizcount > 0)
	{
		QuizHTML += '<div class="quizlisting">';
		//Reverse quizGroups object
		var quizKeys = Object.keys(this.data.quizGroups);
		console.log(quizKeys);
		console.log(quizKeys.reverse());
		for(var key in quizKeys){
			if(typeof this.data.dateSegregation != 'undefined' && this.data.dateSegregation == '1'){
				//Date segregation in quiz is enabled
				QuizHTML += '<span class="quiz-date">'+tr$.dateFormatWithYear(new Date(parseInt(quizKeys[key])*1000))+'</span>';
			}
			var quizData = this.data.quizGroups[quizKeys[key]];
			for(var quiz in quizData){
				QuizHTML += Factory.getObj().dQuizCard({quiz:quizData[quiz]}, '');
			}
		}
		QuizHTML += '</div>';
		$(this.dom).find('.QuizContainer').find('.quizlist').html(QuizHTML);
		$(this.dom).find('.QuizContainer').find('.quizlist').find('.quiz.item').addClass('quizlistquiz');
		$(this.dom).find('.QuizContainer').find('.quizlist').find('.quiz.item').removeClass('quiz');
	}
};
listsquizController.prototype.LoadPackageTabs = function() {
	var packageTabs = Factory.getObj().PackageTabs({
		packagePlanCount : this.data.packagePlanCount,
		PackageActiveTab : this.data.PackageActiveTab,
		plansAndPackages : this.data.plansAndPackages
	});

	if (packageTabs != 0) {
		this.dom.find('.plan-package-align').text('Plans & Packages');
		this.dom.find('.PackageContainer').empty();
		this.dom.find('.PackageContainer').append(packageTabs);
		slider("packageDiv", 'packageList', "package");
		var pkgdescriptionslide = new Array();
		var activeTab = $(".tab-content.p2List").find(".tab-pane.active").find(".packageDiv");
		for (var c = 0; c < activeTab.find('.pkgDetail').length; c++) {
			pkgdescriptionslide[c] = new slideVertical();
			pkgdescriptionslide[c].Init(activeTab.find(".pkgDetail").eq(c), "pkgDescription", "descriptionlines", c);
		}
		$(".packageContainerTab .nav.nav-tabs").bind("click", function() {
			setTimeout(function() {
				var activeTab = $(".tab-content.p2List").find(".tab-pane.active").find(".packageDiv");
				for (var c = 0; c < activeTab.find('.pkgDetail').length; c++) {
					pkgdescriptionslide[c] = new slideVertical();
					pkgdescriptionslide[c].Init(activeTab.find(".pkgDetail").eq(c), "pkgDescription", "descriptionlines", c);
				}
			}, 100);
		});
	}
};