var liststestController = function() {
	this.view = "default";
	this.style = "default";
	this.dom = null;
	this.data = null;
	this.id = 0;
	this.refresh = true;
	this.clickMenuOnRefresh = false;

	this.stableDom = null;
	this.tests = {};
	this.testGroups = {};
	this.testReport = {};
	this.bucketId = 0;
	this.packages = {};
	this.testList = {};
	this.allTests = {};
	this.Subscribebtn_offest = 0;
};
liststestController.prototype.Init = function(viewDom) {
	this.dom = viewDom;
	this.stableDom = viewDom;
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.showLoader();
	this.SetLayout();

	//pull to refresh
	urlMgmt.PullToRefresh($(this.stableDom).attr('id'));

	if (this.data != undefined && this.data.offline != undefined && this.data.offline == true) {
		this.OfflineInit();
	} else {
		this.OnlineInit();
	}
	urlMgmt.removeLoader();
};
liststestController.prototype.SetLayout = function() {
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.lockRotation();
	urlMgmt.menuAction.controler.View();
	urlMgmt.headerAction.controler.DisplayHeader(this.stableDom, this.data["title"], true, false, true);
};
liststestController.prototype.OfflineInit = function() {
	$(this.dom).find(".submenuDiv").hide();
	$(this.dom).find(".TextDark").hide();
	$(this.dom).find(".testlist-dropdown").hide();
	$(this.dom).find("#view-mocktestpage").hide();
	var title = "My Tests";
	if(UrlMgmt.getObj().subscription == "0"){
		title = "Tests";
	}
	UrlMgmt.getObj().headerAction.controler.ChangeHeaderTitle(title);
	Factory.getObj().LoadViewForOffline(this);
};
liststestController.prototype.OnlineInit = function() {
	$(this.dom).find(".TextDark").show();
	$(this.dom).find(".submenuDiv").show();
	$(this.dom).find(".testlist-dropdown").show();
	Factory.getObj().ShowNotifyUpdate();
	if ($(this.dom).find(".tryagain").length != 0)
		$(this.dom).find(".tryagain").remove();
	if (this.id == 0) {
		this.MockTestLoad();
	} else {
		this.LoadCompleteTestList();
		if (!UrlMgmt.getObj().App.isOnline) {
			//populateOfflineImages($(this.stableDom).find('.testlistouter'));
		}
	}
	//tr$.StoreImagesInBase64($(this.stableDom).find('.testlistouter'));
};
liststestController.prototype.RefreshView = function() {
	var urlMgmt = UrlMgmt.getObj();
	urlMgmt.showLoader();
	this.SetLayout();
	this.OnlineInit();
	urlMgmt.removeLoader();
};
liststestController.prototype.MockTestLoad = function() {
	this.clickMenuOnRefresh = true;
	UrlMgmt.getObj().headerAction.controler.ChangeHeaderTitle('Mock Tests');
	$(this.dom).find("#view-testlistpage").remove();
	$(this.dom).find("#view-mocktestpage").show();
	$(this.dom).find(".testlist-dropdown").hide();
	$(this.dom).find('#btnExamSelection').unbind().bind('click', function() {
		if (LoggedInUser.Auth()) {
			console.log(LoggedInUser.Auth());
			UrlMgmt.getObj().Route({
				route : 'common/tr2subscription',
				needData : false
			});
		} else {
			LoggedInUser.onLoginSuccess = function() {
				UrlMgmt.getObj().PopView(function() {
					UrlMgmt.getObj().Route({
						route : 'common/tr2subscription',
						needData : false
					});
				});
			};
			UrlMgmt.getObj().Route({
				route : 'common/tr2login',
				needData : false
			});
		}
	});
	UrlMgmt.getObj().removeLoader();
};

liststestController.prototype.LoadCompleteTestList = function() {
	var title = "My Tests";
	if(UrlMgmt.getObj().subscription == "0"){
		title = "Tests";
	}
	UrlMgmt.getObj().headerAction.controler.ChangeHeaderTitle(this.data["title"]);
	$(this.dom).find("#view-mocktestpage").remove();
	$(this.dom).find("#view-testlistpage").show();
	tr$.touchScrollAnimation(this.dom);

	this.dom = $(this.dom).find('.testlistouter');
	this.LoadTestListDropdown();
	this.LoadTestTabs( function() {
		this.dom = $(this.dom).find(".tab-content").find('.tab-pane');
		this.tests = {};
	}.bind(this));
	if (this.data.examInfo != null && typeof this.data.examInfo.quickaccessList != 'undefined') {
		this.LoadExamInfoTop();
	} else {
		$(this.stableDom).find('.infobutn').remove();
	}
	UrlMgmt.getObj().removeLoader();
	this.LoadQuiz();
	this.LoadFeaturedArticles();
	this.LoadExamSubmenu();
	this.LoadPackageTabs();
	if(UrlMgmt.getObj().subscription == '1'){
		this.LoadFloatingBtn();
		if((typeof this.data.listType != "undefined") && ((parseInt(this.data.listType) == 1) || (parseInt(this.data.listType) == 2)))
		{
			$(this.stableDom).find('.btnExamSubscribe').hide();			
		}
		else
		{
			$(this.stableDom).find('.btnExamSubscribe').show();		
		}
	}
	else{
		$('.btnExamSubscribe').hide();
	}
	
	this.BindEvents();
		

	//header is required for featured articles -- routing back in app
	if (AppBrowser.getObj().data == null && typeof this.data.header !== 'undefined' && tr$.length(this.data.header)) {
		AppBrowser.getObj().data = this.data.header;
	}
	var urlKey = '';
	if (this.data != null && typeof this.data.urlKey != 'undefined') {
		urlKey = this.data.urlKey;
	}
	if(typeof webengage != 'undefined' && webengage == true){
		TRTracker.getObj().TrackWEEvent("PageView_TestList", urlKey);
	}
	
	//Analytics
	analytics_trackView("test_listing");
	analytics_trackEvent("test_listing", '/' + urlKey);
};

liststestController.prototype.BindEvents = function() {
	$('.btnExamSubscribe').unbind().bind('click', this, function() {
		if (LoggedInUser.Auth()) {
			console.log(LoggedInUser.Auth());
			UrlMgmt.getObj().Route({
				route : 'common/tr2subscription',
				needData : false
			});
		} else {
			LoggedInUser.onLoginSuccess = function() {
				UrlMgmt.getObj().PopView(function() {
					UrlMgmt.getObj().Route({
						route : 'common/tr2subscription',
						needData : false
					});
				});
			};
			UrlMgmt.getObj().Route({
				route : 'common/tr2login',
				needData : false
			});
		}
	});
	this.stableDom.find('._eventListener').unbind().bind('click', this, function(e) {
var pkgDom = $(e.currentTarget).closest('[pkgtype="scoreup"]');
		var tagData = null;
		if(pkgDom.length > 0)
		{	
			Factory.getObj().ExplorePkg(pkgDom,  function(tags) {
			    var tagData = tags;
			    console.log(tagData);
			  	if((typeof tagData != 'undefined' || tagData != null) && Object.keys(tagData).length > 0)
				{
					var tag1 = Object.keys(tagData)[0];
					var tag2 = Object.keys(tagData[tag1]["subCategories"])[0];
					var seletedTags = {
						tag1:tag1,
						tag2:tag2
					};
					var pkgDeliveryId = pkgDom.attr('data-deliveryId');
					Factory.getObj().ScoreUpFilterModel({allTags:tagData,
											selectedTags: seletedTags, 
											pkgDeliveryId: pkgDeliveryId});
				}
				else
				{
					var urlMgmt = UrlMgmt.getObj();
					var action = (urlMgmt.actionStack[urlMgmt.actionStack.length - 1].route).split('&')[0];
					if (action == $(this).data('action').split('&')[0]) {
						urlMgmt.RemoveView();
					}
					UrlMgmt.getObj().Route({
						route : $(this).data('action'),
						needData : true,
						offlineAllowed : true
					});
				}
			});
		}
		else
		{
			var urlMgmt = UrlMgmt.getObj();
			var action = (urlMgmt.actionStack[urlMgmt.actionStack.length - 1].route).split('&')[0];
			if (action == $(this).data('action').split('&')[0]) {
				urlMgmt.RemoveView();
			}
			UrlMgmt.getObj().Route({
				route : $(this).data('action'),
				needData : true,
				offlineAllowed : true
			});
		}
	});

	if(typeof payment_policies != "undefined" && parseInt(payment_policies) == 2 )
	{
		this.stableDom.find('.js-checkout').unbind().bind('click',function(e){
				$('#purchaseredirect-modal').modal("show");
				$('#purchaseredirect-modal .js-remoteserver').html(remoteServer);
	        });
	    this.stableDom.find('.js-checkout').html("More");
	}
	else
	{
		this.stableDom.find('.js-checkout').unbind().bind('click', this, function(e) {
			UrlMgmt.getObj().Route({
				route : $(this).data('action'),
				needData : true,
				offlineAllowed : false
			});
		});		
	}	

	//$(this.stableDom).find('.btnExamSubscribe').show();
	if(typeof this.data.threadId != "undefined" && parseInt(this.data.threadId) > 0)
	{
		this.stableDom.find('.discussion_div').html('<div class="loadDiscussion btn btn-default" >VIEW DISCUSSIONS</div>');
		this.stableDom.find('.loadDiscussion').show();
		this.stableDom.find(".discussion_header").html("Discussion");
		$('#liststestController .testlistouter .btnExamSubscribe').css("bottom", "80px");
		$('#liststestController .testlistouter .btnExamSubscribe').css("position", "fixed");
		this.stableDom.find('.loadDiscussion').unbind().bind('click', this, function(e) {
			$('#liststestController .testlistouter .btnExamSubscribe').css("visibility", "hidden");
			Factory.getObj().LoadDiscussions(e.data.data, e.data.stableDom);
			
		});	
	}
	else
	{
		this.stableDom.find('.loadDiscussion').hide();
		$('#liststestController .testlistouter .btnExamSubscribe').css("bottom", "80px");
		$('#liststestController .testlistouter .btnExamSubscribe').css("position", "fixed");
	}
	// $(this.stableDom).scroll(function(){
		// $(this.stableDom).unbind('scroll');
		// if(typeof this.data.threadId != "undefined" && parseInt(this.data.threadId) > 0)
		// {
			// //$('#liststestController .testlistouter .btnExamSubscribe').css("bottom", "15px");
			// Factory.getObj().LoadDiscussions(this.data, this.stableDom);
		// }
		// else
		// {
			// //$('#liststestController .testlistouter .btnExamSubscribe').css("bottom", "80px");
		// }
	// }.bind(this));
	if((typeof this.data.listType != "undefined") && ((parseInt(this.data.listType) == 1) || (parseInt(this.data.listType) == 2)))
	{
		$("#liststestController").find("#infobtn").hide();
	}
	else
	{
		$("#liststestController").find("#infobtn").show();
	}
};
liststestController.prototype.LoadTestListDropdown = function() {
	var urlMgmt = UrlMgmt.getObj();
	$(this.stableDom).find('.testlist-dropdown > span:first-child').empty();
	$(this.stableDom).find('.testlist-dropdown > span:first-child').append(this.data["title"]);

	if (!LoggedInUser.Auth()) {
		$(this.stableDom).find('.testlist-dropdown > span:nth-child(2)').remove();
		urlMgmt.headerAction.controler.ChangeHeaderTitle('Mock Tests');
	} else {
		if (urlMgmt.menuData && urlMgmt.menuData.myExams && urlMgmt.menuData.myExams.length > 0) {
			$(this.stableDom).find('.switchTestTap').unbind().bind('click', function(e) {
				if((typeof this.data.listType != "undefined") && (parseInt(this.data.listType) == 1))
				{
					urlMgmt.Route({
						route: "common/tr2myassignments", 
						needData:false, 
						emptyStack: false
					});
				}
				else
				{
					urlMgmt.Route({
						route : "common/tr2myexams",
						needData : false
					});					
				}
			}.bind(this));
		} else {
			$(this.stableDom).find('.testlist-dropdown > span:nth-child(2)').remove();
			UrlMgmt.getObj().headerAction.controler.ChangeHeaderTitle('Mock Tests');
		}
	}
};
liststestController.prototype.LoadTestTabs = function(callback) {
	if (this.data.testGroupCount) {
		var testTabs = Factory.getObj().TestTabs({
			testGroupCount : this.data.testGroupCount,
			activeTab : this.data.ActiveTab,
			tests : this.data,
			listType : this.data.listType
		});
		$(this.stableDom).find('.TestContainer').find('div.testlist').html(testTabs);

		Factory.getObj().ShowHideList(this.stableDom);
		var calculate1 = $(".tabList").scrollLeft() + $('.tabDiv').find('.active').offset().left - $(".tabList").offset().left - $(".tabList")[0].clientWidth / 2 + $('.tabDiv').find('.active').outerWidth(true) / 2;
		$('.tabList').animate({
			scrollLeft : calculate1
		}, 1000);
		$(".testTab").unbind().bind('click', function(e) {
			var calculate1 = $(".tabList").scrollLeft() + $(e.currentTarget).offset().left - $(".tabList").offset().left - $(".tabList")[0].clientWidth / 2 + $(e.currentTarget).outerWidth(true) / 2;
			$('.tabList').animate({
				scrollLeft : calculate1
			}, 1000);
		});
	}
	slider("tabDiv", 'tabList', "testTab");
	var data = this.data;
	var testIds = [];
	for (var type in data["testGroups"]) {
		for (var section in data["testGroups"][type]) {
			for (var test in data["testGroups"][type][section]) {
				var testData = data["testGroups"][type][section][test];
				testIds.push(testData["itemId"]);
				this.tests[testData["itemId"]] = testData;
			}
		}
	}
	UrlMgmt.getObj().Route({
		route : 'common/testlisting',
		needData : false
	}, function(object) {
		object.controler.view = this.dom;
		object.controler.id = this.id;
		object.controler.parent = this;
		object.controler.tests = this.tests;
		object.controler.type = "testlistpage";
		object.controler.testShortReport = this.data.testShortReport;
		object.controler.data = this.data;
		object.controler.Init();
		callback();
	}.bind(this));
};
liststestController.prototype.LoadPackageTabs = function() {
	var packageTabs = Factory.getObj().PackageTabs({
		packagePlanCount : this.data.packagePlanCount,
		PackageActiveTab : this.data.PackageActiveTab,
		plansAndPackages : this.data.plansAndPackages
	});

	if (packageTabs != 0) {
		this.stableDom.find('.plan-package-align').text('Plans & Packages');
		this.stableDom.find('.PackageContainer').empty();
		this.stableDom.find('.PackageContainer').append(packageTabs);
		slider("packageDiv", 'packageList', "package");
		var pkgdescriptionslide = new Array();
		var activeTab = $(".tab-content.p2List").find(".tab-pane.active").find(".packageDiv");
		for (var c = 0; c < activeTab.find('.pkgDetail').length; c++) {
			pkgdescriptionslide[c] = new slideVertical();
			pkgdescriptionslide[c].Init(activeTab.find(".pkgDetail").eq(c), "pkgDescription", "descriptionlines", c);
		}
		$(".packageContainerTab .nav.nav-tabs").bind("click", function() {
			setTimeout(function() {
				var activeTab = $(".tab-content.p2List").find(".tab-pane.active").find(".packageDiv");
				for (var c = 0; c < activeTab.find('.pkgDetail').length; c++) {
					pkgdescriptionslide[c] = new slideVertical();
					pkgdescriptionslide[c].Init(activeTab.find(".pkgDetail").eq(c), "pkgDescription", "descriptionlines", c);
				}
			}, 100);
		});
	}
};
liststestController.prototype.BinTestdEvents = function() {
	var data = this.data;
	var testIds = [];
	for (var type in data["testGroups"]) {
		for (var section in data["testGroups"][type]) {
			for (var test in data["testGroups"][type][section]) {
				var testData = data["testGroups"][type][section][test];
				testIds.push(testData["itemId"]);
				this.tests[testData["itemId"]] = testData;
			}
		}
	}
	console.log(this.dom);
	UrlMgmt.getObj().Route({
		route : 'common/testlisting',
		needData : false
	}, function(object) {
		console.log(this);
		this.tests = {
			'qwerty' : true
		};
		console.log(this.tests);
		object.controler.view = this.dom;
		object.controler.id = this.id;
		object.controler.parent = this;
		//console.log(this.tests);
		object.controler.tests = this.tests;
		object.controler.type = "testlistpage";
		object.controler.testShortReport = this.data.testShortReport;
		object.controler.data = this.data;
		//console.log(object);
		object.controler.Init();
	}.bind(this));
	console.log(this.tests);
	//var testListing = new testlisting(this.dom, this.tests, this.testListId, "testlistpage", this, this.data.testShortReport);
};
liststestController.prototype.LoadExamInfoTop = function() {
	var urlMgmt = UrlMgmt.getObj();
	Factory.getObj().QuickAccess({
		title : 'EXAM INFO',
		view : this.stableDom,
		buttonDom : this.stableDom.find("#infobtn"),
		quickaccessList : this.data.examInfo.quickaccessList,
		data : {
			examDescription : this.data.examInfo.examDescription,
		},
		bindevents : function() {
			$(".examQuickAccessCard").on('click', this.data, function(e) {
				$('#info-modal').modal('hide');
				$('#examInfoFull-modal').find('#touchablehighlight').remove();
				var regex = /^#/;
				var url = $(this).data('url');
				if (regex.test(url)) {
					var href = $(this).data('url').split("#")[1];
					$('#examInfoFull-modal').find('.examInfoFullmodal-body').empty();
					$('#examInfoFull-modal').find('.examInfoFullmodal-body').append(e.data.examDescription);

					//open all links in AppBrowser
					$('#examInfoFull-modal').find("a").unbind().bind('click', function(e) {
						e.preventDefault();
						var href = $(this).attr('href');
						AppBrowser.getObj().OpenWPBlog(href);
					});

					setTimeout(function() {
						$('#examInfoFull-modal').modal("show");
						var hash = $('.examInfoFullmodal-content').find("#" + href + "").attr('id');
						$('#examInfoFull-modal').animate({
							scrollTop : $("#" + hash + "").offset().top - 65
						}, 800);
					}, 500);
				} else {
					urlMgmt.showLoader();
					tr$.ajax({
						mod : "tr2app",
						ack : "gettemplink",
						additionalParams : {
							url : url
						},
						successClb : function(response) {
							if (response.data != null){
								var serverAddress = remoteServer;
								if(typeof UrlMgmt.getObj().menuData != 'undefined' && typeof UrlMgmt.getObj().menuData.domainmeta != 'undefined' && typeof UrlMgmt.getObj().menuData.domainmeta.homeUrl != 'undefined'&& UrlMgmt.getObj().menuData.domainmeta.homeUrl.length > 0){
									serverAddress = 'http://'+UrlMgmt.getObj().menuData.domainmeta.homeUrl;
								}
								window.open(serverAddress + response.data, '_system');
							}
							else
								window.open(url, '_system');
							urlMgmt.removeLoader();

						},
						errorClb : function() {
							window.open(this.url, '_system');
							urlMgmt.removeLoader();
						}
					});
				}
			});
		}
	});
};
liststestController.prototype.LoadExamSubmenu = function() {
	Factory.getObj().LoadSubMenus(this.data.submenuList, $(this.stableDom).find('.submenuPosition'));

	slider("submenuDiv", 'submenuList', "submenu");
};

liststestController.prototype.LoadFeaturedArticles = function() {
	if (this.data.examInfo != null && typeof this.data.examInfo.wpArticleList !== 'undefined' && tr$.length(this.data.examInfo.wpArticleList) > 0) {
		var fArticlesHTML = Factory.getObj().LoadFeaturedArticles(this.data.examInfo.wpArticleList);
		parentDom = this.stableDom.find('.testlist-featured-articles').html(fArticlesHTML);
		carouselDom = parentDom.find('.carousel');
		tr$.carouselSet(carouselDom, this.stableDom);
		tr$.OpenAllLinksInAppBrowser(parentDom);
	}
};
liststestController.prototype.LoadQuiz = function() {
	console.log(this.data);
	var QuizHTML = '';
	if (this.data != null && this.data.examInfo != null){
		if(typeof this.data.examInfo.dquizcount != "undefined" && this.data.examInfo.dquizcount > 0 && typeof this.data.examInfo.dquiz != 'undefined') {
		
			var currentTimestamp = new Date().getTime();
			var activeQuizCard = 'active';
			QuizHTML = '<h2 class="TextDark quizheading">Daily Quiz</h2><div id="QuizCarousel-' + currentTimestamp + '" class="carousel slide" data-ride="carousel">';
			QuizHTML += '<ol class="carousel-indicators">';
			var count = 0;
			for (var key in this.data.examInfo.dquiz) {
				if (count == 0) {
					QuizHTML += '<li data-target="#QuizCarousel-' + currentTimestamp + '" data-slide-to="' + count + '" class="active"></li>';
					count++;
					continue;
				}
				QuizHTML += '<li data-target="#QuizCarousel-' + currentTimestamp + '" data-slide-to="' + count + '" ></li>';
				count++;
			}
			if(parseInt(this.data.examInfo.dquizcount - this.data.examInfo.dquiz.length) > 0){
				QuizHTML += '<li data-target="#QuizCarousel-' + currentTimestamp + '" data-slide-to="' + count + '" ></li>';
			}
			QuizHTML += '</ol>' + '<div class="carousel-inner">';
			for (var key in this.data.examInfo.dquiz) {
				var quiz = this.data.examInfo.dquiz[key];
				
				QuizHTML += Factory.getObj().dQuizCard({
					quiz : quiz
				}, activeQuizCard);
				if (activeQuizCard == 'active') {
					activeQuizCard = '';
				}
			}
			if(parseInt(this.data.examInfo.dquizcount - this.data.examInfo.dquiz.length) > 0){
				QuizHTML += '<div class="quiz item" style="background-color: white;">'+
								 '<div class="quizHeader">'+
								 	 '<div class="heading">'+
								 	 	 '<span class="cardTitle">More Quizzes</span>'+
								 	 	 '<span class="quizimg">'+
								 	 	 	'<img src="https://cdn.toprankers.com/images/liveclasquiz-023b11deb59b4.png">'+
								 	 	 '</span>'+
								 	  '</div>'+
								 '</div>'+
								 '<div class="quizStates quizdetails">'+
								 	'<span class="quizmsg">We have ' + (this.data.examInfo.dquizcount - this.data.examInfo.dquiz.length) + ' more Quizzes on ' + this.data.examInfo.dquizList[0].title + ' just for you! </span>'+
								 '</div>'+
								 '<div class="quizFooter">'+
								 	'<div class="quiz-btns" style="background-color: white;">'+
								 		'<button class="btn btn-primary btnQuizList" data-action="lists/quiz&id=' + this.data.examInfo.dquizList[0].quizListId + '">Take me there!</button>'+
								 	'</div>'+
								 '</div>'+
							'</div>';
			}
			QuizHTML += '</div></div>';
	
			$(this.stableDom).find('.quizDiv').html(QuizHTML);
			tr$.carouselSet(this.stableDom.find('#QuizCarousel-' + currentTimestamp), this.stableDom);
			this.stableDom.find('.takeQuiz').unbind().bind('click', function() {
				if (!UrlMgmt.getObj().App.isOnline) {
					UrlMgmt.getObj().App.onOffline();
					return false;
				}
				if (!LoggedInUser.Auth()) {
					UrlMgmt.getObj().Route({
						route : 'common/tr2login',
						needData : false
					});
					return false;
				}
				UrlMgmt.getObj().Route({
					route : $(this).data('action'),
					needData : false
				});
			});
			this.stableDom.find('.btnQuizList').unbind().bind('click', function() {
				UrlMgmt.getObj().Route({
					route : $(this).data('action'),
					needData : true,
					offlineAllowed : true
				});
			});
			this.stableDom.find('.report').unbind().bind('click', function() {
				if (!UrlMgmt.getObj().App.isOnline) {
					UrlMgmt.getObj().App.onOffline();
					return false;
				}
				if (!LoggedInUser.Auth()) {
					UrlMgmt.getObj().Route({
						route : 'common/tr2login',
						needData : false
					});
					return false;
				}
				UrlMgmt.getObj().Route({
					route : $(this).data('action'),
					needData : false
				});
			});
		}
		else if(typeof this.data.examInfo.dquizcount != "undefined" && this.data.examInfo.dquizcount > 0){
			QuizHTML = '<h2 class="TextDark quizheading">Daily Quiz</h2>';
			
			QuizHTML += '<div class="quiz item" style="background-color: white;">'+
							 '<div class="quizHeader">'+
							 	 '<div class="heading" style="text-align:center;">'+
							 	 	 '<span class="cardTitle">Whoa!</span>'+
							 	 	 '<span class="quizimg">'+
							 	 	 	'<img src="https://cdn.toprankers.com/images/liveclasquiz-023b11deb59b4.png">'+
							 	 	 '</span>'+
							 	  '</div>'+
							 '</div>'+
							 '<div class="quizStates quizdetails">'+
							 	'<span class="quizmsg">That was quick. You have attempted all Quizzes here.</span>'+
							 '</div>'+
							 '<div class="quizStates quizdetails" style="margin-top:10px;">'+
							 	'<span class="quizmsg">Want more on '+ this.data.examInfo.dquizList[0].title + '?</span>'+
							 '</div>'+
							 '<div class="quizFooter" style="padding-top:5px;">'+
							 	'<div class="quiz-btns" style="background-color: white;">'+
							 		'<button class="btn btn-primary btnQuizList" data-action="lists/quiz&id=' + this.data.examInfo.dquizList[0].quizListId + '">More Quizzes Here!</button>'+
							 	'</div>'+
							 '</div>'+
						'</div>';
			QuizHTML += '</div></div>';
	
			$(this.stableDom).find('.quizDiv').html(QuizHTML);
			this.stableDom.find('.btnQuizList').unbind().bind('click', function() {
				UrlMgmt.getObj().Route({
					route : $(this).data('action'),
					needData : true,
					offlineAllowed : true
				});
			});
		}
	}
};
liststestController.prototype.LoadFloatingBtn = function() {
	//var fab = '<div class="btnExamSubscribe btn-fab">' + '<img src="img/subscribe_btn.png">' + '</div>';
	//this.stableDom.find('.btn-fab').remove();
	//this.stableDom.append(fab);
}; 