function HCP_CheckUpdate()
{
    console.log('HCP_CheckUpdate');
    $('#app-updater .Loader .alert').text("Downloading new updates!");
    tr$.AppUpdateProgress(75);
    if(typeof chcp != "undefined")
      chcp.fetchUpdate(HCP_fetchUpdateCallback);
}
function HCP_CheckAvailableUpdates()
{
	console.log('HCP_CheckAvailableUpdates---------------------------------');
	$.ajax({
		 type: 'GET',
		 url: 'https://s3.ap-south-1.amazonaws.com/cdn.toprankers.net/hcp/com.TopRankers.trapp/version.json',
		 dataType: 'jsonp',
		 jsonpCallback: 'callback',
		 success: function(obj){
		 	var latestVersion = obj.LatestVersion;
		 	if(app.versionInfo == null || app.versionInfo["version"] != latestVersion.version)
	   		{
	   			HCP_CheckUpdate();
	   			app.versionInfo = latestVersion;
	   		}
		 },
		 error: function(XMLHttpRequest, textStatus, errorThrown){
		 	 console.log(errorThrown);
		 }
	});
}
function HCP_CheckInitialUpdates()
{
    var today = new Date();
	today = today.getDate()+'-'+(today.getMonth()+1)+'-'+today.getFullYear();
    readFromCache("Update-"+today,
        function(data){
      		console.log(data);
        }.bind(this),
        function(fileName, e){
        	HCP_CheckAvailableUpdates();
        	writeToCache("Update-"+today,today);
	    }.bind(this));
}
function HCP_configureCallback (error) {
    if (error) {
      console.log('Error during the configuration process');
      console.log(error.description);
    } else {
      console.log('Plugin configured successfully');
      // from this moment only we control when to download and install new releases
	  setTimeout(function(){HCP_CheckInitialUpdates();},10000);
    }
}
function HCP_fetchUpdateCallback (error, data) {
    if (error) {
    	$('#app-updater').hide();
    	tr$.alert("<p class='errorMsg'>Update Failed, Network Error!</p>");
    	
        console.log('Failed to load the update with error code: ' + error.code);
        console.log(error.description);
        return;
    } else {
        console.log('Update is loaded, running the installation');
        // tr$.AppUpdateProgress(85);
        tr$.AppUpdateProgress(100);
        $('#app-updater .Loader .alert').text("Update is loaded, running the installation");
        if(typeof chcp != "undefined")
        setTimeout(function(){ chcp.installUpdate(HCP_installationCallback); }, 1000);
          
    }
}
function HCP_installationCallback (error) {
    $('#app-updater').hide();
    if (error)
    {
    	tr$.alert("<p class='errorMsg'>Failed to install the update!</p>");
        console.log('Failed to install the update with error code: ' + error.code);
    	console.log(error.description);
    }
    else
    {
        console.log('Update installed!');
        tr$.AppUpdateProgress(100);
        $('#app-updater .Loader .alert').text("Update installed!");
        document.location.reload();
        
    }
}
